#include <iostream>
#include <queue>
#include <unordered_set>

using namespace std;

int main() {
    int N;
    cin >> N;

    // Множини для збереження відвіданих боксів для Аліси і Боба
    unordered_set<int> alice_positions, bob_positions;
    queue<int> alice_queue, bob_queue;
    
    // Початкові умови
    alice_queue.push(1);  // Аліса починає в боксі 1
    bob_queue.push(N);    // Боб починає в боксі N
    alice_positions.insert(1);
    bob_positions.insert(N);
    
    int seconds = 0;
    
    while (!alice_queue.empty() || !bob_queue.empty()) {
        // Перевіряємо всі можливі позиції для Аліси за одну секунду
        int alice_size = alice_queue.size();
        for (int i = 0; i < alice_size; i++) {
            int alice_pos = alice_queue.front();
            alice_queue.pop();
            
            if (bob_positions.count(alice_pos)) {
                cout << seconds << endl;
                return 0;
            }

            if (alice_pos + 2 <= N && !alice_positions.count(alice_pos + 2)) {
                alice_positions.insert(alice_pos + 2);
                alice_queue.push(alice_pos + 2);
            }

            if (alice_pos + 3 <= N && !alice_positions.count(alice_pos + 3)) {
                alice_positions.insert(alice_pos + 3);
                alice_queue.push(alice_pos + 3);
            }
        }

        // Перевіряємо всі можливі позиції для Боба за одну секунду
        int bob_size = bob_queue.size();
        for (int i = 0; i < bob_size; i++) {
            int bob_pos = bob_queue.front();
            bob_queue.pop();
            
            if (alice_positions.count(bob_pos)) {
                cout << seconds << endl;
                return 0;
            }

            if (bob_pos - 1 >= 1 && !bob_positions.count(bob_pos - 1)) {
                bob_positions.insert(bob_pos - 1);
                bob_queue.push(bob_pos - 1);
            }

            if (bob_pos - 2 >= 1 && !bob_positions.count(bob_pos - 2)) {
                bob_positions.insert(bob_pos - 2);
                bob_queue.push(bob_pos - 2);
            }
        }

        seconds++;
    }
    
    cout << -1 << endl;
    return 0;
}
