from collections import deque

def find_min_time_to_meet(n):
    # Початкові умови
    alice_positions = deque([1])  # Початкова позиція Аліси
    bob_positions = deque([n])  # Початкова позиція Боба
    
    # Використовуємо множини для відслідковування можливих позицій
    visited_alice = {1}
    visited_bob = {n}
    
    time = 0
    
    while alice_positions and bob_positions:
        time += 1
        
        # Переміщення Аліси на 1 секунду
        next_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= n:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= n:
                next_alice_positions.add(pos + 3)
        
        # Переміщення Боба на 1 секунду
        next_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)
        
        # Перевіряємо на перетин позицій
        if next_alice_positions & next_bob_positions:
            return time
        
        # Оновлюємо позиції для наступної секунди
        alice_positions = deque(next_alice_positions)
        bob_positions = deque(next_bob_positions)
        
        # Оновлюємо відвідані позиції
        visited_alice.update(next_alice_positions)
        visited_bob.update(next_bob_positions)
        
    return -1

# Вхід
n = int(input())

# Виклик функції
print(find_min_time_to_meet(n))
