def find_min_time_to_meet(n):
    # Если n равно 2 или 3, они не могут встретиться
    if n == 2 or n == 3:
        return -1

    # Алиса находится в клетке 1
    # Боб находится в клетке N
    # Мы будем смотреть, сколько времени потребуется для того, чтобы они встретились

    # Минимальные возможные шаги для Алисы и Боба
    time = 0
    alice_positions = {1}
    bob_positions = {n}

    while True:
        time += 1
        
        # Алиса перемещается на 2 или 3 клетки вперед
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= n:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= n:
                new_alice_positions.add(pos + 3)
        alice_positions = new_alice_positions

        # Боб перемещается на 1 или 2 клетки назад
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)
        bob_positions = new_bob_positions

        # Проверяем, есть ли пересечение между позициями Аліси и Боба
        if alice_positions & bob_positions:
            return time

        # Если позиции Аліси и Боба не пересекаются, продолжаем движение
        if not alice_positions or not bob_positions:
            break
    
    return -1

# Чтение входных данных
n = int(input())
print(find_min_time_to_meet(n))
