def find_min_time_to_meet(n):
    # Если n слишком мал, то встреча невозможна
    if n == 2 or n == 3:
        return -1
    
    # Пройдем по возможным шагам, начиная с первого
    # За 1 шаг проверяем возможные позиции
    for t in range(1, n):
        # Аліса может попасть на 1 + 2 * t или 1 + 3 * t
        alice_positions = [1 + 2 * t, 1 + 3 * t]
        if any(pos >= n for pos in alice_positions):
            break
        # Боб может попасть на n - 1 - t или n - 2 - t
        bob_positions = [n - 1 - t, n - 2 - t]
        if any(pos <= 0 for pos in bob_positions):
            break
        
        # Проверяем пересечение
        for alice_pos in alice_positions:
            for bob_pos in bob_positions:
                if alice_pos == bob_pos:
                    return t
    return -1

# Чтение входных данных
n = int(input())
print(find_min_time_to_meet(n))
