from collections import deque

def can_meet(n):
    # Очереди для текущих позиций Алисы и Боба
    alice_queue = deque([1])
    bob_queue = deque([n])
    
    # Множества для отслеживания уже посещенных позиций
    alice_visited = {1}
    bob_visited = {n}
    
    time = 0
    while alice_queue and bob_queue:
        time += 1
        
        # Проходим по очереди Алисы
        for _ in range(len(alice_queue)):
            pos = alice_queue.popleft()
            for new_pos in (pos + 2, pos + 3):
                if new_pos <= n and new_pos not in alice_visited:
                    alice_visited.add(new_pos)
                    alice_queue.append(new_pos)
                    # Проверка пересечения позиций
                    if new_pos in bob_visited:
                        return time
        
        # Проходим по очереди Боба
        for _ in range(len(bob_queue)):
            pos = bob_queue.popleft()
            for new_pos in (pos - 1, pos - 2):
                if new_pos >= 1 and new_pos not in bob_visited:
                    bob_visited.add(new_pos)
                    bob_queue.append(new_pos)
                    # Проверка пересечения позиций
                    if new_pos in alice_visited:
                        return time
    
    return -1

# Ввод
n = int(input())
# Вывод
print(can_meet(n))
