#include <iostream>
#include <queue>
#include <unordered_set>

using namespace std;

// Структура для хранения позиции робота и времени
struct State {
    int alice_pos, bob_pos, time;
    State(int a, int b, int t) : alice_pos(a), bob_pos(b), time(t) {}
};

int min_time_to_meet(int N) {
    // Очередь для BFS
    queue<State> q;
    // Множество для отслеживания уже посещенных состояний (alice_pos, bob_pos)
    unordered_set<int> visited;
    
    // Изначальные позиции
    q.push(State(1, N, 0));  // Аліса в боксі 1, Боб в боксі N, час 0
    visited.insert(1 << 30 | N);  // Помечаем начальное состояние как посещенное

    while (!q.empty()) {
        State current = q.front();
        q.pop();
        
        // Проверяем, могут ли встретиться
        if (current.alice_pos == current.bob_pos) {
            return current.time; // Возвращаем минимальное время
        }

        // Для Алисы возможные перемещения: +2 и +3
        for (int a_move : {2, 3}) {
            int new_alice_pos = current.alice_pos + a_move;
            if (new_alice_pos <= N) {
                // Для Боба возможные перемещения: -1 и -2
                for (int b_move : {-1, -2}) {
                    int new_bob_pos = current.bob_pos + b_move;
                    if (new_bob_pos >= 1) {
                        int new_state = (new_alice_pos << 30) | new_bob_pos;
                        if (visited.find(new_state) == visited.end()) {
                            visited.insert(new_state);
                            q.push(State(new_alice_pos, new_bob_pos, current.time + 1));
                        }
                    }
                }
            }
        }
    }

    return -1; // Если не нашли решения
}

int main() {
    int N;
    cin >> N;
    cout << min_time_to_meet(N) << endl;
    return 0;
}
