#include <iostream>
#include <queue>
#include <vector>

using namespace std;

int can_meet(int n) {
    // Очереди для BFS
    queue<int> alice_queue, bob_queue;
    
    // Массивы для отслеживания посещенных клеток
    vector<bool> alice_visited(n + 1, false);
    vector<bool> bob_visited(n + 1, false);
    
    alice_queue.push(1);    // Аліса начинает с клетки 1
    bob_queue.push(n);      // Боб начинает с клетки N
    alice_visited[1] = true;
    bob_visited[n] = true;
    
    int time = 0;
    
    while (!alice_queue.empty() && !bob_queue.empty()) {
        int size = alice_queue.size();
        
        // Алиса делает шаги
        for (int i = 0; i < size; ++i) {
            int pos = alice_queue.front();
            alice_queue.pop();
            
            // Проверяем возможные позиции
            for (int next_pos : {pos + 2, pos + 3}) {
                if (next_pos <= n && !alice_visited[next_pos]) {
                    alice_visited[next_pos] = true;
                    alice_queue.push(next_pos);
                    
                    // Проверяем, может ли Боб уже быть на этой позиции
                    if (bob_visited[next_pos]) {
                        return time + 1;
                    }
                }
            }
        }
        
        size = bob_queue.size();
        
        // Боб делает шаги
        for (int i = 0; i < size; ++i) {
            int pos = bob_queue.front();
            bob_queue.pop();
            
            // Проверяем возможные позиции
            for (int next_pos : {pos - 1, pos - 2}) {
                if (next_pos >= 1 && !bob_visited[next_pos]) {
                    bob_visited[next_pos] = true;
                    bob_queue.push(next_pos);
                    
                    // Проверяем, может ли Аліса уже быть на этой позиции
                    if (alice_visited[next_pos]) {
                        return time + 1;
                    }
                }
            }
        }
        
        ++time;
    }
    
    return -1;  // Если не нашли пересечения
}

int main() {
    int n;
    cin >> n;
    cout << can_meet(n) << endl;
    return 0;
}
