using System;
using System.Collections.Generic;

class Teleportation
{
    public static int CanMeet(int n)
    {
        // Очереди для позиций Алисы и Боба
        HashSet<int> alicePositions = new HashSet<int> { 1 };  // Начальная позиция Алисы
        HashSet<int> bobPositions = new HashSet<int> { n };    // Начальная позиция Боба

        int time = 0;
        
        while (alicePositions.Count > 0 && bobPositions.Count > 0)
        {
            time++;

            // Новые позиции Алисы
            HashSet<int> newAlicePositions = new HashSet<int>();
            foreach (var pos in alicePositions)
            {
                if (pos + 2 <= n) newAlicePositions.Add(pos + 2);
                if (pos + 3 <= n) newAlicePositions.Add(pos + 3);
            }

            // Новые позиции Боба
            HashSet<int> newBobPositions = new HashSet<int>();
            foreach (var pos in bobPositions)
            {
                if (pos - 1 >= 1) newBobPositions.Add(pos - 1);
                if (pos - 2 >= 1) newBobPositions.Add(pos - 2);
            }

            // Проверка на пересечение позиций
            foreach (var alicePos in newAlicePositions)
            {
                if (newBobPositions.Contains(alicePos))
                {
                    return time;  // Если есть пересечение, возвращаем время
                }
            }

            // Обновление текущих позиций
            alicePositions = newAlicePositions;
            bobPositions = newBobPositions;
        }

        return -1;  // Если пересечение не найдено
    }

    static void Main(string[] args)
    {
        // Чтение входных данных
        int n = int.Parse(Console.ReadLine());

        // Вывод ответа
        Console.WriteLine(CanMeet(n));
    }
}
