import java.util.*;

public class Teleportation {
    public static int canMeet(int n) {
        // Используем множества для хранения позиций Алисы и Боба
        Set<Integer> alicePositions = new HashSet<>();
        Set<Integer> bobPositions = new HashSet<>();
        
        alicePositions.add(1);  // Начальная позиция Алисы
        bobPositions.add(n);    // Начальная позиция Боба
        
        int time = 0;
        
        while (!alicePositions.isEmpty() && !bobPositions.isEmpty()) {
            time++;
            
            // Новые позиции Алисы
            Set<Integer> newAlicePositions = new HashSet<>();
            for (int pos : alicePositions) {
                if (pos + 2 <= n) newAlicePositions.add(pos + 2);
                if (pos + 3 <= n) newAlicePositions.add(pos + 3);
            }
            
            // Новые позиции Боба
            Set<Integer> newBobPositions = new HashSet<>();
            for (int pos : bobPositions) {
                if (pos - 1 >= 1) newBobPositions.add(pos - 1);
                if (pos - 2 >= 1) newBobPositions.add(pos - 2);
            }
            
            // Проверка на пересечение позиций
            for (int pos : newAlicePositions) {
                if (newBobPositions.contains(pos)) {
                    return time;
                }
            }
            
            // Обновление текущих позиций
            alicePositions = newAlicePositions;
            bobPositions = newBobPositions;
        }
        
        return -1; // Если не нашли пересечения
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();  // Ввод N
        System.out.println(canMeet(n));  // Вывод результата
    }
}
