#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
    int N, M;
    cin >> N >> M;

    vector<int> dp(M + 1, -1); // -1 означає, що сума не досягнута
    vector<int> previous(M + 1, -1); // Для відновлення марок

    dp[0] = 0; // Нульова сума досяжна без марок

    // Динамічне програмування: шукаємо мінімальну кількість марок для кожної суми
    for (int i = 1; i <= N; ++i) {
        for (int j = M; j >= i; --j) {
            if (dp[j - i] != -1 && dp[j] == -1) {
                dp[j] = dp[j - i] + 1; // Оновлюємо кількість марок
                previous[j] = i; // Записуємо марку, яку вибрали
            }
        }
    }

    if (dp[M] == -1) {
        cout << 0 << endl; // Якщо сума не досяжна
    } else {
        vector<int> result;
        int sum = M;
        while (sum > 0) {
            result.push_back(previous[sum]);
            sum -= previous[sum];
        }
        
        for (int i = result.size() - 1; i >= 0; --i) {
            cout << result[i] << " ";
        }
        cout << endl;
    }

    return 0;
}
