#include <iostream>
using namespace std;

long long findMeetingTime(long long N) {
    // Якщо кількість боксів менша 2, немає сенсу обчислювати
    if (N < 2) return -1;

    // Аліса може потрапити тільки в позиції виду 1 + 2 * x + 3 * y
    // Боб може потрапити тільки в позиції виду N - z - 2 * w
    // Ми перевіряємо модульну сумісність їхніх траєкторій

    for (long long t = 0; t < N; t++) {
        long long alicePos = 1 + 2 * (t / 2) + 3 * (t % 2);  // Позиція Аліси в момент часу t
        long long bobPos = N - (t / 2) - 2 * (t % 2);        // Позиція Боба в момент часу t
        if (alicePos > N || bobPos < 1) break;              // Якщо виходимо за межі
        if (alicePos == bobPos) return t;                  // Знайдено момент зустрічі
    }

    return -1; // Якщо зустріч неможлива
}

int main() {
    long long N;
    cin >> N;
    cout << findMeetingTime(N) << endl;
    return 0;
}
