#include <iostream>
#include <vector>
#include <queue>
using namespace std;

// Структура для зберігання позицій Аліси і Боба та кількості секунд
struct State {
    int alice, bob, time;
    State(int a, int b, int t) : alice(a), bob(b), time(t) {}
};

int solve(int N) {
    // Створюємо матрицю відвіданих станів
    vector<vector<bool>> visited(N + 1, vector<bool>(N + 1, false));
    queue<State> q;
    
    // Початковий стан: Аліса в позиції 1, Боб в позиції N
    q.push(State(1, N, 0));
    visited[1][N] = true;
    
    while (!q.empty()) {
        State current = q.front();
        q.pop();
        
        int alice = current.alice;
        int bob = current.bob;
        int time = current.time;
        
        // Якщо Аліса і Боб в одній позиції, повертаємо час
        if (alice == bob) {
            return time;
        }
        
        // Можливі ходи Аліси (+2 або +3)
        vector<int> aliceMoves = {alice + 2, alice + 3};
        // Можливі ходи Боба (-1 або -2)
        vector<int> bobMoves = {bob - 1, bob - 2};
        
        // Перебираємо всі можливі комбінації ходів
        for (int newAlice : aliceMoves) {
            for (int newBob : bobMoves) {
                // Перевіряємо чи ходи в межах поля і чи не були в цьому стані
                if (newAlice <= N && newBob >= 1 && !visited[newAlice][newBob]) {
                    visited[newAlice][newBob] = true;
                    q.push(State(newAlice, newBob, time + 1));
                }
            }
        }
    }
    
    // Якщо не знайдено рішення
    return -1;
}

int main() {
    int N;
    cin >> N;
    cout << solve(N) << endl;
    return 0;
}