#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;

inline long long makeKey(int alice, int bob) {
    return (long long)alice << 32 | bob;
}

int solve(int N) {
    queue<pair<long long, int>> q;
    unordered_set<long long> visited;
    
    long long initialState = makeKey(1, N);
    q.push({initialState, 0});
    visited.insert(initialState);
    
    while (!q.empty()) {
        long long state = q.front().first;
        int time = q.front().second;
        q.pop();
        

        int alice = state >> 32;
        int bob = state & 0xFFFFFFFF;
        

        if (alice == bob) {
            return time;
        }
        

        for (int da : {2, 3}) {
            int newAlice = alice + da;
            if (newAlice > N) continue;
            
  
            for (int db : {1, 2}) {
                int newBob = bob - db;
                if (newBob < 1) continue;
                
                long long newState = makeKey(newAlice, newBob);
                if (visited.find(newState) == visited.end()) {
                    visited.insert(newState);
                    q.push({newState, time + 1});
                }
            }
        }
    }
    
    return -1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int N;
    cin >> N;
    cout << solve(N) << endl;
    return 0;
}