#include <iostream>
using namespace std;

// Функція для обчислення найбільшого спільного дільника (НСД) за допомогою алгоритму Евкліда
long long gcd(long long a, long long b) {
    while (b != 0) {
        long long temp = b;
        b = a % b;
        a = temp;
    }
    return a;
}

// Функція для обчислення найменшого спільного кратного (НСК)
long long lcm(long long a, long long b) {
    return (a / gcd(a, b)) * b;
}

int main() {
    long long N, A, B;
    cin >> N >> A >> B;

    // Кількість чисел, які діляться на A
    long long countA = N / A;
    // Кількість чисел, які діляться на B
    long long countB = N / B;
    // Кількість чисел, які діляться на НСК(A, B)
    long long countAB = N / lcm(A, B);

    // Використовуємо принцип включення-виключення
    long long result = countA + countB - countAB;

    cout << result << endl;

    return 0;
}