#include <iostream>
#include <vector>
using namespace std;

int countUniformSquares(int N, vector<vector<int>>& grid) {
    int count = 0;

    // Перебираємо всі можливі розміри квадратів
    for (int size = 1; size < N; ++size) { // Розмір квадрата (1 означає сторону квадрата)
        for (int i = 0; i + size < N; ++i) { // Верхня ліва вершина квадрата (i, j)
            for (int j = 0; j + size < N; ++j) {
                // Вершини квадрата:
                // Верхня ліва (i, j)
                // Верхня права (i, j + size)
                // Нижня ліва (i + size, j)
                // Нижня права (i + size, j + size)
                int color = grid[i][j];
                if (grid[i][j + size] == color &&
                    grid[i + size][j] == color &&
                    grid[i + size][j + size] == color) {
                    ++count; // Усі вершини мають однаковий колір
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));

    // Зчитуємо матрицю
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    // Рахуємо кількість квадратів
    int result = countUniformSquares(N, grid);

    // Вивід результату
    cout << result << endl;

    return 0;
}
