#include <iostream>
#include <vector>
using namespace std;

bool isSquare(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4) {
    // Обчислюємо відстані між всіма парами точок
    vector<int> d;
    d.push_back((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
    d.push_back((x3-x2)*(x3-x2) + (y3-y2)*(y3-y2));
    d.push_back((x4-x3)*(x4-x3) + (y4-y3)*(y4-y3));
    d.push_back((x1-x4)*(x1-x4) + (y1-y4)*(y1-y4));
    d.push_back((x3-x1)*(x3-x1) + (y3-y1)*(y3-y1));
    d.push_back((x4-x2)*(x4-x2) + (y4-y2)*(y4-y2));
    
    // Сортуємо відстані
    sort(d.begin(), d.end());
    
    // Перевіряємо чи є фігура квадратом:
    // - перші 4 відстані (сторони) мають бути рівні
    // - останні 2 відстані (діагоналі) мають бути рівні
    return d[0] == d[1] && d[1] == d[2] && d[2] == d[3] && d[4] == d[5] && d[0] > 0;
}

int main() {
    int N;
    cin >> N;
    
    // Зчитуємо матрицю кольорів
    vector<vector<int>> grid(N, vector<int>(N));
    for(int i = 0; i < N; i++) {
        for(int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }
    
    int count = 0;
    
    // Перебираємо всі можливі комбінації 4 точок
    for(int y1 = 0; y1 < N; y1++) {
        for(int x1 = 0; x1 < N; x1++) {
            for(int y2 = 0; y2 < N; y2++) {
                for(int x2 = x1; x2 < N; x2++) {
                    if(x1 == x2 && y1 == y2) continue;
                    
                    // Знаходимо інші дві точки квадрата
                    int dx = x2 - x1;
                    int dy = y2 - y1;
                    
                    // Повертаємо вектор на 90 градусів для знаходження інших вершин
                    int x3 = x2 - dy;
                    int y3 = y2 + dx;
                    int x4 = x1 - dy;
                    int y4 = y1 + dx;
                    
                    // Перевіряємо чи точки знаходяться в межах квадрата
                    if(x3 >= 0 && x3 < N && y3 >= 0 && y3 < N &&
                       x4 >= 0 && x4 < N && y4 >= 0 && y4 < N) {
                        
                        // Перевіряємо чи утворюють точки квадрат
                        if(isSquare(x1, y1, x2, y2, x3, y3, x4, y4)) {
                            // Перевіряємо чи всі вершини одного кольору
                            if((grid[y1][x1] == grid[y2][x2] &&
                                grid[y2][x2] == grid[y3][x3] &&
                                grid[y3][x3] == grid[y4][x4])) {
                                count++;
                            }
                        }
                    }
                    
                    // Перевіряємо квадрат з поворотом в іншу сторону
                    x3 = x2 + dy;
                    y3 = y2 - dx;
                    x4 = x1 + dy;
                    y4 = y1 - dx;
                    
                    if(x3 >= 0 && x3 < N && y3 >= 0 && y3 < N &&
                       x4 >= 0 && x4 < N && y4 >= 0 && y4 < N) {
                        
                        if(isSquare(x1, y1, x2, y2, x3, y3, x4, y4)) {
                            if((grid[y1][x1] == grid[y2][x2] &&
                                grid[y2][x2] == grid[y3][x3] &&
                                grid[y3][x3] == grid[y4][x4])) {
                                count++;
                            }
                        }
                    }
                }
            }
        }
    }
    
    // Оскільки ми рахуємо кожен квадрат двічі (для кожної пари протилежних вершин)
    cout << count/4 << endl;
    
    return 0;
}