n = int(input())
print ("%d %d\n" % (n/10, n%10))
def calculate_sum(A, B, N):
    """
    Функція обчислює суму чисел Аліси та Боба через N секунд.
    :param A: Початкове число Аліси.
    :param B: Початкове число Боба.
    :param N: Тривалість експерименту в секундах.
    :return: Сума чисел Аліси та Боба або повідомлення про помилку.
    """
    try:
        # Перевірка обмежень
        if not (1 <= A <= 10**9 and 1 <= B <= 10**9 and 1 <= N <= 10**9):
            return "Помилка: числа мають бути у межах 1 ≤ A, B, N ≤ 10^9."

        # Обчислення результату
        return A + B + 2 * N
    except Exception as e:
        return f"Помилка під час виконання: {e}"


# Основна програма
def main():
    try:
        # Зчитування вхідних даних
        A = int(input("Введіть число A (згенероване Алісою): ").strip())
        B = int(input("Введіть число B (згенероване Бобом): ").strip())
        N = int(input("Введіть тривалість експерименту N (у секундах): ").strip())

        # Виклик функції
        result = calculate_sum(A, B, N)

        # Виведення результату
        print(result)
    except ValueError:
        print("Помилка: введено некоректні дані. Перевірте, що всі числа цілі та додатні.")
    except Exception as e:
        print(f"Несподівана помилка: {e}")


# Запуск програми
if __name__ == "__main__":
    main()
