
import java.util.Scanner;
public class Experiment {

    /**
     * Метод обчислює суму чисел Аліси та Боба через N секунд.
     * @param A Початкове число Аліси.
     * @param B Початкове число Боба.
     * @param N Тривалість експерименту в секундах.
     * @return Сума чисел Аліси та Боба.
     * @throws IllegalArgumentException Якщо числа виходять за межі умов задачі.
     */
    public static long calculateSum(long A, long B, long N) {
        if (A < 1 || B < 1 || N < 1 || A > 1_000_000_000 || B > 1_000_000_000 || N > 1_000_000_000) {
            throw new IllegalArgumentException("Числа мають бути у межах 1 ≤ A, B, N ≤ 10^9.");
        }
        return A + B + 2 * N;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        try {
            // Зчитування вхідних даних
            System.out.print("Введіть число A (згенероване Алісою): ");
            long A = scanner.nextLong();
            System.out.print("Введіть число B (згенероване Бобом): ");
            long B = scanner.nextLong();
            System.out.print("Введіть тривалість експерименту N (у секундах): ");
            long N = scanner.nextLong();

            // Виклик методу та виведення результату
            long result = calculateSum(A, B, N);
            System.out.println("Сума чисел Аліси та Боба через " + N + " секунд: " + result);
        } catch (IllegalArgumentException e) {
            System.err.println("Помилка: " + e.getMessage());
        } catch (Exception e) {
            System.err.println("Несподівана помилка: " + e.getMessage());
        } finally {
            scanner.close(); // Закриття сканера
        }
    }
}
