#include <iostream>
#include <queue>
#include <set>
using namespace std;

struct State {
    int alice_pos, bob_pos, time;
};

int min_seconds_to_meet(int N) {
    // Черга для зберігання станів (позиція Аліси, позиція Боба, час)
    queue<State> q;
    set<pair<int, int>> visited;
    
    // Початкові умови: Аліса на позиції 1, Боб на позиції N, час = 0
    q.push({1, N, 0});
    visited.insert({1, N});

    while (!q.empty()) {
        State current = q.front();
        q.pop();
        
        // Якщо Аліса та Боб знаходяться в однаковому боксі
        if (current.alice_pos == current.bob_pos) {
            return current.time;
        }
        
        // Можливі рухи Аліси та Боба
        // Аліса може рухатися на k+2 або k+3
        int alice_moves[] = {current.alice_pos + 2, current.alice_pos + 3};
        
        // Боб може рухатися на k-1 або k-2
        int bob_moves[] = {current.bob_pos - 1, current.bob_pos - 2};
        
        // Перевіряємо всі можливі рухи Аліси та Боба
        for (int alice_new : alice_moves) {
            for (int bob_new : bob_moves) {
                // Перевіряємо чи не виходить за межі боксів
                if (alice_new > 0 && alice_new <= N && bob_new > 0 && bob_new <= N) {
                    if (visited.find({alice_new, bob_new}) == visited.end()) {
                        visited.insert({alice_new, bob_new});
                        q.push({alice_new, bob_new, current.time + 1});
                    }
                }
            }
        }
    }
    
    // Якщо неможливо зустрітися
    return -1;
}

int main() {
    int N;
    cin >> N;  // Вхід: кількість боксів
    
    // Виведення мінімальної кількості секунд для зустрічі
    cout << min_seconds_to_meet(N) << endl;
    return 0;
}
