#include <iostream>
#include <queue>
#include <set>
using namespace std;

int min_time_to_meet(int n) {
    // Черга для BFS: кожен елемент містить (позиція Аліси, позиція Боба, час)
    queue<tuple<int, int, int>> q;
    // Початкові умови: Аліса в боксі 1, Боб в боксі N, час 0
    q.push(make_tuple(1, n, 0));
    
    // Множина для перевірки відвіданих пар (alice_pos, bob_pos)
    set<pair<int, int>> visited;
    visited.insert(make_pair(1, n));
    
    while (!q.empty()) {
        // Витягуємо з черги
        auto [alice_pos, bob_pos, time] = q.front();
        q.pop();
        
        // Якщо Аліса та Боб знаходяться в одному боксі
        if (alice_pos == bob_pos) {
            return time;
        }

        // Рухи Аліси: на 2 або 3 позиції вперед
        int next_alice_moves[] = {alice_pos + 2, alice_pos + 3};
        for (int next_alice_pos : next_alice_moves) {
            if (next_alice_pos >= 1 && next_alice_pos <= n && visited.find({next_alice_pos, bob_pos}) == visited.end()) {
                q.push(make_tuple(next_alice_pos, bob_pos, time + 1));
                visited.insert({next_alice_pos, bob_pos});
            }
        }

        // Рухи Боба: на 1 або 2 позиції назад
        int next_bob_moves[] = {bob_pos - 1, bob_pos - 2};
        for (int next_bob_pos : next_bob_moves) {
            if (next_bob_pos >= 1 && next_bob_pos <= n && visited.find({alice_pos, next_bob_pos}) == visited.end()) {
                q.push(make_tuple(alice_pos, next_bob_pos, time + 1));
                visited.insert({alice_pos, next_bob_pos});
            }
        }
    }

    return -1;  // Якщо Аліса та Боб не можуть зустрітися
}

int main() {
    int N;
    cin >> N;  // Вхід: кількість боксів
    
    // Виведення мінімальної кількості секунд для зустрічі
    cout << min_time_to_meet(N) << endl;
    return 0;
}