#include <iostream>
#include <queue>
#include <unordered_set>
#include <utility>

using namespace std;

int min_time_to_meet(int N) {
    // Черга для BFS: (позиція Аліси, позиція Боба, кількість секунд)
    queue<pair<pair<int, int>, int>> q;
    unordered_set<string> visited;  // для уникнення циклів

    // Початкові позиції Аліси та Боба
    q.push({{1, N}, 0});
    visited.insert("1_" + to_string(N));

    while (!q.empty()) {
        auto front = q.front();
        int alice_pos = front.first.first;
        int bob_pos = front.first.second;
        int time = front.second;
        q.pop();

        // Перевірка на зустріч
        if (alice_pos == bob_pos) {
            return time;
        }

        // Можливі позиції Аліси
        int next_alice_positions[] = {alice_pos + 2, alice_pos + 3};
        for (int next_alice_pos : next_alice_positions) {
            if (next_alice_pos <= N && visited.find(to_string(next_alice_pos) + "_" + to_string(bob_pos)) == visited.end()) {
                visited.insert(to_string(next_alice_pos) + "_" + to_string(bob_pos));
                q.push({{next_alice_pos, bob_pos}, time + 1});
            }
        }

        // Можливі позиції Боба
        int next_bob_positions[] = {bob_pos - 1, bob_pos - 2};
        for (int next_bob_pos : next_bob_positions) {
            if (next_bob_pos >= 1 && visited.find(to_string(alice_pos) + "_" + to_string(next_bob_pos)) == visited.end()) {
                visited.insert(to_string(alice_pos) + "_" + to_string(next_bob_pos));
                q.push({{alice_pos, next_bob_pos}, time + 1});
            }
        }
    }

    return -1;  // Якщо не знайшли можливості для зустрічі
}

int main() {
    int N;
    cin >> N;  // Вхідне значення N
    int result = min_time_to_meet(N);
    cout << result << endl;  // Вивести результат
    return 0;
}
