#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;

    // Вхідні дані: матриця кольорів (0 - синій, 1 - червоний)
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int squareCount = 0;

    // Перевірка всіх можливих квадратів, у яких всі чотири вершини однакові
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            // Розглядаємо всі можливі квадрати з початком в точці (i, j)
            for (int size = 1; size < N; ++size) {
                // Квадрати будуть з вершинами в (i, j), (i+size, j), (i, j+size), (i+size, j+size)
                if (i + size < N && j + size < N) {
                    int color = grid[i][j];
                    if (grid[i + size][j] == color && grid[i][j + size] == color && grid[i + size][j + size] == color) {
                        ++squareCount;
                    }
                }
            }
        }
    }

    cout << squareCount << endl;

    return 0;
}

