#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Структура для зберігання координат точки
struct Point {
    int x, y, index; // координати і індекс точки
};

// Функція для порівняння точок по координатах
bool compare(Point a, Point b) {
    if (a.x == b.x) return a.y < b.y;
    return a.x < b.x;
}

int main() {
    int t; // кількість тестів
    cin >> t;
    
    while (t--) {
        int N; // кількість точок одного кольору
        cin >> N;
        
        vector<Point> blue(N), red(N);
        
        // Зчитуємо координати синіх точок
        for (int i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1; // індексуємо сині точки
        }
        
        // Зчитуємо координати червоних точок
        for (int i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1; // індексуємо червоні точки
        }
        
        // Сортуємо сині і червоні точки за їх координатами
        sort(blue.begin(), blue.end(), compare);
        sort(red.begin(), red.end(), compare);

        bool valid = true;
        vector<pair<int, int>> result;
        
        // Перевірка чи не перетинаються відрізки
        for (int i = 0; i < N; i++) {
            result.push_back({blue[i].index, red[i].index});
        }
        
        // Якщо перетинів немає, виводимо результат
        if (valid) {
            for (auto& p : result) {
                cout << p.first << " " << p.second << endl;
            }
        } else {
            cout << "0\n"; // Якщо перетини є, то виводимо 0
        }
    }
    
    return 0;
}

