from collections import deque

def min_seconds_to_meet(N):
    if N == 2:
        return -1  # Alice and Bob cannot meet if there are only 2 boxes

    alice_positions = deque([(1, 0)])  # (position, time)
    bob_positions = deque([(N, 0)])  # (position, time)
    
    alice_visited = set([1])
    bob_visited = set([N])
    
    while alice_positions and bob_positions:
        # Process Alice's moves
        for _ in range(len(alice_positions)):
            alice_pos, alice_time = alice_positions.popleft()
            for next_pos in (alice_pos + 2, alice_pos + 3):
                if next_pos <= N and next_pos not in alice_visited:
                    if next_pos in bob_visited:
                        return alice_time + 1
                    alice_positions.append((next_pos, alice_time + 1))
                    alice_visited.add(next_pos)
        
        # Process Bob's moves
        for _ in range(len(bob_positions)):
            bob_pos, bob_time = bob_positions.popleft()
            for next_pos in (bob_pos - 1, bob_pos - 2):
                if next_pos >= 1 and next_pos not in bob_visited:
                    if next_pos in alice_visited:
                        return bob_time + 1
                    bob_positions.append((next_pos, bob_time + 1))
                    bob_visited.add(next_pos)
    
    return -1  # If no common position is found

# Read input
N = int(input().strip())
print(min_seconds_to_meet(N))