from itertools import combinations

def is_square(p1, p2, p3, p4):
    dists = sorted([
        (p1[0] - p2[0]) ** 2 + (p1[1] - p2[1]) ** 2,
        (p1[0] - p3[0]) ** 2 + (p1[1] - p3[1]) ** 2,
        (p1[0] - p4[0]) ** 2 + (p1[1] - p4[1]) ** 2,
        (p2[0] - p3[0]) ** 2 + (p2[1] - p3[1]) ** 2,
        (p2[0] - p4[0]) ** 2 + (p2[1] - p4[1]) ** 2,
        (p3[0] - p4[0]) ** 2 + (p3[1] - p4[1]) ** 2
    ])
    return dists[0] > 0 and dists[0] == dists[1] == dists[2] == dists[3] and dists[4] == dists[5]

n = int(input())
grid = [list(map(int, input().split())) for _ in range(n)]

points = [(i, j) for i in range(n) for j in range(n)]
count = 0

for p1, p2, p3, p4 in combinations(points, 4):
    if grid[p1[0]][p1[1]] == grid[p2[0]][p2[1]] == grid[p3[0]][p3[1]] == grid[p4[0]][p4[1]]:
        if is_square(p1, p2, p3, p4):
            count += 1

print(count)