def can_connect(p1, p2, p3, p4):

    def cross(o, a, b):
        return (a[0] - o[0]) * (b[1] - o[1]) - (a[1] - o[1]) * (b[0] - o[0])
    
    return (cross(p1, p3, p4) * cross(p2, p3, p4) < 0) and (cross(p3, p1, p2) * cross(p4, p1, p2) < 0)

def solve():
    t = int(input())  
    for _ in range(t):
        N = int(input()) 
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        
        blue_points = sorted(blue_points)
        red_points = sorted(red_points)
        
        
        pairs = []
        for i in range(N):
            pairs.append((i + 1, i + 1))  
        
        is_possible = True
        for i in range(N):
            for j in range(i + 1, N):
                if can_connect(blue_points[i], red_points[i], blue_points[j], red_points[j]):
                    is_possible = False
                    break
            if not is_possible:
                break
        
        if is_possible:
            for pair in pairs:
                print(pair[0], pair[1])
        else:
            print(0)

solve()
