from collections import deque

def min_time_to_meet(N):
    visited_alice = [False] * (N + 1)  
    visited_bob = [False] * (N + 1)   
    queue_alice = deque([(1, 0)]) 
    queue_bob = deque([(N, 0)])    
    visited_alice[1] = True
    visited_bob[N] = True

    while queue_alice and queue_bob:
        if queue_alice:
            x, time = queue_alice.popleft()
            for next_position in [x + 2, x + 3]:
                if 1 <= next_position <= N and not visited_alice[next_position]:
                    visited_alice[next_position] = True
                    queue_alice.append((next_position, time + 1))
                    if visited_bob[next_position]:
                        return time + 1
        if queue_bob:
            x, time = queue_bob.popleft()
            for next_position in [x - 1, x - 2]:
                if 1 <= next_position <= N and not visited_bob[next_position]:
                    visited_bob[next_position] = True
                    queue_bob.append((next_position, time + 1))
                    if visited_alice[next_position]:
                        return time + 1
    
    return -1 

N = int(input())
print(min_time_to_meet(N))
