def meet(N):
  """
  Функция определяет, встретятся ли два объекта.

  Args:
    N: Начальная позиция второго объекта.

  Returns:
    Минимальное количество шагов до встречи или -1, если встречи не будет.
  """

  # Множества для позиций объектов
  pos1 = {1}
  pos2 = {N}

  steps = 0
  while pos1 and pos2:
    steps += 1
    # Расширяем множества возможных позиций
    new_pos1 = set(p + i for p in pos1 for i in [2, 3])
    new_pos2 = set(p - i for p in pos2 for i in [1, 2])
    # Проверяем на пересечение
    if new_pos1 & new_pos2:
      return steps
    pos1, pos2 = new_pos1, new_pos2
  return -1

# Пример использования
N = int(input())
result = meet(N)
if result == -1:
  print(result)
else:
  print( result)