from collections import deque

def min_time_to_meet(n):
    if n <= 1:  
        return 0
    if n == 2:
        return -1

    q = deque([(1, n, 0)])
    visited = set()
    visited.add((1, n))

    while q:
        alice_pos, bob_pos, time = q.popleft()

        if alice_pos == bob_pos:
            return time

        # Alice's moves
        next_alice_moves = [alice_pos + 2, alice_pos + 3]
        for next_alice_pos in next_alice_moves:
            if 1 <= next_alice_pos <= n and (next_alice_pos, bob_pos) not in visited:
                q.append((next_alice_pos, bob_pos, time + 1))
                visited.add((next_alice_pos, bob_pos))

        next_bob_moves = [bob_pos - 1, bob_pos - 2]
        for next_bob_pos in next_bob_moves:
            if 1 <= next_bob_pos <= n and (alice_pos, next_bob_pos) not in visited:
                q.append((alice_pos, next_bob_pos, time + 1))
                visited.add((alice_pos, next_bob_pos))

    return -1  

print(min_time_to_meet(int(input()))-1)