using System;

class Solution {
    public static void Main() {
        int n = int.Parse(Console.ReadLine());

        // Перевірка на валідність введеного значення N
        if (n >= 2 && n <= 1000000000) {
            int result = Calculation(n);
            Console.WriteLine(result);
        } else {
            Console.WriteLine("N має бути в діапазоні від 2 до 1 000 000 000.");
        }
    }

    public static int Calculation(int N) {
        int a_box = 1; // Початкове місце Аліси
        int b_box = N; // Початкове місце Боба

        // Перевіряємо кількість секунд для можливих зустрічей
        for (int i = 1; i <= N / 2; i++) {
            // Можливі позиції Аліси
            int alice_pos1 = a_box + 2 * i;
            int alice_pos2 = a_box + 3 * i;

            // Можливі позиції Боба
            int bob_pos1 = b_box - i;
            int bob_pos2 = b_box - 2 * i;

            // Перевіряємо, чи є спільна позиція
            if (alice_pos1 == bob_pos1 || alice_pos1 == bob_pos2 ||
                alice_pos2 == bob_pos1 || alice_pos2 == bob_pos2) {
                
                // Перевіряємо чи не виходять позиції за межі допустимих
                if ((alice_pos1 >= 1 && alice_pos1 <= N) || 
                    (alice_pos2 >= 1 && alice_pos2 <= N) || 
                    (bob_pos1 >= 1 && bob_pos1 <= N) || 
                    (bob_pos2 >= 1 && bob_pos2 <= N)) {
                    return i;
                }
            }
        }

        return -1; // Якщо не змогли знайти спільну позицію
    }
}

