using System;

class Solution {
    public static void Main() {
        int n = int.Parse(Console.ReadLine());

        if (n < 2 || n > 1000000000) {
            Console.WriteLine("N має бути в діапазоні від 2 до 1 000 000 000.");
            return;
        }

        int result = FindMinimumTime(n);
        Console.WriteLine(result);
    }

    public static int FindMinimumTime(int N) {
        int alicePos = 1;
        int bobPos = N;

        int seconds = 0;

        while (alicePos <= N && bobPos >= 1) {
            // Можливі позиції Аліси та Боба через 1 секунду
            int[] aliceMoves = { alicePos + 2, alicePos + 3 };
            int[] bobMoves = { bobPos - 1, bobPos - 2 };

            foreach (int aliceMove in aliceMoves) {
                foreach (int bobMove in bobMoves) {
                    if (aliceMove == bobMove) {
                        return seconds + 1;
                    }
                }
            }

            seconds++;

            alicePos = Math.Min(alicePos + 3, N); // Аліса рухається, відпов. до умови
            bobPos = Math.Max(bobPos - 1, 1);    // Боб рухається, відпов. до умови
        }

        // Якщо вони не зустрілися
        return -1;
    }
}

