using System;

class Solution {
    public static void Main() {
        int N = int.Parse(Console.ReadLine());
        int result = FindMinimumTime(N);
        Console.WriteLine(result);
    }

    public static int FindMinimumTime(int N) {
        // Перевірка на мінімальну кількість боксів
        if (N < 2) {
            return -1; // Якщо боксів менше 2, вони не можуть зустрітися
        }

        // Для кожної секунди перевіряємо можливі позиції Аліси та Боба
        for (int t = 0; t <= N; t++) {
            // Позиції Аліси
            int alicePos1 = 1 + 2 * t;  // Аліса може рухатися на 2
            int alicePos2 = 1 + 3 * t;  // Аліса може рухатися на 3

            // Позиції Боба
            int bobPos1 = N - t;        // Боб може рухатися на 1
            int bobPos2 = N - 2 * t;    // Боб може рухатися на 2

            // Перевіряємо чи можуть Аліса та Боб опинитися в одному боксі
            if ((alicePos1 == bobPos1 || alicePos1 == bobPos2) || 
                (alicePos2 == bobPos1 || alicePos2 == bobPos2)) {
                return t;
            }
        }

        // Якщо вони не можуть зустрітися в жоден момент
        return -1;
    }
}
