using System;
using System.Collections.Generic;

class Solution {
    public static void Main() {
        int N = int.Parse(Console.ReadLine());

        if (N < 2 || N > 1000000000) {
            Console.WriteLine("-1");
            return;
        }

        int result = FindMinimumTime(N);
        Console.WriteLine(result);
    }

    public static int FindMinimumTime(int N) {
        HashSet<int> alicePositions = new HashSet<int> { 1 }; // Початкове місце Аліси (1)
        HashSet<int> bobPositions = new HashSet<int> { N };   // Початкове місце Боба (N)
        
        int seconds = 0;

        while (alicePositions.Count > 0 && bobPositions.Count > 0) {
            foreach (var pos in alicePositions) {
                if (bobPositions.Contains(pos)) {
                    return seconds;
                }
            }

            HashSet<int> newAlicePositions = new HashSet<int>();
            foreach (var pos in alicePositions) {
                if (pos + 2 <= N) newAlicePositions.Add(pos + 2);
                if (pos + 3 <= N) newAlicePositions.Add(pos + 3);
            }

            HashSet<int> newBobPositions = new HashSet<int>();
            foreach (var pos in bobPositions) {
                if (pos - 1 >= 1) newBobPositions.Add(pos - 1);
                if (pos - 2 >= 1) newBobPositions.Add(pos - 2);
            }

            foreach (var pos in newAlicePositions) {
                if (newBobPositions.Contains(pos)) {
                    return seconds + 1;
                }
            }

            alicePositions = newAlicePositions;
            bobPositions = newBobPositions;
            seconds++;
        }

        return -1; // Якщо не знайдено спільної позиції
    }
}
