using System;
using System.Linq;

class Program
{
    // Структура для зберігання координат точки і її індексу
    public struct Point
    {
        public int x, y, index;
        public Point(int x, int y, int index)
        {
            this.x = x;
            this.y = y;
            this.index = index;
        }
    }

    static void Main()
    {
        // Зчитуємо кількість тестових блоків
        int t = int.Parse(Console.ReadLine());
        
        for (int test = 0; test < t; test++)
        {
            int N = int.Parse(Console.ReadLine()); // Кількість точок одного кольору

            // Массиви для зберігання синіх та червоних точок
            Point[] bluePoints = new Point[N];
            Point[] redPoints = new Point[N];

            // Зчитуємо координати синіх точок
            for (int i = 0; i < N; i++)
            {
                var coords = Console.ReadLine().Split();
                bluePoints[i] = new Point(int.Parse(coords[0]), int.Parse(coords[1]), i + 1);
            }

            // Зчитуємо координати червоних точок
            for (int i = 0; i < N; i++)
            {
                var coords = Console.ReadLine().Split();
                redPoints[i] = new Point(int.Parse(coords[0]), int.Parse(coords[1]), i + 1);
            }

            // Сортуємо точки за координатами
            var sortedBluePoints = bluePoints.OrderBy(p => p.x).ThenBy(p => p.y).ToArray();
            var sortedRedPoints = redPoints.OrderBy(p => p.x).ThenBy(p => p.y).ToArray();

            // Виводимо індекси з'єднаних точок
            for (int i = 0; i < N; i++)
            {
                Console.WriteLine($"{sortedBluePoints[i].index} {sortedRedPoints[i].index}");
            }
        }
    }
}
