#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;

struct State {
    int position;
    int time;
};
int minTimeToMeet(int N) {
    // Черги для Аліси і Боба
    queue<State> aliceQueue, bobQueue;
    unordered_set<int> visitedAlice, visitedBob;
    
    // Початкові позиції
    aliceQueue.push({1, 0});
    bobQueue.push({N, 0});
    
    visitedAlice.insert(1);
    visitedBob.insert(N);
    
    // BFS для Аліси та Боба
    while (!aliceQueue.empty() || !bobQueue.empty()) {
        // Рухаємо Алісу
        int aliceSize = aliceQueue.size();
        while (aliceSize--) {
            State currentAlice = aliceQueue.front();
            aliceQueue.pop();
            
            // Якщо Аліса потрапила на бокс, де є Боб
            if (visitedBob.find(currentAlice.position) != visitedBob.end()) {
                return currentAlice.time;
            }
            
            // Додаємо нові можливі позиції для Аліси
            for (int move : {currentAlice.position + 2, currentAlice.position + 3}) {
                if (move <= N && visitedAlice.find(move) == visitedAlice.end()) {
                    visitedAlice.insert(move);
                    aliceQueue.push({move, currentAlice.time + 1});
                }
            }
        }
        
        // Рухаємо Боба
        int bobSize = bobQueue.size();
        while (bobSize--) {
            State currentBob = bobQueue.front();
            bobQueue.pop();
            
            // Якщо Боб потрапив на бокс, де є Аліса
            if (visitedAlice.find(currentBob.position) != visitedAlice.end()) {
                return currentBob.time;
            }
            
            // Додаємо нові можливі позиції для Боба
            for (int move : {currentBob.position - 1, currentBob.position - 2}) {
                if (move >= 1 && visitedBob.find(move) == visitedBob.end()) {
                    visitedBob.insert(move);
                    bobQueue.push({move, currentBob.time + 1});
                }
            }
        }
    }
    
    // Якщо зустріч неможлива
    return -1;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int N;
    cin >> N;
    
    // Виводимо результат
    cout << minTimeToMeet(N) << endl;
    
    return 0;
}
