#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y, index;
    
    // Конструктор
    Point(int x = 0, int y = 0, int index = -1) : x(x), y(y), index(index) {}

    // Оператор для порівняння точок
    bool operator<(const Point &other) const {
        if (x == other.x) return y < other.y;
        return x < other.x;
    }
};

// Головна функція для вирішення кожного тесту
void solve_case(int N, vector<Point>& blue_points, vector<Point>& red_points) {
    // Сортуємо сині точки
    sort(blue_points.begin(), blue_points.end());
    // Сортуємо червоні точки
    sort(red_points.begin(), red_points.end());
    
    // Виводимо результат у вигляді пар (синя точка, червона точка)
    for (int i = 0; i < N; ++i) {
        cout << blue_points[i].index << " " << red_points[i].index << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;  // Кількість тестових випадків
    cin >> t;
    
    while (t--) {
        int N;
        cin >> N;
        
        vector<Point> blue_points(N), red_points(N);
        
        // Вводимо сині точки
        for (int i = 0; i < N; ++i) {
            cin >> blue_points[i].x >> blue_points[i].y;
            blue_points[i].index = i + 1;  // Нумеруємо точки
        }
        
        // Вводимо червоні точки
        for (int i = 0; i < N; ++i) {
            cin >> red_points[i].x >> red_points[i].y;
            red_points[i].index = i + 1;  // Нумеруємо точки
        }
        
        solve_case(N, blue_points, red_points);
    }

    return 0;
}
