from collections import deque
from typing import Set, Tuple

def can_meet(n: int) -> int:
    queue = deque([(1, n, 0)])
    visited = set([(1, n)])
    
    while queue:
        alice_pos, bob_pos, time = queue.popleft()
        
        for alice_move in [2, 3]:
            new_alice = alice_pos + alice_move
            if new_alice > n:
                continue
                
            for bob_move in [1, 2]:
                new_bob = bob_pos - bob_move
                if new_bob < 1:
                    continue
                
                if new_alice == new_bob:
                    return time + 1
                
                if new_alice > new_bob:
                    continue
                new_state = (new_alice, new_bob)
                if new_state not in visited:
                    visited.add(new_state)
                    queue.append((new_alice, new_bob, time + 1))
    
    return -1

def main():
    n = int(input())
    print(can_meet(n))

if __name__ == "__main__":
    main()
