def find_stamps(n: int, target_sum: int) -> list[int]:
    """Find minimum number of stamps that sum to target_sum."""

    max_possible_sum = (n * (n + 1)) // 2
    if target_sum > max_possible_sum:
        return [0]
    
    result = []
    current_sum = 0
    current_stamp = n
    
    while current_sum < target_sum and current_stamp > 0:
        if current_sum + current_stamp <= target_sum:
            result.append(current_stamp)
            current_sum += current_stamp
        current_stamp -= 1
    
    return result if current_sum == target_sum else [0]

def main():

    n = int(input())
    m = int(input())
    
    result = find_stamps(n, m)
    
    print(*result)

if __name__ == "__main__":
    main()
