def find_stamps(n: int, target_sum: int) -> list[int]:
    """Find minimum number of stamps that sum to target_sum."""

    max_possible_sum = (n * (n + 1)) // 2
    if target_sum > max_possible_sum:
        return [0]
    
    result = []
    current_sum = 0
    current_stamp = n
    
    while current_sum < target_sum and current_stamp > 0:
        if current_sum + current_stamp <= target_sum:
            result.append(current_stamp)
            current_sum += current_stamp
        current_stamp -= 1
    
    return result if current_sum == target_sum else [0]

def main():

    n = int(input())
    m = int(input())
    
    result = find_stamps(n, m)
    
    print(*result)

if __name__ == "__main__":
    main()
def can_meet(n: int) -> int:
    queue = deque([(1, n, 0)])
    visited = set([(1, n)])
    
    while queue:
        alice_pos, bob_pos, time = queue.popleft()
        if n <= 10:  # Debug print for small n
            print(f"Time {time}: Alice at {alice_pos}, Bob at {bob_pos}")
        # ... rest of the code
assert can_meet(5) == 1  # Example 1
assert can_meet(9) == 2  # Example 2
assert can_meet(2) == -1  # Too close
assert can_meet(1000) != -1  # Large input
