def solve(test_cases):
    results = []
    for n, blue_points, red_points in test_cases:
        pairs = []
        for i in range(n):
            for j in range(n):
                dist = (blue_points[i][0] - red_points[j][0]) ** 2 + (blue_points[i][1] - red_points[j][1]) ** 2
                pairs.append((dist, i + 1, j + 1))

        pairs.sort()
        used_blue = [False] * n
        used_red = [False] * n
        solution = []

        for _, blue, red in pairs:
            if not used_blue[blue - 1] and not used_red[red - 1]:
                solution.append((blue, red))
                used_blue[blue - 1] = True
                used_red[red - 1] = True
                if len(solution) == n:
                    break

        if len(solution) != n:
            results.append([0])
        else:
            results.append(solution)
    
    return results

def read_input():
    import sys
    input = sys.stdin.read
    data = input().split()
    idx = 0
    t = int(data[idx])
    idx += 1
    test_cases = []
    for _ in range(t):
        n = int(data[idx])
        idx += 1
        blue_points = []
        for _ in range(n):
            x = int(data[idx])
            y = int(data[idx + 1])
            blue_points.append((x, y))
            idx += 2
        red_points = []
        for _ in range(n):
            x = int(data[idx])
            y = int(data[idx + 1])
            red_points.append((x, y))
            idx += 2
        test_cases.append((n, blue_points, red_points))
    return test_cases

def main():
    test_cases = read_input()
    results = solve(test_cases)
    for result in results:
        if result == [0]:
            print(0)
        else:
            for blue, red in result:
                print(blue, red)

if __name__ == "__main__":
    main()
