def do_segments_intersect(p1, p2, p3, p4):
    o1 = (p2[0] - p1[0]) * (p3[1] - p1[1]) - (p3[0] - p1[0]) * (p2[1] - p1[1])
    o2 = (p2[0] - p1[0]) * (p4[1] - p1[1]) - (p4[0] - p1[0]) * (p2[1] - p1[1])
    o3 = (p4[0] - p3[0]) * (p1[1] - p3[1]) - (p1[0] - p3[0]) * (p4[1] - p3[1])
    o4 = (p4[0] - p3[0]) * (p2[1] - p3[1]) - (p2[0] - p3[0]) * (p4[1] - p3[1])
    
    return (o1 * o2 < 0) and (o3 * o4 < 0)

def is_valid_matching(matching, blue, red):
    n = len(matching)
    for i in range(n):
        for j in range(i + 1, n):
            p1 = blue[matching[i][0] - 1]
            p2 = red[matching[i][1] - 1]
            p3 = blue[matching[j][0] - 1]
            p4 = red[matching[j][1] - 1]
            
            if do_segments_intersect(p1, p2, p3, p4):
                return False
    return True

def solve_test_case():
    n = int(input())
    
    blue = []
    red = []
    
    for i in range(n):
        x, y = map(int, input().split())
        blue.append((x, y))
        for i in range(n):
        x, y = map(int, input().split())
        red.append((x, y))
    
    from itertools import permutations
    
    for perm in permutations(range(1, n + 1)):
        matching = [(i + 1, p) for i, p in enumerate(perm)]
        if is_valid_matching(matching, blue, red):
            for match in matching:
                print(match[0], match[1])
            return
    
    print("0")

def main():
    t = int(input())
    for _ in range(t):
        solve_test_case()

if __name__ == "__main__":
    main()
