#include <iostream>
#include <queue>
#include <set>
using namespace std;

struct State {
    long long posA;
    long long posB;
    long long time;

    State(int a, int b, int t) : posA(a), posB(b), time(t) {}
};

long long mintime(long long N) {
    queue<State> q;
    q.push(State(1, N, 0));
    set<pair<long long, long long>> visited;
    visited.insert({1, N});

    while (!q.empty()) {
        State current = q.front();
        q.pop();

        if (current.posA == current.posB) {
            return current.time;
        }

        vector<int> newPositionsA = {current.posA + 2, current.posA + 3};
        vector<int> newPositionsB = {current.posB - 1, current.posB - 2};

        for (int newA : newPositionsA) {
            if (newA <= N) {
                for (int newB : newPositionsB) {
                    if (newB >= 1 && visited.find({newA, newB}) == visited.end()) {
                        visited.insert({newA, newB});
                        q.push(State(newA, newB, current.time + 1));
                    }
                }
            }
        }
    }

    return -1;
}

int main() {
    long long N;
    cin >> N;
    int result = mintime(N);
    cout << result << endl;
    return 0;
}
