#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;
struct State {
    long long posA;
    long long posB;
    long long time;
    State(long long a, long long b, long long t) : posA(a), posB(b), time(t) {} 
    bool operator==(const State& other) const {
        return posA == other.posA && posB == other.posB;
    }
};
struct StateHash {
    size_t operator()(const State& s) const {
        return hash<long long>()(s.posA) ^ hash<long long>()(s.posB);
    }
};
long long mintime(long long N) {
    queue<State> q;
    q.push(State(1, N, 0));
    unordered_set<State, StateHash> visited;
    visited.insert(State(1, N, 0));
    while (!q.empty()) {
        State current = q.front();
        q.pop();
        if (current.posA == current.posB) {
            return current.time;
        }
        long long newPositionsA[] = {current.posA + 2, current.posA + 3};
        long long newPositionsB[] = {current.posB - 1, current.posB - 2};
        for (long long newA : newPositionsA) {
            if (newA <= N) {
                for (long long newB : newPositionsB) {
                    if (newB >= 1) {
                        State newState(newA, newB, current.time + 1);
                        if (visited.find(newState) == visited.end()) {
                            visited.insert(newState);
                            q.push(newState);
                        }
                    }
                }
            }
        }
    }

    return -1;
}
int main() {
    long long N;
    cin >> N;
    long long result = mintime(N);
    cout << result << endl;
    return 0;
}
