#include <iostream>
#include <queue>
#include <unordered_set>

using namespace std;
int min_seconds_to_meet(int N) {
    if (N < 2) return -1;
    queue<pair<int, int>> q;
    unordered_set<int> visited;
    q.push({1, N});
    visited.insert(1 * N + N);  
    int seconds = 0;
    while (!q.empty()) {
        int size = q.size();
        for (int i = 0; i < size; ++i) {
            auto current = q.front();
            q.pop();
            int alice = current.first;
            int bob = current.second;
            if (alice == bob) return seconds;
            vector<int> alice_moves = {alice + 2, alice + 3};
            vector<int> bob_moves = {bob - 1, bob - 2};
            for (int a : alice_moves) {
                for (int b : bob_moves) {
                    if (a > 0 && a <= N && b > 0 && b <= N && visited.find(a * N + b) == visited.end()) {
                        q.push({a, b});
                        visited.insert(a * N + b);
                    }
                }
            }
        }
        ++seconds;
    }
    return -1;
}
int main() {
    int N;
    cin >> N;
    int result = min_seconds_to_meet(N);
    if (result == -1) {
        cout << -1 << endl;
    } else {
        cout << result << endl;
    }

    return 0;
}
