#include <iostream>
#include <queue>
#include <unordered_set>

using namespace std;

int min_seconds_to_meet(int N) {
    if (N < 2) return -1;
    const int MAX_STEP = 1000;
    unordered_set<int> aliceVisited, bobVisited;
    queue<pair<int, int>> aliceQueue, bobQueue;
    aliceQueue.push({1, 0});
    bobQueue.push({N, 0});
    aliceVisited.insert(1);
    bobVisited.insert(N);
    while (!aliceQueue.empty() && !bobQueue.empty()) {
        if (!aliceQueue.empty()) {
            auto [alicePos, aliceStep] = aliceQueue.front();
            aliceQueue.pop();
            if (bobVisited.count(alicePos)) return aliceStep;
            for (int newPos : {alicePos + 2, alicePos + 3}) {
                if (newPos <= N && aliceVisited.count(newPos) == 0) {
                    aliceQueue.push({newPos, aliceStep + 1});
                    aliceVisited.insert(newPos);
                }
            }
        }
        if (!bobQueue.empty()) {
            auto [bobPos, bobStep] = bobQueue.front();
            bobQueue.pop();
            if (aliceVisited.count(bobPos)) return bobStep;
            for (int newPos : {bobPos - 1, bobPos - 2}) {
                if (newPos >= 1 && bobVisited.count(newPos) == 0) {
                    bobQueue.push({newPos, bobStep + 1});
                    bobVisited.insert(newPos);
                }
            }
        }
    }
    return -1;
}
int main() {
    int N;
    cin >> N;
    int result = min_seconds_to_meet(N);
    if (result == -1) {
    } else {
        cout  << result << endl;
    }
    
    return 0;
}
