#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;
int minTime(int N) {
    queue<pair<int, int>> aliceQueue, bobQueue;
    unordered_set<int> aliceVisited, bobVisited;
    aliceQueue.push({1, 0}); 
    bobQueue.push({N, 0}); 
    aliceVisited.insert(1);
    bobVisited.insert(N);
    while (!aliceQueue.empty() || !bobQueue.empty()) {
        if (!aliceQueue.empty()) {
            auto [alicePos, time] = aliceQueue.front();
            aliceQueue.pop();
            if (bobVisited.count(alicePos)) {
                return time;
            }
            for (int delta : {2, 3}) {
                int newPos = alicePos + delta;
                if (newPos <= N && !aliceVisited.count(newPos)) {
                    aliceVisited.insert(newPos);
                    aliceQueue.push({newPos, time + 1});
                }
            }
        }
        if (!bobQueue.empty()) {
            auto [bobPos, time] = bobQueue.front();
            bobQueue.pop();
            if (aliceVisited.count(bobPos)) {
                return time;
            }
            for (int delta : {-1, -2}) {
                int newPos = bobPos + delta;
                if (newPos >= 1 && !bobVisited.count(newPos)) {
                    bobVisited.insert(newPos);
                    bobQueue.push({newPos, time + 1});
                }
            }
        }
    }
    return -1; 
}
int main() {
    int N;
    cin >> N;
    int result = minTime(N);
    cout << result << endl;
    return 0;
}
