#include <iostream>
#include <queue>
#include <vector>
using namespace std;

long long findMeetingTime(long long N) {
    if (N == 1) return 0; 
    vector<bool> aliceVisited(N + 1, false), bobVisited(N + 1, false);
    queue<long long> aliceQueue, bobQueue;
    aliceQueue.push(1);
    bobQueue.push(N);
    aliceVisited[1] = true;
    bobVisited[N] = true;
    long long t = 0;
    while (!aliceQueue.empty() || !bobQueue.empty()) {
        t++;
        long long sizeA = aliceQueue.size();
        for (long long i = 0; i < sizeA; ++i) {
            long long alicePos = aliceQueue.front();
            aliceQueue.pop();
            for (long long newPos : {alicePos + 2, alicePos + 3}) {
                if (newPos > N) continue;
                if (bobVisited[newPos]) {
                    return t;
                }
                if (!aliceVisited[newPos]) {
                    aliceQueue.push(newPos);
                    aliceVisited[newPos] = true;
                }
            }
        }
        long long sizeB = bobQueue.size();
        for (long long i = 0; i < sizeB; ++i) {
            long long bobPos = bobQueue.front();
            bobQueue.pop();
            for (long long newPos : {bobPos - 1, bobPos - 2}) {
                if (newPos < 1) continue;
                if (aliceVisited[newPos]) {
                    return t;
                }
                if (!bobVisited[newPos]) {
                    bobQueue.push(newPos);
                    bobVisited[newPos] = true;
                }
            }
        }
    }
    return -1;
}
int main() {
    long long N;
    cin >> N;
    cout << findMeetingTime(N) << endl;
    return 0;
}