#include <iostream>
#include <unordered_map>
#include <vector>
#include <string>

using namespace std;
typedef pair<int, int> Point;
struct PointHash {
    size_t operator()(const Point& p) const {
        return hash<int>()(p.first) ^ hash<int>()(p.second);
    }
};
int countMonochromaticSquares(int N, const unordered_map<Point, string, PointHash>& colors) {
    int count = 0;
    for (int x1 = 0; x1 < N; ++x1) {
        for (int y1 = 0; y1 < N; ++y1) {
            for (int size = 1; size <= N - max(x1, y1); ++size) {
                int x2 = x1 + size, y2 = y1;
                int x3 = x1, y3 = y1 + size;
                int x4 = x1 + size, y4 = y1 + size;
                if (colors.at({x1, y1}) == colors.at({x2, y2}) &&
                    colors.at({x2, y2}) == colors.at({x3, y3}) &&
                    colors.at({x3, y3}) == colors.at({x4, y4})) {
                    ++count;
                }
            }
        }
    }
    return count;
}
int main() {
    int N = 3;
    unordered_map<Point, string, PointHash> colors = {
        {{0, 0}, "red"}, {{1, 0}, "red"}, {{2, 0}, "blue"},
        {{0, 1}, "red"}, {{1, 1}, "red"}, {{2, 1}, "blue"},
        {{0, 2}, "blue"}, {{1, 2}, "blue"}, {{2, 2}, "blue"}
    };
    int result = countMonochromaticSquares(N, colors);

    cout << result << endl;

    return 0;
}
