#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
struct Point {
    int x, y, id;
};
bool compare(const Point& a, const Point& b) {
    if (a.x != b.x)
    return a.x < b.x;
    return a.y < b.y;
}
vector<pair<int, int>> solveTestCase(int N, vector<Point>& blue, vector<Point>& red) {
    sort(blue.begin(), blue.end(), compare);
    sort(red.begin(), red.end(), compare);
    vector<pair<int, int>> result;
    for (int i = 0; i < N; ++i) {
        result.push_back({blue[i].id, red[i].id});
    }
    return result;
}
int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);
        for (int i = 0; i < N; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].id = i + 1;
        }
        for (int i = 0; i < N; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].id = i + 1;
        }
        vector<pair<int, int>> result = solveTestCase(N, blue, red);
        for (const auto& pair : result) {
            cout << pair.first << " " << pair.second << endl;
        }
    }
    return 0;
}
