#include <iostream>
#include <queue>
#include <unordered_set>

using namespace std;

// BFS для поиска минимального времени встречи
int find_meeting_time(int N) {
    // Начальные позиции
    int alice_start = 1;
    int bob_start = N;

    // Если начальная позиция Алисы совпадает с позицией Боба
    if (alice_start == bob_start) return 0;

    // Очереди для BFS (позиция, время)
    queue<pair<int, int>> alice_queue, bob_queue;
    alice_queue.push({alice_start, 0});
    bob_queue.push({bob_start, 0});

    // Посещенные позиции для Алисы и Боба
    unordered_set<int> alice_visited, bob_visited;
    alice_visited.insert(alice_start);
    bob_visited.insert(bob_start);

    // BFS
    while (!alice_queue.empty() && !bob_queue.empty()) {
        // Обрабатываем шаг Алисы
        auto [alice_pos, alice_time] = alice_queue.front();
        alice_queue.pop();

        // Обрабатываем возможные движения Алисы
        for (int next_pos : {alice_pos + 2, alice_pos + 3}) {
            if (next_pos > N) continue; // За пределами
            if (bob_visited.count(next_pos)) {
                return alice_time + 1; // Встретились
            }
            if (!alice_visited.count(next_pos)) {
                alice_visited.insert(next_pos);
                alice_queue.push({next_pos, alice_time + 1});
            }
        }

        // Обрабатываем шаг Боба
        auto [bob_pos, bob_time] = bob_queue.front();
        bob_queue.pop();

        // Обрабатываем возможные движения Боба
        for (int next_pos : {bob_pos - 1, bob_pos - 2}) {
            if (next_pos < 1) continue; // За пределами
            if (alice_visited.count(next_pos)) {
                return bob_time + 1; // Встретились
            }
            if (!bob_visited.count(next_pos)) {
                bob_visited.insert(next_pos);
                bob_queue.push({next_pos, bob_time + 1});
            }
        }
    }

    // Если невозможно встретиться
    return -1;
}

int main() {
    int N;
    cin >> N;

    cout << find_meeting_time(N) << endl;

    return 0;
}
