#include <iostream>
using namespace std;

int find_meeting_time(int N) {
    // Если N < 2, встреча невозможна
    if (N < 2) return -1;

    // Решение сравнения 3t ≡ (N - 1) (mod 5)
    int remainder = (N - 1) % 5;
    if (remainder < 0) remainder += 5; // Приводим к положительному остатку

    // Умножаем на обратный элемент 3 по модулю 5 (это 2)
    int t = (2 * remainder) % 5;

    // Проверяем, что встреча возможна
    int alice_pos = 1 + 2 * t;
    int bob_pos = N - t;
    if (alice_pos > bob_pos) return -1;

    return t;
}

int main() {
    int N;
    cin >> N;
    cout << find_meeting_time(N) << endl;
    return 0;
}
