#include <iostream>  
#include <vector>  

using namespace std;  

int main() {  
    int N;  
    cin >> N;  

    // Check for valid N  
    if (N < 2 || N > 50) {  
        cerr << "N must be between 2 and 50." << endl;  
        return 1;  
    }  

    // Зчитування матриці кольорів  
    vector<vector<int>> color(N, vector<int>(N));  
    for (int i = 0; i < N; ++i) {  
        for (int j = 0; j < N; ++j) {  
            cin >> color[i][j];  
            // Ensure color is either 0 or 1  
            if (color[i][j] != 0 && color[i][j] != 1) {  
                cerr << "Invalid color value. Must be 0 (blue) or 1 (red)." << endl;  
                return 1;  
            }  
        }  
    }  

    int count = 0;  

    // Перебір можливих квадратів  
    for (int size = 1; size < N; ++size) { // розмір квадрату (1 до N-1)  
        for (int i = 0; i <= N - size; ++i) { // верхня координата квадрата  
            for (int j = 0; j <= N - size; ++j) { // ліва координата квадрата  
                // Перевіряємо всі 4 вершини  
                int a = color[i][j];                   // (i, j)  
                int b = color[i][j + size];           // (i, j + size)  
                int c = color[i + size][j];           // (i + size, j)  
                int d = color[i + size][j + size];    // (i + size, j + size)  

                // Якщо усі вершини однакові, збільшуємо лічильник  
                if (a == b && b == c && c == d) {  
                    count++;  
                }  
            }  
        }  
    }  

    // Виведення результату  
    cout << count << endl;  

    return 0;  
} 