#include <iostream>
#include <vector>

using namespace std;

int count_same_color_squares(const vector<vector<int>>& matrix) {
    int n = matrix.size();
    int count = 0;

    // Перебір розмірів квадратів від 2 до n
    for (int size = 1; size < n; ++size) {
        for (int i = 0; i <= n - size - 1; ++i) {
            for (int j = 0; j <= n - size - 1; ++j) {
                // Координати вершин квадрата
                int color = matrix[i][j];
                bool is_valid = true;

                // Перевіряємо вершини квадрата
                if (matrix[i][j + size] != color ||   // Верхній правий
                    matrix[i + size][j] != color ||   // Нижній лівий
                    matrix[i + size][j + size] != color) { // Нижній правий
                    is_valid = false;
                }

                if (is_valid) {
                    count++;
                }
            }
        }
    }

    return count;
}

int main() {
    int n;
    cin >> n;

    vector<vector<int>> matrix(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }

    int result = count_same_color_squares(matrix);
    cout << result << endl;

    return 0;
}