def solve(test_cases):
    results = []

    for case in test_cases:
        n, blue_points, red_points = case

        # Сортуємо точки за координатами x (при однакових x сортуємо за y)
        blue_points_sorted = sorted(enumerate(blue_points, start=1), key=lambda x: (x[1][0], x[1][1]))
        red_points_sorted = sorted(enumerate(red_points, start=1), key=lambda x: (x[1][0], x[1][1]))

        # Перевірка на можливість вирішення задачі
        if len(blue_points_sorted) != len(red_points_sorted):
            results.append(0)
            continue

        # Жадібно з'єднуємо точки за порядком після сортування
        pairs = []
        used_red = set()

        for blue in blue_points_sorted:
            min_dist = float('inf')
            chosen_red = None

            for red in red_points_sorted:
                if red[0] in used_red:
                    continue

                dist = (blue[1][0] - red[1][0])**2 + (blue[1][1] - red[1][1])**2
                if dist < min_dist:
                    min_dist = dist
                    chosen_red = red

            if chosen_red:
                pairs.append((blue[0], chosen_red[0]))
                used_red.add(chosen_red[0])

        if len(pairs) == n:
            results.append(pairs)
        else:
            results.append(0)

    return results


def main():
    t = int(input())
    test_cases = []

    for _ in range(t):
        n = int(input())

        blue_points = [tuple(map(int, input().split())) for _ in range(n)]
        red_points = [tuple(map(int, input().split())) for _ in range(n)]

        test_cases.append((n, blue_points, red_points))

    results = solve(test_cases)

    for res in results:
        if res == 0:
            print(0)
        else:
            for b, r in res:
                print(b, r)


if __name__ == "__main__":
    main()
