def solve(test_cases):
    results = []

    for case in test_cases:
        n, blue_points, red_points = case

        # Сортуємо точки за координатами x (при однакових x сортуємо за y)
        blue_points_sorted = sorted(enumerate(blue_points, start=1), key=lambda x: (x[1][0], x[1][1]))
        red_points_sorted = sorted(enumerate(red_points, start=1), key=lambda x: (x[1][0], x[1][1]))

        # З'єднуємо точки за порядком після сортування
        pairs = [(blue[0], red[0]) for blue, red in zip(blue_points_sorted, red_points_sorted)]

        results.append(pairs)

    return results


def main():
    t = int(input())
    test_cases = []

    for _ in range(t):
        n = int(input())

        blue_points = [tuple(map(int, input().split())) for _ in range(n)]
        red_points = [tuple(map(int, input().split())) for _ in range(n)]

        test_cases.append((n, blue_points, red_points))

    results = solve(test_cases)

    for res in results:
        if res == 0:
            print(0)
        else:
            for b, r in res:
                print(b, r)


if __name__ == "__main__":
    main()

