def solve(test_cases):
    def do_segments_intersect(a, b, c, d):
        """
        Перевіряє, чи перетинаються відрізки AB і CD.
        """
        def ccw(p1, p2, p3):
            return (p3[1] - p1[1]) * (p2[0] - p1[0]) > (p2[1] - p1[1]) * (p3[0] - p1[0])

        return ccw(a, c, d) != ccw(b, c, d) and ccw(a, b, c) != ccw(a, b, d)

    results = []

    for case in test_cases:
        n, blue_points, red_points = case

        # Сортуємо точки за координатами x (при однакових x сортуємо за y)
        blue_points_sorted = sorted(enumerate(blue_points, start=1), key=lambda x: (x[1][0], x[1][1]))
        red_points_sorted = sorted(enumerate(red_points, start=1), key=lambda x: (x[1][0], x[1][1]))

        pairs = [(blue[0], red[0]) for blue, red in zip(blue_points_sorted, red_points_sorted)]

        # Перевірка на перетини
        valid = True
        for i in range(len(pairs)):
            for j in range(i + 1, len(pairs)):
                b1, r1 = pairs[i]
                b2, r2 = pairs[j]

                if do_segments_intersect(blue_points[b1 - 1], red_points[r1 - 1], blue_points[b2 - 1], red_points[r2 - 1]):
                    valid = False
                    break
            if not valid:
                break

        if valid:
            results.append(pairs)
        else:
            results.append(0)

    return results


def main():
    t = int(input())
    test_cases = []

    for _ in range(t):
        n = int(input())

        blue_points = [tuple(map(int, input().split())) for _ in range(n)]
        red_points = [tuple(map(int, input().split())) for _ in range(n)]

        test_cases.append((n, blue_points, red_points))

    results = solve(test_cases)

    for res in results:
        if res == 0:
            print(0)
        else:
            for b, r in res:
                print(b, r)


if __name__ == "__main__":
    main()


