def intersects(p1, p2, blue_points, red_points, i, j):
    def ccw(a, b, c):
        return (c[1] - a[1]) * (b[0] - a[0]) > (b[1] - a[1]) * (c[0] - a[0])

    for k in range(len(blue_points)):
        if k != i:
            for l in range(len(red_points)):
                if l != j:
                    if ccw(p1, p2, blue_points[k]) != ccw(p1, p2, red_points[1]) and \
                       ccw(blue_points[k], red_points[1], p1) != ccw(blue_points[k], red_points[1], p2):
                        return True
    return False

def solve(n, blue_points, red_points):
    graph = {}
    for i in range(n):
        graph[i] = []

    for i in range(n):
        graph[i] = []

    for i in range(n):
        for j in range(n):
            if not intersects(blue_points[i], red_points[j], blue_points, red_points, i, j):
                graph[i].append(j)

    matching = []
    for i in range(n):
        for j in graph[i]:
            if j not in matching:
                matching.append(j)
                break

    if len(matching) != n:
        return[0]

    return[(i, matching[i]) for i in range (n)]


if __name__ == "__main__":
    n = 3
    blue_points = [(0, 0), (1,1), (2, 2)]
    red_points = [(0,1), (1, 0), (2, 1)]
    result = solve(n, blue_points, red_points)
    print(result)