from itertools import combinations
def dis_sq(p1, p2):
    return (p1[0] - p2[0])**2 + (p1[1] - p2[1])**2
def is_square(p1, p2, p3, p4):
    dists = [
        dis_sq(p1, p2), dis_sq(p1, p3), dis_sq(p1, p4),
        dis_sq(p2, p3), dis_sq(p2, p4), dis_sq(p3, p4)
    ]
    dists.sort()
  
    return (dists[0] > 0 and
            dists[0] == dists[1] == dists[2] == dists[3] and
            dists[4] == dists[5] and
            dists[4] == 2 * dists[0])

def count_squares(points):
    square_count = 0

    for p1, p2, p3, p4 in combinations(points, 4):
        if is_square(p1, p2, p3, p4):
            square_count += 1

    return square_count

n = int(input())
a = " ".join(input() for _ in range(n))
k = list(map(int, a.split()))
points = []
points2 = []
for i in range(n):
    for j in range(n):
        if k[j + i * n] == 1:
            points.append((i, j))
        else:
            points2.append((i, j))
f_rs = count_squares(points) + count_squares(points2)
print(f_rs)
