#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Структура для зберігання координат точок
struct Point {
    int x, y, index;
};

int main() {
    int t;
    cin >> t;  // Читання кількості тестів
    while (t--) {
        int N;
        cin >> N;  // Читання кількості точок одного кольору

        vector<Point> blue(N), red(N);

        // Читання координат синіх точок
        for (int i = 0; i < N; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;  // Збереження індексу
        }

        // Читання координат червоних точок
        for (int i = 0; i < N; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;  // Збереження індексу
        }

        // Сортуємо точки по координатах (можна по x, а при рівності по y)
        sort(blue.begin(), blue.end(), [](const Point &a, const Point &b) {
            return a.x < b.x || (a.x == b.x && a.y < b.y);
        });
        sort(red.begin(), red.end(), [](const Point &a, const Point &b) {
            return a.x < b.x || (a.x == b.x && a.y < b.y);
        });

        // Виведення пар точок, що будуть з'єднані
        for (int i = 0; i < N; ++i) {
            cout << blue[i].index << " " << red[i].index << endl;
        }
    }
    return 0;
}
