#include <iostream>
#include <vector>
#include <algorithm>

struct Point {
    int x, y, index;
};

bool compare(const Point& a, const Point& b) {
    return a.y < b.y;
}

int main() {
    int t;
    std::cin >> t;

    while (t--) {
        int N;
        std::cin >> N;

        std::vector<Point> blue(N), red(N);
        for (int i = 0; i < N; ++i) {
            std::cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }

        for (int i = 0; i < N; ++i) {
            std::cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        std::sort(blue.begin(), blue.end(), compare);
        std::sort(red.begin(), red.end(), compare);

        std::vector<std::pair<int, int>> pairs;
        for (int i = 0; i < N; ++i) {
            pairs.push_back({blue[i].index, red[i].index});
        }

        for (const auto& p : pairs) {
            std::cout << p.first << " " << p.second << std::endl;
        }
    }

    return 0;
}

