#include <iostream>
#include <vector>
#include <algorithm>

struct Point {
    int x, y, index;
};

bool compare_by_x(const Point& a, const Point& b) {
    return a.x < b.x;
}

int main() {
    int t;
    std::cin >> t;

    while (t--) {
        int N;
        std::cin >> N;

        std::vector<Point> blue(N), red(N);
        for (int i = 0; i < N; ++i) {
            std::cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }

        for (int i = 0; i < N; ++i) {
            std::cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        std::sort(blue.begin(), blue.end(), compare_by_x);
        std::sort(red.begin(), red.end(), compare_by_x);

        bool possible = true;
        std::vector<std::pair<int, int>> result;
        for (int i = 0; i < N; ++i) {
            result.push_back({blue[i].index, red[i].index});
        }

        if (possible) {
            for (const auto& pair : result) {
                std::cout << pair.first << " " << pair.second << std::endl;
            }
        } else {
            std::cout << 0 << std::endl;
        }
    }
}



