#include <iostream>
#include <vector>
#include <algorithm>

struct Point {
    int x, y, index;
    char color; // 'B' for Blue, 'R' for Red
};

bool compare_blue(const Point& a, const Point& b) {
    return a.y < b.y;
}

bool compare_red(const Point& a, const Point& b) {
    return a.y < b.y;
}

int main() {
    int t;
    std::cin >> t;

    while (t--) {
        int N;
        std::cin >> N;

        std::vector<Point> blue(N), red(N);
        for (int i = 0; i < N; ++i) {
            std::cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
            blue[i].color = 'B';
        }

        for (int i = 0; i < N; ++i) {
            std::cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
            red[i].color = 'R';
        }

        std::sort(blue.begin(), blue.end(), compare_blue);
        std::sort(red.begin(), red.end(), compare_red);

        std::vector<std::pair<int, int>> result;
        for (int i = 0; i < N; ++i) {
            result.push_back({blue[i].index, red[i].index});
        }

        for (const auto& pair : result) {
            std::cout << pair.first << " " << pair.second << std::endl;
        }
    }

    return 0;
}





