def connect_points(test_cases):
    results = []
    for case in test_cases:
        N, blue_points, red_points = case
        blue_points_sorted = sorted(blue_points, key=lambda p: p[1])
        red_points_sorted = sorted(red_points, key=lambda p: p[1])
        
        pairs = [(b[2], r[2]) for b, r in zip(blue_points_sorted, red_points_sorted)]
        results.append(pairs)
    
    return results

if __name__ == "__main__":
    t = int(input())
    test_cases = []

    for _ in range(t):
        N = int(input())
        blue_points = [(*map(int, input().split()), i + 1) for i in range(N)]
        red_points = [(*map(int, input().split()), i + 1) for i in range(N)]
        test_cases.append((N, blue_points, red_points))
    
    results = connect_points(test_cases)
    
    for result in results:
        for blue_idx, red_idx in result:
            print(blue_idx, red_idx)





