using System;

class Solution {
static int CountSquares(int N, int[,] grid)
    {
        int count = 0;
        int[,] dpRed = new int[N, N];
        int[,] dpBlue = new int[N, N];

        for (int i = 0; i < N; i++)
        {
            for (int j = 0; j < N; j++)
            {
                if (i == 0 || j == 0)
                {
                    dpRed[i, j] = (grid[i, j] == 1) ? 1 : 0;
                    dpBlue[i, j] = (grid[i, j] == 0) ? 1 : 0;
                }
                else
                {
                    dpRed[i, j] = grid[i, j] == 1 ? Math.Min(Math.Min(dpRed[i-1, j], dpRed[i, j-1]), dpRed[i-1, j-1]) + 1 : 0;
                    dpBlue[i, j] = grid[i, j] == 0 ? Math.Min(Math.Min(dpBlue[i-1, j], dpBlue[i, j-1]), dpBlue[i-1, j-1]) + 1 : 0;
                }

                count += dpRed[i, j] + dpBlue[i, j];
            }
        }

        return count;
    }


  public static void Main(string[] args) {
      int N = int.Parse(Console.ReadLine());
        int[,] grid = new int[N, N];

        for (int i = 0; i < N; i++)
        {
            var row = Console.ReadLine().Split(' ');
            for (int j = 0; j < N; j++)
            {
                grid[i, j] = int.Parse(row[j]);
            }
        }

        Console.WriteLine(CountSquares(N, grid));
    }
}
