using System;
using System.Collections.Generic;
using System.Linq;

class Solution {
  public static void Main(string[] args) {
        int t = int.Parse(Console.ReadLine());
        for (int test = 0; test < t; test++)
        {
            int N = int.Parse(Console.ReadLine());
            List<Point> bluePoints = new List<Point>();
            List<Point> redPoints = new List<Point>();

            for (int i = 0; i < N; i++)
            {
                var coords = Console.ReadLine().Split().Select(int.Parse).ToArray();
                bluePoints.Add(new Point(coords[0], coords[1], i + 1));
            }

            for (int i = 0; i < N; i++)
            {
                var coords = Console.ReadLine().Split().Select(int.Parse).ToArray();
                redPoints.Add(new Point(coords[0], coords[1], i + 1));
            }

            var result = Solve(N, bluePoints, redPoints);
            if (result == null)
            {
                Console.WriteLine(0);
            }
            else
            {
                foreach (var pair in result)
                {
                    Console.WriteLine($"{pair.Item1} {pair.Item2}");
                }
            }
        }
    }

    static List<Tuple<int, int>> Solve(int N, List<Point> bluePoints, List<Point> redPoints)
    {
        bluePoints.Sort((a, b) => a.X.CompareTo(b.X));
        redPoints.Sort((a, b) => a.X.CompareTo(b.X));

        List<Tuple<int, int>> result = new List<Tuple<int, int>>();
        for (int i = 0; i < N; i++)
        {
            result.Add(new Tuple<int, int>(bluePoints[i].Index, redPoints[i].Index));
        }

        return result;
    }


class Point
{
    public int X { get; }
    public int Y { get; }
    public int Index { get; }

    public Point(int x, int y, int index)
    {
        X = x;
        Y = y;
        Index = index;
    }
}

}