def can_meet(N):
    # Початкові позиції
    alice_positions = [(1, 0)]  # (позиція, секунди)
    bob_positions = [(N, 0)]  # (позиція, секунди)
    
    alice_visited = set()
    bob_visited = set()
    
    while alice_positions and bob_positions:
        # Обробка позицій Аліси
        next_alice_positions = []
        for a_pos, a_time in alice_positions:
            if (a_pos, a_time) in bob_visited:
                return a_time
            alice_visited.add((a_pos, a_time))
            if a_pos + 2 <= N and (a_pos + 2, a_time + 1) not in alice_visited:
                next_alice_positions.append((a_pos + 2, a_time + 1))
            if a_pos + 3 <= N and (a_pos + 3, a_time + 1) not in alice_visited:
                next_alice_positions.append((a_pos + 3, a_time + 1))
        
        # Обновлення черги позицій Аліси
        alice_positions = next_alice_positions
        
        # Обробка позицій Боба
        next_bob_positions = []
        for b_pos, b_time in bob_positions:
            if (b_pos, b_time) in alice_visited:
                return b_time
            bob_visited.add((b_pos, b_time))
            if b_pos - 1 >= 1 and (b_pos - 1, b_time + 1) not in bob_visited:
                next_bob_positions.append((b_pos - 1, b_time + 1))
            if b_pos - 2 >= 1 and (b_pos - 2, b_time + 1) not in bob_visited:
                next_bob_positions.append((b_pos - 2, b_time + 1))
        
        # Обновлення черги позицій Боба
        bob_positions = next_bob_positions
    
    return -1

# Вхідні дані
N = int(input("Введіть кількість боксів N: "))

# Виводимо результат
result = can_meet(N)
if result == -1:
    print("Аліса та Боб не можуть зустрітися в одному боксі.")
else:
    print(f"Аліса та Боб зустрінуться через {result} секунд.")
