#include <iostream>
#include <queue>
#include <unordered_set>

using namespace std;

struct State {
    int position;
    int seconds;
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int N;
    cin >> N;

    queue<State> queueAlice, queueBob;
    unordered_set<int> visitedAlice, visitedBob;

    queueAlice.push({1, 0});
    queueBob.push({N, 0});

    visitedAlice.insert(1);
    visitedBob.insert(N);

    while (!queueAlice.empty() && !queueBob.empty()) {
        // Process Alice's moves
        if (!queueAlice.empty()) {
            State currentAlice = queueAlice.front();
            queueAlice.pop();

            if (visitedBob.count(currentAlice.position)) {
                cout << currentAlice.seconds << endl;
                return 0;
            }

            int nextPositionsAlice[] = {currentAlice.position + 2, currentAlice.position + 3};
            for (int next : nextPositionsAlice) {
                if (next <= N && !visitedAlice.count(next)) {
                    queueAlice.push({next, currentAlice.seconds + 1});
                    visitedAlice.insert(next);
                }
            }
        }

        // Process Bob's moves
        if (!queueBob.empty()) {
            State currentBob = queueBob.front();
            queueBob.pop();

            if (visitedAlice.count(currentBob.position)) {
                cout << currentBob.seconds << endl;
                return 0;
            }

            int nextPositionsBob[] = {currentBob.position - 1, currentBob.position - 2};
            for (int next : nextPositionsBob) {
                if (next >= 1 && !visitedBob.count(next)) {
                    queueBob.push({next, currentBob.seconds + 1});
                    visitedBob.insert(next);
                }
            }
        }
    }

    cout << -1 << endl;
    return 0;
}
