#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>

#define MAX_N 100000

typedef struct {
    int position;
    int time;
} State;

bool visitedA[MAX_N + 1];
bool visitedB[MAX_N + 1];

int bfs(int N) {
    State queueA[MAX_N * 2];
    State queueB[MAX_N * 2];
    int frontA = 0, rearA = 0;
    int frontB = 0, rearB = 0;

    queueA[rearA++] = (State){1, 0};
    queueB[rearB++] = (State){N, 0};
    visitedA[1] = true;
    visitedB[N] = true;

    while (frontA < rearA && frontB < rearB) {
        State currentA = queueA[frontA++];
        State currentB = queueB[frontB++];

        if (visitedB[currentA.position]) {
            return currentA.time;
        }
        if (visitedA[currentB.position]) {
            return currentB.time;
        }

        int nextPositionsA[] = {currentA.position + 2, currentA.position + 3};
        for (int i = 0; i < 2; i++) {
            int nextPos = nextPositionsA[i];
            if (nextPos <= N && !visitedA[nextPos]) {
                visitedA[nextPos] = true;
                queueA[rearA++] = (State){nextPos, currentA.time + 1};
            }
        }

        int nextPositionsB[] = {currentB.position - 1, currentB.position - 2};
        for (int i = 0; i < 2; i++) {
            int nextPos = nextPositionsB[i];
            if (nextPos > 0 && !visitedB[nextPos]) {
                visitedB[nextPos] = true;
                queueB[rearB++] = (State){nextPos, currentB.time + 1};
            }
        }
    }

    return -1; // Якщо Аліса та Боб не можуть зустрітися
}

int main() {
    int N;
    scanf("%d", &N);

    if (N == 1) {
        printf("0\n");
        return 0;
    }

    int result = bfs(N);
    printf("%d\n", result);

    return 0;
}#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>

#define MAX_N 100000

typedef struct {
    int position;
    int time;
} State;

bool visitedA[MAX_N + 1];
bool visitedB[MAX_N + 1];

int bfs(int N) {
    State queueA[MAX_N * 2];
    State queueB[MAX_N * 2];
    int frontA = 0, rearA = 0;
    int frontB = 0, rearB = 0;

    queueA[rearA++] = (State){1, 0};
    queueB[rearB++] = (State){N, 0};
    visitedA[1] = true;
    visitedB[N] = true;

    while (frontA < rearA && frontB < rearB) {
        State currentA = queueA[frontA++];
        State currentB = queueB[frontB++];

        if (visitedB[currentA.position]) {
            return currentA.time;
        }
        if (visitedA[currentB.position]) {
            return currentB.time;
        }

        int nextPositionsA[] = {currentA.position + 2, currentA.position + 3};
        for (int i = 0; i < 2; i++) {
            int nextPos = nextPositionsA[i];
            if (nextPos <= N && !visitedA[nextPos]) {
                visitedA[nextPos] = true;
                queueA[rearA++] = (State){nextPos, currentA.time + 1};
            }
        }

        int nextPositionsB[] = {currentB.position - 1, currentB.position - 2};
        for (int i = 0; i < 2; i++) {
            int nextPos = nextPositionsB[i];
            if (nextPos > 0 && !visitedB[nextPos]) {
                visitedB[nextPos] = true;
                queueB[rearB++] = (State){nextPos, currentB.time + 1};
            }
        }
    }

    return -1; // Якщо Аліса та Боб не можуть зустрітися
}

int main() {
    int N;
    scanf("%d", &N);

    if (N == 1) {
        printf("0\n");
        return 0;
    }

    int result = bfs(N);
    printf("%d\n", result);

    return 0;
}