def solve_matching_problem(test_cases):
    results = []
    for case in test_cases:
        N, blue_points, red_points = case
        
        blue_points = sorted((x, y, idx + 1) for idx, (x, y) in enumerate(blue_points))
        red_points = sorted((x, y, idx + 1) for idx, (x, y) in enumerate(red_points))
        
        matching = []
        for b, r in zip(blue_points, red_points):
            matching.append((b[2], r[2]))
        
        results.append(matching)
    return results


t = int(input())
test_cases = []
for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

results = solve_matching_problem(test_cases)

for result in results:
    if result:
        for pair in result:
            print(*pair)
    else:
        print(0)
