from collections import deque

def min_time_to_meet(N):
    # Початкові позиції
    alice_start = 1
    bob_start = N
    
    # Черги BFS для Аліси та Боба
    queue_alice = deque([alice_start])
    queue_bob = deque([bob_start])
    
    # Відвідані позиції для Аліси та Боба
    visited_alice = {alice_start}
    visited_bob = {bob_start}
    
    # Час для Аліси та Боба
    time = 0
    
    # BFS для Аліси і Боба
    while queue_alice and queue_bob:
        time += 1
        # Пошук для Аліси (переміщаємо Алісу)
        size_alice = len(queue_alice)
        for _ in range(size_alice):
            current = queue_alice.popleft()
            # Якщо Аліса і Боб можуть зустрітися в цій клітинці
            if current in visited_bob:
                return time
            for next_pos in [current + 2, current + 3]:
                if 1 <= next_pos <= N and next_pos not in visited_alice:
                    visited_alice.add(next_pos)
                    queue_alice.append(next_pos)
        
        # Пошук для Боба (переміщаємо Боба)
        size_bob = len(queue_bob)
        for _ in range(size_bob):
            current = queue_bob.popleft()
            # Якщо Аліса і Боб можуть зустрітися в цій клітинці
            if current in visited_alice:
                return time
            for next_pos in [current - 1, current - 2]:
                if 1 <= next_pos <= N and next_pos not in visited_bob:
                    visited_bob.add(next_pos)
                    queue_bob.append(next_pos)
    
    return -1  # Якщо не можна зустрітися

# Введення значення N від користувача
N = int(input("Введіть кількість клітинок N: "))

# Виклик функції та виведення результату
result = min_time_to_meet(N)
print(result)
