from collections import deque

def min_seconds_to_meet(N):
    # Початкові позиції роботів: Аліса в боксі 1, Боб в боксі N
    start_alice = 1
    start_bob = N
    
    # Черга BFS: кожен елемент - це (позиція Аліси, позиція Боба, час)
    queue = deque([(start_alice, start_bob, 0)])
    
    # Множина відвіданих станів (позиція Аліси, позиція Боба)
    visited = set()
    visited.add((start_alice, start_bob))
    
    while queue:
        alice_pos, bob_pos, time = queue.popleft()
        
        # Якщо Аліса і Боб на одній позиції, ми знайшли рішення
        if alice_pos == bob_pos:
            return time
        
        # Можливі нові позиції для Аліси (k -> k+2, k -> k+3)
        alice_moves = [alice_pos + 2, alice_pos + 3]
        
        # Можливі нові позиції для Боба (k -> k-1, k -> k-2)
        bob_moves = [bob_pos - 1, bob_pos - 2]
        
        # Перевіряємо всі можливі переходи для Аліси і Боба
        for new_alice_pos in alice_moves:
            for new_bob_pos in bob_moves:
                # Перевірка, чи знаходяться нові позиції в межах можливих значень
                if 1 <= new_alice_pos <= N and 1 <= new_bob_pos <= N:
                    # Якщо цей стан ще не відвідували, додаємо до черги
                    if (new_alice_pos, new_bob_pos) not in visited:
                        visited.add((new_alice_pos, new_bob_pos))
                        queue.append((new_alice_pos, new_bob_pos, time + 1))
    
    return -1  # Якщо рішення неможливо знайти (не повинно бути в цьому випадку)

# Вхідне значення для кількості боксів
N = int(input("Введіть кількість боксів (N): "))

# Викликаємо функцію для знаходження мінімальної кількості секунд
result = min_seconds_to_meet(N)
print(f"Мінімальна кількість секунд: {result}")
