from collections import deque

def min_seconds_to_meet(N):
    start_alice = 1
    start_bob = N
    queue = deque([(start_alice, start_bob, 0)])
    visited = set()
    visited.add((start_alice, start_bob))
    
    while queue:
        alice_pos, bob_pos, time = queue.popleft()
        
        if alice_pos == bob_pos:
            return time
        
        alice_moves = [alice_pos + 2, alice_pos + 3]
        bob_moves = [bob_pos - 1, bob_pos - 2]
        
        for new_alice_pos in alice_moves:
            for new_bob_pos in bob_moves:
                if 1 <= new_alice_pos <= N and 1 <= new_bob_pos <= N:
                    if (new_alice_pos, new_bob_pos) not in visited:
                        visited.add((new_alice_pos, new_bob_pos))
                        queue.append((new_alice_pos, new_bob_pos, time + 1))
    
    return -1

N = int(input())
result = min_seconds_to_meet(N)
print(result)
