from collections import deque

def min_seconds_to_meet(N):
    alice_queue = deque([(1, 0)])
    bob_queue = deque([(N, 0)])
    
    alice_visited = [False] * (N + 1)
    bob_visited = [False] * (N + 1)
    
    alice_visited[1] = True
    bob_visited[N] = True
    
    while alice_queue and bob_queue:
        alice_pos, alice_time = alice_queue.popleft()
        bob_pos, bob_time = bob_queue.popleft()
        
        if alice_pos == bob_pos:
            return alice_time
        
        for new_alice_pos in [alice_pos + 2, alice_pos + 3]:
            if 1 <= new_alice_pos <= N and not alice_visited[new_alice_pos]:
                alice_visited[new_alice_pos] = True
                alice_queue.append((new_alice_pos, alice_time + 1))
        
        for new_bob_pos in [bob_pos - 1, bob_pos - 2]:
            if 1 <= new_bob_pos <= N and not bob_visited[new_bob_pos]:
                bob_visited[new_bob_pos] = True
                bob_queue.append((new_bob_pos, bob_time + 1))
        
        if alice_visited[bob_pos]:
            return alice_time + bob_time + 1
        if bob_visited[alice_pos]:
            return alice_time + bob_time + 1
    
    return -1

N = int(input())
result = min_seconds_to_meet(N)
print(result)