from collections import deque

def find_min_time(n):
    # Стан кожного робота зберігається як пара (позиція Аліси, позиція Боба)
    visited = set()
    queue = deque([(1, n, 0)])  # Початкові позиції: Аліса в 1, Боб в n, час = 0
    visited.add((1, n))

    while queue:
        a, b, time = queue.popleft()

        # Якщо Аліса і Боб знаходяться в одному боксі, повертаємо час
        if a == b:
            return time

        # Рух Аліси (кроки +2 або +3)
        for next_a in (a + 2, a + 3):
            if next_a <= n:
                # Рух Боба (кроки -1 або -2)
                for next_b in (b - 1, b - 2):
                    if next_b >= 1:
                        # Перевірка, чи відвідували ми цей стан
                        if (next_a, next_b) not in visited:
                            visited.add((next_a, next_b))
                            queue.append((next_a, next_b, time + 1))

    # Якщо неможливо знайти рішення
    return -1

# Вхід
n = int(input())
result = find_min_time(n)
print(result)
