def is_square(x1, y1, x2, y2):
    # Перевірка чи є чотири точки, що утворюють квадрат
    return (x1 != x2 and y1 != y2 and abs(x1 - x2) == abs(y1 - y2))

def count_squares(N, grid):
    count = 0
    
    # Перебираємо всі можливі пари точок
    for x1 in range(N):
        for y1 in range(N):
            for x2 in range(x1 + 1, N):
                for y2 in range(y1 + 1, N):
                    if is_square(x1, y1, x2, y2):
                        # Отримуємо координати чотирьох точок квадрата
                        x3, y3 = x1, y2
                        x4, y4 = x2, y1
                        
                        # Перевіряємо, чи всі чотири точки одного кольору
                        if grid[x1][y1] == grid[x2][y2] == grid[x3][y3] == grid[x4][y4]:
                            count += 1
    return count

# Вхідні дані
N = int(input())  # сторона квадрата
grid = [list(map(int, input().split())) for _ in range(N)]  # матриця кольорів

# Виведення результату
print(count_squares(N, grid))
