def cross_product(o, a, b):
    return (a[0] - o[0]) * (b[1] - o[1]) - (a[1] - o[1]) * (b[0] - o[0])

def intersect(p1, q1, p2, q2):
    return (cross_product(p1, q1, p2) * cross_product(p1, q1, q2) < 0 and
            cross_product(p2, q2, p1) * cross_product(p2, q2, q1) < 0)


def solve():
    n = int(input())
    blue_points = []
    for i in range(n):
        x, y = map(int, input().split())
        blue_points.append((x, y, i))
    red_points = []
    for i in range(n):
        x, y = map(int, input().split())
        red_points.append((x, y, i))

    def backtrack(blue_matched, red_matched, current_matching):
        if len(blue_matched) == n:
            return current_matching

        best_matching = None
        min_intersections = float('inf')

        for i in range(n):
            if i not in blue_matched:
                for j in range(n):
                    if j not in red_matched:
                        new_intersections = 0
                        for k in range(len(current_matching)):
                            if intersect(blue_points[current_matching[k][0]][:2], red_points[current_matching[k][1]][:2], blue_points[i][:2], red_points[j][:2]):
                                new_intersections += 1

                        if new_intersections < min_intersections:
                            min_intersections = new_intersections
                            best_matching = (i, j)


        if best_matching:
            new_matching = current_matching + [best_matching]
            result = backtrack(blue_matched | {best_matching[0]}, red_matched | {best_matching[1]}
