from collections import deque

def min_time_to_meet(N):
    # Черга для BFS
    queue = deque()
    
    # Массив відстаней для Аліси і Боба
    dist_alice = [-1] * (N + 1)  # -1 означає, що бокс ще не досягнуто
    dist_bob = [-1] * (N + 1)  # -1 означає, що бокс ще не досягнуто
    
    # Початкові позиції
    dist_alice[1] = 0  # Аліса починає з боксу 1
    dist_bob[N] = 0  # Боб починає з боксу N
    
    # Додаємо початкові позиції в чергу
    queue.append(('alice', 1))  # (тип, позиція)
    queue.append(('bob', N))  # (тип, позиція)
    
    # BFS
    while queue:
        current_type, position = queue.popleft()
        
        if current_type == 'alice':  # Якщо це Аліса
            # Якщо Аліса потрапляє на бокс, де вже був Боб
            if dist_bob[position] != -1:
                return dist_alice[position] + dist_bob[position]
            
            # Аліса може телепортуватися в k+2 або k+3
            for move in [2, 3]:
                next_pos = position + move
                if next_pos <= N and dist_alice[next_pos] == -1:  # Якщо бокс існує і ще не відвідувався
                    dist_alice[next_pos] = dist_alice[position] + 1
                    queue.append(('alice', next_pos))
        
        elif current_type == 'bob':  # Якщо це Боб
            # Якщо Боб потрапляє на бокс, де вже була Аліса
            if dist_alice[position] != -1:
                return dist_bob[position] + dist_alice[position]
            
            # Боб може телепортуватися в k-1 або k-2
            for move in [1, 2]:
                next_pos = position - move
                if next_pos >= 1 and dist_bob[next_pos] == -1:  # Якщо бокс існує і ще не відвідувався
                    dist_bob[next_pos] = dist_bob[position] + 1
                    queue.append(('bob', next_pos))
    
    return -1  # Якщо вони не можуть зустрітися

# Зчитуємо вхід
N = int(input())

# Виводимо результат
print(min_time_to_meet(N))

