def min_meeting_time(n: int) -> int:
    """
    Знаходить мінімальну кількість секунд для зустрічі Аліси та Боба або повертає -1, якщо це неможливо.
    
    :param n: Кількість боксів (2 <= N <= 10^9)
    :return: Мінімальна кількість секунд або -1
    """
    # Обчислюємо відстань між Алісою (позиція 1) і Бобом (позиція N)
    distance = n - 1

    # Умови можливості зустрічі:
    # Якщо відстань непарна, то за парну кількість секунд вони не зможуть опинитися в одному боксі
    if distance % 2 != 0:
        return -1

    # Мінімальна кількість секунд для зустрічі:
    # Якщо відстань парна, обидва роботи поступово зближаються, скорочуючи різницю на 2 за секунду.
    return distance // 2


if __name__ == "__main__":
    # Ввід даних
    n = int(input("Введіть кількість боксів (N): "))
    # Виведення результату
    print(min_meeting_time(n))
