def find_president(n: int, numbers: list[int]) -> int:
    """
    Знаходить число, що зробить робота президентом, або -1, якщо вибори не відбулися.
    
    :param n: Кількість роботів (1 <= N <= 10^5)
    :param numbers: Список з N чисел (1 <= ai <= 10^9)
    :return: Унікальне мінімальне число або -1
    """
    from collections import Counter

    # Підрахунок частоти чисел
    freq = Counter(numbers)

    # Знаходимо унікальні числа
    unique_numbers = (num for num, count in freq.items() if count == 1)

    # Мінімальне серед унікальних, якщо вони є
    return min(unique_numbers, default=-1)


if __name__ == "__main__":
    n = int(input())  # Кількість роботів
    numbers = list(map(int, input().split()))  # Згенеровані числа роботів
    print(find_president(n, numbers))
