def count_uniform_squares(n: int, grid: list[list[int]]) -> int:
    """
    Підраховує кількість квадратів із вершинами одного кольору.
    
    :param n: Розмір квадрата (сторона)
    :param grid: Двовимірний список із значеннями кольорів (0 або 1)
    :return: Кількість квадратів із вершинами одного кольору
    """
    count = 0
    
    # Перебираємо всі можливі розміри квадратів (від 1 до N-1)
    for size in range(1, n):
        # Початкові координати квадрата
        for i in range(n - size):
            for j in range(n - size):
                # Вершини квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]
                
                # Перевіряємо, чи всі вершини одного кольору
                if (top_left == top_right == bottom_left == bottom_right):
                    count += 1
    
    return count


if __name__ == "__main__":
    # Зчитування вхідних даних
    n = int(input("Введіть сторону квадрата N: "))
    grid = [list(map(int, input().split())) for _ in range(n)]
    
    # Обчислення та виведення результату
    print(count_uniform_squares(n, grid))
