import math

def robot_meeting_time(N):
  """
  Розраховує мінімальну кількість секунд до зустрічі роботів.

  Args:
    N: Кількість боксів.

  Returns:
    Мінімальну кількість секунд або -1, якщо зустріч неможлива.
  """

  if N < 2:
    return -1

  distance = N - 1
  max_divisor = math.ceil(math.sqrt(distance))

  # Проверка на особые случаи, когда расстояние равно 3 или 4
  if distance in [3, 4]:
    return 1

  # Дополнительная проверка для делителя, равного расстоянию
  if distance % distance == 0:
    return 2

  for divisor in reversed(range(1, int(max_divisor) + 1)):
    if distance % divisor == 0:
      return math.ceil(distance / divisor) * 2

  return -1
# Приклад використання
N = int(input())
result = robot_meeting_time(N)
print(result)