#include <iostream>  
#include <vector>  
#include <algorithm>  

using namespace std;  

vector<int> select_stamps(int N, int M) {  
    // Обчислюємо максимальну можливу суму марок  
    long long total_value = (static_cast<long long>(N) * (N + 1)) / 2;  

    // Якщо M більша за максимально можливу суму, повертаємо 0  
    if (M > total_value) {  
        return {0};  
    }  

    vector<int> selected_stamps;  

    // Перебираємо марки з максимальної до мінімальної  
    for (int stamp_value = N; M > 0 && stamp_value > 0; --stamp_value) {  
        if (stamp_value <= M) {  // Якщо марка може бути включена  
            selected_stamps.push_back(stamp_value);  
            M -= stamp_value; // Зменшуємо залишок M  
        }  
    }  

    // Якщо M дорівнює 0, ми знайшли вірні марки  
    if (M == 0) {  
        return selected_stamps; // Повертаємо вже готовий вектор  
    }  

    // Якщо залишилося M, повертаємо 0  
    return {0};  
}  

int main() {  
    int N, M;  
    // Зчитування вхідних даних  
    cin >> N >> M;  

    // Отримуємо результат  
    vector<int> result = select_stamps(N, M);  

    // Виведення результату  
    if (result[0] == 0) {  
        cout << 0 << endl;  
    } else {  
        for (int stamp : result) {  
            cout << stamp << " ";  
        }  
        cout << endl;  
    }  

    return 0;  
}  