#include <iostream>
#include <vector>

using namespace std;

bool is_valid_square(const vector<vector<int>>& matrix, int row, int col, int size) {
    int color = matrix[row][col];
    for (int i = row; i < row + size; ++i) {
        for (int j = col; j < col + size; ++j) {
            if (matrix[i][j] != color) {
                return false;
            }
        }
    }
    return true;
}

int count_squares(const vector<vector<int>>& matrix) {
    int n = matrix.size();
    int count = 0;

    for (int size = 2; size <= n; ++size) {
        for (int i = 0; i <= n - size; ++i) {
            for (int j = 0; j <= n - size; ++j) {
                if (is_valid_square(matrix, i, j, size)) {
                    count++;
                }
            }
        }
    }

    return count;
}

int main() {
    int n;
    cout << "Введіть розмір матриці: ";
    cin >> n;

    vector<vector<int>> matrix(n, vector<int>(n));
    cout << "Введіть елементи матриці (0 або 1):\n";
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }

    int result = count_squares(matrix);
    cout << "Кількість квадратів: " << result << endl;

    return 0;
}