#include <iostream>
#include <vector>

using namespace std;

int countSameColorSquares(const vector<vector<int>>& matrix) {
    int n = matrix.size();
    int count = 0;

    // Перебір розмірів квадратів
    for (int size = 2; size <= n; ++size) {
        // Перебір лівих верхніх кутів квадратів
        for (int i = 0; i <= n - size; ++i) {
            for (int j = 0; j <= n - size; ++j) {
                bool allSame = true;
                int color = matrix[i][j];

                // Перевірка кольору всіх вершин квадрата з коректною перевіркою меж
                for (int k = i; k < i + size; ++k) {
                    for (int l = j; l < j + size; ++l) {
                        if (matrix[k][l] != color) {
                            allSame = false;
                            break;
                        }
                    }
                    if (!allSame) {
                        break;  // Оптимізація: якщо знайшли різний колір, переходимо до наступного квадрата
                    }
                }

                if (allSame) {
                    ++count;
                }
            }
        }
    }

    return count;
}

int main() {
    int n;
    cin >> n;

    vector<vector<int>> matrix(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }

    cout << countSameColorSquares(matrix) << endl;
    return 0;
}