#include <iostream>
#include <vector>

using namespace std;

int count_same_color_squares(const vector<vector<int>>& matrix) {
    int n = matrix.size();
    int count = 0;

    for (int size = 2; size <= n; ++size) {
        for (int i = 0; i <= n - size; ++i) {
            for (int j = 0; j <= n - size; ++j) {
                int color = matrix[i][j];
                bool is_valid = true;
                for (int x = i; x < i + size; ++x) {
                    for (int y = j; y < j + size; ++y) {
                        if (matrix[x][y] != color) {
                            is_valid = false;
                            break;
                        }
                    }
                    if (!is_valid) {
                        break;
                    }
                }
                if (is_valid) {
                    count++;
                }
            }
        }
    }

    return count;
}

int main() {
    int n;
    cin >> n;

    vector<vector<int>> matrix(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }

    int result = count_same_color_squares(matrix);
    cout << result << endl;

    return 0;
}