#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;

int main() {
    int N;
    cin >> N;

    // Множини для відслідковування відвіданих боксів Алісою і Бобом
    unordered_set<int> alice_positions, bob_positions;
    
    // Черга для BFS
    queue<pair<int, int>> q_alice, q_bob; // (поточний бокс, кількість секунд)

    // Аліса починає з боксу 1
    q_alice.push({1, 0});
    alice_positions.insert(1);

    // Боб починає з боксу N
    q_bob.push({N, 0});
    bob_positions.insert(N);

    // BFS для Аліси та Боба
    while (!q_alice.empty() || !q_bob.empty()) {
        // BFS для Аліси
        if (!q_alice.empty()) {
            int alice_pos = q_alice.front().first;
            int alice_time = q_alice.front().second;
            q_alice.pop();

            // Перевіряємо можливі нові позиції для Аліси
            for (int move : {2, 3}) {
                int new_pos = alice_pos + move;
                if (new_pos <= N && alice_positions.find(new_pos) == alice_positions.end()) {
                    if (bob_positions.find(new_pos) != bob_positions.end()) {
                        cout << alice_time + 1 << endl;
                        return 0;
                    }
                    q_alice.push({new_pos, alice_time + 1});
                    alice_positions.insert(new_pos);
                }
            }
        }

        // BFS для Боба
        if (!q_bob.empty()) {
            int bob_pos = q_bob.front().first;
            int bob_time = q_bob.front().second;
            q_bob.pop();

            // Перевіряємо можливі нові позиції для Боба
            for (int move : {-1, -2}) {
                int new_pos = bob_pos + move;
                if (new_pos >= 1 && bob_positions.find(new_pos) == bob_positions.end()) {
                    if (alice_positions.find(new_pos) != alice_positions.end()) {
                        cout << bob_time + 1 << endl;
                        return 0;
                    }
                    q_bob.push({new_pos, bob_time + 1});
                    bob_positions.insert(new_pos);
                }
            }
        }
    }

    // Якщо Аліса і Боб не зустрілися
    cout << -1 << endl;

    return 0;
}