#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;

// Структура для збереження стану
struct State {
    int pos;  // Позиція
    int time; // Час
};

// Основна функція для пошуку
int teleportation(int N) {
    // Черга для BFS
    queue<State> aliceQueue, bobQueue;
    
    // Множини для відстеження відвіданих боксів
    unordered_set<int> aliceVisited, bobVisited;
    
    // Початкові стани
    aliceQueue.push({1, 0}); // Аліса на позиції 1
    bobQueue.push({N, 0});   // Боб на позиції N
    aliceVisited.insert(1);
    bobVisited.insert(N);
    
    // BFS для Аліси та Боба
    while (!aliceQueue.empty() && !bobQueue.empty()) {
        // Обробляємо позиції Аліси
        int alicePos = aliceQueue.front().pos;
        int aliceTime = aliceQueue.front().time;
        aliceQueue.pop();
        
        // Перевіряємо, чи Боб вже був на цій позиції
        if (bobVisited.find(alicePos) != bobVisited.end()) {
            return aliceTime;
        }
        
        // Аліса може рухатися на +2 або +3
        for (int move : {2, 3}) {
            int newAlicePos = alicePos + move;
            if (newAlicePos <= N && aliceVisited.find(newAlicePos) == aliceVisited.end()) {
                aliceVisited.insert(newAlicePos);
                aliceQueue.push({newAlicePos, aliceTime + 1});
            }
        }
        
        // Обробляємо позиції Боба
        int bobPos = bobQueue.front().pos;
        int bobTime = bobQueue.front().time;
        bobQueue.pop();
        
        // Перевіряємо, чи Аліса вже була на цій позиції
        if (aliceVisited.find(bobPos) != aliceVisited.end()) {
            return bobTime;
        }
        
        // Боб може рухатися на -1 або -2
        for (int move : {1, 2}) {
            int newBobPos = bobPos - move;
            if (newBobPos >= 1 && bobVisited.find(newBobPos) == bobVisited.end()) {
                bobVisited.insert(newBobPos);
                bobQueue.push({newBobPos, bobTime + 1});
            }
        }
    }
    
    // Якщо ми не знайшли спільної позиції
    return -1;
}

int main() {
    int N;
    cin >> N;
    
    // Виводимо результат
    cout << teleportation(N) << endl;
    
    return 0;
}
