#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Структура для збереження точки
struct Point {
    int x, y, index;
    bool isRed; // true якщо червона точка, false якщо синя
    
    // Оператор порівняння для сортування точок
    bool operator<(const Point& other) const {
        if (x == other.x) return y < other.y; // Якщо x однакові, порівнюємо за y
        return x < other.x; // Якщо x різні, порівнюємо за x
    }
};

int main() {
    int t;  // кількість тестів
    cin >> t;
    
    while (t--) {
        int N;
        cin >> N;
        
        vector<Point> bluePoints(N), redPoints(N);
        
        // Зчитуємо координати синіх точок
        for (int i = 0; i < N; ++i) {
            cin >> bluePoints[i].x >> bluePoints[i].y;
            bluePoints[i].index = i + 1;  // зберігаємо індекс точки
            bluePoints[i].isRed = false;  // це синя точка
        }
        
        // Зчитуємо координати червоних точок
        for (int i = 0; i < N; ++i) {
            cin >> redPoints[i].x >> redPoints[i].y;
            redPoints[i].index = i + 1;  // зберігаємо індекс точки
            redPoints[i].isRed = true;   // це червона точка
        }
        
        // Сортуємо обидва масиви точок
        sort(bluePoints.begin(), bluePoints.end());
        sort(redPoints.begin(), redPoints.end());
        
        // Виводимо відповідь для цього тесту
        for (int i = 0; i < N; ++i) {
            cout << bluePoints[i].index << " " << redPoints[i].index << endl;
        }
    }
    
    return 0;
}