#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y, index;
    bool isRed;
    
    bool operator<(const Point& other) const {
        if (x == other.x) return y < other.y;
        return x < other.x;
    }
};

int main() {
    int t;  // кількість тестів
    cin >> t;

    while (t--) {
        int N;
        cin >> N;
        
        vector<Point> bluePoints(N), redPoints(N);
        
        // Зчитуємо координати синіх точок
        for (int i = 0; i < N; ++i) {
            cin >> bluePoints[i].x >> bluePoints[i].y;
            bluePoints[i].index = i + 1;
            bluePoints[i].isRed = false;  // синя точка
        }
        
        // Зчитуємо координати червоних точок
        for (int i = 0; i < N; ++i) {
            cin >> redPoints[i].x >> redPoints[i].y;
            redPoints[i].index = i + 1;
            redPoints[i].isRed = true;   // червона точка
        }
        
        // Сортуємо сині та червоні точки
        sort(bluePoints.begin(), bluePoints.end());
        sort(redPoints.begin(), redPoints.end());
        
        // Перевірка, чи відрізки не перетинаються
        bool canConnect = true;
        for (int i = 0; i < N; ++i) {
            // Якщо відрізки будуть перетинатись, то по координатах
            // одна з червоних точок має бути вищою за відповідну синю
            if (bluePoints[i].y > redPoints[i].y) {
                canConnect = false;
                break;
            }
        }

        if (canConnect) {
            // Якщо можна з'єднати всі точки, виводимо пари
            for (int i = 0; i < N; ++i) {
                cout << bluePoints[i].index << " " << redPoints[i].index << endl;
            }
        } else {
            cout << 0 << endl; // Якщо не можна з'єднати
        }
    }

    return 0;
}
