#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Структура для зберігання точок
struct Point {
    int x, y, index;
    bool isRed;  // Прапор для визначення кольору точки
    
    // Для сортування точок за x, потім за y
    bool operator<(const Point& other) const {
        if (x == other.x) return y < other.y;
        return x < other.x;
    }
};

int main() {
    int t;  // Кількість тестових блоків
    cin >> t;

    while (t--) {
        int N;  // Кількість точок одного кольору
        cin >> N;

        vector<Point> bluePoints(N), redPoints(N);

        // Зчитуємо координати синіх точок
        for (int i = 0; i < N; ++i) {
            cin >> bluePoints[i].x >> bluePoints[i].y;
            bluePoints[i].index = i + 1;  // Зберігаємо індекс
            bluePoints[i].isRed = false;  // Визначаємо, що це синя точка
        }

        // Зчитуємо координати червоних точок
        for (int i = 0; i < N; ++i) {
            cin >> redPoints[i].x >> redPoints[i].y;
            redPoints[i].index = i + 1;  // Зберігаємо індекс
            redPoints[i].isRed = true;   // Визначаємо, що це червона точка
        }

        // Сортуємо сині і червоні точки за x, потім за y
        sort(bluePoints.begin(), bluePoints.end());
        sort(redPoints.begin(), redPoints.end());

        // Виводимо пари з'єднаних точок
        for (int i = 0; i < N; ++i) {
            cout << bluePoints[i].index << " " << redPoints[i].index << endl;
        }
    }

    return 0;
}
