#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, id;
};

bool comparePoints(const Point &a, const Point &b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

bool segmentsIntersect(Point a, Point b, Point c, Point d) {
    auto cross = [](Point p1, Point p2, Point p3) {
        return (p2.x - p1.x) * (p3.y - p1.y) - (p2.y - p1.y) * (p3.x - p1.x);
    };
    return (cross(a, b, c) * cross(a, b, d) < 0) && (cross(c, d, a) * cross(c, d, b) < 0);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ios::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vector<Point> blue(n), red(n);
        for (int i = 0; i < n; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].id = i + 1;
        }
        for (int i = 0; i < n; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].id = i + 1;
        }

        sort(blue.begin(), blue.end(), comparePoints);
        sort(red.begin(), red.end(), comparePoints);

        vector<pair<int, int>> result;
        vector<int> usedBlue(n, 0), usedRed(n, 0);

        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (usedBlue[i] || usedRed[j]) continue;

                bool intersect = false;
                for (const auto &[b, r] : result) {
                    if (segmentsIntersect(blue[b - 1], red[r - 1], blue[i], red[j])) {
                        intersect = true;
                        break;
                    }
                }
                if (!intersect) {
                    result.emplace_back(blue[i].id, red[j].id);
                    usedBlue[i] = 1;
                    usedRed[j] = 1;
                    break;
                }
            }
        }

        if (result.size() == n) {
            for (const auto &p : result) {
                cout << p.first << " " << p.second << "\n";
            }
        } else {
            cout << 0 << "\n";
        }
    }

    return 0;

}
