function generate_subsets(array, index, current, subsets)
    if index > #array then
        table.insert(subsets, {unpack(current)})
        return
    end

    generate_subsets(array, index + 1, current, subsets)
    table.insert(current, array[index])
    generate_subsets(array, index + 1, current, subsets)
    table.remove(current)
end


function find_stamps(N, M)

    local stamps = {}
    for i = 1, N do
        table.insert(stamps, i)
    end

    local subsets = {}
    generate_subsets(stamps, 1, {}, subsets)

    local min_subset = nil
    for _, subset in ipairs(subsets) do
        local sum = 0
        for _, value in ipairs(subset) do
            sum = sum + value
        end

        if sum == M then
            if not min_subset or #subset < #min_subset then
                min_subset = subset
            end
        end
    end

    if min_subset then
        for _, value in ipairs(min_subset) do
            print(value)
        end
    else
        print(0)
    end
end

local N = tonumber(io.read())
local M = tonumber(io.read())

find_stamps(N, M)
