function find_stamps(N, M)
    -- Максимально оптимізуємо за допомогою обчислень без великих структур
    local dp = {}
    dp[0] = 0  -- База: сума 0 досягається без марок

    -- Динамічне програмування для знаходження мінімальної кількості марок
    for sum = 1, M do
        dp[sum] = math.huge
    end

    local used = {}
    for stamp = 1, N do
        for sum = M, stamp, -1 do
            if dp[sum - stamp] + 1 < dp[sum] then
                dp[sum] = dp[sum - stamp] + 1
                used[sum] = stamp
            end
        end
    end

    -- Якщо сума недосяжна
    if dp[M] == math.huge then
        print(0)
        return
    end

    -- Відновлюємо результат
    local result = {}
    local sum = M
    while sum > 0 do
        local stamp = used[sum]
        table.insert(result, stamp)
        sum = sum - stamp
    end

    -- Виводимо результат
    for _, value in ipairs(result) do
        print(value)
    end
end

-- Читання вхідних даних
local N = tonumber(io.read())
local M = tonumber(io.read())

-- Викликаємо функцію
find_stamps(N, M)
