function customSplit(input, delimiter)
    local result = {}
    local pattern = "(.-)" .. delimiter
    local lastEnd = 1

    for part, pos in input:gmatch(pattern .. "()") do
        table.insert(result, part)
        lastEnd = pos
    end
    if lastEnd <= #input then
        table.insert(result, input:sub(lastEnd))
    end
    return result
end

local amount = tonumber(io.read())
local numbers = customSplit(io.read()," ")


local counts = {}
for _, num in ipairs(numbers) do
    counts[num] = (counts[num] or 0) + 1
end

local min_unique = nil
for num, count in pairs(counts) do
    if count == 1 and (min_unique == nil or num < min_unique) then
        min_unique = num
    end
end

if min_unique then
    print(min_unique)
else
    print(-1)
end