#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

struct Point {
    int x, y, index;
};

double distance(const Point& a, const Point& b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);
        for (int i = 0; i < N; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }
        for (int i = 0; i < N; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        vector<bool> usedBlue(N, false), usedRed(N, false);
        vector<pair<int, int>> result;

        for (int i = 0; i < N; ++i) {
            double minDist = 1e9;
            int chosenBlue = -1, chosenRed = -1;
            for (int j = 0; j < N; ++j) {
                if (usedBlue[j]) continue;
                for (int k = 0; k < N; ++k) {
                    if (usedRed[k]) continue;
                    double d = distance(blue[j], red[k]);
                    if (d < minDist) {
                        minDist = d;
                        chosenBlue = j;
                        chosenRed = k;
                    }
                }
            }
            if (chosenBlue != -1 && chosenRed != -1) {
                usedBlue[chosenBlue] = true;
                usedRed[chosenRed] = true;
                result.push_back({blue[chosenBlue].index, red[chosenRed].index});
            }
        }

        if (result.size() == N) {
            for (auto& p : result) {
                cout << p.first << " " << p.second << endl;
            }
        } else {
            cout << 0 << endl;
        }
    }

    return 0;
}
