#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Point {
    int x, y, index;
};

bool compare(const Point& a, const Point& b) {
    if (a.x != b.x) return a.x < b.x;
    return a.y < b.y;
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);
        for (int i = 0; i < N; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }
        for (int i = 0; i < N; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        sort(blue.begin(), blue.end(), compare);
        sort(red.begin(), red.end(), compare);

        vector<pair<int, int>> result;
        for (int i = 0; i < N; ++i) {
            result.emplace_back(blue[i].index, red[i].index);
        }

        for (const auto& pair : result) {
            cout << pair.first << " " << pair.second << endl;
        }
    }

    return 0;
}
