#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

struct aba {
    ll x, y, ind;
};

bool comp(aba a, aba b) {
    if (a.y == b.y) {
        return a.x < b.x;
    }
    return a.y < b.y;
}


bool cross(ll x1, ll y1, ll x2, ll y2, ll x3, ll y3, ll x4, ll y4) {
    float x, y;
    float n;
    if (y2 - y1 != 0) { 
        float q = float(x2 - x1) / float(y1 - y2);
        float sn = float(x3 - x4) + float(y3 - y4) * q; 
        if (!sn) { 
            return 0; 
        } 
        float fn = float(x3 - x1) + float(y3 - y1) * q;  
        n = fn / sn;
    }
    else {
        if (!(y3 - y4)) { 
            return 0; 
        }  
        n = (y3 - y1) / (y3 - y4);  
    }
    x = x3 + (x4 - x3) * n;  
    y = y3 + (y4 - y3) * n;  
    if (x < x1 || x > x2 || x < x3 || x > x4) {
        return 0; 
    }
    return 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    ll t;
    cin >> t;
    vector<aba> red, blue;
    while (t--) {
        ll N;
        cin >> N;
        red.resize(N);
        blue.resize(N);
        for (ll i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].ind = i + 1;
        }
        for (ll i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].ind = i + 1;
        }
        sort(red.begin(), red.end(), comp);
        sort(blue.begin(), blue.end(), comp);
        bool ans = true;
        for (ll i = 0; i < N; i++) {
            for (ll j = i + 1; j < N; j++) {
                if (cross(blue[i].x, blue[i].y, red[i].x, red[i].y, blue[j].x, blue[j].y, red[j].y, red[j].x)) {
                    cout << 0 << '\n';
                    ans = false;
                    break;
                }
            }
            if (!ans) {
                break;
            }
        }
        if (ans) {
            for (ll i = 0; i < N; i++) {
                cout << blue[i].ind << ' ' << red[i].ind << '\n';
            }
        }
    }
}