def min_seconds_to_meet(N):
    if N <= 3:
        return -1

    from collections import deque

    alice_queue = deque([(1, 0)]) 
    bob_queue = deque([(N, 0)])   
    
    alice_visited = set([1])
    bob_visited = set([N])

    while alice_queue or bob_queue:
        if alice_queue:
            alice, a_sec = alice_queue.popleft()
            for move in [alice + 2, alice + 3]:
                if move > N:
                    continue
                if move in bob_visited:
                    return a_sec + 1
                if move not in alice_visited:
                    alice_visited.add(move)
                    alice_queue.append((move, a_sec + 1))

        if bob_queue:
            bob, b_sec = bob_queue.popleft()
            for move in [bob - 1, bob - 2]:
                if move < 1:
                    continue
                if move in alice_visited:
                    return b_sec + 1
                if move not in bob_visited:
                    bob_visited.add(move)
                    bob_queue.append((move, b_sec + 1))

    return -1


N = int(input())
print(min_seconds_to_meet(N))
