def solve_problem(test_cases):
    results = []

    for n, blue_points, red_points in test_cases:
        # Сортуємо точки за координатами
        blue_points_sorted = sorted(enumerate(blue_points, start=1), key=lambda p: (p[1][0], p[1][1]))
        red_points_sorted = sorted(enumerate(red_points, start=1), key=lambda p: (p[1][0], p[1][1]))

        # Формуємо пари
        pairs = [(blue[0], red[0]) for blue, red in zip(blue_points_sorted, red_points_sorted)]

        results.append(pairs)

    return results


def read_input():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    t = int(data[0])  # Кількість тестових блоків
    idx = 1
    test_cases = []
    
    for _ in range(t):
        n = int(data[idx])
        idx += 1
        blue_points = [tuple(map(int, data[idx:idx+2])) for _ in range(n)]
        idx += 2 * n
        red_points = [tuple(map(int, data[idx:idx+2])) for _ in range(n)]
        idx += 2 * n
        test_cases.append((n, blue_points, red_points))
    
    return test_cases


def print_results(results):
    for result in results:
        if result == [0]:
            print(0)
        else:
            for blue, red in result:
                print(blue, red)


if __name__ == "__main__":
    test_cases = read_input()
    results = solve_problem(test_cases)
    print_results(results)
