def count_colored_squares(grid, N):
    count = 0

    # Ітерація по всіх парах точок (i1, j1) і (i2, j2)
    for i1 in range(N):
        for j1 in range(N):
            for i2 in range(N):
                for j2 in range(N):
                    # Пропустити однакові точки
                    if (i1 == i2 and j1 == j2):
                        continue

                    # Обчислення координат можливих інших двох вершин
                    dx = i2 - i1
                    dy = j2 - j1

                    x3, y3 = i1 - dy, j1 + dx
                    x4, y4 = i2 - dy, j2 + dx

                    # Перевірка, чи всі точки лежать у межах квадрата
                    if 0 <= x3 < N and 0 <= y3 < N and 0 <= x4 < N and 0 <= y4 < N:
                        # Перевірка кольору всіх чотирьох точок
                        if (grid[i1][j1] == grid[i2][j2] == grid[x3][y3] == grid[x4][y4]):
                            count += 1

    # Оскільки кожен квадрат враховується 4 рази, ділимо результат на 4
    return count // 4

# Зчитування даних
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Розрахунок і виведення результату
print(count_colored_squares(grid, N))