def solve():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    t = int(data[0])  # кількість тестів
    index = 1
    results = []
    
    for _ in range(t):
        N = int(data[index])  # кількість точок одного кольору
        index += 1
        
        blue_points = []
        for i in range(N):
            x, y = map(int, data[index + i].split())
            blue_points.append((x, y, i + 1))  # додаємо координати і номер
        index += N
        
        red_points = []
        for i in range(N):
            x, y = map(int, data[index + i].split())
            red_points.append((x, y, i + 1))  # додаємо координати і номер
        index += N
        
        # Сортуємо точки за координатами (x, y)
        blue_points.sort(key=lambda p: (p[0], p[1]))
        red_points.sort(key=lambda p: (p[0], p[1]))
        
        # Підбираємо пари точок
        used_red = [False] * N  # Чи використана червона точка
        result = []
        
        for bx, by, bidx in blue_points:
            best_dist = float('inf')
            best_red = -1
            
            for j in range(N):
                if not used_red[j]:
                    rx, ry, ridx = red_points[j]
                    dist = (bx - rx) ** 2 + (by - ry) ** 2  # Евклідова відстань
                    if dist < best_dist:
                        best_dist = dist
                        best_red = j
            
            if best_red != -1:
                used_red[best_red] = True
                result.append(f"{bidx} {red_points[best_red][2]}")
        
        if len(result) != N:
            results.append("0")  # Неможливо створити розбиття
        else:
            results.append("\n".join(result))
    
    # Вивід результату
    sys.stdout.write("\n\n".join(results) + "\n")

solve()