from collections import deque

def solve():
    N = int(input())  # кількість боксів

    # Черга для BFS: кожна пара (позиція Аліси, позиція Боба, кількість секунд)
    queue = deque([(1, N, 0)])  # початкові позиції: Аліса на 1, Боб на N
    visited = set([(1, N)])  # для відслідковування відвіданих пар

    # Можливі переміщення для Аліси та Боба
    alice_moves = [2, 3]
    bob_moves = [-1, -2]

    while queue:
        alice_pos, bob_pos, seconds = queue.popleft()

        # Якщо Аліса та Боб знаходяться в одному боксі
        if alice_pos == bob_pos:
            print(seconds)
            return
        
        # Перевіряємо нові можливі позиції Аліси та Боба
        for a_move in alice_moves:
            new_alice_pos = alice_pos + a_move
            if new_alice_pos <= N and (new_alice_pos, bob_pos) not in visited:
                visited.add((new_alice_pos, bob_pos))
                queue.append((new_alice_pos, bob_pos, seconds + 1))
        
        for b_move in bob_moves:
            new_bob_pos = bob_pos + b_move
            if new_bob_pos >= 1 and (alice_pos, new_bob_pos) not in visited:
                visited.add((alice_pos, new_bob_pos))
                queue.append((alice_pos, new_bob_pos, seconds + 1))

    # Якщо не знайшли жодної спільної клітинки
    print(-1)

solve()