#include <iostream>
#include <queue>
#include <unordered_set>
#include <tuple>

using namespace std;

int minSecondsToMeet(int N) {
    if (N < 2) {
        return -1;
    }

    unordered_set<int> visitedAlice;
    unordered_set<int> visitedBob;

    queue<pair<int, int>> aliceQueue;
    queue<pair<int, int>> bobQueue;

    aliceQueue.push({1, 0});
    bobQueue.push({N, 0});

    visitedAlice.insert(1);
    visitedBob.insert(N);

    while (!aliceQueue.empty() && !bobQueue.empty()) {
        auto [alicePos, aliceTime] = aliceQueue.front();
        aliceQueue.pop();

        if (visitedBob.count(alicePos)) {
            return aliceTime;
        }

        if (alicePos + 2 <= N && !visitedAlice.count(alicePos + 2)) {
            aliceQueue.push({alicePos + 2, aliceTime + 1});
            visitedAlice.insert(alicePos + 2);
        }
        if (alicePos + 3 <= N && !visitedAlice.count(alicePos + 3)) {
            aliceQueue.push({alicePos + 3, aliceTime + 1});
            visitedAlice.insert(alicePos + 3);
        }

        auto [bobPos, bobTime] = bobQueue.front();
        bobQueue.pop();

        if (visitedAlice.count(bobPos)) {
            return bobTime;
        }

        if (bobPos - 1 >= 1 && !visitedBob.count(bobPos - 1)) {
            bobQueue.push({bobPos - 1, bobTime + 1});
            visitedBob.insert(bobPos - 1);
        }
        if (bobPos - 2 >= 1 && !visitedBob.count(bobPos - 2)) {
            bobQueue.push({bobPos - 2, bobTime + 1});
            visitedBob.insert(bobPos - 2);
        }
    }

    return -1;
}

int main() {
    int N;
    cin >> N;

    cout << minSecondsToMeet(N) << endl;

    return 0;
}
