def read_input():
    t = int(input())
    test_cases = []
    for _ in range(t):
        N = int(input())
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]
        test_cases.append((N, blue_points, red_points))
    return test_cases

def is_intersecting(a, b, c, d):
    def ccw(p1, p2, p3):
        return (p3[1] - p1[1]) * (p2[0] - p1[0]) > (p2[1] - p1[1]) * (p3[0] - p1[0])
    return ccw(a, c, d) != ccw(b, c, d) and ccw(a, b, c) != ccw(a, b, d)

def solve_case(N, blue_points, red_points):
    blue_points.sort()
    red_points.sort()
    pairs = list(zip(blue_points, red_points))
    for i in range(len(pairs)):
        for j in range(i + 1, len(pairs)):
            if is_intersecting(*pairs[i], *pairs[j]):
                pairs[j], pairs[i] = (pairs[j][0], pairs[i][1]), (pairs[i][0], pairs[j][1])
    return pairs

def format_output(pairs):
    return "\n".join(f"{blue[0]} {blue[1]}" for blue, red in pairs)

for N, blue_points, red_points in read_input():
    print(format_output(solve_case(N, blue_points, red_points)))
