from collections import deque

def find_meeting_time(N):
    
    if N == 2:
        return -1
    
    
    alice_queue = deque([1])  
    bob_queue = deque([N])    
    visited_by_alice = set([1])  
    visited_by_bob = set([N])    

    seconds = 0  

    
    while alice_queue or bob_queue:
        seconds += 1
        
       
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            
            for next_position in (current + 2, current + 3):
                if 1 <= next_position <= N and next_position not in visited_by_alice:
                    visited_by_alice.add(next_position)
                    alice_queue.append(next_position)
                   
                    if next_position in visited_by_bob:
                        return seconds
        
        
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
           
            for next_position in (current - 1, current - 2):
                if 1 <= next_position <= N and next_position not in visited_by_bob:
                    visited_by_bob.add(next_position)
                    bob_queue.append(next_position)
                    
                    if next_position in visited_by_alice:
                        return seconds

    return -1  


N = int(input())
print(find_meeting_time(N))