from collections import deque

def find_meeting_time(N):
    # Якщо N = 2, то неможливо зустрітися
    if N == 2:
        return -1

    # Черги для BFS: одна для Аліси, інша для Боба
    alice_queue = deque([1])  # Початкова позиція Аліси
    bob_queue = deque([N])    # Початкова позиція Боба
    visited_by_alice = set([1])  # Відвідані клітинки Алісою
    visited_by_bob = set([N])    # Відвідані клітинки Бобом

    seconds = 0  # Лічильник секунд

    # BFS для Аліси та Боба
    while alice_queue or bob_queue:
        seconds += 1
        
        # Обробка Аліси
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            # Аліса може телепортуватися в k+2 або k+3
            for next_position in (current + 2, current + 3):
                if 1 <= next_position <= N and next_position not in visited_by_alice:
                    visited_by_alice.add(next_position)
                    alice_queue.append(next_position)
                    # Якщо ця клітинка вже відвідана Бобом, ми знайшли зустріч
                    if next_position in visited_by_bob:
                        return seconds
        
        # Обробка Боба
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            # Боб може телепортуватися в k-1 або k-2
            for next_position in (current - 1, current - 2):
                if 1 <= next_position <= N and next_position not in visited_by_bob:
                    visited_by_bob.add(next_position)
                    bob_queue.append(next_position)
                    # Якщо ця клітинка вже відвідана Алісою, ми знайшли зустріч
                    if next_position in visited_by_alice:
                        return seconds

    return -1  # Якщо Аліса та Боб не можуть зустрітися

# Вхідні дані
N = int(input())
print(find_meeting_time(N))