from collections import deque

def teleportation(N):
    # Початкові позиції
    alice_pos = 1  # Аліса на 1 боксі
    bob_pos = N    # Боб на N боксі
    
    # Черги для BFS
    alice_queue = deque([(alice_pos, 0)])  # кожен елемент - (позиція, кількість секунд)
    bob_queue = deque([(bob_pos, 0)])
    
    # Множини для відслідковування відвіданих позицій
    alice_visited = set([alice_pos])
    bob_visited = set([bob_pos])
    
    while alice_queue and bob_queue:
        # Обробляємо один крок для Аліси
        alice_curr_pos, alice_time = alice_queue.popleft()
        for next_pos in [alice_curr_pos + 2, alice_curr_pos + 3]:
            if 1 <= next_pos <= N and next_pos not in alice_visited:
                alice_visited.add(next_pos)
                alice_queue.append((next_pos, alice_time + 1))
                if next_pos in bob_visited:
                    return alice_time + 1
        
        # Обробляємо один крок для Боба
        bob_curr_pos, bob_time = bob_queue.popleft()
        for next_pos in [bob_curr_pos - 1, bob_curr_pos - 2]:
            if 1 <= next_pos <= N and next_pos not in bob_visited:
                bob_visited.add(next_pos)
                bob_queue.append((next_pos, bob_time + 1))
                if next_pos in alice_visited:
                    return bob_time + 1
    
    return -1

# Зчитуємо вхід
N = int(input())

# Викликаємо функцію та виводимо результат
print(teleportation(N))