def check_intersection(x1, y1, x2, y2, x3, y3, x4, y4):
  """Перевірка перетину відрізків."""
  area1 = abs((x2 - x1) * (y3 - y1) - (x3 - x1) * (y2 - y1))
  area2 = abs((x2 - x1) * (y4 - y1) - (x4 - x1) * (y2 - y1))
  area3 = abs((x4 - x3) * (y1 - y3) - (x1 - x3) * (y4 - y3))
  area4 = abs((x4 - x3) * (y2 - y3) - (x2 - x3) * (y4 - y3))
  return (area1 == 0 or area2 == 0 or area3 == 0 or area4 == 0)

def solve(points_blue, points_red):
  """Розв'язання задачі."""
  n = len(points_blue)
  points = sorted(points_blue + points_red, key=lambda x: (x[0], x[1]))
  connections = []
  for i in range(n):
    current_point = points[i]
    next_point_index = i + 1
    while next_point_index < 2 * n:
      next_point = points[next_point_index]
      if (current_point[0] != next_point[0] or current_point[1] != next_point[1]) and (
        len(connections) == 0 or not check_intersection(
          current_point[0], current_point[1], next_point[0], next_point[1],
          connections[-1][0][0], connections[-1][0][1], connections[-1][1][0], connections[-1][1][1]
        )
      ):
        connections.append((current_point, next_point))
        break
      next_point_index += 1
    if next_point_index == 2 * n:
      return 0
  return connections

t = int(input())
for _ in range(t):
  n = int(input())
  points_blue = [tuple(map(int, input().split())) for _ in range(n)]
  points_red = [tuple(map(int, input().split())) for _ in range(n)]
  connections = solve(points_blue, points_red)
  if connections == 0:
    print(0)
  else:
    for i in range(n):
      blue_index = points_blue.index(connections[i][0]) + 1
      red_index = points_red.index(connections[i][1]) + 1
      print(blue_index, red_index)
