def find_connections(blue_points, red_points):
  """Функція для знаходження з'єднань."""
  connections = []
  used_red_points = set()

  for i, blue_point in enumerate(blue_points):
    closest_red_point = None
    min_distance = float('inf')

    for j, red_point in enumerate(red_points):
      if j not in used_red_points:
        distance = ((blue_point[0] - red_point[0]) ** 2 + (blue_point[1] - red_point[1]) ** 2) ** 0.5
        if distance < min_distance:
          closest_red_point = j
          min_distance = distance

    if closest_red_point is not None:
      connections.append((i + 1, closest_red_point + 1))
      used_red_points.add(closest_red_point)
    else:
      return None

  return connections

def check_intersections(connections, blue_points, red_points):
  """Функція для перевірки перетинів."""
  for i in range(len(connections)):
    for j in range(i + 1, len(connections)):
      # Перевірка перетину відрізків
      if is_segments_intersect(
          blue_points[connections[i][0] - 1],
          red_points[connections[i][1] - 1],
          blue_points[connections[j][0] - 1],
          red_points[connections[j][1] - 1]
      ):
        return False

  return True

def is_segments_intersect(p1, q1, p2, q2):
  """Функція для перевірки перетину відрізків."""
  # Реалізація перевірки перетину відрізків
  # ...

# Зчитування даних
t = int(input())

for _ in range(t):
  n = int(input())
  blue_points = [list(map(int, input().split())) for _ in range(n)]
  red_points = [list(map(int, input().split())) for _ in range(n)]

  # Сортування точок
  blue_points.sort()
  red_points.sort()

  # Знаходження з'єднань
  connections = find_connections(blue_points, red_points)

  # Перевірка на перетини
  if connections is not None and check_intersections(connections, blue_points, red_points):
    # Виведення результату
    for connection in connections:
      print(connection[0], connection[1])
  else:
    print(0)
