from collections import deque

def min_meeting_time(n):
    alice_positions = {1}  
    bob_positions = {n}

    alice_queue = deque([1])
    bob_queue = deque([n])

    alice_visited = set()
    bob_visited = set()

    alice_visited.add(1)
    bob_visited.add(n)

    time = 0

    while alice_queue and bob_queue:
        time += 1
        next_alice_positions = set()
        next_bob_positions = set()

        for pos in alice_queue:
            for new_pos in (pos + 2, pos + 3):
                if new_pos <= n and new_pos not in alice_visited:
                    next_alice_positions.add(new_pos)
                    alice_visited.add(new_pos)

        for pos in bob_queue:
            for new_pos in (pos - 1, pos - 2):
                if new_pos >= 1 and new_pos not in bob_visited:
                    next_bob_positions.add(new_pos)
                    bob_visited.add(new_pos)

        if next_alice_positions & next_bob_positions:
            return time

        alice_queue = deque(next_alice_positions)
        bob_queue = deque(next_bob_positions)

    return -1

n = int(input())
print(min_meeting_time(n))