import numpy as np

def count_same_color_squares(N, grid):
    count = 0
    
    # Конвертуємо в numpy масив для зручності
    grid = np.array(grid)
    
    # Перевіряємо всі квадрати різних розмірів
    for size in range(1, N):  # size - розмір квадрата (від 1 до N-1)
        for i in range(N - size):  # координати лівого нижнього кута по осі x
            for j in range(N - size):  # координати лівого нижнього кута по осі y
                # Визначимо координати чотирьох вершин квадрата
                x1, y1 = i, j
                x2, y2 = i + size, j
                x3, y3 = i, j + size
                x4, y4 = i + size, j + size
                
                # Перевіримо, чи всі чотири вершини одного кольору
                color = grid[y1, x1]  # Колір в лівому нижньому куті
                if (grid[y2, x2] == color and 
                    grid[y3, x3] == color and 
                    grid[y4, x4] == color):
                    count += 1
                    
    return count

# Вхідні дані
N = int(input())  # Читаємо розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]  # Читаємо матрицю кольорів

# Вивести відповідь
print(count_same_color_squares(N, grid))