import math

def rotate_point(x, y, angle):
    angle_rad = math.radians(angle)
    x_new = x * math.cos(angle_rad) - y * math.sin(angle_rad)
    y_new = x * math.sin(angle_rad) + y * math.cos(angle_rad)
    return (x_new, y_new)

def is_square(corners, grid):
    color = grid[corners[0][0]][corners[0][1]]
    for x, y in corners[1:]:
        if grid[x][y] != color:
            return False
    return True

def count_squares(N, grid, angles):
    count = 0
    
    for size in range(1, N):
        for i in range(N - size):
            for j in range(N - size):
                corners = [
                    (i, j),
                    (i + size, j),
                    (i, j + size),
                    (i + size, j + size)
                ]

                if is_square(corners, grid):
                    count += 1
                
                for angle in angles:
                    rotated_corners = [rotate_point(x, y, angle) for x, y in corners]
                    rotated_corners_int = [(round(x), round(y)) for x, y in rotated_corners]
                    if all(0 <= x < N and 0 <= y < N for x, y in rotated_corners_int):
                        if is_square(rotated_corners_int, grid):
                            count += 1

    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

angles = [45, 90, 135, 180, 225, 270, 315]  # Можна додати будь-які кути

print(count_squares(N, grid, angles))