def solve_problem(t, test_cases):
    results = []
    for case in range(t):
        N = test_cases[case][0]
        blue_points = test_cases[case][1]
        red_points = test_cases[case][2]

        # Сортируем точки по x-координате
        blue_points_sorted = sorted(enumerate(blue_points, start=1), key=lambda p: p[1][0])
        red_points_sorted = sorted(enumerate(red_points, start=1), key=lambda p: p[1][0])

        # Проверяем, можем ли соединить без пересечений
        matching = []
        for i in range(N):
            matching.append((blue_points_sorted[i][0], red_points_sorted[i][0]))

        results.append(matching)

    return results


# Чтение входных данных
t = int(input())
test_cases = []

for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

# Решение задачи
output = solve_problem(t, test_cases)

# Вывод результатов
for result in output:
    if result:
        for pair in result:
            print(pair[0], pair[1])
    else:
        print(0)