#include <iostream>
#include <vector>
#include <sstream>
#include <algorithm>
#include <limits>
#include <unordered_map>

int main() {
    // Ignore the first line of input
    std::string dummy;
    std::getline(std::cin, dummy);

    // Read the second line of input
    std::string input;
    std::getline(std::cin, input);

    // Parse the input into a vector of integers
    std::vector<int> a;
    std::istringstream iss(input);
    int num;
    while (iss >> num) {
        a.push_back(num);
    }

    // Count occurrences of each number
    std::unordered_map<int, int> count_map;
    for (int x : a) {
        count_map[x]++;
    }

    // Filter the vector to keep only elements that appear exactly once
    std::vector<int> filtered;
    for (int x : a) {
        if (count_map[x] == 1) {
            filtered.push_back(x);
        }
    }

    // Find the minimum value in the filtered vector
    if (!filtered.empty()) {
        int min_value = *std::min_element(filtered.begin(), filtered.end());
        std::cout << min_value << std::endl;
    } else {
        std::cout << -1 << std::endl;
    }

    return 0;
}
