import java.util.*;

public class Main {
    public static void main(String[] args) {
        // Ignore the first line of input
        Scanner scanner = new Scanner(System.in);
        String dummy = scanner.nextLine();

        // Read the second line of input
        String input = scanner.nextLine();

        // Parse the input into a list of integers
        String[] inputArray = input.split(" ");
        List<Integer> a = new ArrayList<>();
        for (String numStr : inputArray) {
            a.add(Integer.parseInt(numStr));
        }

        // Count occurrences of each number
        Map<Integer, Integer> countMap = new HashMap<>();
        for (int x : a) {
            countMap.put(x, countMap.getOrDefault(x, 0) + 1);
        }

        // Filter the list to keep only elements that appear exactly once
        List<Integer> filtered = new ArrayList<>();
        for (int x : a) {
            if (countMap.get(x) == 1) {
                filtered.add(x);
            }
        }

        // Find the minimum value in the filtered list
        if (!filtered.isEmpty()) {
            int minValue = Collections.min(filtered);
            System.out.println(minValue);
        } else {
            System.out.println(-1);
        }

        scanner.close();
    }
}