from collections import deque

def can_meet(N):
    # Initialize visited arrays to track visited positions for both Alice and Bob
    alice_visited = [False] * (N + 1)
    bob_visited = [False] * (N + 1)
    
    # Starting positions
    alice_visited[1] = True
    bob_visited[N] = True
    
    # Queues for BFS (Breadth First Search)
    alice_queue = deque([1])
    bob_queue = deque([N])
    
    time = 0

    # BFS loop
    while alice_queue and bob_queue:
        time += 1
        
        # Move Alice
        for _ in range(len(alice_queue)):
            pos = alice_queue.popleft()
            for move in [2, 3]:
                new_pos = pos + move
                if new_pos <= N and not alice_visited[new_pos]:
                    alice_visited[new_pos] = True
                    alice_queue.append(new_pos)
                    # Check if Alice and Bob meet
                    if bob_visited[new_pos]:
                        return time
        
        # Move Bob
        for _ in range(len(bob_queue)):
            pos = bob_queue.popleft()
            for move in [1, 2]:
                new_pos = pos - move
                if new_pos >= 1 and not bob_visited[new_pos]:
                    bob_visited[new_pos] = True
                    bob_queue.append(new_pos)
                    # Check if Alice and Bob meet
                    if alice_visited[new_pos]:
                        return time

    # If no meeting point found
    return -1

# Input and output
n = int(input())
print(can_meet(n))
