from collections import deque

def min_teleport_time(N):
    # BFS для Аліси та Боба
    # Створюємо черги для Аліси та Боба, починаємо з їхніх стартових позицій
    alice_queue = deque([(1, 0)])  # (поточний бокс, час)
    bob_queue = deque([(N, 0)])
    
    # Створюємо множини для відслідковування відвіданих боксів Алісою та Бобом
    alice_visited = {1}
    bob_visited = {N}
    
    while alice_queue and bob_queue:
        # Розглядаємо кожен крок Аліси
        for _ in range(len(alice_queue)):
            a_pos, a_time = alice_queue.popleft()
            
            # Перевіряємо, чи Аліса і Боб можуть зустрітись на тій самій позиції
            if a_pos in bob_visited:
                return a_time
            
            # Переміщуємо Алісу в нові позиції
            for move in (a_pos + 2, a_pos + 3):
                if 1 <= move <= N and move not in alice_visited:
                    alice_visited.add(move)
                    alice_queue.append((move, a_time + 1))
        
        # Розглядаємо кожен крок Боба
        for _ in range(len(bob_queue)):
            b_pos, b_time = bob_queue.popleft()
            
            # Перевіряємо, чи Аліса і Боб можуть зустрітись на тій самій позиції
            if b_pos in alice_visited:
                return b_time
            
            # Переміщуємо Боба в нові позиції
            for move in (b_pos - 1, b_pos - 2):
                if 1 <= move <= N and move not in bob_visited:
                    bob_visited.add(move)
                    bob_queue.append((move, b_time + 1))
    
    # Якщо не знайшли спільну позицію
    return -1

# Вхід
N = int(input())

# Виведення результату
print(min_teleport_time(N))
