from collections import deque

def min_teleport_time(N):
    # Черги для BFS для Аліси та Боба
    alice_queue = deque([1])  # Аліса починає з 1
    bob_queue = deque([N])    # Боб починає з N
    
    # Множини для відслідковування відвіданих боксів
    alice_visited = {1}
    bob_visited = {N}
    
    # Лічильники часу для Аліси та Боба
    time = 0
    
    # Поки черги не порожні
    while alice_queue and bob_queue:
        time += 1
        
        # Аліса робить кроки
        for _ in range(len(alice_queue)):
            a_pos = alice_queue.popleft()
            
            # Аліса може телепортуватися на a_pos+2 або a_pos+3
            for move in [a_pos + 2, a_pos + 3]:
                if 1 <= move <= N and move not in alice_visited:
                    # Якщо Боб вже в цьому боксі, ми знайшли зустріч
                    if move in bob_visited:
                        return time
                    alice_visited.add(move)
                    alice_queue.append(move)
        
        # Боб робить кроки
        for _ in range(len(bob_queue)):
            b_pos = bob_queue.popleft()
            
            # Боб може телепортуватися на b_pos-1 або b_pos-2
            for move in [b_pos - 1, b_pos - 2]:
                if 1 <= move <= N and move not in bob_visited:
                    # Якщо Аліса вже в цьому боксі, ми знайшли зустріч
                    if move in alice_visited:
                        return time
                    bob_visited.add(move)
                    bob_queue.append(move)
    
    # Якщо не знайшли спільної позиції
    return -1

# Вхід
N = int(input())

# Виведення результату
print(min_teleport_time(N))
