def min_teleport_time(N):
    # Початкові позиції Аліси та Боба
    alice_positions = {1}  # Аліса починає з 1
    bob_positions = {N}    # Боб починає з N
    
    # Лічильник часу
    time = 0
    
    # Поки у нас є можливість рухатися (є позиції в обох множинах)
    while alice_positions and bob_positions:
        time += 1
        
        # Оновлення позицій для Аліси
        next_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= N: next_alice_positions.add(pos + 2)
            if pos + 3 <= N: next_alice_positions.add(pos + 3)
        
        # Перевіряємо, чи є спільні позиції з Бобом
        if next_alice_positions & bob_positions:
            return time
        
        # Оновлюємо позиції Аліси
        alice_positions = next_alice_positions
        
        # Оновлення позицій для Боба
        next_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1: next_bob_positions.add(pos - 1)
            if pos - 2 >= 1: next_bob_positions.add(pos - 2)
        
        # Перевіряємо, чи є спільні позиції з Алісою
        if next_bob_positions & alice_positions:
            return time
        
        # Оновлюємо позиції Боба
        bob_positions = next_bob_positions
    
    # Якщо не знайшли спільної позиції
    return -1

# Вхід
N = int(input())

# Виведення результату
print(min_teleport_time(N))
