from collections import deque

def min_teleport_time(N):
    # Стартові позиції для Аліси та Боба
    alice_queue = deque([1])  # Аліса починає з 1
    bob_queue = deque([N])    # Боб починає з N

    # Лічильник часу
    time = 0

    # Поки в обох чергах є елементи (вони ще можуть рухатись)
    while alice_queue and bob_queue:
        time += 1

        # Оновлення позицій для Аліси
        next_alice_positions = set()
        for a_pos in alice_queue:
            if a_pos + 2 <= N: next_alice_positions.add(a_pos + 2)
            if a_pos + 3 <= N: next_alice_positions.add(a_pos + 3)

        # Оновлення позицій для Боба
        next_bob_positions = set()
        for b_pos in bob_queue:
            if b_pos - 1 >= 1: next_bob_positions.add(b_pos - 1)
            if b_pos - 2 >= 1: next_bob_positions.add(b_pos - 2)

        # Перевірка на перетин позицій
        if next_alice_positions & next_bob_positions:
            return time
        
        # Оновлюємо черги для Аліси та Боба
        alice_queue = deque(next_alice_positions)
        bob_queue = deque(next_bob_positions)

    # Якщо не знайшли спільної позиції
    return -1

# Вхід
N = int(input())

# Виведення результату
print(min_teleport_time(N))
