from collections import deque

def min_teleport_time(N):
    # Стартові позиції для Аліси та Боба
    alice_queue = deque([1])  # Аліса починає з 1
    bob_queue = deque([N])    # Боб починає з N

    # Відвідані позиції
    visited_alice = set([1])
    visited_bob = set([N])

    # Лічильник часу
    time = 0

    # Поки в обох чергах є елементи (вони ще можуть рухатись)
    while alice_queue and bob_queue:
        time += 1

        # Оновлення позицій для Аліси
        for _ in range(len(alice_queue)):
            a_pos = alice_queue.popleft()
            for next_a in (a_pos + 2, a_pos + 3):
                if next_a <= N and next_a not in visited_alice:
                    visited_alice.add(next_a)
                    alice_queue.append(next_a)

        # Оновлення позицій для Боба
        for _ in range(len(bob_queue)):
            b_pos = bob_queue.popleft()
            for next_b in (b_pos - 1, b_pos - 2):
                if next_b >= 1 and next_b not in visited_bob:
                    visited_bob.add(next_b)
                    bob_queue.append(next_b)

        # Перевірка на перетин позицій
        if visited_alice & visited_bob:
            return time

    # Якщо не знайшли спільної позиції
    return -1

# Вхід
N = int(input())

# Виведення результату
print(min_teleport_time(N))