from collections import deque

def min_teleport_time(N):
    # Черги для BFS для Аліси та Боба
    alice_queue = deque([1])  # Аліса починає з 1
    bob_queue = deque([N])    # Боб починає з N
    
    # Множини для відслідковування відвіданих позицій
    alice_visited = {1}
    bob_visited = {N}
    
    # Лічильник часу
    time = 0
    
    # Функція для обробки кроків
    def process_queue(queue, visited, move_func, opponent_visited):
        for _ in range(len(queue)):
            pos = queue.popleft()
            for move in move_func(pos):
                if move not in visited:
                    if move in opponent_visited:
                        return True
                    visited.add(move)
                    queue.append(move)
        return False
    
    # Поки черги не порожні
    while alice_queue and bob_queue:
        time += 1
        
        # Аліса робить кроки
        if process_queue(alice_queue, alice_visited, lambda x: [x + 2, x + 3], bob_visited):
            return time
        
        # Боб робить кроки
        if process_queue(bob_queue, bob_visited, lambda x: [x - 1, x - 2], alice_visited):
            return time
    
    # Якщо не знайшли спільної позиції
    return -1

# Вхід
N = int(input())

# Виведення результату
print(min_teleport_time(N))