def count_uniform_squares(N, grid):
    count = 0

    # Loop through each possible starting point of the square
    for i in range(N):
        for j in range(N):
            # Check squares of increasing sizes
            for size in range(2, N - max(i, j) + 1):
                # Check if the square of size 'size' is within grid bounds
                if i + size <= N and j + size <= N:
                    # Check if all elements in the square are the same
                    uniform = True
                    for x in range(i, i + size):
                        for y in range(j, j + size):
                            if grid[x][y] != grid[i][j]:
                                uniform = False
                                break
                        if not uniform:
                            break
                    # If uniform, increment the count
                    if uniform:
                        count += 1

    return count

# Input processing
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Output the result
print(count_uniform_squares(N, grid))
