def count_uniform_squares(N, grid):
    dp = [[0] * N for _ in range(N)]
    count = 0
    
    # Initialize the dp table and count uniform squares
    for i in range(N):
        for j in range(N):
            if i == 0 or j == 0:  # First row or first column, squares can only be size 1
                dp[i][j] = 1
            else:
                if grid[i][j] == grid[i-1][j] == grid[i][j-1] == grid[i-1][j-1]:
                    dp[i][j] = min(dp[i-1][j], dp[i][j-1], dp[i-1][j-1]) + 1
                else:
                    dp[i][j] = 1

            # Count the squares of size 2 and above
            if dp[i][j] > 1:
                count += dp[i][j] - 1

    return count

# Input processing
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Output the result
print(count_uniform_squares(N, grid))
