def count_uniform_squares(N, grid):
    dp = [[0] * N for _ in range(N)]
    count = 0
    
    # Process the grid
    for i in range(N):
        for j in range(N):
            if i == 0 or j == 0:  # For the first row and first column
                dp[i][j] = 1  # A square of size 1 is always possible here
            else:
                if grid[i][j] == grid[i-1][j] == grid[i][j-1] == grid[i-1][j-1]:
                    dp[i][j] = min(dp[i-1][j], dp[i][j-1], dp[i-1][j-1]) + 1
                else:
                    dp[i][j] = 1  # A square of size 1 if not uniform with neighbors

            # Add all squares of size 2x2 or greater
            count += dp[i][j] - 1  # We subtract 1 to avoid counting the 1x1 square itself

    return count

# Input processing
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Output the result
print(count_uniform_squares(N, grid))
