def connect_points(test_cases):
    results = []
    
    for case in test_cases:
        N, blue_points, red_points = case
        
        # Sort blue points and red points
        sorted_blue = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
        sorted_red = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))
        
        # Prepare the result for this case
        connections = []
        
        # Check for valid connections
        for i in range(N):
            blue_index = sorted_blue[i][2]
            red_index = sorted_red[i][2]
            connections.append(f"{blue_index} {red_index}")
        
        # Check if connections are valid (non-intersecting)
        valid = True
        for i in range(N - 1):
            if (sorted_blue[i][0] < sorted_blue[i + 1][0] and sorted_red[i][0] > sorted_red[i + 1][0]) or \
               (sorted_blue[i][0] > sorted_blue[i + 1][0] and sorted_red[i][0] < sorted_red[i + 1][0]):
                valid = False
                break
        
        if valid:
            results.append("\n".join(connections))
        else:
            results.append("0")
    
    return results

# Read input
t = int(input())
test_cases = []

for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

# Get results
results = connect_points(test_cases)

# Print results
for result in results:
    print(result)