from collections import deque

def solve():
    N = int(input())  # Вхідне значення N
    
    # Якщо N менше 3, вони можуть зустрітися без жодних телепортацій
    if N == 2:
        print(1)
        return
    
    # Черга для Аліси і Боба
    alice_queue = deque([1])  # Аліса починає з клітинки 1
    bob_queue = deque([N])    # Боб починає з клітинки N
    alice_visited = {1}       # Відвідані клітинки для Аліси
    bob_visited = {N}         # Відвідані клітинки для Боба
    seconds = 0
    
    while alice_queue and bob_queue:
        seconds += 1
        # Переміщення Аліси
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for move in [2, 3]:
                next_pos = current + move
                if next_pos <= N and next_pos not in alice_visited:
                    if next_pos in bob_visited:
                        print(seconds)
                        return
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)
        
        # Переміщення Боба
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for move in [1, 2]:
                next_pos = current - move
                if next_pos >= 1 and next_pos not in bob_visited:
                    if next_pos in alice_visited:
                        print(seconds)
                        return
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)
    
    print(-1)

if __name__ == "__main__":
    solve()
