#include <iostream>
#include <vector>

using namespace std;

// Функція для підрахунку однорідних квадратів
int countUniformSquares(const vector<vector<int>>& grid, int N) {
    int count = 0;

    // Перебираємо всі можливі розміри квадратів
    for (int size = 1; size <= N; ++size) { // size - сторона квадрата
        for (int i = 0; i <= N - size; ++i) { // верхній лівий кут квадрата (i, j)
            for (int j = 0; j <= N - size; ++j) {
                bool isUniform = true;
                int color = grid[i][j]; // колір верхньої лівої точки квадрата

                // Перевіряємо, чи всі вершини мають однаковий колір
                for (int x = i; x < i + size; ++x) {
                    for (int y = j; y < j + size; ++y) {
                        if (grid[x][y] != color) {
                            isUniform = false;
                            break;
                        }
                    }
                    if (!isUniform) break;
                }

                if (isUniform) ++count; // якщо квадрат однорідний, збільшуємо лічильник
            }
        }
    }

    return count;
}

// Функція для обробки одного тесту
void processInputAndOutput(int caseNumber) {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));

    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    cout << "Вхідні дані #" << caseNumber << endl;
    cout << N << endl;
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cout << grid[i][j] << " ";
        }
        cout << endl;
    }

    int result = countUniformSquares(grid, N);
    cout << "Відповідь #" << caseNumber << endl;
    cout << result << endl;
}

// Головна функція
int main() {
    processInputAndOutput(1); // Обробка першого тесту
    processInputAndOutput(2); // Обробка другого тесту

    return 0;
}
