#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

// Структура для зберігання координат точок із їх індексами
struct Point {
    int x, y, index;
};

// Функція для читання тестових даних та обробки
vector<vector<pair<int, int>>> solve(int t, vector<pair<int, vector<Point>>> test_cases) {
    vector<vector<pair<int, int>>> results;

    for (int case_index = 0; case_index < t; ++case_index) {
        int N = test_cases[case_index].first;
        vector<Point> blue_points(test_cases[case_index].second.begin(), test_cases[case_index].second.begin() + N);
        vector<Point> red_points(test_cases[case_index].second.begin() + N, test_cases[case_index].second.end());

        // Сортування точок за x (якщо x однаковий, сортуємо за y)
        sort(blue_points.begin(), blue_points.end(), [](const Point &a, const Point &b) {
            return a.x < b.x || (a.x == b.x && a.y < b.y);
        });
        sort(red_points.begin(), red_points.end(), [](const Point &a, const Point &b) {
            return a.x < b.x || (a.x == b.x && a.y < b.y);
        });

        // Створення пар
        vector<pair<int, int>> pairs;
        for (int i = 0; i < N; ++i) {
            pairs.push_back({blue_points[i].index, red_points[i].index});
        }

        results.push_back(pairs);
    }

    return results;
}

int main() {
    int t;
    cin >> t;
    vector<pair<int, vector<Point>>> test_cases;

    for (int i = 0; i < t; ++i) {
        int N;
        cin >> N;

        vector<Point> blue_points(N);
        vector<Point> red_points(N);

        for (int j = 0; j < N; ++j) {
            cin >> blue_points[j].x >> blue_points[j].y;
            blue_points[j].index = j + 1; // Зберігаємо індекс
        }

        for (int j = 0; j < N; ++j) {
            cin >> red_points[j].x >> red_points[j].y;
            red_points[j].index = j + 1; // Зберігаємо індекс
        }

        vector<Point> all_points(blue_points);
        all_points.insert(all_points.end(), red_points.begin(), red_points.end());

        test_cases.push_back({N, all_points});
    }

    vector<vector<pair<int, int>>> results = solve(t, test_cases);

    for (const auto &result : results) {
        if (result.empty()) {
            cout << 0 << endl;
        } else {
            for (const auto &p : result) {
                cout << p.first << " " << p.second << endl;
            }
        }
    }

    return 0;
}
