<?php

function min_seconds_to_meet($N) {
    // Initial positions of Alice and Bob
    $alice_pos = 1;
    $bob_pos = $N;
    
    // Number of seconds passed
    $seconds = 0;
    
    // Sets to track visited positions
    $alice_visited = [1 => true];
    $bob_visited = [$N => true];
    
    while (true) {
        // Step 1: Alice's moves
        $new_alice_positions = [];
        foreach ([2, 3] as $move) {
            $new_pos = $alice_pos + $move;
            if ($new_pos <= $N && !isset($alice_visited[$new_pos])) {
                $new_alice_positions[] = $new_pos;
                $alice_visited[$new_pos] = true;
                if (isset($bob_visited[$new_pos])) {
                    return $seconds + 1;
                }
            }
        }
        
        // Step 2: Bob's moves
        $new_bob_positions = [];
        foreach ([1, 2] as $move) {
            $new_pos = $bob_pos - $move;
            if ($new_pos >= 1 && !isset($bob_visited[$new_pos])) {
                $new_bob_positions[] = $new_pos;
                $bob_visited[$new_pos] = true;
                if (isset($alice_visited[$new_pos])) {
                    return $seconds + 1;
                }
            }
        }
        
        // If Alice and Bob cannot meet, stop
        if (empty($new_alice_positions) && empty($new_bob_positions)) {
            break;
        }
        
        // Update positions for the next second
        $alice_pos = $new_alice_positions[0] ?? $alice_pos;
        $bob_pos = $new_bob_positions[0] ?? $bob_pos;
        
        // Increment the seconds
        $seconds++;
    }
    
    return -1;
}

// Input
$N = intval(trim(fgets(STDIN)));

// Output the result
echo min_seconds_to_meet($N) . "\n";

?>