<?php

function min_seconds_to_meet($N) {
    // Queues to store positions of Alice and Bob
    $alice_queue = [1];  // Starting position of Alice (box 1)
    $bob_queue = [$N];    // Starting position of Bob (box N)
    
    // Sets to track visited positions for Alice and Bob
    $alice_visited = [1 => true];
    $bob_visited = [$N => true];
    
    // Initialize the number of seconds
    $seconds = 0;
    
    while (!empty($alice_queue) && !empty($bob_queue)) {
        // Step 1: Alice teleports
        $alice_queue_size = count($alice_queue);
        for ($i = 0; $i < $alice_queue_size; $i++) {
            $current_alice = array_shift($alice_queue);  // Dequeue Alice's position
            // Alice's possible moves (k+2, k+3)
            foreach ([2, 3] as $move) {
                $new_pos = $current_alice + $move;
                if ($new_pos <= $N && !isset($alice_visited[$new_pos])) {
                    $alice_visited[$new_pos] = true;
                    $alice_queue[] = $new_pos;
                    // Check if Alice and Bob meet
                    if (isset($bob_visited[$new_pos])) {
                        return $seconds + 1;
                    }
                }
            }
        }
        
        // Step 2: Bob teleports
        $bob_queue_size = count($bob_queue);
        for ($i = 0; $i < $bob_queue_size; $i++) {
            $current_bob = array_shift($bob_queue);  // Dequeue Bob's position
            // Bob's possible moves (k-1, k-2)
            foreach ([1, 2] as $move) {
                $new_pos = $current_bob - $move;
                if ($new_pos >= 1 && !isset($bob_visited[$new_pos])) {
                    $bob_visited[$new_pos] = true;
                    $bob_queue[] = $new_pos;
                    // Check if Alice and Bob meet
                    if (isset($alice_visited[$new_pos])) {
                        return $seconds + 1;
                    }
                }
            }
        }
        
        // Increment seconds
        $seconds++;
    }
    
    // If they can't meet
    return -1;
}

// Input
$N = intval(trim(fgets(STDIN)));

// Output the result
echo min_seconds_to_meet($N) . "\n";

?>