#include <iostream>
#include <vector>
using namespace std;

int countUniformSquares(int N, const vector<vector<int>>& grid) {
    int count = 0;
    
    // Створюємо масив для збереження максимальних розмірів квадратів
    vector<vector<int>> dp(N, vector<int>(N, 0));
    
    // Ідемо через усі точки сітки
    for (int i = N - 1; i >= 0; --i) {
        for (int j = N - 1; j >= 0; --j) {
            // Якщо на останньому рядку або стовпці, квадрат 1x1 є єдиним можливим варіантом
            if (i == N - 1 || j == N - 1) {
                dp[i][j] = 1;
            } else {
                // Якщо поточна точка може бути частиною більшого квадрату
                if (grid[i][j] == grid[i+1][j] && grid[i][j] == grid[i][j+1] && grid[i][j] == grid[i+1][j+1]) {
                    dp[i][j] = min({dp[i+1][j], dp[i][j+1], dp[i+1][j+1]}) + 1;
                } else {
                    dp[i][j] = 1;
                }
            }
            // Додаємо кількість однотипних квадратів
            count += dp[i][j];
        }
    }
    
    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));

    // Читання сітки
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    // Обчислення кількості однотипних квадратів
    int result = countUniformSquares(N, grid);

    // Виведення результату
    cout << result << endl;

    return 0;
}
