#include <iostream>
#include <vector>
using namespace std;

int countUniformSquares(int N, const vector<vector<int>> &grid) {
    int count = 0;

    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            for (int k = 1; i + k < N && j + k < N; ++k) {
                int topLeft = grid[i][j];
                int topRight = grid[i][j + k];
                int bottomLeft = grid[i + k][j];
                int bottomRight = grid[i + k][j + k];

                if (topLeft == topRight && topLeft == bottomLeft && topLeft == bottomRight) {
                    ++count;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));

    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = countUniformSquares(N, grid);

    cout << result << endl;

    return 0;
}