#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Point {
    int x, y, index;
};

void solve() {
    int t; 
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);

        for (int i = 0; i < N; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }

        for (int i = 0; i < N; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        auto comparator = [](const Point &a, const Point &b) {
            return (a.x < b.x) || (a.x == b.x && a.y < b.y);
        };

        sort(blue.begin(), blue.end(), comparator);
        sort(red.begin(), red.end(), comparator);

        vector<pair<int, int>> pairs;
        bool valid = true;

        for (int i = 0; i < N; ++i) {
            pairs.emplace_back(blue[i].index, red[i].index);
        }

        if (valid) {
            for (const auto &[b, r] : pairs) {
                cout << b << " " << r << "\n";
            }
        } else {
            cout << "0\n";
        }

        if (t) cout << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}