import java.util.*;

class Point {
    int x, y, index;

    Point(int x, int y, int index) {
        this.x = x;
        this.y = y;
        this.index = index;
    }
}

public class Main {
    public static void solve() {
        Scanner scanner = new Scanner(System.in);

        int t = scanner.nextInt();

        while (t-- > 0) {
            int N = scanner.nextInt();

            List<Point> blue = new ArrayList<>();
            List<Point> red = new ArrayList<>();

            // Читання синіх точок
            for (int i = 0; i < N; i++) {
                int x = scanner.nextInt();
                int y = scanner.nextInt();
                blue.add(new Point(x, y, i + 1)); // Зберігаємо індекс для кожної точки
            }

            // Читання червоних точок
            for (int i = 0; i < N; i++) {
                int x = scanner.nextInt();
                int y = scanner.nextInt();
                red.add(new Point(x, y, i + 1)); // Зберігаємо індекс для кожної точки
            }

            // Сортуємо обидва набори точок: спочатку за x, а потім за y
            Comparator<Point> comparator = (a, b) -> {
                if (a.x != b.x) {
                    return Integer.compare(a.x, b.x);
                } else {
                    return Integer.compare(a.y, b.y);
                }
            };

            Collections.sort(blue, comparator);
            Collections.sort(red, comparator);

            // Виведення пар точок
            for (int i = 0; i < N; i++) {
                System.out.println(blue.get(i).index + " " + red.get(i).index);
            }

            // Додатковий порожній рядок для розділення тестів
            if (t > 0) {
                System.out.println();
            }
        }

        scanner.close();
    }

    public static void main(String[] args) {
        solve();
    }
}