def find_pairs(canvas, color):
    pairs = []
    zero_indices = []

    for i in range(len(canvas)):
        for j in range(len(canvas[0])):
            if canvas[i][j] == color:
                zero_indices.append((i, j))

    for i in range(len(zero_indices)):
        for j in range(i + 1, len(zero_indices)):
            pairs.append((zero_indices[i], zero_indices[j]))

    return pairs

def find_squares(canvas, color, pair):
    # first and second point
    a, b = pair
    ay, ax = a
    by, bx = b

    diff_x = bx - ax
    diff_y = by - ay

    # points c and d of a squares 1 and 2
    c1x = ax + diff_y
    c1y = ay - diff_x
    d1x = bx + diff_y
    d1y = by - diff_x

    c2x = ax - diff_y
    c2y = ay + diff_x
    d2x = bx - diff_y
    d2y = by + diff_x

    squares = []
    try:
        if c1x >= 0 and c1y >= 0 and d1x >= 0 and d1y >= 0:
            if canvas[c1y][c1x] == color and canvas[d1y][d1x] == color:
                squares.append([a, b, (c1y, c1x), (d1y, d1x)])
    except IndexError:
        pass
    try:
        if c2x >= 0 and c2y >= 0 and d2x >= 0 and d2y >= 0:
            if canvas[c2y][c2x] == color and canvas[d2y][d2x] == color:
                squares.append([a, b, (c2y, c2x), (d2y, d2x)])
    except IndexError:
        pass
    
    return squares


def are_points_equivalent(square1, square2):

    set1 = set(square1)
    set2 = set(square2)

    return set1 == set2


def count_unique_squares(squares):
    unique_squares = []
    
    for square in squares:
        
        is_new_square = True
        for unique_square in unique_squares:
            if are_points_equivalent(square, unique_square):
                is_new_square = False
                break
        
        if is_new_square:
            unique_squares.append(square)
    
    return len(unique_squares)

def solve(cavas, color):
    pairs = find_pairs(canvas, color)
    squares = []
    for pair in pairs:
        squares += find_squares(canvas, color, pair)

    return count_unique_squares(squares)

n = int(input())

canvas = []
for row in range(n):
    canvas.append(list(map(int, input().split(" "))))

print(solve(canvas, 0) + solve(canvas, 1))