t = int(input())


def pair_points(blue_points, red_points):

    N = len(blue_points)
    used_red = [False] * N
    pairings = []

    def backtrack(current_pairing):
        if len(current_pairing) == N:
            pairings.append(current_pairing.copy())
            return

        for i in range(N):
            if not used_red[i]:
                used_red[i] = True
                current_pairing.append((blue_points[len(current_pairing)], red_points[i]))
                backtrack(current_pairing)
                current_pairing.pop()
                used_red[i] = False

    backtrack([])
    return pairings


def ccw(A, B, C):
    return (C[1] - A[1]) * (B[0] - A[0]) > (B[1] - A[1]) * (C[0] - A[0])
             
                                          
def intersect(A, B, C, D):
    return ccw(A, C, D) != ccw(B, C, D) and ccw(A, B, C) != ccw(A, B, D)


def solve(n, blue_points, red_points):
    possible_solutions = pair_points(blue_points, red_points)
    for solution in possible_solutions:
        fail = False
        for i in range(len(solution)):
            for j in range(i+1, len(solution)):
                if intersect(*solution[i], *solution[j]):
                    fail = True
        if not fail:
            return [solution]


for block in range(t):
    n = int(input())
    blue_points = []
    red_points = []
    for blue in range(n):
        blue_points.append(tuple(map(int, input().split(" "))))
    for red in range(n):
        red_points.append(tuple(map(int, input().split(" "))))
    
    solution = solve(n, blue_points, red_points)[0]

    for pair in solution:
        try:
            a = blue_points.index(pair[0]) + 1
        except ValueError:
            a = red_points.index(pair[0]) + 1
        try:
            b = red_points.index(pair[1]) + 1
        except ValueError:
            b = blue_points.index(pair[1]) + 1
        print(a, b)