import networkx as nx
def solve(blue_points, red_points):
    n = len(blue_points)
    G = nx.Graph()
    for i in range(n):
        G.add_node(i, color='blue')
        G.add_node(n + i, color='red')
    for i in range(n):
        for j in range(n):
            x1, y1 = blue_points[i]
            x2, y2 = red_points[j]
            distance = ((x1 - x2)**2 + (y1 - y2)**2)**0.5
            G.add_edge(i, n + j, weight=distance)
    matching = nx.max_weight_matching(G)
    result = [(i, j - n) for i, j in matching]
    return result
t = int(input())
for _ in range(t):
    n = int(input())
    blue_points = []
    red_points = []
    for _ in range(n):
        x, y = map(int, input().split())
        blue_points.append((x, y))
    for _ in range(n):
        x, y = map(int, input().split())
        red_points.append((x, y))
    result = solve(blue_points, red_points)
    if result:
        for pair in result:
            print(*pair)
    else:
        print(0)