from collections import deque

def min_time_to_meet(N):
    # Черга для Аліси та Боба
    alice_queue = deque([1])  # Початкові позиції Аліси
    bob_queue = deque([N])    # Початкові позиції Боба
    
    # Множини відвіданих позицій
    alice_visited = {1}
    bob_visited = {N}
    
    time = 0
    
    while alice_queue and bob_queue:
        time += 1
        
        # Рух Аліси
        for _ in range(len(alice_queue)):
            position = alice_queue.popleft()
            for next_position in (position + 2, position + 3):
                if 1 <= next_position <= N and next_position not in alice_visited:
                    if next_position in bob_visited:
                        return time
                    alice_visited.add(next_position)
                    alice_queue.append(next_position)
        
        # Рух Боба
        for _ in range(len(bob_queue)):
            position = bob_queue.popleft()
            for next_position in (position - 1, position - 2):
                if 1 <= next_position <= N and next_position not in bob_visited:
                    if next_position in alice_visited:
                        return time
                    bob_visited.add(next_position)
                    bob_queue.append(next_position)
    
    return -1  # Якщо не знайшли спільного бокс

# Вхідні дані
N = int(input())

# Вивести результат
print(min_time_to_meet(N))
