def min_time_to_meet(N):
    # If the number of boxes is 2, they can meet in 1 second
    if N == 2:
        return 1
    
    # Initialize the positions of Alice and Bob
    alice = 1
    bob = N
    time = 0
    
    # Use sets to store possible positions of Alice and Bob at each time step
    alice_positions = {alice}
    bob_positions = {bob}
    
    while alice_positions and bob_positions:
        time += 1
        next_alice_positions = set()
        next_bob_positions = set()
        
        # Alice moves
        for pos in alice_positions:
            if pos + 2 <= N:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                next_alice_positions.add(pos + 3)
        
        # Bob moves
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)
        
        # Check if any of Alice's positions coincide with Bob's
        if next_alice_positions & next_bob_positions:
            return time
        
        # Update the positions
        alice_positions = next_alice_positions
        bob_positions = next_bob_positions
    
    return -1  # If no common position is found

# Input
N = int(input())

# Output
print(min_time_to_meet(N))
