from collections import deque

def min_time_to_meet(N):
    # Initialize queues for Alice and Bob
    alice_queue = deque([1])  # Alice starts at position 1
    bob_queue = deque([N])    # Bob starts at position N
    
    # Sets to track visited positions for Alice and Bob
    alice_visited = {1}
    bob_visited = {N}
    
    # Time counter
    time = 0
    
    while alice_queue and bob_queue:
        time += 1
        
        # Process Alice's movements for this second
        for _ in range(len(alice_queue)):
            position = alice_queue.popleft()
            for next_position in (position + 2, position + 3):
                if 1 <= next_position <= N and next_position not in alice_visited:
                    if next_position in bob_visited:
                        return time
                    alice_visited.add(next_position)
                    alice_queue.append(next_position)
        
        # Process Bob's movements for this second
        for _ in range(len(bob_queue)):
            position = bob_queue.popleft()
            for next_position in (position - 1, position - 2):
                if 1 <= next_position <= N and next_position not in bob_visited:
                    if next_position in alice_visited:
                        return time
                    bob_visited.add(next_position)
                    bob_queue.append(next_position)
    
    # If no meeting point found
    return -1

# Input
N = int(input())

# Output
print(min_time_to_meet(N))
