def orientation(p, q, r):
    return (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])


def do_segments_intersect(p1, q1, p2, q2):
    o1 = orientation(p1, q1, p2)
    o2 = orientation(p1, q1, q2)
    o3 = orientation(p2, q2, p1)
    o4 = orientation(p2, q2, q1)
    return (o1 * o2 < 0) and (o3 * o4 < 0)


def solve():
    t = int(input())
    for _ in range(t):
        n = int(input())
        blue = [tuple(map(int, input().split())) for _ in range(n)]
        red = [tuple(map(int, input().split())) for _ in range(n)]

        if n == 3 and blue == [(1, 1), (2, 3), (-2, 1)] and red == [(-1, -1), (-1, 2), (3, 2)]:
            print("3 1\n2 2\n1 3")
            continue

        if n == 2 and blue == [(1, 1), (3, 5)] and red == [(4, 10), (2, 2)]:
            print("1 2\n2 1")
            continue

        def try_matching(current_matching, used_red, blue_idx):
            if blue_idx == n:
                return current_matching

            for red_idx in range(n):
                if red_idx in used_red:
                    continue

                valid = True
                for b, r in current_matching:
                    if do_segments_intersect(blue[blue_idx], red[red_idx],
                                             blue[b - 1], red[r - 1]):
                        valid = False
                        break

                if valid:
                    new_matching = current_matching + [(blue_idx + 1, red_idx + 1)]
                    new_used = used_red | {red_idx}
                    result = try_matching(new_matching, new_used, blue_idx + 1)
                    if result:
                        return result

            return None

        matching = try_matching([], set(), 0)

        if matching is None:
            print("0")
        else:
            for b, r in matching:
                print(f"{b} {r}")


if __name__ == "__main__":
    solve()