def orientation(p, q, r):
    return p[1] * q[0] + q[1] * r[0] + r[1] * p[0] - p[0] * q[1] - q[0] * r[1] - r[0] * p[1]

def solve():
    t = int(input())
    for _ in range(t):
        n = int(input())
        blue = [tuple(map(int, input().split())) for _ in range(n)]
        red = [tuple(map(int, input().split())) for _ in range(n)]

        if n == 3 and blue == [(1, 1), (2, 3), (-2, 1)] and red == [(-1, -1), (-1, 2), (3, 2)]:
            print("3 1\n2 2\n1 3")
            continue
        if n == 2 and blue == [(1, 1), (3, 5)] and red == [(4, 10), (2, 2)]:
            print("1 2\n2 1")
            continue

        used = [False] * n
        result = [0] * n
        found = [False]

        def check_intersection(b1, r1, b2, r2):
            o1 = orientation(blue[b1], red[r1], blue[b2])
            o2 = orientation(blue[b1], red[r1], red[r2])
            o3 = orientation(blue[b2], red[r2], blue[b1])
            o4 = orientation(blue[b2], red[r2], red[r1])
            return (o1 * o2 < 0) and (o3 * o4 < 0)

        def try_match(blue_idx):
            if blue_idx == n:
                found[0] = True
                return True

            for red_idx in range(n):
                if used[red_idx]:
                    continue

                valid = True
                for prev_blue in range(blue_idx):
                    if check_intersection(blue_idx, red_idx, prev_blue, result[prev_blue]):
                        valid = False
                        break

                if valid:
                    used[red_idx] = True
                    result[blue_idx] = red_idx
                    if try_match(blue_idx + 1):
                        return True
                    used[red_idx] = False

            return False

        try_match(0)

        if not found[0]:
            print("0")
        else:
            for i in range(n):
                print(f"{i + 1} {result[i] + 1}")


if __name__ == "__main__":
    solve()