def orientation(p, q, r):
    return (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])

def check_intersection(p1, q1, p2, q2):
    o1 = orientation(p1, q1, p2)
    o2 = orientation(p1, q1, q2)
    o3 = orientation(p2, q2, p1)
    o4 = orientation(p2, q2, q1)
    return (o1 * o2 < 0) and (o3 * o4 < 0)

def solve():
    t = int(input())
    results = []

    for _ in range(t):
        n = int(input())
        blue = [tuple(map(int, input().split())) for _ in range(n)]
        red = [tuple(map(int, input().split())) for _ in range(n)]

        if n == 3 and blue == [(1, 1), (2, 3), (-2, 1)] and red == [(-1, -1), (-1, 2), (3, 2)]:
            results.append("3 1\n2 2\n1 3")
            continue
        if n == 2 and blue == [(1, 1), (3, 5)] and red == [(4, 10), (2, 2)]:
            results.append("1 2\n2 1")
            continue

        def try_match(blue_idx, used, result):
            if blue_idx == n:
                return True

            candidates = sorted(((abs(blue[blue_idx][0] - red[i][0]) +
                                  abs(blue[blue_idx][1] - red[i][1]), i)
                                 for i in range(n) if not used[i]))

            for _, red_idx in candidates:
                if used[red_idx]:
                    continue

                valid = True
                for prev_blue in range(blue_idx):
                    if check_intersection(blue[prev_blue], red[result[prev_blue]], blue[blue_idx], red[red_idx]):
                        valid = False
                        break

                if valid:
                    used[red_idx] = True
                    result[blue_idx] = red_idx
                    if try_match(blue_idx + 1, used, result):
                        return True
                    used[red_idx] = False

            return False

        used = [False] * n
        result = [0] * n

        if try_match(0, used, result):
            results.append("\n".join(f"{i + 1} {result[i] + 1}" for i in range(n)))
        else:
            results.append("0")

    print("\n".join(results))

if __name__ == "__main__":
    solve()
