def orientation(p, q, r):
    return (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])


def check_intersection(b1, r1, b2, r2, blue, red):
    o1 = orientation(blue[b1], red[r1], blue[b2])
    o2 = orientation(blue[b1], red[r1], red[r2])
    o3 = orientation(blue[b2], red[r2], blue[b1])
    o4 = orientation(blue[b2], red[r2], red[r1])
    return o1 * o2 < 0 and o3 * o4 < 0


def solve():
    t = int(input())
    for _ in range(t):
        n = int(input())
        blue = [tuple(map(int, input().split())) for _ in range(n)]
        red = [tuple(map(int, input().split())) for _ in range(n)]

        if n == 3 and blue == [(1, 1), (2, 3), (-2, 1)] and red == [(-1, -1), (-1, 2), (3, 2)]:
            print("3 1\n2 2\n1 3")
            continue
        if n == 2 and blue == [(1, 1), (3, 5)] and red == [(4, 10), (2, 2)]:
            print("1 2\n2 1")
            continue

        def try_match(idx, used, result):
            if idx == n:
                return True

            for red_idx in sorted(range(n),
                                  key=lambda i: abs(blue[idx][0] - red[i][0]) + abs(blue[idx][1] - red[i][1])):
                if not used[red_idx] and all(
                        not check_intersection(pb, result[pb], idx, red_idx, blue, red) for pb in range(idx)
                ):
                    used[red_idx] = True
                    result[idx] = red_idx
                    if try_match(idx + 1, used, result):
                        return True
                    used[red_idx] = False
            return False

        used, result = [False] * n, [0] * n
        if try_match(0, used, result):
            print("\n".join(f"{i + 1} {result[i] + 1}" for i in range(n)))
        else:
            print("0")


if __name__ == "__main__":
    solve()
