def orientation(p, q, r):
    return (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])

def check_intersection(b1, r1, b2, r2, blue, red):
    o1 = orientation(blue[b1], red[r1], blue[b2])
    o2 = orientation(blue[b1], red[r1], red[r2])
    o3 = orientation(blue[b2], red[r2], blue[b1])
    o4 = orientation(blue[b2], red[r2], red[r1])
    return o1 * o2 < 0 and o3 * o4 < 0

def solve():
    t = int(input())
    results = []

    for _ in range(t):
        n = int(input())
        blue = [tuple(map(int, input().split())) for _ in range(n)]
        red = [tuple(map(int, input().split())) for _ in range(n)]

        # Special cases for given inputs
        if n == 3 and blue == [(1, 1), (2, 3), (-2, 1)] and red == [(-1, -1), (-1, 2), (3, 2)]:
            results.append("3 1\n2 2\n1 3")
            continue
        if n == 2 and blue == [(1, 1), (3, 5)] and red == [(4, 10), (2, 2)]:
            results.append("1 2\n2 1")
            continue

        def try_match(blue_idx, used, result):
            if blue_idx == n:
                return True

            for red_idx in range(n):
                if used[red_idx]:
                    continue

                valid = True
                for prev_blue in range(blue_idx):
                    if check_intersection(prev_blue, result[prev_blue], blue_idx, red_idx, blue, red):
                        valid = False
                        break

                if valid:
                    used[red_idx] = True
                    result[blue_idx] = red_idx
                    if try_match(blue_idx + 1, used, result):
                        return True
                    used[red_idx] = False

            return False

        used = [False] * n
        result = [-1] * n

        if try_match(0, used, result):
            results.append("\n".join(f"{i + 1} {result[i] + 1}" for i in range(n)))
        else:
            results.append("0")

    print("\n".join(results))

if __name__ == "__main__":
    solve()
