from collections import deque

def min_time_to_meet(N):
    # Чекати на зустріч двох роботів
    queue_A = deque([1])  # Черга для Аліси
    queue_B = deque([N])  # Черга для Боба
    visited_A = set([1])  # Множина для відвіданих Алісою
    visited_B = set([N])  # Множина для відвіданих Бобом
    seconds = 0  # Лічильник секунд

    # Процес BFS для двох роботів
    while queue_A and queue_B:
        # Проходимо всі клітини для Аліси
        for _ in range(len(queue_A)):
            position_A = queue_A.popleft()
            if position_A in visited_B:  # Якщо Аліса зустрілась з Бобом
                return seconds
            # Телепортуємо Алісу в наступні клітини
            if position_A + 2 <= N and position_A + 2 not in visited_A:
                visited_A.add(position_A + 2)
                queue_A.append(position_A + 2)
            if position_A + 3 <= N and position_A + 3 not in visited_A:
                visited_A.add(position_A + 3)
                queue_A.append(position_A + 3)

        # Проходимо всі клітини для Боба
        for _ in range(len(queue_B)):
            position_B = queue_B.popleft()
            if position_B in visited_A:  # Якщо Боб зустрівся з Алісою
                return seconds
            # Телепортуємо Боба в наступні клітини
            if position_B - 1 >= 1 and position_B - 1 not in visited_B:
                visited_B.add(position_B - 1)
                queue_B.append(position_B - 1)
            if position_B - 2 >= 1 and position_B - 2 not in visited_B:
                visited_B.add(position_B - 2)
                queue_B.append(position_B - 2)

        # Збільшуємо кількість секунд після кожного рівня BFS
        seconds += 1
    
    # Якщо роботам не вдалося зустрітись
    return -1

# Читання вхідних даних
N = int(input().strip())

# Виведення результату
print(min_time_to_meet(N))
