from collections import deque

def minimum_steps(N):
    # Ініціалізуємо чергу для BFS
    queue = deque([(1, 0, 'A'), (N, 0, 'B')])  # (позиція, кроки, хто)
    
    # Відвідані позиції для Аліси і Боба
    visited_A = set([1])
    visited_B = set([N])
    
    while queue:
        pos, steps, who = queue.popleft()
        
        # Якщо зустрілися
        if who == 'A' and pos in visited_B:
            return steps
        if who == 'B' and pos in visited_A:
            return steps
        
        # Рух для Аліси
        if who == 'A':
            # Додаємо можливі рухи Аліси
            for move in [2, 3]:
                new_pos = pos + move
                if new_pos <= N and new_pos not in visited_A:
                    visited_A.add(new_pos)
                    queue.append((new_pos, steps + 1, 'A'))
        
        # Рух для Боба
        elif who == 'B':
            # Додаємо можливі рухи Боба
            for move in [1, 2]:
                new_pos = pos - move
                if new_pos >= 1 and new_pos not in visited_B:
                    visited_B.add(new_pos)
                    queue.append((new_pos, steps + 1, 'B'))
    
    return -1

# Читання вхідних даних
N = int(input())

# Виведення результату
print(minimum_steps(N))
