from collections import deque

def min_seconds(N):
    # Стартові умови
    alice_positions = deque([1])  # Аліса починає з боксом 1
    bob_positions = deque([N])    # Боб починає з боксом N
    
    # Масив для відслідковування, чи було вже відвідано якийсь бокс
    alice_visited = set([1])  
    bob_visited = set([N])  
    
    seconds = 0
    
    # Поки позиції Аліси та Боба не перетинаються
    while alice_positions and bob_positions:
        seconds += 1
        # Обробляємо рухи Аліси
        for _ in range(len(alice_positions)):
            pos = alice_positions.popleft()
            # Аліса може переміщатися на 2 або 3 клітинки вперед
            for move in [2, 3]:
                new_pos = pos + move
                if new_pos not in alice_visited and new_pos <= N:
                    alice_visited.add(new_pos)
                    alice_positions.append(new_pos)

        # Обробляємо рухи Боба
        for _ in range(len(bob_positions)):
            pos = bob_positions.popleft()
            # Боб може переміщатися на 1 або 2 клітинки назад
            for move in [1, 2]:
                new_pos = pos - move
                if new_pos not in bob_visited and new_pos >= 1:
                    bob_visited.add(new_pos)
                    bob_positions.append(new_pos)

        # Перевіряємо на перетинання позицій
        if alice_visited & bob_visited:
            return seconds

    # Якщо перетину не сталося
    return -1

# Вхідні дані
N = int(input())

# Виведення результату
print(min_seconds(N))
