def min_steps_to_meet(N):
    # Два набори для позицій робітників
    visited_1 = set()
    visited_2 = set()
    
    # Початкові позиції
    robot1_positions = [1]
    robot2_positions = [N]
    
    # Початкові кількості ходів
    steps_1 = 0
    steps_2 = 0
    
    # Черга для BFS
    while robot1_positions or robot2_positions:
        # Крок 1: обробка ходів робота 1
        next_robot1_positions = []
        for pos in robot1_positions:
            if pos in visited_2:  # Перевірка на зустріч
                return steps_1 + steps_2
            visited_1.add(pos)
            if pos + 2 <= N and pos + 2 not in visited_1:
                next_robot1_positions.append(pos + 2)
            if pos + 3 <= N and pos + 3 not in visited_1:
                next_robot1_positions.append(pos + 3)
        
        robot1_positions = next_robot1_positions
        steps_1 += 1
        
        # Крок 2: обробка ходів робота 2
        next_robot2_positions = []
        for pos in robot2_positions:
            if pos in visited_1:  # Перевірка на зустріч
                return steps_1 + steps_2
            visited_2.add(pos)
            if pos - 1 > 0 and pos - 1 not in visited_2:
                next_robot2_positions.append(pos - 1)
            if pos - 2 > 0 and pos - 2 not in visited_2:
                next_robot2_positions.append(pos - 2)
        
        robot2_positions = next_robot2_positions
        steps_2 += 1
    
    # Якщо роботи не можуть зустрітися
    return -1

# Читання вхідних даних
N = int(input())
print(min_steps_to_meet(N))
