from collections import deque

def min_steps_to_meet(N):
    # Черга для BFS для обох роботів
    queue_1 = deque([(1, 0)])  # Перший робот: (позиція, кількість ходів)
    queue_2 = deque([(N, 0)])  # Другий робот: (позиція, кількість ходів)
    
    # Множини для відслідковування відвіданих позицій
    visited_1 = {1}
    visited_2 = {N}
    
    # Обробка BFS
    while queue_1 and queue_2:
        # Обробка черги першого робота
        for _ in range(len(queue_1)):
            pos_1, steps_1 = queue_1.popleft()
            # Якщо позиція першого робота зустрічається з позицією другого робота
            if pos_1 in visited_2:
                return steps_1 + next(steps for p, steps in queue_2 if p == pos_1)
            
            # Рух першого робота на 2 куби вперед
            if pos_1 + 2 <= N and pos_1 + 2 not in visited_1:
                visited_1.add(pos_1 + 2)
                queue_1.append((pos_1 + 2, steps_1 + 1))
            # Рух першого робота на 3 куби вперед
            if pos_1 + 3 <= N and pos_1 + 3 not in visited_1:
                visited_1.add(pos_1 + 3)
                queue_1.append((pos_1 + 3, steps_1 + 1))

        # Обробка черги другого робота
        for _ in range(len(queue_2)):
            pos_2, steps_2 = queue_2.popleft()
            # Якщо позиція другого робота зустрічається з позицією першого робота
            if pos_2 in visited_1:
                return steps_2 + next(steps for p, steps in queue_1 if p == pos_2)

            # Рух другого робота на 1 куб назад
            if pos_2 - 1 > 0 and pos_2 - 1 not in visited_2:
                visited_2.add(pos_2 - 1)
                queue_2.append((pos_2 - 1, steps_2 + 1))
            # Рух другого робота на 2 куби назад
            if pos_2 - 2 > 0 and pos_2 - 2 not in visited_2:
                visited_2.add(pos_2 - 2)
                queue_2.append((pos_2 - 2, steps_2 + 1))

    # Якщо роботи не можуть зустрітися
    return -1

# Читання вхідних даних
N = int(input())
print(min_steps_to_meet(N))
