def find_minimum_stamps(N, M):
    # Максимальна сума всіх марок від 1 до N
    total_sum = N * (N + 1) // 2
    
    # Якщо M більше за максимальну можливу суму марок, то це неможливо
    if M > total_sum:
        return [0]

    # Рекурсивна функція для вибору марок
    def choose_stamps(M, N, result):
        if M == 0:
            return result  # Якщо сума досягнута, повертаємо результат
        if N == 0:
            return None  # Якщо не можемо вибрати більше марок

        # Якщо поточна марка менша або рівна M, вибираємо її
        if M >= N:
            result.append(N)
            return choose_stamps(M - N, N - 1, result)
        else:
            return choose_stamps(M, N - 1, result)

    # Рекурсивно вибираємо марки
    result = choose_stamps(M, N, [])
    
    # Якщо результат None, значить сума M не може бути досягнута
    if result is None:
        return [0]

    # Повертаємо марки у зростаючому порядку
    return sorted(result)

# Вхідні дані
N = int(input())
M = int(input())

# Виведення результату
result = find_minimum_stamps(N, M)
print(*result)
