def count_squares(N, grid):
    def check_square(x1, y1, x2, y2):
        mid_x = (x1 + x2) // 2
        mid_y = (y1 + y2) // 2
        
        dx = x2 - x1
        dy = y2 - y1
        
        x3, y3 = mid_x - dy, mid_y + dx
        x4, y4 = mid_x + dy, mid_y - dx
        
        if 0 <= x3 < N and 0 <= y3 < N and 0 <= x4 < N and 0 <= y4 < N:
            color = grid[x1][y1]
            return grid[x3][y3] == color and grid[x4][y4] == color
        return False
    
    square_count = 0
    
    for x1 in range(N):
        for y1 in range(N):
            for x2 in range(x1 + 1, N):
                for y2 in range(y1 + 1, N):
                    if check_square(x1, y1, x2, y2):
                        square_count += 1
    
    return square_count

N = int(input())  
grid = [list(map(int, input().split())) for _ in range(N)]

print(count_squares(N, grid))
