def count_squares(N, grid):
    count = 0

    # Check all possible square sizes from 1x1 to (N-1)x(N-1)
    for size in range(1, N):
        for i in range(N - size):
            for j in range(N - size):
                # Coordinates of the four corners of the square
                top_left = grid[i][j]
                top_right = grid[i][j+size]
                bottom_left = grid[i+size][j]
                bottom_right = grid[i+size][j+size]
                
                # If all four corners have the same color (either 0 or 1)
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count


# Read the input
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Output the result
print(count_squares(N, grid))
