from collections import deque

def min_time_to_meet(N):
    # Ініціалізація множин для Аліси та Боба
    alice_positions = {1}  # Початкове положення Аліси
    bob_positions = {N}    # Початкове положення Боба
    
    # Ініціалізація черг для BFS
    alice_queue = deque([(1, 0)])  # (позиція, час)
    bob_queue = deque([(N, 0)])    # (позиція, час)
    
    # Відвідані позиції для обох роботів
    alice_visited = {1}
    bob_visited = {N}
    
    # BFS з двох боків
    while alice_queue and bob_queue:
        # Обробка черги для Аліси
        for _ in range(len(alice_queue)):
            alice_pos, alice_time = alice_queue.popleft()
            
            # Перевірка перетину
            if alice_pos in bob_visited:
                return alice_time
            
            # Телепортуємось в нові можливі позиції для Аліси
            for next_pos in [alice_pos + 2, alice_pos + 3]:
                if next_pos <= N and next_pos not in alice_visited:
                    alice_visited.add(next_pos)
                    alice_queue.append((next_pos, alice_time + 1))
        
        # Обробка черги для Боба
        for _ in range(len(bob_queue)):
            bob_pos, bob_time = bob_queue.popleft()
            
            # Перевірка перетину
            if bob_pos in alice_visited:
                return bob_time
            
            # Телепортуємось в нові можливі позиції для Боба
            for next_pos in [bob_pos - 1, bob_pos - 2]:
                if next_pos >= 1 and next_pos not in bob_visited:
                    bob_visited.add(next_pos)
                    bob_queue.append((next_pos, bob_time + 1))
    
    # Якщо не вдалося зустрітися
    return -1

# Приклади
print(min_time_to_meet(5))  # 1
print(min_time_to_meet(9))  # 2
