from collections import deque

def min_meeting_time(N):
    # Черга для BFS для Аліси та Боба
    alice_queue = deque([1])  # Аліса починає з 1
    bob_queue = deque([N])    # Боб починає з N
    
    # Множини для відвіданих позицій
    alice_visited = {1}
    bob_visited = {N}
    
    time = 0
    while alice_queue and bob_queue:
        time += 1
        
        # Обробка кроку для Аліси
        for _ in range(len(alice_queue)):
            alice_pos = alice_queue.popleft()
            for next_pos in [alice_pos + 2, alice_pos + 3]:
                if next_pos <= N and next_pos not in alice_visited:
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)
                    # Якщо позиція Аліси збігається з позицією Боба
                    if next_pos in bob_visited:
                        return time
        
        # Обробка кроку для Боба
        for _ in range(len(bob_queue)):
            bob_pos = bob_queue.popleft()
            for next_pos in [bob_pos - 1, bob_pos - 2]:
                if next_pos >= 1 and next_pos not in bob_visited:
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)
                    # Якщо позиція Боба збігається з позицією Аліси
                    if next_pos in alice_visited:
                        return time
    
    return -1

# Зчитування вхідних даних
N = int(input())
print(min_meeting_time(N))
