def solve_test_case(N, blue_points, red_points):
    # Створюємо список пар (синя точка, червона точка, відстань між ними)
    pairs = []
    for i, (bx, by) in enumerate(blue_points, start=1):
        for j, (rx, ry) in enumerate(red_points, start=1):
            distance = (bx - rx) ** 2 + (by - ry) ** 2  # Використовуємо квадрат відстані
            pairs.append((distance, i, j))

    # Сортуємо пари за відстанню
    pairs.sort()

    # Використовуємо жадібний підхід для вибору пар
    blue_used = set()
    red_used = set()
    result = []

    for _, blue_idx, red_idx in pairs:
        if blue_idx not in blue_used and red_idx not in red_used:
            result.append((blue_idx, red_idx))
            blue_used.add(blue_idx)
            red_used.add(red_idx)
        if len(result) == N:  # Якщо всі точки вже з'єднані
            break

    # Якщо не вдалося знайти рішення
    if len(result) != N:
        return [0]
    return result


def main():
    t = int(input())  # Кількість тестів
    results = []

    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]
        red_points = [tuple(map(int, input().split())) for _ in range(N)]

        # Розв'язуємо кожен тест
        result = solve_test_case(N, blue_points, red_points)
        results.append(result)

    # Вивід результатів
    for result in results:
        if result == [0]:
            print(0)
        else:
            for blue_idx, red_idx in result:
                print(blue_idx, red_idx)


# Викликаємо основну функцію
if __name__ == "__main__":
    main()
