from heapq import heappop, heappush
import sys

def solve_test_case(N, blue_points, red_points):
    # Побудуємо граф із вагами між синіми та червоними точками
    graph = []
    for i, (bx, by) in enumerate(blue_points):
        for j, (rx, ry) in enumerate(red_points):
            weight = (bx - rx) ** 2 + (by - ry) ** 2
            graph.append((weight, i, j))

    # Сортуємо ребра за вагою
    graph.sort()

    # Використовуємо алгоритм Куна для мінімального парування
    blue_match = [-1] * N  # Для синіх точок
    red_match = [-1] * N  # Для червоних точок

    for weight, blue, red in graph:
        if blue_match[blue] == -1 and red_match[red] == -1:
            blue_match[blue] = red
            red_match[red] = blue

    # Якщо вдалося знайти повне парування
    if -1 in blue_match:
        return [0]
    else:
        return [(i + 1, blue_match[i] + 1) for i in range(N)]


def main():
    input_data = sys.stdin.read().splitlines()
    t = int(input_data[0])  # Кількість тестових блоків
    results = []
    idx = 1

    for _ in range(t):
        N = int(input_data[idx])  # Кількість точок одного кольору
        idx += 1
        blue_points = [tuple(map(int, input_data[idx + i].split())) for i in range(N)]
        idx += N
        red_points = [tuple(map(int, input_data[idx + i].split())) for i in range(N)]
        idx += N

        # Розв'язок для кожного тесту
        result = solve_test_case(N, blue_points, red_points)
        results.append(result)

    # Вивід результатів
    for result in results:
        if result == [0]:
            print(0)
        else:
            for blue, red in result:
                print(blue, red)


# Запуск програми
if __name__ == "__main__":
    main()
