def do_intersect(p1, q1, p2, q2):
    # Функція для перевірки, чи перетинаються два відрізки
    def orientation(p, q, r):
        val = (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])
        if val == 0:
            return 0  # колінеарні
        return 1 if val > 0 else 2  # 1 - за годинниковою стрілкою, 2 - проти

    o1 = orientation(p1, q1, p2)
    o2 = orientation(p1, q1, q2)
    o3 = orientation(p2, q2, p1)
    o4 = orientation(p2, q2, q1)

    return (o1 != o2) and (o3 != o4)

def can_connect(blue_points, red_points):
    N = len(blue_points)
    connections = []
    
    for i in range(N):
        connections.append((i + 1, i + 1))  # спочатку з'єднуємо по порядку

    for i in range(N):
        for j in range(i + 1, N):
            if do_intersect(blue_points[i], red_points[i], blue_points[j], red_points[j]):
                return 0  # якщо перетинаються, повертаємо 0

    return connections

def main():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    index = 0
    t = int(data[index])
    index += 1
    results = []
    
    for _ in range(t):
        N = int(data[index])
        index += 1
        
        blue_points = []
        red_points = []
        
        for _ in range(N):
            x, y = map(int, data[index].split())
            blue_points.append((x, y))
            index += 1
            
        for _ in range(N):
            x, y = map(int, data[index].split())
            red_points.append((x, y))
            index += 1
        
        result = can_connect(blue_points, red_points)
        
        if result == 0:
            results.append("0")
        else:
            results.extend(f"{b} {r}" for b, r in result)
    
    print("\n".join(results))

if __name__ == "__main__":
    main()
