import sys

def dfs(blue, red_match, blue_match, visited, graph):
    for red in graph[blue]:
        if not visited[red]:
            visited[red] = True
            if red_match[red] == -1 or dfs(red_match[red], red_match, blue_match, visited, graph):
                blue_match[blue] = red
                red_match[red] = blue
                return True
    return False

def solve_test_case(N, blue_points, red_points):
    # Створюємо граф, в якому кожна синя точка може бути з'єднана з певними червоними точками
    graph = [[] for _ in range(N)]
    for i, (bx, by) in enumerate(blue_points):
        for j, (rx, ry) in enumerate(red_points):
            weight = (bx - rx) ** 2 + (by - ry) ** 2
            graph[i].append(j)

    # Для кожної синьої точки намагаємося знайти пару з червоною
    blue_match = [-1] * N  # для синіх точок
    red_match = [-1] * N   # для червоних точок
    
    match_count = 0
    
    for blue in range(N):
        visited = [False] * N
        if dfs(blue, red_match, blue_match, visited, graph):
            match_count += 1
    
    if match_count < N:
        return [0]
    else:
        return [(blue_match[i] + 1, i + 1) for i in range(N)]

def main():
    input_data = sys.stdin.read().splitlines()
    t = int(input_data[0])  # Кількість тестових блоків
    results = []
    idx = 1

    for _ in range(t):
        N = int(input_data[idx])  # Кількість точок одного кольору
        idx += 1
        blue_points = [tuple(map(int, input_data[idx + i].split())) for i in range(N)]
        idx += N
        red_points = [tuple(map(int, input_data[idx + i].split())) for i in range(N)]
        idx += N

        # Розв'язок для кожного тесту
        result = solve_test_case(N, blue_points, red_points)
        results.append(result)

    # Вивід результатів
    for result in results:
        if result == [0]:
            print(0)
        else:
            for blue, red in result:
                print(blue, red)

# Запуск програми
if __name__ == "__main__":
    main()
