import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int N = scanner.nextInt();

        // Якщо N менше ніж 2, зустріч неможлива
        if (N < 2) {
            System.out.println(-1);
            return;
        }

        // Черги для руху Аліси і Боба
        Queue<Integer> queueAlice = new LinkedList<>();
        Queue<Integer> queueBob = new LinkedList<>();

        // Множини для відстеження відвіданих боксів
        Set<Integer> visitedAlice = new HashSet<>();
        Set<Integer> visitedBob = new HashSet<>();

        // Ініціалізація початкових значень
        queueAlice.add(1);  // Аліса починає з 1
        visitedAlice.add(1);
        queueBob.add(N);    // Боб починає з N
        visitedBob.add(N);

        // Лічильник секунд
        int seconds = 0;

        // Виконуємо BFS одночасно для Аліси та Боба
        while (!queueAlice.isEmpty() && !queueBob.isEmpty()) {
            // Проходимо крок для Аліси
            int sizeAlice = queueAlice.size();
            for (int i = 0; i < sizeAlice; i++) {
                int currentAlice = queueAlice.poll();
                // Перевірка, чи Аліса і Боб зустрілися
                if (visitedBob.contains(currentAlice)) {
                    System.out.println(seconds);
                    return;
                }
                // Додаємо нові можливі бокси для Аліси
                if (currentAlice + 2 <= N && !visitedAlice.contains(currentAlice + 2)) {
                    visitedAlice.add(currentAlice + 2);
                    queueAlice.add(currentAlice + 2);
                }
                if (currentAlice + 3 <= N && !visitedAlice.contains(currentAlice + 3)) {
                    visitedAlice.add(currentAlice + 3);
                    queueAlice.add(currentAlice + 3);
                }
            }

            // Проходимо крок для Боба
            int sizeBob = queueBob.size();
            for (int i = 0; i < sizeBob; i++) {
                int currentBob = queueBob.poll();
                // Перевірка, чи Аліса і Боб зустрілися
                if (visitedAlice.contains(currentBob)) {
                    System.out.println(seconds);
                    return;
                }
                // Додаємо нові можливі бокси для Боба
                if (currentBob - 1 >= 1 && !visitedBob.contains(currentBob - 1)) {
                    visitedBob.add(currentBob - 1);
                    queueBob.add(currentBob - 1);
                }
                if (currentBob - 2 >= 1 && !visitedBob.contains(currentBob - 2)) {
                    visitedBob.add(currentBob - 2);
                    queueBob.add(currentBob - 2);
                }
            }

            // Збільшуємо лічильник секунд
            seconds++;
        }

        // Якщо не знайшли спільну клітину
        System.out.println(-1);
    }
}
