import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        
        // Черга для телепортації, що зберігає пари (позиція, хто рухається)
        Queue<int[]> queue = new LinkedList<>();
        Set<Integer> visited = new HashSet<>();
        
        // Стартові позиції Аліси і Боба
        queue.add(new int[]{1, 0});  // (позиція Аліси, 0 - Аліса)
        queue.add(new int[]{N, 1});  // (позиція Боба, 1 - Боб)
        visited.add(1);  // Аліса вже на позиції 1
        visited.add(N);  // Боб вже на позиції N
        
        int seconds = 0;
        
        // BFS
        while (!queue.isEmpty()) {
            int size = queue.size();
            
            for (int i = 0; i < size; i++) {
                int[] current = queue.poll();
                int position = current[0];
                int who = current[1];  // 0 - Аліса, 1 - Боб
                
                // Якщо хтось зустрічається, то вони можуть бути в тому ж боксі
                if (visited.contains(position) && (who == 0 ? visited.contains(position) : visited.contains(position))) {
                    System.out.println(seconds);
                    return;
                }
                
                if (who == 0) { // Аліса
                    if (position + 2 <= N && !visited.contains(position + 2)) {
                        visited.add(position + 2);
                        queue.add(new int[]{position + 2, 0});
                    }
                    if (position + 3 <= N && !visited.contains(position + 3)) {
                        visited.add(position + 3);
                        queue.add(new int[]{position + 3, 0});
                    }
                } else { // Боб
                    if (position - 1 >= 1 && !visited.contains(position - 1)) {
                        visited.add(position - 1);
                        queue.add(new int[]{position - 1, 1});
                    }
                    if (position - 2 >= 1 && !visited.contains(position - 2)) {
                        visited.add(position - 2);
                        queue.add(new int[]{position - 2, 1});
                    }
                }
            }
            seconds++;
        }
        
        // Якщо ми не можемо зустрітися
        System.out.println(-1);
    }
}
