import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int N = scanner.nextInt();
        
        // Якщо Аліса і Боб не можуть зустрітись:
        if (N < 3) {
            System.out.println(-1);
            return;
        }
        
        // Массив для відстеження кроків Аліси та Боба
        boolean[] alice = new boolean[N + 1];
        boolean[] bob = new boolean[N + 1];
        
        // Початкові позиції
        alice[1] = true;
        bob[N] = true;
        
        // Черга для симуляції переміщення
        Queue<Integer> queueAlice = new LinkedList<>();
        Queue<Integer> queueBob = new LinkedList<>();
        
        queueAlice.add(1);
        queueBob.add(N);
        
        int steps = 0;
        while (!queueAlice.isEmpty() && !queueBob.isEmpty()) {
            steps++;
            
            // Крок Аліси
            int sizeAlice = queueAlice.size();
            for (int i = 0; i < sizeAlice; i++) {
                int position = queueAlice.poll();
                
                // Аліса може переміщуватись на +2 або +3
                if (position + 2 <= N && !alice[position + 2]) {
                    alice[position + 2] = true;
                    queueAlice.add(position + 2);
                }
                if (position + 3 <= N && !alice[position + 3]) {
                    alice[position + 3] = true;
                    queueAlice.add(position + 3);
                }
            }
            
            // Крок Боба
            int sizeBob = queueBob.size();
            for (int i = 0; i < sizeBob; i++) {
                int position = queueBob.poll();
                
                // Боб може переміщуватись на -1 або -2
                if (position - 1 >= 1 && !bob[position - 1]) {
                    bob[position - 1] = true;
                    queueBob.add(position - 1);
                }
                if (position - 2 >= 1 && !bob[position - 2]) {
                    bob[position - 2] = true;
                    queueBob.add(position - 2);
                }
            }
            
            // Перевірка на перехрестя
            for (int i = 1; i <= N; i++) {
                if (alice[i] && bob[i]) {
                    System.out.println(steps);
                    return;
                }
            }
        }
        
        // Якщо не знайшли спільної клітинки
        System.out.println(-1);
    }
}
