import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        
        if (N <= 2) {
            System.out.println(-1);
            return;
        }
        
        Queue<Integer> queueAlice = new LinkedList<>();
        Queue<Integer> queueBob = new LinkedList<>();
        
        boolean[] visitedAlice = new boolean[N + 1];
        boolean[] visitedBob = new boolean[N + 1];
        
        queueAlice.add(1);
        queueBob.add(N);
        visitedAlice[1] = true;
        visitedBob[N] = true;
        
        int seconds = 0;
        
        while (!queueAlice.isEmpty() || !queueBob.isEmpty()) {
            seconds++;
            
            int sizeAlice = queueAlice.size();
            for (int i = 0; i < sizeAlice; i++) {
                int position = queueAlice.poll();
                if (position + 2 <= N && !visitedAlice[position + 2]) {
                    visitedAlice[position + 2] = true;
                    queueAlice.add(position + 2);
                }
                if (position + 3 <= N && !visitedAlice[position + 3]) {
                    visitedAlice[position + 3] = true;
                    queueAlice.add(position + 3);
                }
            }
            
            int sizeBob = queueBob.size();
            for (int i = 0; i < sizeBob; i++) {
                int position = queueBob.poll();
                if (position - 1 >= 1 && !visitedBob[position - 1]) {
                    visitedBob[position - 1] = true;
                    queueBob.add(position - 1);
                }
                if (position - 2 >= 1 && !visitedBob[position - 2]) {
                    visitedBob[position - 2] = true;
                    queueBob.add(position - 2);
                }
            }
            
            for (int i = 1; i <= N; i++) {
                if (visitedAlice[i] && visitedBob[i]) {
                    System.out.println(seconds);
                    return;
                }
            }
        }
        
        System.out.println(-1);
    }
}
