import java.util.*; 
 
public class Teleportation { 
    public static int findMeetingTime(int n) { 
        if ((n - 1) % 2 != 0) return -1; 
 
        Queue<int[]> queue = new LinkedList<>(); 
        Set<String> visited = new HashSet<>(); 
 
        queue.add(new int[]{1, n, 0});
        visited.add("1:" + n); 
 
        while (!queue.isEmpty()) { 
            int[] state = queue.poll(); 
            int alice = state[0]; 
            int bob = state[1]; 
            int time = state[2]; 
  
            if (alice == bob) return time; 
 
            int[] aliceNext = {alice + 2, alice + 3}; 
            int[] bobNext = {bob - 1, bob - 2}; 
 
            for (int aNext : aliceNext) { 
                if (aNext > n) continue;
                for (int bNext : bobNext) { 
                    if (bNext < 1) continue;
 
                    String newState = aNext + ":" + bNext; 
                    if (!visited.contains(newState)) { 
                        queue.add(new int[]{aNext, bNext, time + 1}); 
                        visited.add(newState); 
                    } 
                } 
            } 
        } 
 
        return -1;
    } 
 
    public static void main(String[] args) { 
        Scanner scanner = new Scanner(System.in); 
        int n = scanner.nextInt(); 
        System.out.println(findMeetingTime(n)); 
    } 
}