import java.util.*;

public class Teleportation {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        
        // Считываем количество боксов
        long N = sc.nextLong();
        
        // Проводим BFS для поиска минимального количества шагов
        int result = bfs(N);
        
        // Выводим результат
        System.out.println(result);
    }

    public static int bfs(long N) {
        // Создаем для BFS
        Queue<int[]> queue = new LinkedList<>();
        
        // Начальные позиции: Алиса в 1, Боб в N, 0 шагов на старте
        queue.add(new int[]{1, (int) N, 0});
        
        // Посещенные состояния чек
        Set<String> visited = new HashSet<>();
        visited.add("1," + N);

        // BFS
        while (!queue.isEmpty()) {
            int[] current = queue.poll();
            int alicePos = current[0];
            int bobPos = current[1];
            int steps = current[2];

            // Проверяем, могут ли встретиться
            if (alicePos == bobPos) {
                return steps; //  минимальное количество шагов
            }

            // Алиса перемещается в k+2 и k+3
            int[] aliceMoves = {alicePos + 2, alicePos + 3};
            // Боб перемещается в k-1 и k-2
            int[] bobMoves = {bobPos - 1, bobPos - 2};

            for (int nextAlice : aliceMoves) {
                if (nextAlice <= N) {
                    for (int nextBob : bobMoves) {
                        if (nextBob >= 1) { // Проверяем Боб остаётся в диапазоне 

                            String state = nextAlice + "," + nextBob;
                            if (!visited.contains(state)) {
                                visited.add(state);
                                queue.add(new int[]{nextAlice, nextBob, steps + 1});
                            }
                        }
                    }
                }
            }
        }

        // Если нет пути
        return -1;
    }
}