import java.util.Scanner;

public class Teleportation {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        // Считываем общее количество боксов
        long N = sc.nextLong();

        // Проверяем минимальные условия для встречи
        if (canMeet(N)) {
            // Выводим минимальное количество шагов, если встреча возможна
            System.out.println(minimumSteps(N));
        } else {
            // Если невозможно встретиться, выводим -1
            System.out.println(-1);
        }
    }

    // Проверяем, могут ли Алиса и Боб вообще встретиться
    public static boolean canMeet(long N) {
        // Алиса и Боб могут встретиться, только если число боксов позволяет пересечение перемещений
        // Проверяем, попадает ли число боксов в допустимый диапазон
        return (N % 2 == 1) || (N >= 4);
    }

    // Возвращаем минимальные секунды, когда может произойти встреча
    public static int minimumSteps(long N) {
        if (N == 2) {
            return -1; // Если боксов только 2, Алиса и Боб не смогут встретиться
        }

        if (N % 2 == 1) {
            return 1; // Если число боксов нечетное, они встретятся за 1 секунду
        }

        return 2; // В остальных случаях, встреча возможна за 2 секунды
    }
}