import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        
        // Створюємо матрицю для збереження кольорів
        int[][] grid = new int[N][N];
        
        // Зчитуємо кольори точок
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                grid[i][j] = sc.nextInt();
            }
        }
        
        int count = 0;
        
        // Перебираємо квадрати розміром від 1x1 до NxN
        for (int i = 0; i < N - 1; i++) {
            for (int j = 0; j < N - 1; j++) {
                int color = grid[i][j];
                
                // Перевіряємо квадрати розміру 2x2
                if (grid[i + 1][j] == color && grid[i][j + 1] == color && grid[i + 1][j + 1] == color) {
                    count++;
                }

                // Перевіряємо більші квадрати
                for (int size = 2; i + size < N && j + size < N; size++) {
                    boolean allSameColor = true;
                    
                    // Перевіряємо всі чотири вершини квадрата розміру size x size
                    for (int x = i; x <= i + size; x++) {
                        for (int y = j; y <= j + size; y++) {
                            if (grid[x][y] != color) {
                                allSameColor = false;
                                break;
                            }
                        }
                        if (!allSameColor) break;
                    }
                    
                    if (allSameColor) {
                        count++;
                    }
                }
            }
        }
        
        // Виводимо результат
        System.out.println(count);
    }
}
