import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        
        // Створюємо матрицю для збереження кольорів
        int[][] grid = new int[N][N];
        
        // Зчитуємо кольори точок
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                grid[i][j] = sc.nextInt();
            }
        }
        
        int count = 0;
        
        // Перебираємо всі пари точок, які можуть бути діагоналями квадратів
        for (int i = 0; i < N - 1; i++) {
            for (int j = 0; j < N - 1; j++) {
                // Перевіряємо квадрати з різними розмірами
                for (int size = 1; size < N; size++) {
                    // Визначаємо координати можливих вершин квадрата
                    int x1 = i, y1 = j;
                    int x2 = i + size, y2 = j + size;
                    int x3 = x1 + size, y3 = y1 - size;
                    int x4 = x2 + size, y4 = y2 - size;
                    
                    // Перевіряємо чи всі вершини цього квадрата мають однаковий колір
                    if (grid[x1][y1] == grid[x2][y2] && 
                        grid[x1][y1] == grid[x3][y3] && 
                        grid[x1][y1] == grid[x4][y4]) {
                        count++;
                    }
                }
            }
        }
        
        // Виводимо результат
        System.out.println(count);
    }
}
