import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt(); // Кількість тестів
        while (t-- > 0) {
            int N = sc.nextInt(); // Кількість точок одного кольору
            int[][] points = new int[2 * N][3]; // Массив для точок, кожна точка має координати x, y, тип (0 - синя, 1 - червона)
            
            for (int i = 0; i < N; i++) {
                points[i][0] = sc.nextInt(); // x координата синьої точки
                points[i][1] = sc.nextInt(); // y координата синьої точки
                points[i][2] = 0; // Синя точка
            }

            for (int i = 0; i < N; i++) {
                points[i + N][0] = sc.nextInt(); // x координата червоної точки
                points[i + N][1] = sc.nextInt(); // y координата червоної точки
                points[i + N][2] = 1; // Червона точка
            }

            // Сортуємо точки спочатку по x, потім по y для однакових x
            Arrays.sort(points, (a, b) -> a[0] == b[0] ? Integer.compare(a[1], b[1]) : Integer.compare(a[0], b[0]));

            // Виводимо пари точок, де сині і червоні точки будуть з'єднані
            for (int i = 0; i < N; i++) {
                if (points[i][2] == 0) {
                    // Знаходимо пару для синьої точки
                    for (int j = N; j < 2 * N; j++) {
                        if (points[j][2] == 1) {
                            System.out.println((i + 1) + " " + (j - N + 1));
                            points[j][2] = -1; // Позначаємо червону точку як використану
                            break;
                        }
                    }
                }
            }
        }
    }
}
