#include <iostream>
#include <set>

int min_time_to_meet(int N) {
    std::set<int> alice_positions = {1};
    std::set<int> bob_positions = {N};

    int time = 0;

    while (!alice_positions.empty() && !bob_positions.empty()) {
        if (std::find_first_of(alice_positions.begin(), alice_positions.end(), bob_positions.begin(), bob_positions.end()) != alice_positions.end()) {
            return time;
        }

        time++;
        std::set<int> new_alice_positions, new_bob_positions;

        for (int pos : alice_positions) {
            if (pos + 2 <= N) {
                new_alice_positions.insert(pos + 2);
            }
            if (pos + 3 <= N) {
                new_alice_positions.insert(pos + 3);
            }
        }

        for (int pos : bob_positions) {
            if (pos - 1 >= 1) {
                new_bob_positions.insert(pos - 1);
            }
            if (pos - 2 >= 1) {
                new_bob_positions.insert(pos - 2);
            }
        }

        alice_positions = new_alice_positions;
        bob_positions = new_bob_positions;
    }

    return -1;
}

int main() {
    int N;
    std::cin >> N;
    std::cout << min_time_to_meet(N) << std::endl;
    return 0;
}