#include <stdio.h>
#include <stdlib.h>

#define MAX_SIZE 1000000

int binary_search(int arr[], int l, int r, int x) {
    if (r >= l) {
        int mid = l + (r - l) / 2;
        if (arr[mid] == x)
            return mid;
        if (arr[mid] > x)
            return binary_search(arr, l, mid - 1, x);
        return binary_search(arr, mid + 1, r, x);
    }
    return -1;
}

int min_time_to_meet(int N) {
    int alice_positions[MAX_SIZE], bob_positions[MAX_SIZE];
    int alice_size = 1, bob_size = 1;
    alice_positions[0] = 1;
    bob_positions[0] = N;

    int time = 0;

    while (alice_size > 0 && bob_size > 0) {
        int found = 0;
        for (int i = 0; i < alice_size; i++) {
            if (binary_search(bob_positions, 0, bob_size - 1, alice_positions[i]) != -1) {
                found = 1;
                break;
            }
        }
        if (found) {
            return time;
        }

        time++;
        int new_alice_size = 0, new_bob_size = 0;
        for (int i = 0; i < alice_size; i++) {
            if (alice_positions[i] + 2 <= N) {
                alice_positions[new_alice_size++] = alice_positions[i] + 2;
            }
            if (alice_positions[i] + 3 <= N) {
                alice_positions[new_alice_size++] = alice_positions[i] + 3;
            }
        }
        for (int i = 0; i < bob_size; i++) {
            if (bob_positions[i] - 1 >= 1) {
                bob_positions[new_bob_size++] = bob_positions[i] - 1;
            }
            if (bob_positions[i] - 2 >= 1) {
                bob_positions[new_bob_size++] = bob_positions[i] - 2;
            }
        }
        alice_size = new_alice_size;
        bob_size = new_bob_size;
    }

    return -1;
}

int main() {
    int N;
    scanf("%d", &N);
    printf("%d\n", min_time_to_meet(N));
    return 0;
}