#include <iostream>
#include <queue>
#include <vector>
using namespace std;

int min_time_to_meet(int N) {
    // Масив для відстеження відвіданих позицій
    vector<bool> alice_visited(N + 1, false);
    vector<bool> bob_visited(N + 1, false);
    
    // Черги для позицій
    queue<int> alice_queue, bob_queue;
    
    // Початкові позиції
    alice_queue.push(1);
    bob_queue.push(N);
    alice_visited[1] = true;
    bob_visited[N] = true;
    
    // Лічильник часу
    int time = 0;
    
    // Ітерація
    while (!alice_queue.empty() && !bob_queue.empty()) {
        int size = alice_queue.size();
        
        // Перевіряємо позиції Аліси
        for (int i = 0; i < size; i++) {
            int pos = alice_queue.front();
            alice_queue.pop();
            if (bob_visited[pos]) return time;
            
            if (pos + 2 <= N && !alice_visited[pos + 2]) {
                alice_visited[pos + 2] = true;
                alice_queue.push(pos + 2);
            }
            if (pos + 3 <= N && !alice_visited[pos + 3]) {
                alice_visited[pos + 3] = true;
                alice_queue.push(pos + 3);
            }
        }
        
        size = bob_queue.size();
        
        // Перевіряємо позиції Боба
        for (int i = 0; i < size; i++) {
            int pos = bob_queue.front();
            bob_queue.pop();
            if (alice_visited[pos]) return time;
            
            if (pos - 1 >= 1 && !bob_visited[pos - 1]) {
                bob_visited[pos - 1] = true;
                bob_queue.push(pos - 1);
            }
            if (pos - 2 >= 1 && !bob_visited[pos - 2]) {
                bob_visited[pos - 2] = true;
                bob_queue.push(pos - 2);
            }
        }
        
        // Збільшуємо час
        time++;
    }
    
    return -1;  // Якщо не знайдено
}

int main() {
    int N;
    cin >> N;
    cout << min_time_to_meet(N) << endl;
    return 0;
}