def find_stamps(N, M):
    """
    Знаходить набір марок, сума вартостей яких дорівнює M.

    Args:
        N: Кількість марок.
        M: Загальна вартість марок.

    Returns:
        Список номерів марок або пустий список, якщо рішення немає.
    """

    dp = [False] * (M + 1)  # Динамічне програмування для відстеження можливих сум
    dp[0] = True  # Сума 0 досяжна без жодної марки

    # Заповнення таблиці динамічного програмування
    for i in range(1, N + 1):
        for j in range(M, i - 1, -1):
            dp[j] = dp[j] or dp[j - i]

    # Якщо сума M недосяжна, повертаємо пустий список
    if not dp[M]:
        return []

    # Відновлення набору марок
    result = []
    i = M
    for stamp in range(N, 0, -1):
        if dp[i - stamp] and i >= stamp:
            result.append(stamp)
            i -= stamp

    return result[::-1]  # Повертаємо список у правильному порядку

# Введення даних
N = int(input())
M = int(input())

# Виклик функції та виведення результату
result = find_stamps(N, M)
if result:
    print(*result)
else:
    print(0)