def count_colored_squares(N, matrix):
    count = 0
    
    # Перебираємо всі можливі квадрати (їх верхні ліві кути можуть бути в діапазоні (0,0) до (N-1, N-1))
    for x1 in range(N-1):  # x1 - координата верхнього лівого кута по осі X
        for y1 in range(N-1):  # y1 - координата верхнього лівого кута по осі Y
            for size in range(1, N - max(x1, y1)):  # size - розмір квадрата (від 1 до N-1)
                x2, y2 = x1 + size, y1  # верхній правий кут
                x3, y3 = x1, y1 + size  # нижній лівий кут
                x4, y4 = x1 + size, y1 + size  # нижній правий кут

                # Перевіряємо кольори всіх 4 вершин
                colors = [
                    matrix[y1][x1],
                    matrix[y1][x2],
                    matrix[y3][x1],
                    matrix[y4][x4]
                ]
                if all(c == colors[0] for c in colors):  # всі чотири вершини одного кольору
                    count += 1
    return count

# Вхідні дані
N = int(input())  # розмір квадрата
matrix = [list(map(int, input().split())) for _ in range(N)]  # матриця кольорів

# Виведення результату
print(count_colored_squares(N, matrix))
