def count_colored_squares(N, matrix):
    count = 0

    # Перебираємо всі пари точок, які можуть бути протилежними вершинами квадрата
    for x1 in range(N):
        for y1 in range(N):
            for x2 in range(x1+1, N):
                for y2 in range(y1+1, N):
                    # Перевірка, чи точки (x1, y1) і (x2, y2) можуть бути діагоналями квадрата
                    if (x2 - x1) == (y2 - y1):  # Перевірка на рівні відстані
                        # Обчислюємо інші дві вершини квадрата
                        x3, y3 = x2, y1
                        x4, y4 = x1, y2
                        
                        # Перевіряємо кольори всіх чотирьох точок
                        colors = [
                            matrix[y1][x1],
                            matrix[y2][x2],
                            matrix[y3][x3],
                            matrix[y4][x4]
                        ]
                        if all(c == colors[0] for c in colors):  # Якщо всі однакові
                            count += 1

    return count

# Вхідні дані
N = int(input())  # розмір квадрата
matrix = [list(map(int, input().split())) for _ in range(N)]  # матриця кольорів

# Виведення результату
print(count_colored_squares(N, matrix))