def find_coins(n, m):
    total_sum = n * (n + 1) // 2
    if m > total_sum:
        return -1 

    dp = [float('inf')] * (m + 1)
    dp[0] = 0

    last_coin_index = [-1] * (m + 1)
    coins = list(range(1, n + 1))

    for index, coin in enumerate(coins):
        for s in range(m, coin - 1, -1):
            if dp[s - coin] + 1 < dp[s]:
                dp[s] = dp[s - coin] + 1
                last_coin_index[s] = index

    if dp[m] == float('inf'):
        return -1

    result_indices = []
    current_sum = m
    while current_sum > 0:
        coin_index = last_coin_index[current_sum]
        if coin_index == -1:
            return -1
        result_indices.append(coin_index)
        current_sum -= coins[coin_index]

    return result_indices[::-1]

n = int(input())
m = int(input())
indices = find_coins(n, m)

if indices == -1:
    print(0)
else:
    for idx in indices:
        print(idx + 1)