def find_coins(n, m):
    total_sum = n * (n + 1) // 2
    if m > total_sum:
        return -1

    dp = [float('inf')] * (m + 1)
    dp[0] = 0

    last_coin_index = [-1] * (m + 1)
    coins = list(range(1, n + 1))

    for coin in coins:
        for s in range(m, coin - 1, -1):
            if dp[s - coin] + 1 < dp[s]:
                dp[s] = dp[s - coin] + 1
                last_coin_index[s] = coin

    if dp[m] == float('inf'):
        return -1

    result = []
    current_sum = m
    while current_sum > 0:
        coin_used = last_coin_index[current_sum]
        if coin_used == -1:
            return -1
        result.append(coin_used)
        current_sum -= coin_used

    return result

n = int(input())
m = int(input())
coins = find_coins(n, m)

if coins == -1:
    print(0)
else:
    for coin in sorted(coins):
        print(coin)