def find_minimum_marks(n, m):
    total_sum = n * (n + 1) // 2
    if total_sum < m:
        return [0]

    def sum_k(k):
        return k * n - (k * (k - 1)) // 2

    left, right = 1, n
    k = -1
    while left <= right:
        mid = (left + right) // 2
        current_sum = sum_k(mid)
        if current_sum >= m:
            k = mid
            right = mid - 1
        else:
            left = mid + 1
    if k == -1:
        return [0]

    sum_initial = sum_k(k)
    d = sum_initial - m

    if d == 0:
        marks = [n - k + 1 + i for i in range(k)]
        marks.sort()
        return marks

    def sum_possible_reduction(t):
        return t * (2 * (n - k + 1) + t - 3) // 2

    t_left, t_right = 0, k
    t_max = 0
    while t_left <= t_right:
        t_mid = (t_left + t_right) // 2
        s = sum_possible_reduction(t_mid)
        if s <= d:
            t_max = t_mid
            t_left = t_mid + 1
        else:
            t_right = t_mid - 1

    sum_reduced = sum_possible_reduction(t_max)
    remaining_d = d - sum_reduced

    marks = [1] * t_max
    if t_max < k:
        new_mark = (n - k + 1 + t_max) - remaining_d
        if new_mark < 2:
            return [0]
        marks.append(new_mark)
        for i in range(t_max + 1, k):
            marks.append(n - k + 1 + i)
    
    marks.sort()
    return marks

import sys
input = sys.stdin.read
data = input().split()
n = int(data[0])
m = int(data[1])

marks = find_minimum_marks(n, m)
for i in marks:
    print(i)
