def orientation(p, q, r):
    val = (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])
    if val == 0:
        return 0
    return 1 if val > 0 else -1

def on_segment(p, q, r):
    return min(p[0], r[0]) <= q[0] <= max(p[0], r[0]) and min(p[1], r[1]) <= q[1] <= max(p[1], r[1])

def do_intersect(p1, q1, p2, q2):
    o1 = orientation(p1, q1, p2)
    o2 = orientation(p1, q1, q2)
    o3 = orientation(p2, q2, p1)
    o4 = orientation(p2, q2, q1)

    if o1 != o2 and o3 != o4:
        return True

    if o1 == 0 and on_segment(p1, p2, q1): return True
    if o2 == 0 and on_segment(p1, q2, q1): return True
    if o3 == 0 and on_segment(p2, p1, q2): return True
    if o4 == 0 and on_segment(p2, q1, q2): return True

    return False

e = int(input())

for f in range(e):
    n = int(input())
    
    blue_points = []
    red_points = []
    
    for i in range(n):
        x, y = map(int, input().split())
        blue_points.append((x, y, i + 1))
    
    for i in range(n):
        x, y = map(int, input().split())
        red_points.append((x, y, i + 1))
    
    blue_points.sort(key=lambda p: (p[0], p[1]))
    red_points.sort(key=lambda p: (p[0], p[1]))

    intersect = False
    pairs = []
    
    for i in range(n):
        for j in range(i + 1, n):
            if do_intersect(blue_points[i], red_points[i], blue_points[j], red_points[j]):
                intersect = True
                break
        if intersect:
            break

    if intersect:
        print(0)
    else:
        for i in range(n):
            print(blue_points[i][2], red_points[i][2])
