#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int side;
    cin >> side;

    vector<vector<int>> colors(side, vector<int>(side));

    for (int y = 0; y < side; y++) {
        for (int x = 0; x < side; x++) {
            cin >> colors[y][x];
        }
    }

    auto in_range = [&](int y, int x) {
        return 0 <= y && y < side && 0 <= x && x < side;
    };

    int count = 0;

    for (int point1_y = 0; point1_y < side; point1_y++) {
        for (int point1_x = 0; point1_x < side; point1_x++) {
            for (int point2_y = 0; point2_y <= point1_y; point2_y++) {
                for (int point2_x = point1_x; point2_x < side; point2_x++) {
                    int point3_x = point2_x + (point1_y - point2_y);
                    int point3_y = point2_y + (point2_x - point1_x);
                    int point4_x = point1_x + (point1_y - point2_y);
                    int point4_y = point1_y + (point2_x - point1_x);

                    if (
                        point1_x == point2_x
                        && point1_y == point2_y
                        || point2_x == point3_x
                        && point2_y == point3_y
                        || point3_x == point4_x
                        && point3_y == point4_y
                        || point4_x == point1_x
                        && point4_y == point1_y
                    ) {
                        continue;
                    }

                    if (
                        in_range(point3_y, point3_x)
                        && in_range(point4_y, point4_x)
                        && colors[point1_y][point1_x] == colors[point2_y][point2_x]
                        && colors[point2_y][point2_x] == colors[point3_y][point4_x]
                        && colors[point3_y][point3_x] == colors[point4_y][point4_x]
                    ) {
                        count += 1;
                    }
                }
            }
        }
    }

    cout << count << "\n";

    return 0;
}
