#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>

using namespace std;
using ll = long long;

struct Point {
    int x;
    int y;
    int id;

    Point(int x, int y, int id) : x(x), y(y), id(id) {}
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;

    while (tests--) {
        int count;
        cin >> count;

        vector<Point> red{};
        vector<Point> blue{};

        for (int i = 0; i < count; i++) {
            int x, y;
            cin >> x >> y;

            red.push_back(Point(x, y, i));
        }

        for (int i = 0; i < count; i++) {
            int x, y;
            cin >> x >> y;

            blue.push_back(Point(x, y, i));
        }

        vector<pair<int, int>> segments{};

        for (int i = 0; i < count; i++) {
            for (int j = 0; j < count; j++) {
                segments.push_back({ i, j });
            }
        }

        sort(segments.begin(), segments.end(), [&](const pair<int, int>& segment1, const pair<int, int>& segment2) {
            const Point& start1 = red[segment1.first];
            const Point& end1 = blue[segment1.second];

            int dx1 = start1.x - end1.x;
            int dy1 = start1.y - end1.y;
            int length1 = dx1 * dx1 + dy1 * dy1;

            const Point& start2 = red[segment2.first];
            const Point& end2 = blue[segment2.second];

            int dx2 = start2.x - end2.x;
            int dy2 = start2.y - end2.y;
            int length2 = dx2 * dx2 + dy2 * dy2;

            return length1 < length2;
        });

        vector<bool> red_taken(count, false);
        vector<bool> blue_taken(count, false);

        for (const pair<int, int>& segment : segments) {
            if (red_taken[segment.first] || blue_taken[segment.second]) {
                continue;
            }

            red_taken[segment.first] = true;
            blue_taken[segment.second] = true;

            cout << segment.first + 1 << " " << segment.second + 1 << "\n";
        }
    }

    return 0;
}
