from collections import deque

def teleport(N):
    alice_queue = deque([(1, 0)])
    bob_queue = deque([(N, 0)])
    alice_visited = set([1])
    bob_visited = set([N])
    
    while alice_queue and bob_queue:
        alice_pos, alice_time = alice_queue.popleft()
        bob_pos, bob_time = bob_queue.popleft()
        
        if alice_pos in bob_visited or bob_pos in alice_visited:
            return max(alice_time, bob_time)
        
        for move in [2, 3]:
            new_pos = alice_pos + move
            if 1 <= new_pos <= N and new_pos not in alice_visited:
                alice_visited.add(new_pos)
                alice_queue.append((new_pos, alice_time + 1))
        
        for move in [1, 2]:
            new_pos = bob_pos - move
            if 1 <= new_pos <= N and new_pos not in bob_visited:
                bob_visited.add(new_pos)
                bob_queue.append((new_pos, bob_time + 1))
    
    return -1

N = int(input())
print(teleport(N))
