from collections import deque

def min_time_to_meet(N):
    # Ініціалізація черги з початковим станом
    queue = deque([(1, N, 0)])  # (позиція Аліси, позиція Боба, кількість секунд)
    visited = set((1, N))  # Відвідані стани

    while queue:
        alice_pos, bob_pos, time = queue.popleft()

        # Якщо Аліса та Боб зустрілися
        if alice_pos == bob_pos:
            return time

        # Генерація можливих нових станів
        # Переміщення Аліси
        for new_alice_pos in (alice_pos + 2, alice_pos + 3):
            if 1 <= new_alice_pos <= N:
                # Переміщення Боба
                for new_bob_pos in (bob_pos - 1, bob_pos - 2):
                    if 1 <= new_bob_pos <= N:
                        new_state = (new_alice_pos, new_bob_pos)
                        if new_state not in visited:
                            visited.add(new_state)
                            queue.append((new_alice_pos, new_bob_pos, time + 1))

    return -1  # Якщо неможливо зустрітись

# Приклад використання:
N = int(input())  # Виправлено на int(input())
result = min_time_to_meet(N)
print(result)  # Виведе мінімальну кількість секунд або -1, якщо неможливо
