def min_time_to_meet_recursive(alice_pos, bob_pos, N, memo):
    # Якщо Аліса і Боб зустрілися
    if alice_pos == bob_pos:
        return 0

    # Якщо позиції виходять за межі
    if alice_pos < 1 or alice_pos > N or bob_pos < 1 or bob_pos > N:
        return float('inf')  # Невірний стан

    # Перевірка мемоізації
    if (alice_pos, bob_pos) in memo:
        return memo[(alice_pos, bob_pos)]

    # Рекурсивно перевіряємо всі варіанти переміщення Аліси та Боба
    min_time = float('inf')

    # Переміщення Аліси (на 2 або 3 кроки вперед)
    for new_alice_pos in (alice_pos + 2, alice_pos + 3):
        # Переміщення Боба (на 1 або 2 кроки назад)
        for new_bob_pos in (bob_pos - 1, bob_pos - 2):
            time = min_time_to_meet_recursive(new_alice_pos, new_bob_pos, N, memo)
            min_time = min(min_time, time + 1)

    # Записуємо в мемоізацію
    memo[(alice_pos, bob_pos)] = min_time
    return min_time

def min_time_to_meet(N):
    memo = {}  # Словник для мемоізації
    result = min_time_to_meet_recursive(1, N, N, memo)
    return result if result != float('inf') else -1  # Якщо не вдалося зустрітися, повертаємо -1

# Приклад використання:
N = int(input())  # Вводимо максимальне число
result = min_time_to_meet(N)
print(result)  # Виведе мінімальну кількість секунд або -1, якщо неможливо
