def dfs(alice_pos, bob_pos, N, visited, time):
    # Якщо Аліса і Боб зустрілися
    if alice_pos == bob_pos:
        return time

    # Якщо позиції виходять за межі
    if alice_pos < 1 or alice_pos > N or bob_pos < 1 or bob_pos > N:
        return -1  # Невірний стан

    # Якщо цей стан вже відвідано
    if (alice_pos, bob_pos) in visited:
        return -1

    # Позначаємо стан як відвіданий
    visited.add((alice_pos, bob_pos))

    # Рекурсивно перевіряємо всі варіанти переміщення Аліси та Боба
    min_time = float('inf')

    # Переміщення Аліси (на 2 або 3 кроки вперед)
    for new_alice_pos in (alice_pos + 2, alice_pos + 3):
        # Переміщення Боба (на 1 або 2 кроки назад)
        for new_bob_pos in (bob_pos - 1, bob_pos - 2):
            time_result = dfs(new_alice_pos, new_bob_pos, N, visited, time + 1)
            if time_result != -1:
                min_time = min(min_time, time_result)

    # Повертаємо мінімальний час або -1, якщо шляху немає
    return min_time if min_time != float('inf') else -1

def min_time_to_meet(N):
    visited = set()  # Множина для зберігання відвіданих станів
    result = dfs(1, N, N, visited, 0)
    return result

# Приклад використання:
N = int(input())  # Вводимо максимальне число
result = min_time_to_meet(N)
print(result)  # Виведе мінімальну кількість секунд або -1, якщо неможливо
