def find_elements_sum(M, n):
    dp = [float('inf')] * (M + 1)  # Масив для збереження мінімальної кількості елементів для кожної суми
    dp[0] = 0  # Для суми 0 потрібно 0 елементів
    prev = [-1] * (M + 1)  # Масив для відстеження елементів, які складають суму
    
    for num in range(1, n + 1):  # Перебираємо всі числа від 1 до n
        for i in range(M, num - 1, -1):  # Перебираємо можливі суми від M до num
            if dp[i - num] + 1 < dp[i]:  # Якщо знайдено кращий варіант
                dp[i] = dp[i - num] + 1
                prev[i] = num  # Зберігаємо число, яке дозволило отримати цю суму
    
    if dp[M] == float('inf'):  # Якщо сума M неможлива
        return []
    
    # Відтворюємо самі числа, які складають суму M
    result = []
    while M > 0:
        result.append(prev[M])  # Додаємо число, яке складає поточну суму
        M -= prev[M]  # Зменшуємо суму на це число
    
    return result

N = int(input())  # Максимальне число
M = int(input())  # Сума
result = find_elements_sum(M, N)
print(*result)
