def is_square(i, j, k, l):
    # Перевірка, чи утворюють точки (i, j), (k, l) квадрат з іншими точками
    # У квадраті кути повинні мати рівні відстані між собою
    # Тобто відстань між двома точками по горизонталі та вертикалі однакова
    return (i != k and j != l and abs(i - k) == abs(j - l))

def count_squares(N, grid):
    count = 0
    # Перебираємо всі пари точок (i, j) і (k, l)
    for i in range(N):
        for j in range(N):
            for k in range(i+1, N):
                for l in range(j+1, N):
                    # Якщо (i, j) та (k, l) можуть бути протилежними кутами квадрата
                    if is_square(i, j, k, l):
                        # Перевіряємо, чи всі чотири точки мають однаковий колір
                        color = grid[i][j]
                        if (grid[k][l] == color and 
                            grid[i][l] == color and 
                            grid[k][j] == color):
                            count += 1
    return count

def main():
    N = int(input())  # Розмір матриці
    grid = [list(map(int, input().split())) for _ in range(N)]  # Матриця кольорів
    print(count_squares(N, grid))

if __name__ == "__main__":
    main()
