def orientation(p, q, r):
    # Обчислюємо орієнтацію для трійки точок (p, q, r)
    # Орієнтація 0 означає, що точки лінійно розташовані, 1 - за годинниковою стрілкою, 2 - проти годинникової стрілки
    val = (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])
    if val == 0:
        return 0  # Колінеарні
    return 1 if val > 0 else 2  # 1 - за годинниковою стрілкою, 2 - проти

def do_intersect(p1, q1, p2, q2):
    # Перевірка, чи перетинаються відрізки p1q1 та p2q2
    o1 = orientation(p1, q1, p2)
    o2 = orientation(p1, q1, q2)
    o3 = orientation(p2, q2, p1)
    o4 = orientation(p2, q2, q1)
    return o1 != o2 and o3 != o4

def solve_case(N, blue_points, red_points):
    # Сортуємо точки
    blue_points.sort(key=lambda x: (x[0], x[1]))  # Сортуємо за x, потім за y
    red_points.sort(key=lambda x: (x[0], x[1]))  # Сортуємо за x, потім за y
    
    result = []
    
    # З'єднуємо точки
    for i in range(N):
        result.append((i + 1, i + 1))  # З'єднуємо синю точку i з червоною точкою i
    
    # Перевіряємо, чи є перетини
    for i in range(N):
        for j in range(i + 1, N):
            # Перевіряємо перетин для відрізків (blue[i], red[i]) і (blue[j], red[j])
            if do_intersect(blue_points[i], red_points[i], blue_points[j], red_points[j]):
                return [0]  # Якщо є перетин, повертаємо 0
    
    return result  # Якщо немає перетину, повертаємо результат

def main():
    t = int(input())  # Кількість тестів
    for _ in range(t):
        N = int(input())  # Кількість точок одного кольору
        blue_points = [tuple(map(int, input().split())) for _ in range(N)]  # Сині точки
        red_points = [tuple(map(int, input().split())) for _ in range(N)]  # Червоні точки
        
        result = solve_case(N, blue_points, red_points)
        
        if result == [0]:
            print(0)
        else:
            for blue_idx, red_idx in result:
                print(blue_idx, red_idx)

if __name__ == "__main__":
    main()
