def min_meeting_time(n):
    # Початкові позиції
    alice_positions = {1}
    bob_positions = {n}

    # Множини для перевірки вже відвіданих позицій
    visited_by_alice = set()
    visited_by_bob = set()

    # Кількість секунд
    seconds = 0

    while alice_positions and bob_positions:
        # Перевірка на зустріч
        if alice_positions & bob_positions:
            return seconds

        # Оновлення множин відвіданих позицій
        visited_by_alice.update(alice_positions)
        visited_by_bob.update(bob_positions)

        # Розрахунок нових позицій для Аліси
        new_alice_positions = set()
        for pos in alice_positions:
            if pos + 2 <= n:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= n:
                new_alice_positions.add(pos + 3)

        # Розрахунок нових позицій для Боба
        new_bob_positions = set()
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)

        # Видалення вже відвіданих позицій
        alice_positions = new_alice_positions - visited_by_alice
        bob_positions = new_bob_positions - visited_by_bob

        # Збільшення секунд
        seconds += 1

    # Якщо зустріч неможлива
    return -1

# Зчитування числа N
n = int(input())

# Виведення результату
print(min_meeting_time(n))
