from collections import deque

def minimum_time_to_meet(N):
    # Черги для позицій Аліси і Боба
    alice_positions = deque([1])
    bob_positions = deque([N])
    
    # Час
    time = 0
    
    # Відвідані позиції для Аліси і Боба
    alice_visited = set([1])
    bob_visited = set([N])
    
    # Поки є можливість для телепортації
    while alice_positions and bob_positions:
        time += 1
        
        # Нові позиції для Аліси і Боба на наступній секунді
        next_alice_positions = set()
        next_bob_positions = set()
        
        # Аліса телепортується
        for pos in alice_positions:
            if pos + 2 <= N:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                next_alice_positions.add(pos + 3)
        
        # Боб телепортується
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)
        
        # Перевіряємо, чи є спільні позиції між Алісою і Бобом
        if next_alice_positions & next_bob_positions:
            return time
        
        # Оновлюємо черги і відвідані позиції
        alice_positions = deque(next_alice_positions - alice_visited)
        bob_positions = deque(next_bob_positions - bob_visited)
        
        # Оновлюємо відвідані позиції
        alice_visited.update(next_alice_positions)
        bob_visited.update(next_bob_positions)
    
    # Якщо не знайшли спільну позицію
    return -1

# Зчитуємо вхідні дані
N = int(input())

# Виводимо результат
print(minimum_time_to_meet(N))
