def minimum_time_to_meet(N):
    # Множини для зберігання можливих позицій Аліси та Боба
    alice_positions = {1}  # Початкові позиції Аліси
    bob_positions = {N}    # Початкові позиції Боба

    # Час
    time = 0
    
    # Поки є можливість для телепортації
    while alice_positions and bob_positions:
        time += 1
        
        # Множини для нових можливих позицій
        next_alice_positions = set()
        next_bob_positions = set()

        # Аліса може телепортуватися в k+2 або k+3
        for pos in alice_positions:
            if pos + 2 <= N:
                next_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                next_alice_positions.add(pos + 3)

        # Боб може телепортуватися в k-1 або k-2
        for pos in bob_positions:
            if pos - 1 >= 1:
                next_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_bob_positions.add(pos - 2)

        # Перевіряємо, чи є спільні позиції між Алісою і Бобом
        if next_alice_positions & next_bob_positions:
            return time

        # Оновлюємо позиції Аліси і Боба
        alice_positions = next_alice_positions
        bob_positions = next_bob_positions

    # Якщо не знайшли спільну позицію
    return -1

# Зчитуємо вхідні дані
N = int(input())

# Виводимо результат
print(minimum_time_to_meet(N))
