def calculate_meeting_time(N):
    def alice_positions(t):
        """Повертає всі можливі позиції Аліси через t секунд."""
        return {1 + 2 * t, 1 + 3 * t}

    def bob_positions(t):
        """Повертає всі можливі позиції Боба через t секунд."""
        return {N - t, N - 2 * t}

    # Зберігаємо всі відвідані позиції для перевірки
    alice_visited = set()
    bob_visited = set()

    t = 0  # Лічильник часу
    while True:
        # Отримуємо позиції Аліси та Боба через t секунд
        current_alice_positions = alice_positions(t)
        current_bob_positions = bob_positions(t)

        # Зберігаємо всі позиції, які відвідують Аліса та Боб
        alice_visited.update(current_alice_positions)
        bob_visited.update(current_bob_positions)

        # Перевіряємо, чи є перетин між позиціями Аліси та Боба
        if current_alice_positions & current_bob_positions:
            return t  # Зустріч можлива через t секунд

        # Якщо всі можливі позиції Аліси виходять за межі, завершити
        if all(pos > N for pos in current_alice_positions):
            return -1  # Зустріч неможлива

        t += 1  # Переходимо до наступної секунди


# Зчитування вхідних даних
N = int(input("Введіть кількість боксів: "))
result = calculate_meeting_time(N)
if result == -1:
    print("Зустріч неможлива")
else:
    print(f"Мінімальна кількість секунд для зустрічі: {result}")
