def calculate_meeting_time(N):
    from collections import deque

    # Моделюємо позиції Аліси та Боба
    def get_next_positions(pos, is_alice=True):
        """Отримати наступні можливі позиції для робота."""
        if is_alice:
            return {pos + 2, pos + 3}
        else:
            return {pos - 1, pos - 2}

    # Черга для BFS (позиція, час, робот)
    queue = deque([(1, 0, True), (N, 0, False)])  # (позиція, час, Аліса=True/Боб=False)

    # Відвідані позиції для Аліси та Боба
    visited_alice = set()
    visited_bob = set()

    while queue:
        current_pos, current_time, is_alice = queue.popleft()

        # Визначаємо, яка множина відвіданих точок актуальна
        visited = visited_alice if is_alice else visited_bob
        other_visited = visited_bob if is_alice else visited_alice

        # Якщо вже відвідували, пропускаємо
        if current_pos in visited:
            continue

        # Позначаємо точку як відвідану
        visited.add(current_pos)

        # Перевіряємо, чи є перетин із позиціями іншого робота
        if current_pos in other_visited:
            return current_time

        # Додаємо наступні позиції в чергу
        next_positions = get_next_positions(current_pos, is_alice)
        for next_pos in next_positions:
            if 1 <= next_pos <= N:  # Перевіряємо, чи позиція в межах
                queue.append((next_pos, current_time + 1, is_alice))

    # Якщо цикл завершився, зустріч неможлива
    return -1


# Зчитування вхідних даних
N = int(input("Введіть кількість боксів: "))
result = calculate_meeting_time(N)
if result == -1:
    print("Зустріч неможлива")
else:
    print(f"Мінімальна кількість секунд для зустрічі: {result}")
