def find_minimal_stamps(N, M):
    # Масив для збереження можливих сум
    dp = [False] * (M + 1)
    dp[0] = True  # Сума 0 можлива, якщо не вибирати жодної марки

    # Масив для відстеження, які марки вибрані для кожної суми
    previous = [-1] * (M + 1)
    
    # Проходимо по всіх марках від 1 до N
    for i in range(1, N + 1):
        # Ітерація від M до i, щоб уникнути повторного використання однієї марки
        for j in range(M, i - 1, -1):
            if dp[j - i]:
                dp[j] = True
                previous[j] = i

    # Якщо сума M не можлива, повертаємо 0
    if not dp[M]:
        return [0]
    
    # Відтворюємо вибрані марки, відслідковуючи попередні вибори
    result = []
    current_sum = M
    while current_sum > 0:
        result.append(previous[current_sum])
        current_sum -= previous[current_sum]
    
    return result[::-1]  # Повертаємо в порядку зростання

# Вхідні дані
N = int(input())  # Кількість марок
M = int(input())  # Загальна вартість марок

# Отримуємо результат
result = find_minimal_stamps(N, M)

# Виводимо результат
print(" ".join(map(str, result)))
