def find_stamps(N, M):
    # Функція для пошуку
    def helper(n, m, selected, best_solution):
        # Якщо ми досягли нульової вартості, перевіряємо чи це найкраще рішення
        if m == 0:
            if len(selected) < len(best_solution) or not best_solution:
                return selected
            return best_solution
        
        # Якщо ми вийшли за межі можливих марок, повертаємо поточне рішення
        if n == 0 or m < 0:
            return best_solution
        
        # Пробуємо включити поточну марку n
        new_solution = selected + [n]
        best_solution = helper(n - 1, m - n, new_solution, best_solution)

        # А також пробуємо не включати поточну марку n
        best_solution = helper(n - 1, m, selected, best_solution)
        
        return best_solution
    
    # Викликаємо допоміжну рекурсивну функцію з початковими значеннями
    solution = helper(N, M, [], [])
    
    # Якщо рішення порожнє, значить не знайшли жодних марок
    if not solution:
        return 0
    else:
        return solution

# Читання вхідних даних
N = int(input())  # Кількість марок
M = int(input())  # Загальна вартість марок

# Отримуємо відповідь
result = find_stamps(N, M)

# Виводимо результат
if result == 0:
    print(0)
else:
    for stamp in result:
        print(stamp)
