#include <iostream>
#include <vector>

using namespace std;

bool check1(const vector<vector<int>> &m, int x1, int y1, int x2, int y2) {
  return m[x1][y1] == m[x1][y2] && m[x1][y1] == m[x2][y1] &&
         m[x1][y1] == m[x2][y2];
}

bool check2(const vector<vector<int>> &m, int x1, int y1, int x2, int y2) {
  int x3 = x2 + (x2 - x1);
  int y3 = y2 + (y2 - y1);
  int x4 = x1 + (x2 - x1);
  int y4 = y1 + (y2 - y1);

  int n = m.size();
  if (x3 >= 0 && x3 < n && y3 >= 0 && y3 < n && x4 >= 0 && x4 < n && y4 >= 0 &&
      y4 < n) {
    return m[x1][y1] == m[x2][y2] && m[x1][y1] == m[x3][y3] &&
           m[x1][y1] == m[x4][y4];
  }
  return false;
}

int f(const vector<vector<int>> &m, int n) {
  int k = 0;

  for (int i = 1; i < n; ++i) {
    for (int x = 0; x + i < n; ++x) {
      for (int y = 0; y + i < n; ++y) {
        if (check1(m, x, y, x + i, y + i)) {
          ++k;
        }
      }
    }
  }

  for (int x1 = 0; x1 < n; ++x1) {
    for (int y1 = 0; y1 < n; ++y1) {
      for (int x2 = x1 + 1; x2 < n; ++x2) {
        for (int y2 = y1 + 1; y2 < n; ++y2) {
          if (abs(x2 - x1) == abs(y2 - y1)) {
            if (check2(m, x1, y1, x2, y2)) {
              ++k;
            }
          }
        }
      }
    }
  }

  return k;
}

int main() {
  int n;
  cin >> n;

  vector<vector<int>> m(n, vector<int>(n));
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      cin >> m[i][j];
    }
  }

  cout << f(m, n) << endl;

  return 0;
}