#include <iostream>
#include <vector>

using namespace std;

bool check1(const vector<vector<long long>> &m, long long x1, long long y1,
            long long x2, long long y2) {
  return m[x1][y1] == m[x1][y2] && m[x1][y1] == m[x2][y1] &&
         m[x1][y1] == m[x2][y2];
}

bool check2(const vector<vector<long long>> &m, long long x1, long long y1,
            long long x2, long long y2) {
  long long x3 = x2 + (x2 - x1);
  long long y3 = y2 + (y2 - y1);
  long long x4 = x1 + (x2 - x1);
  long long y4 = y1 + (y2 - y1);

  long long n = m.size();
  if (x3 >= 0 && x3 < n && y3 >= 0 && y3 < n && x4 >= 0 && x4 < n && y4 >= 0 &&
      y4 < n) {
    return m[x1][y1] == m[x2][y2] && m[x1][y1] == m[x3][y3] &&
           m[x1][y1] == m[x4][y4];
  }
  return false;
}

long long f(const vector<vector<long long>> &m, long long n) {
  long long k = 0;

  for (long long i = 1; i < n; ++i) {
    for (long long x = 0; x + i < n; ++x) {
      for (long long y = 0; y + i < n; ++y) {
        if (check1(m, x, y, x + i, y + i)) {
          ++k;
        }
      }
    }
  }

  for (long long x1 = 0; x1 < n; ++x1) {
    for (long long y1 = 0; y1 < n; ++y1) {
      for (long long x2 = x1 + 1; x2 < n; ++x2) {
        for (long long y2 = y1 + 1; y2 < n; ++y2) {
          if (abs(x2 - x1) == abs(y2 - y1)) {
            if (check2(m, x1, y1, x2, y2)) {
              ++k;
            }
          }
        }
      }
    }
  }

  return k;
}

int main() {
  long long n;
  cin >> n;

  vector<vector<long long>> m(n, vector<long long>(n));
  for (long long i = 0; i < n; ++i) {
    for (long long j = 0; j < n; ++j) {
      cin >> m[i][j];
    }
  }

  cout << f(m, n) << endl;

  return 0;
}
