from collections import deque

def min_time_to_meet(N):
    # Черги для відстеження позицій Аліси та Боба
    alice_queue = deque([1])
    bob_queue = deque([N])
    
    # Відвідані клітинки для обох роботів
    alice_visited = set([1])
    bob_visited = set([N])
    
    # Час
    time = 0
    
    while alice_queue and bob_queue:
        time += 1
        
        # Обробка Аліси (робимо всі можливі переміщення за один крок)
        for _ in range(len(alice_queue)):
            current_alice = alice_queue.popleft()
            for move in [2, 3]:
                next_alice = current_alice + move
                if next_alice <= N and next_alice not in alice_visited:
                    alice_visited.add(next_alice)
                    alice_queue.append(next_alice)
                    # Якщо точка є в Bob-visited, то знайдено перетин
                    if next_alice in bob_visited:
                        return time
        
        # Обробка Боба
        for _ in range(len(bob_queue)):
            current_bob = bob_queue.popleft()
            for move in [1, 2]:
                next_bob = current_bob - move
                if next_bob >= 1 and next_bob not in bob_visited:
                    bob_visited.add(next_bob)
                    bob_queue.append(next_bob)
                    # Якщо точка є в Alice-visited, то знайдено перетин
                    if next_bob in alice_visited:
                        return time
    
    return -1  # Якщо не знайшли жодного перетину

n = int(input())
print(min_time_to_meet(n))
