def orientation(p, q, r):
    """ Функція для обчислення орієнтації трьох точок.
        Повертає:
        0: якщо точки колінеарні
        1: якщо оберт по годинниковій стрілці
        2: якщо оберт проти годинникової стрілки
    """
    val = (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])
    if val == 0:
        return 0 
    elif val > 0:
        return 1 
    else:
        return 2

def doIntersect(p1, q1, p2, q2):
    o1 = orientation(p1, q1, p2)
    o2 = orientation(p1, q1, q2)
    o3 = orientation(p2, q2, p1)
    o4 = orientation(p2, q2, q1)

    if o1 != o2 and o3 != o4:
        return True 
    return False

def solve_case(N, blue_points, red_points):
    blue_points_sorted = sorted(blue_points)
    red_points_sorted = sorted(red_points)
    
    result = []
    for i in range(N):
        result.append((blue_points_sorted[i][2], red_points_sorted[i][2]))
    
    return result

def main():
    t = int(input())
    for _ in range(t):
        N = int(input())
        blue_points = []
        red_points = []
        
        for i in range(N):
            x, y = map(int, input().split())
            blue_points.append((x, y, i + 1))
        for i in range(N):
            x, y = map(int, input().split())
            red_points.append((x, y, i + 1)) 

        result = solve_case(N, blue_points, red_points)
        if result:
            for blue, red in result:
                print(blue, red)
        else:
            print(0)

if __name__ == "__main__":
    main()
