#include <iostream>
#include <vector>
#include <unordered_set>
using namespace std;

int countSquares(int n, const vector<vector<int>>& grid) {
    int total = 0;

    for (int x = 0; x < n - 1; ++x) {
        for (int y = 0; y < n - 1; ++y) {
            for (int size = 1; size < n - max(x, y); ++size) {
                for (int offset = 0; offset < size; ++offset) {
                    unordered_set<int> uniqueValues = {
                        grid[x + offset][y],
                        grid[x + size][y + offset],
                        grid[x + size - offset][y + size],
                        grid[x][y + size - offset]
                    };

                    if (uniqueValues.size() == 1) {
                        total++;
                    }
                }
            }
        }
    }

    return total;
}

int main() {
    int n;
    cin >> n;

    vector<vector<int>> grid(n, vector<int>(n));
    for (int row = 0; row < n; ++row) {
        for (int col = 0; col < n; ++col) {
            cin >> grid[row][col];
        }
    }

    int result = countSquares(n, grid);
    cout << result;

    return 0;
}