#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Point {
    int x, y, index;
};

void solveTestCase(int N, vector<Point>& bluePoints, vector<Point>& redPoints) {
    sort(bluePoints.begin(), bluePoints.end(), [](const Point& a, const Point& b) {
        return a.x < b.x;
    });
    sort(redPoints.begin(), redPoints.end(), [](const Point& a, const Point& b) {
        return a.x < b.x;
    });

    vector<pair<int, int>> pairs;
    for (int i = 0; i < N; i++) {
        pairs.emplace_back(bluePoints[i].index, redPoints[i].index);
    }

    for (const auto& p : pairs) {
        cout << p.first << " " << p.second << endl;
    }
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> bluePoints(N);
        vector<Point> redPoints(N);

        for (int i = 0; i < N; i++) {
            cin >> bluePoints[i].x >> bluePoints[i].y;
            bluePoints[i].index = i + 1;
        }

        for (int i = 0; i < N; i++) {
            cin >> redPoints[i].x >> redPoints[i].y;
            redPoints[i].index = i + 1;
        }

        solveTestCase(N, bluePoints, redPoints);
    }

    return 0;
}