#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <string>
using namespace std;

struct Point {
    int x, y;
    string color;
    int index;
};

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> points;
        int x, y;

        for (int i = 0; i < N; i++) {
            cin >> x >> y;
            points.push_back({x, y, "blue", i + 1});
        }

        for (int i = 0; i < N; i++) {
            cin >> x >> y;
            points.push_back({x, y, "red", i + 1});
        }

        sort(points.begin(), points.end(), [](const Point& a, const Point& b) {
            return a.x < b.x;
        });

        stack<Point> s;
        vector<pair<int, int>> pairs;

        for (const auto& p : points) {
            if (s.empty() || s.top().color == p.color) {
                s.push(p);
            } else {
                Point q = s.top();
                s.pop();

                int blue_index, red_index;
                if (q.color == "blue") {
                    blue_index = q.index;
                    red_index = p.index;
                } else {
                    blue_index = p.index;
                    red_index = q.index;
                }
                pairs.push_back({blue_index, red_index});
            }
        }

        if (!s.empty()) {
            cout << 0 << endl;
        } else {
            for (const auto& pr : pairs) {
                cout << pr.first << " " << pr.second << endl;
            }
        }
    }

    return 0;
}