#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

struct Point {
    int x, y, index;
};

double distance(const Point& a, const Point& b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> bluePoints(N), redPoints(N);
        for (int i = 0; i < N; ++i) {
            cin >> bluePoints[i].x >> bluePoints[i].y;
            bluePoints[i].index = i + 1;
        }
        for (int i = 0; i < N; ++i) {
            cin >> redPoints[i].x >> redPoints[i].y;
            redPoints[i].index = i + 1;
        }

        vector<vector<double>> distances(N, vector<double>(N));
        for (int i = 0; i < N; ++i)
            for (int j = 0; j < N; ++j)
                distances[i][j] = distance(bluePoints[i], redPoints[j]);

        vector<int> matchedRed(N, -1);
        vector<bool> usedBlue(N, false), usedRed(N, false);
        bool possible = true;

        for (int i = 0; i < N; ++i) {
            double minDist = 1e9;
            int bestBlue = -1, bestRed = -1;

            for (int b = 0; b < N; ++b) {
                if (usedBlue[b]) continue;
                for (int r = 0; r < N; ++r) {
                    if (usedRed[r]) continue;
                    if (distances[b][r] < minDist) {
                        minDist = distances[b][r];
                        bestBlue = b;
                        bestRed = r;
                    }
                }
            }

            if (bestBlue == -1 || bestRed == -1) {
                possible = false;
                break;
            }

            usedBlue[bestBlue] = true;
            usedRed[bestRed] = true;
            matchedRed[bestBlue] = bestRed;
        }

        if (!possible) {
            cout << 0 << endl;
        } else {
            for (int i = 0; i < N; ++i) {
                cout << bluePoints[i].index << " " << redPoints[matchedRed[i]].index << endl;
            }
        }
    }

    return 0;
}