#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y, index;
};

bool comparePoints(const Point& a, const Point& b) {
    if (a.x != b.x) return a.x < b.x;
    return a.y < b.y;
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> bluePoints(N), redPoints(N);
        for (int i = 0; i < N; ++i) {
            cin >> bluePoints[i].x >> bluePoints[i].y;
            bluePoints[i].index = i + 1;
        }
        for (int i = 0; i < N; ++i) {
            cin >> redPoints[i].x >> redPoints[i].y;
            redPoints[i].index = i + 1;
        }

        sort(bluePoints.begin(), bluePoints.end(), comparePoints);
        sort(redPoints.begin(), redPoints.end(), comparePoints);

        vector<pair<int, int>> result;
        for (int i = 0; i < N; ++i) {
            result.emplace_back(bluePoints[i].index, redPoints[i].index);
        }

        for (int i = 0; i < N; ++i) {
            cout << result[i].first << " " << result[i].second << endl;
        }
    }

    return 0;
}