#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

struct Point {
    int x, y, index;
};

// Функція для сортування за полярним кутом
bool polarOrder(const Point& a, const Point& b) {
    return atan2(a.y, a.x) < atan2(b.y, b.x);
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> bluePoints(N), redPoints(N);
        for (int i = 0; i < N; ++i) {
            cin >> bluePoints[i].x >> bluePoints[i].y;
            bluePoints[i].index = i + 1;
        }
        for (int i = 0; i < N; ++i) {
            cin >> redPoints[i].x >> redPoints[i].y;
            redPoints[i].index = i + 1;
        }

        sort(bluePoints.begin(), bluePoints.end(), polarOrder);
        sort(redPoints.begin(), redPoints.end(), polarOrder);

        vector<pair<int, int>> result;
        for (int i = 0; i < N; ++i) {
            result.emplace_back(bluePoints[i].index, redPoints[i].index);
        }

        bool isValid = true;
        for (int i = 0; i < N - 1; ++i) {
            if (bluePoints[i].x * redPoints[i + 1].y - bluePoints[i].y * redPoints[i + 1].x !=
                bluePoints[i + 1].x * redPoints[i].y - bluePoints[i + 1].y * redPoints[i].x) {
                isValid = false;
                break;
            }
        }

        if (!isValid) {
            cout << 0 << endl;
        } else {
            for (const auto& p : result) {
                cout << p.first << " " << p.second << endl;
            }
        }
    }

    return 0;
}