#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y, index;
};

bool compareByX(const Point& a, const Point& b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> bluePoints(N), redPoints(N);

        for (int i = 0; i < N; ++i) {
            cin >> bluePoints[i].x >> bluePoints[i].y;
            bluePoints[i].index = i + 1;
        }
        for (int i = 0; i < N; ++i) {
            cin >> redPoints[i].x >> redPoints[i].y;
            redPoints[i].index = i + 1;
        }

        sort(bluePoints.begin(), bluePoints.end(), compareByX);
        sort(redPoints.begin(), redPoints.end(), compareByX);

        vector<pair<int, int>> result;

        for (int i = 0; i < N; ++i) {
            result.emplace_back(bluePoints[i].index, redPoints[i].index);
        }

        for (const auto& pair : result) {
            cout << pair.first << " " << pair.second << endl;
        }
    }

    return 0;
}