from collections import deque

def minimum_time_to_meet(N):
    if N == 2:
        return -1

    alice_positions = {1}
    bob_positions = {N}
    visited = set()
    visited.add((1, N))
    time = 0

    while alice_positions and bob_positions:
        time += 1

        new_alice_positions = set()
        for pos in alice_positions:
            for new_pos in (pos + 2, pos + 3):
                if new_pos <= N:
                    new_alice_positions.add(new_pos)

        new_bob_positions = set()
        for pos in bob_positions:
            for new_pos in (pos - 1, pos - 2):
                if new_pos >= 1:
                    new_bob_positions.add(new_pos)

        if new_alice_positions & new_bob_positions:
            return time

        alice_positions = new_alice_positions
        bob_positions = new_bob_positions

    return -1

N = int(input())
print(minimum_time_to_meet(N))
