from collections import deque

def minimum_time_to_meet(N, alice_start=1, bob_start=None, alice_moves=(2, 3), bob_moves=(-1, -2)):
    if bob_start is None:
        bob_start = N

    if N < 2 or alice_start >= bob_start:
        return -1

    alice_positions = {alice_start}
    bob_positions = {bob_start}
    visited = set()
    visited.add((alice_start, bob_start))
    time = 0

    while alice_positions and bob_positions:
        time += 1

        new_alice_positions = set()
        for pos in alice_positions:
            for move in alice_moves:
                new_pos = pos + move
                if 1 <= new_pos <= N:
                    new_alice_positions.add(new_pos)

        new_bob_positions = set()
        for pos in bob_positions:
            for move in bob_moves:
                new_pos = pos + move
                if 1 <= new_pos <= N:
                    new_bob_positions.add(new_pos)

        if new_alice_positions & new_bob_positions:
            return time

        alice_positions = new_alice_positions
        bob_positions = new_bob_positions

    return -1

N = int(input())
print(minimum_time_to_meet(N))
