def ccw(P, Q, R):
    return (R[1] - P[1]) * (Q[0] - P[0]) > (Q[1] - P[1]) * (R[0] - P[0])

def segments_intersect(A, B, C, D):
    return (ccw(A, C, D) != ccw(B, C, D)) and (ccw(A, B, C) != ccw(A, B, D))

def solve_test_case(N, blue_points, red_points):
    blue_points = sorted((pt, idx + 1) for idx, pt in enumerate(blue_points))
    red_points = sorted((pt, idx + 1) for idx, pt in enumerate(red_points))
    
    result = []
    used_red = set()
    for b_point, b_idx in blue_points:
        best_distance = float('inf')
        best_red = None
        for r_point, r_idx in red_points:
            if r_idx in used_red:
                continue
            dist = (b_point[0] - r_point[0])**2 + (b_point[1] - r_point[1])**2
            if dist < best_distance:
                best_distance = dist
                best_red = (r_point, r_idx)
        
        if best_red:
            result.append((b_idx, best_red[1]))
            used_red.add(best_red[1])
    
    
    for i in range(len(result)):
        for j in range(i + 1, len(result)):
            b1, r1 = result[i]
            b2, r2 = result[j]
            if segments_intersect(blue_points[b1 - 1][0], red_points[r1 - 1][0],
                                  blue_points[b2 - 1][0], red_points[r2 - 1][0]):
                return [0]  
    
    return result


t = int(input())  
results = []
for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    results.append(solve_test_case(N, blue_points, red_points))


for res in results:
    if res == [0]:
        print(0)
    else:
        for b, r in res:
            print(b, r)
