def solve_robot_president(t, test_cases):
    results = []
    for case in test_cases:
        N, blue_points, red_points = case
        
        # Нумерація точок для відповідності індексам
        blue_points = sorted((point, idx + 1) for idx, point in enumerate(blue_points))
        red_points = sorted((point, idx + 1) for idx, point in enumerate(red_points))
        
        # Побудова пар
        pairs = []
        for i in range(N):
            blue_idx = blue_points[i][1]
            red_idx = red_points[i][1]
            pairs.append((blue_idx, red_idx))
        
        results.append(pairs)
    
    return results

# Зчитування вхідних даних
t = int(input())
test_cases = []
for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

# Обробка
results = solve_robot_president(t, test_cases)

# Виведення результатів
for result in results:
    if result:
        for blue, red in result:
            print(blue, red)
    else:
        print(0)

