#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, index;
};

inline long long distanceSquared(const Point &a, const Point &b) {
    return 1LL * (a.x - b.x) * (a.x - b.x) + 1LL * (a.y - b.y) * (a.y - b.y);
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        vector<Point> blue(n), red(n);

        for (int i = 0; i < n; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1; 
        }

        for (int i = 0; i < n; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        sort(blue.begin(), blue.end(), [](const Point &a, const Point &b) {
            return a.x < b.x || (a.x == b.x && a.y < b.y);
        });

        sort(red.begin(), red.end(), [](const Point &a, const Point &b) {
            return a.x < b.x || (a.x == b.x && a.y < b.y);
        });

        vector<pair<int, int>> result;
        for (int i = 0; i < n; ++i) {
            result.emplace_back(blue[i].index, red[i].index);
        }

        bool valid = true;
        for (int i = 0; i < n && valid; ++i) {
            for (int j = i + 1; j < n && valid; ++j) {
                const Point &a1 = blue[i], &b1 = red[i];
                const Point &a2 = blue[j], &b2 = red[j];

                auto cross = [](const Point &p1, const Point &p2, const Point &p3) {
                    return 1LL * (p2.x - p1.x) * (p3.y - p1.y) - 1LL * (p2.y - p1.y) * (p3.x - p1.x);
                };
                bool intersect = (cross(a1, b1, a2) * cross(a1, b1, b2) < 0) &&
                                 (cross(a2, b2, a1) * cross(a2, b2, b1) < 0);
                if (intersect) valid = false;
            }
        }

        if (!valid) {
            cout << "0\n";
        } else {
            for (const auto &[b, r] : result) {
                cout << b << " " << r << "\n";
            }
        }
    }
    return 0;
}