from collections import deque

def teleportation(N):
    if N == 1:
        return 0
    
    alice_queue = deque([(1, 0)])
    bob_queue = deque([(N, 0)])
    
    alice_visited = set([1])
    bob_visited = set([N])
    
    while alice_queue or bob_queue:
        if alice_queue:
            alice_pos, alice_time = alice_queue.popleft()
            for next_pos in (alice_pos + 2, alice_pos + 3):
                if next_pos > N:
                    continue
                if next_pos in bob_visited:
                    return alice_time + 1
                if next_pos not in alice_visited:
                    alice_visited.add(next_pos)
                    alice_queue.append((next_pos, alice_time + 1))
        
        if bob_queue:
            bob_pos, bob_time = bob_queue.popleft()
            for next_pos in (bob_pos - 1, bob_pos - 2):
                if next_pos < 1:
                    continue
                if next_pos in alice_visited:
                    return bob_time + 1
                if next_pos not in bob_visited:
                    bob_visited.add(next_pos)
                    bob_queue.append((next_pos, bob_time + 1))

N = int(input())
print(teleportation(N))
