var scanf = require('scanf');

var n = scanf('%d'); 
var m = scanf('%d');

// Function to get the minimal set of numbers that sum up to m
function findCombination(n, m) {
    let result = [];
    let remainingSum = m;

    // Check if it's possible to form 'm' with the numbers from 1 to n
    if (n * (n + 1) / 2 < m) {
        return [0]; // Impossible to form m
    }

    // Start with the largest number 'n' and reduce 'm' step by step
    while (remainingSum > 0 && n > 0) {
        if (remainingSum >= n) {
            result.push(n);
            remainingSum -= n;
        }
        n--;
    }

    return remainingSum === 0 ? result : [0]; // If exact sum is found, return result; otherwise, 0
}

let combination = findCombination(n, m);

if (combination[0] === 0) {
    console.log(0);
} else {
    combination.forEach(e => console.log(e)); // Output the result
}
