var scanf = require('scanf');
var n = scanf('%d');  // Зчитуємо кількість боксів

function minTimeToMeet(n) {
    const queue = [[1, n, 0]];  // Початкові позиції Аліси (1) та Боба (N) і час (0)
    const visited = new Set();  // Множина для відслідковування відвіданих позицій

    // Додаємо початкову позицію в множину
    visited.add('1,' + n);

    while (queue.length > 0) {
        const [alicePos, bobPos, time] = queue.shift();  // Витягуємо перший елемент черги

        // Якщо Аліса і Боб знаходяться в одному боксі
        if (alicePos === bobPos) {
            return time;
        }

        // Аліса може телепортуватися на k + 2 або k + 3
        const nextAliceMoves = [alicePos + 2, alicePos + 3];
        for (const nextAlicePos of nextAliceMoves) {
            if (nextAlicePos >= 1 && nextAlicePos <= n && !visited.has(nextAlicePos + ',' + bobPos)) {
                queue.push([nextAlicePos, bobPos, time + 1]);
                visited.add(nextAlicePos + ',' + bobPos);
            }
        }

        // Боб може телепортуватися на k - 1 або k - 2
        const nextBobMoves = [bobPos - 1, bobPos - 2];
        for (const nextBobPos of nextBobMoves) {
            if (nextBobPos >= 1 && nextBobPos <= n && !visited.has(alicePos + ',' + nextBobPos)) {
                queue.push([alicePos, nextBobPos, time + 1]);
                visited.add(alicePos + ',' + nextBobPos);
            }
        }
    }

    // Якщо неможливо зустрітися
    return -1;
}

// Викликаємо функцію та виводимо результат
console.log(minTimeToMeet(n));