#include <bits/stdc++.h>
using namespace std;
using ll = long long;


double dist(pair<int, int> f, pair<int, int> s) {
    return sqrt((f.first - s.first) * (f.first - s.first) +
            (f.second - s.second) * (f.second - s.second));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int T;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;

        pair<int, int> red[n + 1], blue[n + 1];
        for (int i = 1; i <= n; i++) {
            cin >> red[i].first >> red[i].second;
        }
        for (int i = 1; i <= n; i++) {
            cin >> blue[i].first >> blue[i].second;
        }


        double weights[n + 1][n + 1] = {};

        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++) {
                weights[i][j] = dist(red[i], blue[j]);
            }
        }


        double rows[n + 1] = {}, cols[n + 1] = {};
        int matching[n + 1] = {}, where[n + 1] = {};

        for (int i = 1; i <= n; i++) {
            matching[0] = i;

            bool used[n + 1] = {};
            double minima[n + 1];
            for (int i = 0; i <= n; i++) {
                minima[i] = INT_MAX;
            }


            int free = 0;

            while (matching[free] != 0) {
                used[free] = true;

                
                int ii = matching[free];
                int jj = -1;
                double delta = INT_MAX;

                for (int j = 1; j <= n; j++) {
                    if (!used[j]) {
                        double cur = weights[ii][j] - rows[ii] - cols[j];
                        if (cur < minima[j]) {
                            minima[j] = cur;
                            where[j] = free;
                        }

                        if (minima[j] < delta) {
                            delta = minima[j];
                            jj = j;
                        }
                    }
                } 

                for (int j = 0; j <= n; j++) {
                    if (used[j]) {
                        rows[matching[j]] += delta;
                        cols[j] -= delta;
                    }
                    else {
                        minima[j] -= delta;
                    }
                }

                free = jj;
            }

            while (free > 0) {
                int jj = where[free];
                matching[free] = matching[jj];
                free = jj;
            }
        }

        int ans[n + 1];
        for (int j = 1; j <= n; j++) {
            ans[matching[j]] = j;
        }

        for (int i = 1; i <= n; i++) {
            printf("%i %i\n", i, ans[i]);
        }
    }   
    
}

