#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;


int minSecondsToMeet(int N) {
    if (N <= 1) return -1;  
    

    unordered_set<int> alice_positions = {1};
    unordered_set<int> bob_positions = {N};

    queue<pair<int, int>> alice_queue;
    queue<pair<int, int>> bob_queue;

    alice_queue.push({1, 0});
    bob_queue.push({N, 0});

    unordered_set<int> visited_alice = {1};
    unordered_set<int> visited_bob = {N};

    while (!alice_queue.empty() && !bob_queue.empty()) {
   
        for (int pos : alice_positions) {
            if (bob_positions.count(pos)) {
                return alice_queue.front().second;
            }
        }

   
        int alice_size = alice_queue.size();
        for (int i = 0; i < alice_size; ++i) {
            auto current = alice_queue.front(); alice_queue.pop();
            int pos = current.first, time = current.second;
            for (int next_pos : {pos + 2, pos + 3}) {
                if (next_pos <= N && !visited_alice.count(next_pos)) {
                    visited_alice.insert(next_pos);
                    alice_queue.push({next_pos, time + 1});
                    alice_positions.insert(next_pos);
                }
            }
        }

       
        int bob_size = bob_queue.size();
        for (int i = 0; i < bob_size; ++i) {
            auto current = bob_queue.front(); bob_queue.pop();
            int pos = current.first, time = current.second;
            for (int next_pos : {pos - 1, pos - 2}) {
                if (next_pos >= 1 && !visited_bob.count(next_pos)) {
                    visited_bob.insert(next_pos);
                    bob_queue.push({next_pos, time + 1});
                    bob_positions.insert(next_pos);
                }
            }
        }
    }

    return -1;  
}

int main() {
    int N;
    cout << "Введите количество боксов: ";
    cin >> N;
    int result = minSecondsToMeet(N);
    if (result != -1)
        cout << "Минимальное количество секунд: " << result << endl;
    else
        cout << "Встреча невозможна" << endl;
    return 0;
}
