#include <iostream>
#include <queue>
#include <set>

using namespace std;

struct State {
    int position;
    int time;
};

long long minimal_meeting_time(long long N) {
    if (N % 2 == 0) {
        return -1; // Якщо N парне, то вони ніколи не зустрінуться
    }
    
    set<long long> alice_positions;
    queue<State> q;
    q.push({1, 0}); // Початкова позиція Аліси
    alice_positions.insert(1);
    
    while (!q.empty()) {
        State current = q.front();
        q.pop();
        long long pos = current.position;
        long long time = current.time;
        
        if (pos == N || pos == N - 1 || pos == N - 2) {
            return time + 1; // Аліса може зустрітися з Бобом
        }
        
        long long next_pos1 = pos + 2;
        long long next_pos2 = pos + 3;
        
        if (next_pos1 <= N && !alice_positions.count(next_pos1)) {
            q.push({next_pos1, time + 1});
            alice_positions.insert(next_pos1);
        }
        
        if (next_pos2 <= N && !alice_positions.count(next_pos2)) {
            q.push({next_pos2, time + 1});
            alice_positions.insert(next_pos2);
        }
    }
    
    return -1;
}

int main() {
    long long N;
    cin >> N;
    
    cout << minimal_meeting_time(N) << endl;
    
    return 0;
}
