#include <iostream>
#include <vector>
#include <algorithm>
#include <tuple>

struct Point {
    int x, y;
    int index;
    bool is_blue;
};

bool compare_points(const Point& a, const Point& b) {
    return std::make_tuple(a.x, a.y) < std::make_tuple(b.x, b.y);
}

std::vector<std::pair<int, int>> solve_case(int N, std::vector<Point>& points) {
    std::sort(points.begin(), points.end(), compare_points);
    std::vector<std::pair<int, int>> pairs;

    for (int i = 0; i < N; ++i) {
        if (points[i].is_blue) {
            for (int j = N; j < 2 * N; ++j) {
                if (!points[j].is_blue) {
                    pairs.emplace_back(points[i].index, points[j].index);
                    points[j].is_blue = true;  // Использовать точку
                    break;
                }
            }
        }
    }

    return pairs;
}

int main() {
    int t;
    std::cin >> t;

    while (t--) {
        int N;
        std::cin >> N;
        std::vector<Point> points(2 * N);

        for (int i = 0; i < N; ++i) {
            std::cin >> points[i].x >> points[i].y;
            points[i].index = i + 1;
            points[i].is_blue = true;
        }

        for (int i = N; i < 2 * N; ++i) {
            std::cin >> points[i].x >> points[i].y;
            points[i].index = i - N + 1;
            points[i].is_blue = false;
        }

        std::vector<std::pair<int, int>> result = solve_case(N, points);

        for (const auto& pair : result) {
            std::cout << pair.first << " " << pair.second << std::endl;
        }
    }

    return 0;
}
