#include <iostream>
#include <vector>
#include <algorithm>

struct Point {
    int x, y;
    int index;
};

bool comparePoints(const Point &a, const Point &b) {
    if (a.x != b.x) return a.x < b.x;
    return a.y < b.y;
}

std::vector<std::pair<int, int>> solve_case(int N, std::vector<Point>& blue_points, std::vector<Point>& red_points) {
    std::sort(blue_points.begin(), blue_points.end(), comparePoints);
    std::sort(red_points.begin(), red_points.end(), comparePoints);

    std::vector<std::pair<int, int>> pairs;
    for (int i = 0; i < N; ++i) {
        pairs.push_back({blue_points[i].index, red_points[i].index});
    }
    return pairs;
}

int main() {
    int t;
    std::cin >> t;

    while (t--) {
        int N;
        std::cin >> N;
        std::vector<Point> blue_points(N);
        std::vector<Point> red_points(N);

        for (int i = 0; i < N; ++i) {
            std::cin >> blue_points[i].x >> blue_points[i].y;
            blue_points[i].index = i + 1;
        }

        for (int i = 0; i < N; ++i) {
            std::cin >> red_points[i].x >> red_points[i].y;
            red_points[i].index = i + 1;
        }

        std::vector<std::pair<int, int>> result = solve_case(N, blue_points, red_points);

        for (const auto& pair : result) {
            std::cout << pair.first << " " << pair.second << std::endl;
        }
    }

    return 0;
}
