#include <bits/stdc++.h>
#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;

typedef pair<int, int> State; // {позиція, час}

int minMeetingTime(int n) {
    // Черга для BFS
    queue<State> aliceQueue, bobQueue;
    unordered_set<int> aliceVisited, bobVisited;

    // Початкові позиції
    aliceQueue.push({1, 0});
    bobQueue.push({n, 0});
    aliceVisited.insert(1);
    bobVisited.insert(n);

    while (!aliceQueue.empty() && !bobQueue.empty()) {
        // Розглядаємо чергу Аліси
        State alice = aliceQueue.front();
        aliceQueue.pop();

        // Розглядаємо чергу Боба
        State bob = bobQueue.front();
        bobQueue.pop();

        // Перевіряємо зустріч
        if (aliceVisited.count(bob.first) || bobVisited.count(alice.first)) {
            return max(alice.second, bob.second);
        }

        // Додаємо нові позиції для Аліси
        int alicePos = alice.first, aliceTime = alice.second + 1;
        if (alicePos + 2 <= n && !aliceVisited.count(alicePos + 2)) {
            aliceQueue.push({alicePos + 2, aliceTime});
            aliceVisited.insert(alicePos + 2);
        }
        if (alicePos + 3 <= n && !aliceVisited.count(alicePos + 3)) {
            aliceQueue.push({alicePos + 3, aliceTime});
            aliceVisited.insert(alicePos + 3);
        }

        // Додаємо нові позиції для Боба
        int bobPos = bob.first, bobTime = bob.second + 1;
        if (bobPos - 1 >= 1 && !bobVisited.count(bobPos - 1)) {
            bobQueue.push({bobPos - 1, bobTime});
            bobVisited.insert(bobPos - 1);
        }
        if (bobPos - 2 >= 1 && !bobVisited.count(bobPos - 2)) {
            bobQueue.push({bobPos - 2, bobTime});
            bobVisited.insert(bobPos - 2);
        }
    }

    return -1; // Якщо зустріч неможлива
}

int main() {
    int n;
    cin >> n;
    cout << minMeetingTime(n) << endl;
    return 0;
}
