def solve_evas_task(test_cases):
    results = []

    for case in test_cases:
        n, blue_points, red_points = case['n'], case['blue'], case['red']


        blue_points = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
        red_points = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))

        matching = []

        used_red = [False] * n

        for x_b, y_b, b_idx in blue_points:
            closest_red = None
            closest_dist = float('inf')

            for j, (x_r, y_r, r_idx) in enumerate(red_points):
                if used_red[j]:
                    continue

                dist = (x_b - x_r) ** 2 + (y_b - y_r) ** 2
                if dist < closest_dist:
                    closest_dist = dist
                    closest_red = (j, r_idx)

            if closest_red is not None:
                used_red[closest_red[0]] = True
                matching.append((b_idx, closest_red[1]))

        if len(matching) != n:
            results.append([0])
        else:
            results.append(matching)

    return results


def main():
    t = int(input())
    test_cases = []

    for _ in range(t):
        n = int(input())
        blue_points = [tuple(map(int, input().split())) for _ in range(n)]
        red_points = [tuple(map(int, input().split())) for _ in range(n)]
        test_cases.append({'n': n, 'blue': blue_points, 'red': red_points})

    results = solve_evas_task(test_cases)

    for result in results:
        if result == [0]:
            print(0)
        else:
            for b_idx, r_idx in result:
                print(b_idx, r_idx)


if __name__ == "__main__":
    main()