local N = tonumber(io.read())
local grid = {}

local function readGrid()
    for i = 1, N do
        local row = {}
        for val in io.read():gmatch("%d") do
            table.insert(row, tonumber(val))
        end
        grid[i] = row
    end
end
readGrid()

local function isValid(x, y)
    return x >= 1 and x <= N and y >= 1 and y <= N
end

local function checkSquare(x1, y1, x2, y2, x3, y3, x4, y4)
    if not (isValid(x1, y1) and isValid(x2, y2) and 
            isValid(x3, y3) and isValid(x4, y4)) then
        return 0
    end
    
    local color = grid[y1][x1]
    if color == grid[y2][x2] and 
       color == grid[y3][x3] and 
       color == grid[y4][x4] then
        return 1
    end
    return 0
end

local count = 0
local sqrt2 = math.sqrt(2)

setmetatable(grid, {__index = function() return {} end})

for i = 1, N-1 do
    for j = 1, N-1 do
        for k = 1, math.min(N-i, N-j) do
            count = count + checkSquare(i, j, i+k, j, i, j+k, i+k, j+k)
            
            if i+k <= N and j-k >= 1 then
                count = count + checkSquare(i, j, i+k, j, i+k, j-k, i, j-k)
            end
        end
    end
end

print(count)
