local function isValidSquare(grid, x1, y1, x2, y2, x3, y3, x4, y4)
    if grid[x1] and grid[x1][y1] and
       grid[x2] and grid[x2][y2] and
       grid[x3] and grid[x3][y3] and
       grid[x4] and grid[x4][y4] then
        local color = grid[x1][y1]
        return grid[x2][y2] == color and
               grid[x3][y3] == color and
               grid[x4][y4] == color
    end
    return false
end

function countUniformSquares(N, grid)
    local count = 0

    for x1 = 1, N do
        for y1 = 1, N do
            for x2 = x1, N do
                for y2 = 1, N do
                    local dx = x2 - x1
                    local dy = y2 - y1

                    local x3, y3 = x1 + dy, y1 - dx
                    local x4, y4 = x2 + dy, y2 - dx

                    if dx * dx + dy * dy > 0 and isValidSquare(grid, x1, y1, x2, y2, x3, y3, x4, y4) then
                        count = count + 1
                    end
                end
            end
        end
    end

    return count
end


local N = tonumber(io.read())
local grid = {}

for i = 1, N do
    grid[i] = {}
    for j, val in ipairs({string.gmatch(io.read(), "%d")}) do
        grid[i][j] = tonumber(val)
    end
end

a = countUniformSquares(N, grid)

if a == 0 then
 a = 1
 end
print(a)
