import sys
import threading

def match_points(points, matching):
    if len(points) == 0:
        return True
    elif len(points) == 2:
        p1, p2 = points
        if p1[2] == p2[2]:
            return False
        if p1[2] == 'blue':
            matching.append((p1[3], p2[3]))
        else:
            matching.append((p2[3], p1[3]))
        return True
    else:
        points.sort(key=lambda p: (p[0], p[1]))
        N = len(points)
        total_blue = sum(1 for p in points if p[2] == 'blue')
        total_red = N - total_blue
        if total_blue != total_red:
            return False
        blue_count = 0
        red_count = 0
        for i in range(N):
            if points[i][2] == 'blue':
                blue_count += 1
            else:
                red_count += 1
            if blue_count == total_blue // 2 and red_count == total_red // 2:
                mid = i + 1
                break
        else:
            return False
        left_points = points[:mid]
        right_points = points[mid:]

        if not match_points(left_points, matching):
            return False
        if not match_points(right_points, matching):
            return False
        return True

sys.setrecursionlimit(1 << 25)

t = int(sys.stdin.readline())
for _ in range(t):
    N = int(sys.stdin.readline())
    blue_points = [tuple(map(int, sys.stdin.readline().split())) + ('blue', i + 1) for i in range(N)]
    red_points = [tuple(map(int, sys.stdin.readline().split())) + ('red', i + 1) for i in range(N)]
    points = blue_points + red_points

    matching = []
    if not match_points(points, matching):
        print(0)
    else:
        for b_idx, r_idx in matching:
            print(f"{b_idx} {r_idx}")