def find_stamps(N, M):
    min_count = float('inf')  # Мінімальна кількість марок
    best_combination = None  # Найкраща комбінація
    
    # Перебір усіх можливих підмножин за допомогою бітових масок
    for mask in range(1, 1 << N):  # Від 1 до 2^N - 1
        subset_sum = 0
        subset = []
        
        for i in range(N):
            if mask & (1 << i):  # Якщо i-та марка включена
                subset_sum += i + 1
                subset.append(i + 1)
        
        # Якщо сума підмножини дорівнює M
        if subset_sum == M:
            if len(subset) < min_count:
                min_count = len(subset)
                best_combination = subset
    
    # Якщо жодної комбінації не знайшлося
    if best_combination is None:
        return [0]
    
    return best_combination

# Зчитування даних
N = int(input())
M = int(input())

# Виведення результату
print(*find_stamps(N, M))
