#include <iostream>
#include <vector>
#include <set>
using namespace std;

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перевіряємо всі пари точок, які можуть бути діагоналями квадрата
    for (int x1 = 0; x1 < N; x1++) {
        for (int y1 = 0; y1 < N; y1++) {
            for (int x2 = x1 + 1; x2 < N; x2++) {
                for (int y2 = 0; y2 < N; y2++) {
                    // Перевірка, чи є це можливими діагоналями квадрата
                    if ((x1 != x2 || y1 != y2) && grid[x1][y1] == grid[x2][y2]) {
                        // Знаходимо інші дві вершини квадрата
                        int x3 = x1 + y2 - y1;
                        int y3 = y1 + x1 - x2;
                        int x4 = x2 + y1 - y2;
                        int y4 = y2 + x2 - x1;

                        // Перевіряємо, чи ці координати знаходяться в межах сітки і чи мають однаковий колір
                        if (x3 >= 0 && x3 < N && y3 >= 0 && y3 < N &&
                            x4 >= 0 && x4 < N && y4 >= 0 && y4 < N &&
                            grid[x1][y1] == grid[x3][y3] && grid[x1][y1] == grid[x4][y4]) {
                            count++;
                        }
                    }
                }
            }
        }
    }

    cout << count / 4 << endl; // Оскільки кожен квадрат рахується чотири рази
    return 0;
}
