#include <iostream>
#include <vector>
using namespace std;

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));

    // Вводимо матрицю кольорів
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перевіряємо всі квадрати розміру 2x2, 3x3, ..., NxN
    for (int size = 2; size <= N; size++) { // Розмір квадрата від 2x2 до NxN
        for (int i = 0; i <= N - size; i++) { // Початок квадрата по x
            for (int j = 0; j <= N - size; j++) { // Початок квадрата по y
                int color = grid[i][j]; // колір першої вершини
                bool isValid = true;

                // Перевіряємо всі 4 вершини квадрата
                for (int x = i; x < i + size; ++x) {
                    for (int y = j; y < j + size; ++y) {
                        if (grid[x][y] != color) {
                            isValid = false;
                            break;
                        }
                    }
                    if (!isValid) break;
                }

                // Якщо всі вершини одного кольору
                if (isValid) {
                    count++;
                }
            }
        }
    }

    cout << count << endl; // Виводимо кількість квадратів з однаковим кольором
    return 0;
}
