function countSquares(N, grid) {
    let count = 0;

    // Перевірка всіх можливих квадратів розміру 2x2, 3x3, ..., NxN
    for (let size = 2; size <= N; size++) { // Розмір квадрата від 2x2 до NxN
        for (let i = 0; i <= N - size; i++) { // Початок квадрата по x
            for (let j = 0; j <= N - size; j++) { // Початок квадрата по y
                let color = grid[i][j]; // Колір першої вершини
                let isValid = true;

                // Перевіряємо всі 4 вершини квадрата
                // Точки: (i, j), (i+size-1, j), (i, j+size-1), (i+size-1, j+size-1)
                if (grid[i][j] === color && 
                    grid[i + size - 1][j] === color && 
                    grid[i][j + size - 1] === color && 
                    grid[i + size - 1][j + size - 1] === color) {
                    count++;
                }
            }
        }
    }

    return count;
}

// Приклад використання
let N = 4;
let grid = [
    [0, 1, 0, 0],
    [0, 0, 1, 1],
    [1, 0, 0, 0],
    [0, 1, 1, 1]
];

console.log(countSquares(N, grid)); // Виведе кількість квадратів з однаковим кольором
