import math

def is_square(p1, p2, p3, p4):
    # Рахуємо відстані між усіма парами точок і перевіряємо, чи є 2 однакові сторони і 2 однакові діагоналі
    distances = [
        math.dist(p1, p2),
        math.dist(p1, p3),
        math.dist(p1, p4),
        math.dist(p2, p3),
        math.dist(p2, p4),
        math.dist(p3, p4)
    ]
    distances.sort()
    return distances[0] == distances[1] == distances[2] == distances[3] and distances[4] == distances[5]

def count_squares(N, grid):
    count = 0
    
    # Збираємо всі точки сітки
    points = [(i, j) for i in range(N) for j in range(N)]
    
    # Перевіряємо всі можливі квадрати з усіх точок на сітці
    for i in range(N):
        for j in range(N):
            for size in range(1, N - max(i, j)):  # Розмір квадратів від 1 до N
                for k in range(i + size, N):
                    for l in range(j + size, N):
                        if grid[i][j] == grid[k][l] and grid[i][l] == grid[k][j]:
                            count += 1
    return count

# Вхідні дані
N = int(input())  # розмір квадрата
grid = [list(map(int, input().split())) for _ in range(N)]

# Виводимо результат
print(count_squares(N, grid))
