import math
from itertools import combinations 

def is_square(p1, p2, p3, p4):
    dists = [
        math.dist(p1, p2),
        math.dist(p1, p3),
        math.dist(p1, p4),
        math.dist(p2, p3),
        math.dist(p2, p4),
        math.dist(p3, p4)
    ]
    
    dists.sort()
    return dists[0] == dists[1] == dists[2] == dists[3] and dists[4] == dists[5]

def count_squares(N, grid):
    count = 0
    points = [(i, j) for i in range(N) for j in range(N)]
    
    for comb in combinations(points, 4):
        p1, p2, p3, p4 = comb
        if grid[p1[0]][p1[1]] == grid[p2[0]][p2[1]] == grid[p3[0]][p3[1]] == grid[p4[0]][p4[1]]:
            if is_square(p1, p2, p3, p4):
                count += 1
    return count

N = int(input())  
grid = [list(map(int, input().split())) for _ in range(N)]

print(count_squares(N, grid))
