import itertools
import math

def is_square(p1, p2, p3, p4):

    distances = [
        math.dist(p1, p2),
        math.dist(p1, p3),
        math.dist(p1, p4),
        math.dist(p2, p3),
        math.dist(p2, p4),
        math.dist(p3, p4)
    ]
    distances.sort()
    return distances[0] == distances[1] == distances[2] == distances[3] and distances[4] == distances[5]

def count_squares(N, grid):
    count = 0

    points = [(i, j) for i in range(N) for j in range(N)]
    
    for p1, p2, p3, p4 in itertools.combinations(points, 4):
        if grid[p1[0]][p1[1]] == grid[p2[0]][p2[1]] == grid[p3[0]][p3[1]] == grid[p4[0]][p4[1]]:
            if is_square(p1, p2, p3, p4):
                count += 1
    return count

N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

print(count_squares(N, grid))
