# Файл: connect_points.py

def solve_eva_problem(test_cases):
    results = []

    for t in test_cases:
        N, blue_points, red_points = t
        # Сортуємо точки за x-координатою
        blue_points_sorted = sorted((x, y, i + 1) for i, (x, y) in enumerate(blue_points))
        red_points_sorted = sorted((x, y, i + 1) for i, (x, y) in enumerate(red_points))

        # Створюємо список пар
        pairs = []
        for i in range(N):
            blue_idx = blue_points_sorted[i][2]
            red_idx = red_points_sorted[i][2]
            pairs.append((blue_idx, red_idx))

        results.append(pairs)

    return results


if __name__ == "__main__":
    import sys
    input = sys.stdin.read
    data = input().splitlines()

    # Зчитуємо кількість тестів
    t = int(data[0])
    index = 1
    test_cases = []

    for _ in range(t):
        N = int(data[index])
        index += 1

        blue_points = []
        for _ in range(N):
            x, y = map(int, data[index].split())
            blue_points.append((x, y))
            index += 1

        red_points = []
        for _ in range(N):
            x, y = map(int, data[index].split())
            red_points.append((x, y))
            index += 1

        test_cases.append((N, blue_points, red_points))

    # Викликаємо розв'язання задачі
    results = solve_eva_problem(test_cases)

    # Форматуємо вихідні дані
    output = []
    for res in results:
        if not res:
            output.append("0")
        else:
            output.extend(f"{b} {r}" for b, r in res)

    print("\n".join(output))
