def solve(test_cases):
    results = []
    
    for t in test_cases:
        n, blue_points, red_points = t
        
        # Сортуємо точки за координатою x (можна спростити перевірку перетинів)
        blue_points = sorted((x, y, idx+1) for idx, (x, y) in enumerate(blue_points))
        red_points = sorted((x, y, idx+1) for idx, (x, y) in enumerate(red_points))
        
        # Формуємо пари (по прямій: найменший з найменшим)
        pairs = [(blue_points[i][2], red_points[i][2]) for i in range(n)]
        
        # Перевірка на перетини
        def do_segments_intersect(p1, q1, p2, q2):
            # Визначення орієнтації
            def orientation(p, q, r):
                val = (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])
                if val == 0:
                    return 0  # Колінеарні
                return 1 if val > 0 else 2  # 1 -> за годинниковою стрілкою, 2 -> проти
            
            o1 = orientation(p1, q1, p2)
            o2 = orientation(p1, q1, q2)
            o3 = orientation(p2, q2, p1)
            o4 = orientation(p2, q2, q1)
            
            # Загальний випадок
            if o1 != o2 and o3 != o4:
                return True
            
            return False
        
        # Перевіряємо кожну пару на перетин
        no_intersection = True
        for i in range(n):
            for j in range(i+1, n):
                if do_segments_intersect(blue_points[i][:2], red_points[i][:2],
                                         blue_points[j][:2], red_points[j][:2]):
                    no_intersection = False
                    break
            if not no_intersection:
                break
        
        # Додаємо результат
        if no_intersection:
            results.append(pairs)
        else:
            results.append([0])
    
    return results

# Зчитування даних
t = int(input())
test_cases = []

for _ in range(t):
    n = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(n)]
    red_points = [tuple(map(int, input().split())) for _ in range(n)]
    test_cases.append((n, blue_points, red_points))

# Обробка
output = solve(test_cases)

# Вивід результату
for res in output:
    if res == [0]:
        print(0)
    else:
        for pair in res:
            print(pair[0], pair[1])
