#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef long long lli;
typedef long double ld;


struct point
{
    lli x, y,ind,type;
};

const point P = { -13341,-13123 ,0,0};

vector<point> v;
vector<pair<lli, lli>> ans;


ld angle(point p1, point p2) {
    ld dx = abs(p2.x - p1.x);
    ld dy = abs(p2.y - p1.y);
    return dx / dy;
}

bool cmp(point p1, point p2) {
    return angle(P, p1) < angle(P, p2);
}


bool check(point p1, point p2, point p3) {
    if (p1.x <= p3.x) {
        if (p1.x == p3.x) {
            if (p1.y < p3.y) return p2.x < p1.x;
            else return p2.x > p1.x;
        }
        ld k = (ld)(p1.y - p3.y) / (ld)(p1.x - p3.x);
        ld b = p1.y - k * p1.x;
        ld y = k * p2.x + b;
        return p2.y > y;
    }
    else {
        ld k = (ld)(p1.y - p3.y) / (ld)(p1.x - p3.x);
        ld b = p1.y - k * p1.x;
        ld y = k * p2.x + b;
        return p2.y < y;
    }

}

vector<point> make_convex_hull(vector<point> q) {
    vector<point> z;
    z.push_back(q[0]);
    for (int i = 1; i < q.size(); i++) {
        while (z.size() > 1 && !check(z[z.size()-2],z[z.size()-1],q[i]))z.pop_back();
        z.push_back(q[i]);
    }
    return z;
}

void func(vector<vector<point>> aq){
    while (!aq.empty()) {
        vector<point> q = aq.back();
        aq.pop_back();
        if (q.size() == 2) {
            lli a = q[0].ind;
            lli b = q[1].ind;
            if (q[0].type == 2)swap(a, b);
            ans.push_back({ a,b });
            continue;
        }

        lli balance = 0;
        lli cnt = 0;
        bool c = 0;
        for (auto to : q) {
            if (to.type == 1)balance++;
            else balance--;
            cnt++;
            if (balance == 0 && cnt != q.size()) {
                vector<point> q2;
                while (q.size() != cnt) {
                    q2.push_back(q.back());
                    q.pop_back();
                }
                aq.push_back(q);
                aq.push_back(q2);
                c = 1;
                break;
            }
        }
        if (c)continue;
        vector<point> z = make_convex_hull(q);
        map<pair<lli, lli>, lli> used;

        for (int i = 0; i < z.size() - 1; i++) {
            if (z[i].type != z[i + 1].type) {
                aq.push_back({ z[i],z[i + 1] });
                used[{z[i].ind, z[i].type}] = 1;
                used[{z[i + 1].ind, z[i + 1].type}] = 1;
                break;
            }
        }
        z.clear();
        for (auto to : q) if (used[{to.ind, to.type}] == 0)z.push_back(to);
        aq.push_back(z);
    }
}

void solve()
{
    lli n;
    cin >> n;
    v.clear();
    ans.clear();
    for (int i = 1; i <= n; i++) {
        lli x, y;
        cin >> x >> y;
        v.push_back({ x,y,i,1 });
    }
    for (int i = 1; i <= n; i++) {
        lli x, y;
        cin >> x >> y;
        v.push_back({ x,y,i,2 });
    }
    
    sort(v.begin(), v.end(), cmp);

    vector<vector<point>> q;
    q.push_back(v);
    func(q);
   
    for (auto to : ans) {
        cout << to.first << " " <<  to.second << LF;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    lli t;
    cin >> t;
    while (t--)solve();
}

