#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <algorithm>
#include <vector>
#include <math.h>
#include <random>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <numeric>

using namespace std;

#define LF '\n';
typedef int lli;
typedef double ld;


struct point
{
    lli x, y,ind,type;
};

const point P = { -13341,-13123 ,0,0};

vector<point> v;
vector<pair<lli, lli>> ans;



ld angle(point p1, point p2) {
    ld dx = abs(p2.x - p1.x);
    ld dy = abs(p2.y - p1.y);
    return dx / dy;
}

bool cmp(int p1, int p2) {
    return angle(P, v[p1]) < angle(P, v[p2]);
}


bool check(point p1, point p2, point p3) {
    if (p1.x <= p3.x) {
        if (p1.x == p3.x) {
            if (p1.y < p3.y) return p2.x < p1.x;
            else return p2.x > p1.x;
        }
        ld k = (ld)(p1.y - p3.y) / (ld)(p1.x - p3.x);
        ld b = p1.y - k * p1.x;
        ld y = k * p2.x + b;
        return p2.y > y;
    }
    else {
        ld k = (ld)(p1.y - p3.y) / (ld)(p1.x - p3.x);
        ld b = p1.y - k * p1.x;
        ld y = k * p2.x + b;
        return p2.y < y;
    }

}

vector<int> make_convex_hull(vector<int> &q) {
    vector<int> z;
    z.push_back(q[0]);
    for (int i = 1; i < q.size(); i++) {
        while (z.size() > 1 && !check(v[z[z.size()-2]],v[z[z.size()-1]],v[q[i]]) )z.pop_back();
        z.push_back(q[i]);
    }
    return z;
}

void func(queue<vector<int>> aq){
    while (!aq.empty()) {
        vector<int> q;
        swap(aq.front(),q);
        aq.pop();
        if (q.size() == 2) {
            lli a = v[q[0]].ind;
            lli b = v[q[1]].ind;
            if (v[q[0]].type == 2)swap(a, b);
            ans.push_back({ a,b });
            continue;
        }

        lli balance = 0;
        lli cnt = 0;
        bool c = 0;
        for (auto to : q) {
            if (v[to].type == 1)balance++;
            else balance--;
            cnt++;
            if (balance == 0 && cnt != q.size()) {
                vector<int> q2;
                while (q.size() != cnt) {
                    q2.push_back(q.back());
                    q.pop_back();
                }
                aq.push(q);
                aq.push(q2);
                c = 1;
                break;
            }
        }
        if (c)continue;
        vector<int> z = make_convex_hull(q);
        map<pair<lli, lli>, lli> used;

        for (int i = 0; i < z.size() - 1; i++) {
            if (v[z[i]].type != v[z[i + 1]].type) {
                aq.push({ z[i],z[i + 1] });
                used[{v[z[i]].ind, v[z[i]].type}] = 1;
                used[{v[z[i + 1]].ind, v[z[i + 1]].type}] = 1;
                break;
            }
        }
        z.clear();
        for (auto to : q) if (used[{v[to].ind, v[to].type}] == 0)z.push_back(to);
        aq.push(z);
    }
}

void solve()
{
    lli n;
    cin >> n;
    v.clear();
    ans.clear();
    v.push_back({ 0,0,0,0 });
    for (int i = 1; i <= n; i++) {
        lli x, y;
        cin >> x >> y;
        v.push_back({ x,y,i,1 });
    }
    for (int i = 1; i <= n; i++) {
        lli x, y;
        cin >> x >> y;
        v.push_back({ x,y,i,2 });
    }
    vector<int> a;
    a.resize(2 * n);
    for (int i = 0; i < 2 * n; i++)a[i] = i+1;
    sort(a.begin(), a.end(), cmp);

    queue<vector<int>> q;
    q.push(a);
    func(q);
   
    for (auto to : ans) {
        cout << to.first << " " <<  to.second << LF;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif 

    lli t;
    cin >> t;
    while (t--)solve();
}

