def solve_block(N, blue_points, red_points):
    # Зберігаємо початкові індекси точок
    blue_points_with_index = [(blue_points[i], i + 1) for i in range(N)]
    red_points_with_index = [(red_points[i], i + 1) for i in range(N)]
    
    # Сортуємо точки за координатами
    blue_points_sorted = sorted(blue_points_with_index, key=lambda x: (x[0][0], x[0][1]))
    red_points_sorted = sorted(red_points_with_index, key=lambda x: (x[0][0], x[0][1]))
    
    pairs = []
    for i in range(N):
        pairs.append((blue_points_sorted[i][1], red_points_sorted[i][1]))
    
    return pairs

def main():
    import sys
    input = sys.stdin.read
    data = input().split()
    
    index = 0
    t = int(data[index])
    index += 1
    results = []
    
    for _ in range(t):
        N = int(data[index])
        index += 1
        blue_points = []
        red_points = []
        
        for _ in range(N):
            x = int(data[index])
            y = int(data[index + 1])
            blue_points.append((x, y))
            index += 2
        
        for _ in range(N):
            x = int(data[index])
            y = int(data[index + 1])
            red_points.append((x, y))
            index += 2
        
        result = solve_block(N, blue_points, red_points)
        results.append(result)
    
    for result in results:
        if result == 0:
            print(0)
        else:
            for pair in result:
                print(pair[0], pair[1])

if __name__ == "__main__":
    main()
