from collections import deque

def minimum_time_to_meet(N):
    if N == 1:
        return 0  
    if N == 2:
        return -1 
 
    alice_queue = deque([(1, 0)]) 
    bob_queue = deque([(N, 0)]) 
    
    alice_visited = set([1])
    bob_visited = set([N])

    while alice_queue and bob_queue:
        a_pos, a_time = alice_queue.popleft()
        for next_a_pos in (a_pos + 2, a_pos + 3):
            if next_a_pos <= N and next_a_pos not in alice_visited:
                alice_visited.add(next_a_pos)
                alice_queue.append((next_a_pos, a_time + 1))
        
        b_pos, b_time = bob_queue.popleft()
        for next_b_pos in (b_pos - 1, b_pos - 2):
            if next_b_pos >= 1 and next_b_pos not in bob_visited:
                bob_visited.add(next_b_pos)
                bob_queue.append((next_b_pos, b_time + 1))
        
        if alice_visited & bob_visited:
            return a_time + 1
        
    return -1


N = int(input())
print(minimum_time_to_meet(N))
