from collections import deque

def solve():
    # Читання вхідних даних
    N = int(input())
    
    # Якщо N == 1, то вони вже на одній клітинці (ми одразу відповідаємо 0)
    if N == 1:
        print(0)
        return
    
    # Черги для BFS: (позиція, час)
    alice_queue = deque([(1, 0)])  # Аліса починає з боксу 1
    bob_queue = deque([(N, 0)])  # Боб починає з боксу N
    
    # Массиви для відслідковування відвіданих клітин
    alice_visited = [False] * (N + 1)
    bob_visited = [False] * (N + 1)
    
    alice_visited[1] = True
    bob_visited[N] = True
    
    # Виконуємо BFS для Аліси та Боба
    while alice_queue or bob_queue:
        # Обробка черги Аліси
        if alice_queue:
            a_pos, a_time = alice_queue.popleft()
            
            # Якщо Аліса зустріла Боба в такій самій клітинці
            if bob_visited[a_pos]:
                print(a_time)
                return
            
            # Можливі рухи Аліси
            for move in [a_pos + 2, a_pos + 3]:
                if 1 <= move <= N and not alice_visited[move]:
                    alice_visited[move] = True
                    alice_queue.append((move, a_time + 1))
        
        # Обробка черги Боба
        if bob_queue:
            b_pos, b_time = bob_queue.popleft()
            
            # Якщо Боб зустрів Алісу в такій самій клітинці
            if alice_visited[b_pos]:
                print(b_time)
                return
            
            # Можливі рухи Боба
            for move in [b_pos - 1, b_pos - 2]:
                if 1 <= move <= N and not bob_visited[move]:
                    bob_visited[move] = True
                    bob_queue.append((move, b_time + 1))
    
    # Якщо ми не знайшли спільну клітинку
    print(-1)

# Виклик функції
solve()
