from collections import deque

def meet_time(N):
    if N <= 2:
        return -1

    queue = deque([(1, N, 0)])  # Стартові позиції: Аліса на 1, Боб на N, час = 0
    visited = set([(1, N)])  # Відвідані позиції

    while queue:
        alice, bob, time = queue.popleft()

        # Якщо Аліса і Боб на одному місці
        if alice == bob:
            return time

        # Перевірка рухів Аліси
        for a_move in [2, 3]:
            new_alice = alice + a_move
            if new_alice <= N and (new_alice, bob) not in visited:
                visited.add((new_alice, bob))
                queue.append((new_alice, bob, time + 1))

        # Перевірка рухів Боба
        for b_move in [1, 2]:
            new_bob = bob - b_move
            if new_bob >= 1 and (alice, new_bob) not in visited:
                visited.add((alice, new_bob))
                queue.append((alice, new_bob, time + 1))

    return -1

# Вхідні дані
N = int(input())

# Виведення результату
print(meet_time(N))
