from collections import deque

def can_meet(N):
    # Якщо N - непарне, то Аліса та Боб не можуть зустрітися
    if N % 2 == 1:
        return -1
    
    # BFS для Аліси
    alice_queue = deque([1])  # стартує з 1-го боксу
    alice_visited = [False] * (N + 1)
    alice_visited[1] = True
    alice_steps = [float('inf')] * (N + 1)
    alice_steps[1] = 0
    
    while alice_queue:
        a = alice_queue.popleft()
        for move in [2, 3]:
            next_a = a + move
            if next_a <= N and not alice_visited[next_a]:
                alice_visited[next_a] = True
                alice_steps[next_a] = alice_steps[a] + 1
                alice_queue.append(next_a)
    
    # BFS для Боба
    bob_queue = deque([N])  # стартує з N-го боксу
    bob_visited = [False] * (N + 1)
    bob_visited[N] = True
    bob_steps = [float('inf')] * (N + 1)
    bob_steps[N] = 0
    
    while bob_queue:
        b = bob_queue.popleft()
        for move in [1, 2]:
            next_b = b - move
            if next_b >= 1 and not bob_visited[next_b]:
                bob_visited[next_b] = True
                bob_steps[next_b] = bob_steps[b] + 1
                bob_queue.append(next_b)
    
    # Пошук мінімальної кількості кроків для зустрічі
    min_time = float('inf')
    for i in range(1, N + 1):
        if alice_visited[i] and bob_visited[i]:
            min_time = min(min_time, alice_steps[i] + bob_steps[i])
    
    return min_time if min_time != float('inf') else -1

# Вхід
N = int(input())

# Виведення результату
print(can_meet(N))
