from collections import deque

def teleportation(N):
    alice_queue = deque([(1, 0)])
    bob_queue = deque([(N, 0)])
    alice_visited = set([1])
    bob_visited = set([N])
    
    while alice_queue and bob_queue:
        for a_pos, a_time in alice_queue:
            if a_pos in bob_visited:
                return a_time
        for b_pos, b_time in bob_queue:
            if b_pos in alice_visited:
                return b_time
        
        alice_queue_next = deque()
        while alice_queue:
            a_pos, a_time = alice_queue.popleft()
            for step in [2, 3]:
                next_pos = a_pos + step
                if next_pos <= N and next_pos not in alice_visited:
                    alice_visited.add(next_pos)
                    alice_queue_next.append((next_pos, a_time + 1))
        alice_queue = alice_queue_next
        
        bob_queue_next = deque()
        while bob_queue:
            b_pos, b_time = bob_queue.popleft()
            for step in [1, 2]:
                next_pos = b_pos - step
                if next_pos >= 1 and next_pos not in bob_visited:
                    bob_visited.add(next_pos)
                    bob_queue_next.append((next_pos, b_time + 1))
        bob_queue = bob_queue_next
    
    return -1

N = int(input())
print(teleportation(N))
