from collections import deque

def find_meeting_point(N):
    if N <= 1:
        return -1
    
    alice_positions = deque([(1, 0)])  # (position, time)
    bob_positions = deque([(N, 0)])  # (position, time)
    
    alice_visited = set()
    bob_visited = set()
    
    while alice_positions and bob_positions:
        alice_pos, alice_time = alice_positions.popleft()
        bob_pos, bob_time = bob_positions.popleft()
        
        if alice_pos in bob_visited:
            return alice_time
        if bob_pos in alice_visited:
            return bob_time
        
        alice_visited.add(alice_pos)
        bob_visited.add(bob_pos)
        
        # Add next positions for Alice
        if alice_pos + 2 <= N:
            alice_positions.append((alice_pos + 2, alice_time + 1))
        if alice_pos + 3 <= N:
            alice_positions.append((alice_pos + 3, alice_time + 1))
        
        # Add next positions for Bob
        if bob_pos - 1 > 0:
            bob_positions.append((bob_pos - 1, bob_time + 1))
        if bob_pos - 2 > 0:
            bob_positions.append((bob_pos - 2, bob_time + 1))
    
    return -1

# Reading input
N = int(input().strip())

# Find and print the result
result = find_meeting_point(N)
print(result)
