#include <bits/stdc++.h>
using namespace std;

// Функція для обчислення найбільшого спільного дільника (НСД) за допомогою бінарного алгоритму Евкліда
long long binary_gcd(long long a, long long b) {
    if (a == 0) return b;
    if (b == 0) return a;

    // Знаходимо кількість спільних двійкових нулів у a та b
    int shift;
    for (shift = 0; ((a | b) & 1) == 0; ++shift) {
        a >>= 1;
        b >>= 1;
    }

    // Знімаємо всі двійкові нулі з a
    while ((a & 1) == 0)
        a >>= 1;

    while (b != 0) {
        // Знімаємо всі двійкові нулі з b
        while ((b & 1) == 0)
            b >>= 1;

        // Встановлюємо менше з a та b в a, більше в b
        if (a > b)
            swap(a, b);

        b = b - a;
    }

    return a << shift;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    long long N, A, B;
    cin >> N;
    cin >> A >> B;

    // Обчислюємо НСД використовуючи бінарний алгоритм
    long long gcd_ab = binary_gcd(A, B);

    // Обчислюємо НСК без переповнення
    // Перевіряємо, чи (A / gcd_ab) * B не перевищує 1e18
    long long lcm_ab = (A / gcd_ab) * B;

    // Обчислюємо кількість кратних A, B та обидвом
    long long count_A = N / A;
    long long count_B = N / B;
    long long count_AB = (lcm_ab <= N) ? (N / lcm_ab) : 0;

    // Використовуємо бітові операції для обчислення фінального результату
    // count_A + count_B - count_AB можна записати як (count_A | count_B) - count_AB
    // Однак це не є еквівалентним, тому залишимо арифметичні операції
    long long result = count_A + count_B - count_AB;

    cout << result;
}