#include <bits/stdc++.h>
using namespace std;

// Структура для зберігання точок з координатами та оригінальним індексом
struct Point {
    int x;
    int y;
    int original_index;
};

// Функція для сортування точок за x, потім за y
bool comparePoints(const Point &a, const Point &b) {
    if (a.x != b.x)
        return a.x < b.x;
    return a.y < b.y;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    
    int t;
    cin >> t;
    
    while(t--){
        int N;
        cin >> N;
        
        // Зчитуємо сині точки
        vector<Point> blue(N);
        for(int i=0; i<N; ++i){
            cin >> blue[i].x >> blue[i].y;
            blue[i].original_index = i+1; // Нумерація з 1
        }
        
        // Зчитуємо червоні точки
        vector<Point> red(N);
        for(int i=0; i<N; ++i){
            cin >> red[i].x >> red[i].y;
            red[i].original_index = i+1; // Нумерація з 1
        }
        
        // Сортуємо сині та червоні точки
        sort(blue.begin(), blue.end(), comparePoints);
        sort(red.begin(), red.end(), comparePoints);
        
        // Створюємо відповідність: blue_sorted[i] -> red_sorted[i]
        // Зберігаємо відповідність у векторі
        vector<pair<int, int>> matching(N);
        for(int i=0; i<N; ++i){
            matching[i] = {blue[i].original_index, red[i].original_index};
        }
        
        // Сортуємо відповідності за індексом червоної точки
        sort(matching.begin(), matching.end(), [&](const pair<int, int> &a, const pair<int, int> &b) -> bool {
            if(a.second != b.second)
                return a.second < b.second;
            return a.first < b.first;
        });
        
        // Виводимо відповідність
        for(auto &[b, r] : matching){
            cout << b << " " << r << "\n";
        }
    }
    
    return 0;
}