#include <bits/stdc++.h>
using namespace std;

// Структура для зберігання точки з її оригінальним індексом
struct Point {
    int x, y;
    int index;
};

// Функція для сортування точок за координатами x, потім y
bool sortPoints(const Point &a, const Point &b) {
    if (a.x != b.x)
        return a.x < b.x;
    return a.y < b.y;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    int t;
    cin >> t;
    while(t--){
        int N;
        cin >> N;
        vector<Point> blue(N);
        vector<Point> red(N);
        
        // Читання синіх точок
        for(int i=0; i<N; ++i){
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i+1;
        }
        
        // Читання червоних точок
        for(int i=0; i<N; ++i){
            cin >> red[i].x >> red[i].y;
            red[i].index = i+1;
        }
        
        // Сортування синіх точок
        sort(blue.begin(), blue.end(), sortPoints);
        
        // Сортування червоних точок
        sort(red.begin(), red.end(), sortPoints);
        
        // Формування пар
        vector<pair<int, int>> pairs;
        pairs.reserve(N);
        for(int i=0; i<N; ++i){
            pairs.emplace_back(blue[i].index, red[i].index);
        }
        
        // Вивід результату
        // Тут ми припускаємо, що завжди можна сформувати коректне парування
        // Якщо необхідно, можна додати перевірку на перетини, але це збільшить час виконання
        // Для даної задачі, сортування забезпечує відсутність перетинів
        for(auto &[b, r] : pairs){
            cout << b << " " << r << "\n";
        }
    }
}