#include <iostream>
#include <vector>

using namespace std;

int countSameColorSquares(const vector<vector<int>>& grid) {
    int n = grid.size();
    int count = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int size = 1; i + size - 1 < n && j + size - 1 < n; ++size) {
                bool allSame = true;
                int color = grid[i][j];
                for (int k = i; k < i + size && allSame; ++k) {
                    for (int l = j; l < j + size && allSame; ++l) {
                        if (grid[k][l] != color) {
                            allSame = false;
                            break;
                        }
                    }
                }
                if (allSame) {
                    count++;
                }
            }
        }
    }

    return count;
}

int main() {
    int n;
    cin >> n;

    vector<vector<int>> grid(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> grid[i][j];
        }
    }

    cout << countSameColorSquares(grid) << endl;

    return 0;
}