#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Структура для зберігання координат точки
struct Point {
    int x, y, index;
};

// Функція для сортування точок за їх x і y координатами
bool compare(Point p1, Point p2) {
    if (p1.x == p2.x) return p1.y < p2.y;
    return p1.x < p2.x;
}

int main() {
    int t;  // кількість тестових блоків
    cin >> t;

    while (t--) {
        int N;  // кількість точок одного кольору
        cin >> N;

        vector<Point> blue(N), red(N);

        // Зчитуємо координати синіх точок
        for (int i = 0; i < N; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;  // індексація з 1
        }

        // Зчитуємо координати червоних точок
        for (int i = 0; i < N; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;  // індексація з 1
        }

        // Сортуємо обидві множини точок за їх координатами
        sort(blue.begin(), blue.end(), compare);
        sort(red.begin(), red.end(), compare);

        // Виводимо пари точок, що не перетинаються
        for (int i = 0; i < N; ++i) {
            cout << blue[i].index << " " << red[i].index << endl;
        }
    }

    return 0;
}
