from collections import deque

def min_seconds_to_meet(N):
    if N < 2:
        return -1

    alice_queue = deque([(1, 0)])  # (позиція, секунди)
    bob_queue = deque([(N, 0)])  # (позиція, секунди)
    alice_visited = {1}
    bob_visited = {N}

    while alice_queue and bob_queue:
        # Розглядаємо рух Аліси
        pos, seconds = alice_queue.popleft()
        for new_pos in [pos + 2, pos + 3]:
            if new_pos in bob_visited:
                return seconds + 1
            if new_pos <= N and new_pos not in alice_visited:
                alice_visited.add(new_pos)
                alice_queue.append((new_pos, seconds + 1))

        # Розглядаємо рух Боба
        pos, seconds = bob_queue.popleft()
        for new_pos in [pos - 1, pos - 2]:
            if new_pos in alice_visited:
                return seconds + 1
            if new_pos >= 1 and new_pos not in bob_visited:
                bob_visited.add(new_pos)
                bob_queue.append((new_pos, seconds + 1))

    return -1

# Приклад виклику функції
N = int(input())
print(min_seconds_to_meet(N))
