#include <iostream>
#include <queue>
#include <unordered_set>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int N;
    cin >> N;

    if (N == 2) {
        cout << 0 << endl;
        return 0;
    }

    queue<int> aliceQueue, bobQueue;
    aliceQueue.push(1);
    bobQueue.push(N);

    unordered_set<int> aliceVisited, bobVisited;
    aliceVisited.insert(1);
    bobVisited.insert(N);

    int seconds = 0;
    while (!aliceQueue.empty() && !bobQueue.empty()) {
        seconds++;

        int size = aliceQueue.size();
        for (int i = 0; i < size; ++i) {
            int position = aliceQueue.front();
            aliceQueue.pop();

            if (position + 2 <= N && aliceVisited.find(position + 2) == aliceVisited.end()) {
                if (bobVisited.find(position + 2) != bobVisited.end()) {
                    cout << seconds << endl;
                    return 0;
                }
                aliceQueue.push(position + 2);
                aliceVisited.insert(position + 2);
            }
            if (position + 3 <= N && aliceVisited.find(position + 3) == aliceVisited.end()) {
                if (bobVisited.find(position + 3) != bobVisited.end()) {
                    cout << seconds << endl;
                    return 0;
                }
                aliceQueue.push(position + 3);
                aliceVisited.insert(position + 3);
            }
        }

        size = bobQueue.size();
        for (int i = 0; i < size; ++i) {
            int position = bobQueue.front();
            bobQueue.pop();
            if (position - 1 >= 1 && bobVisited.find(position - 1) == bobVisited.end()) {
                if (aliceVisited.find(position - 1) != aliceVisited.end()) {
                    cout << seconds << endl;
                    return 0;
                }
                bobQueue.push(position - 1);
                bobVisited.insert(position - 1);
            }
            if (position - 2 >= 1 && bobVisited.find(position - 2) == bobVisited.end()) {
                if (aliceVisited.find(position - 2) != aliceVisited.end()) {
                    cout << seconds << endl;
                    return 0;
                }
                bobQueue.push(position - 2);
                bobVisited.insert(position - 2);
            }
        }
    }

    cout << -1 << endl;
    return 0;
}
