#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
using namespace std;

void findStamps(int N, int M) {
    vector<int> dp(M + 1, INT_MAX);
    vector<int> last(M + 1, -1);

    dp[0] = 0;

    for (int i = 1; i <= N; ++i) {
        for (int j = M; j >= i; --j) {
            if (dp[j - i] != INT_MAX && dp[j - i] + 1 < dp[j]) {
                dp[j] = dp[j - i] + 1;
                last[j] = i;
            }
        }
    }

    if (dp[M] == INT_MAX) {
        cout << 0 << endl;
        return;
    }

    vector<int> result;
    for (int i = M; i > 0; i -= last[i]) {
        result.push_back(last[i]);
    }

    sort(result.begin(), result.end());

    for (int stamp : result) {
        cout << stamp << endl;
    }
}

int main() {
    int N, M;
    cin >> N >> M;
    findStamps(N, M);
    return 0;
}
