#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
using namespace std;

void findStamps(int N, int M) {
    vector<int> dp(M + 1, INT_MAX);
    vector<int> last(M + 1, -1);

    dp[0] = 0;

    for (int i = 1; i <= N; ++i) {
        for (int j = M; j >= i; --j) {
            if (dp[j - i] != INT_MAX && dp[j - i] + 1 < dp[j]) {
                dp[j] = dp[j - i] + 1;
                last[j] = i;
            }
        }
    }

    if (dp[M] == INT_MAX) {
        cout << 0 << endl;
        return;
    }

    vector<int> result;
    int current = M;
    while (current > 0) {
        if (last[current] == -1) {
            cout << 0 << endl; // У разі непередбаченої помилки
            return;
        }
        result.push_back(last[current]);
        current -= last[current];
    }

    sort(result.begin(), result.end());

    for (int stamp : result) {
        cout << stamp << endl;
    }
}

int main() {
    int N, M;
    cin >> N >> M;
    if (N < 1 || M < 1 || N > 109 || M > 109) {
        cout << 0 << endl;
        return 0;
    }
    findStamps(N, M);
    return 0;
}
