#include <iostream>
#include <vector>
#include <set>
#include <cmath>
using namespace std;

struct Point {
    int x, y;
    Point(int x = 0, int y = 0) : x(x), y(y) {}
};

bool isValid(int x, int y, int N) {
    return x >= 0 && x < N && y >= 0 && y < N;
}

int findSquares(int N, const vector<vector<int>>& grid) {
    int count = 0;
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            for (int k = i + 1; k < N; ++k) {
                for (int l = j + 1; l < N; ++l) {
                    Point A(i, j), B(k, l);
                    Point C(k, j), D(i, l);
                    if (isValid(C.x, C.y, N) && isValid(D.x, D.y, N) &&
                        grid[A.x][A.y] == grid[B.x][B.y] &&
                        grid[A.x][A.y] == grid[C.x][C.y] &&
                        grid[A.x][A.y] == grid[D.x][D.y]) {
                        count++;
                    }
                }
            }
        }
    }
    
    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    cout << findSquares(N, grid) << endl;

    return 0;
}
