#include <iostream>
#include <set>
using namespace std;

int find_meeting_time(int N) {
    set<int> alice_positions;
    set<int> bob_positions;

    // Початкові позиції
    alice_positions.insert(1);
    bob_positions.insert(N);
    
    int seconds = 0;
    
    // Перевіряємо, чи є перетин між позиціями Аліси та Боба
    while (true) {
        seconds++;
        set<int> new_alice_positions;
        set<int> new_bob_positions;
        
        // Аліса може переміщуватись на +2 або +3
        for (int pos : alice_positions) {
            if (pos + 2 <= N) new_alice_positions.insert(pos + 2);
            if (pos + 3 <= N) new_alice_positions.insert(pos + 3);
        }
        
        // Боб може переміщуватись на -1 або -2
        for (int pos : bob_positions) {
            if (pos - 1 >= 1) new_bob_positions.insert(pos - 1);
            if (pos - 2 >= 1) new_bob_positions.insert(pos - 2);
        }
        
        // Перевіряємо на перетин
        for (int pos : new_alice_positions) {
            if (new_bob_positions.count(pos)) {
                return seconds;
            }
        }
        
        // Оновлюємо позиції для наступної секунди
        alice_positions = new_alice_positions;
        bob_positions = new_bob_positions;
        
        // Якщо неможливо зустрітися, припиняємо
        if (alice_positions.empty() || bob_positions.empty()) {
            break;
        }
    }
    
    return -1;
}

int main() {
    int N;
    cin >> N;
    cout << find_meeting_time(N) << endl;
    return 0;
}

