#include <iostream>
#include <queue>
#include <set>
using namespace std;

int find_meeting_time(int N) {
    // Черги для Аліси та Боба
    queue<int> alice_queue, bob_queue;
    set<int> alice_visited, bob_visited;

    // Початкові позиції
    alice_queue.push(1);
    bob_queue.push(N);
    alice_visited.insert(1);
    bob_visited.insert(N);
    
    int seconds = 0;

    // Поки є можливість рухатися, перевіряємо на перетин
    while (!alice_queue.empty() && !bob_queue.empty()) {
        seconds++;

        int alice_size = alice_queue.size();
        int bob_size = bob_queue.size();

        // Рух Аліси
        for (int i = 0; i < alice_size; i++) {
            int alice_pos = alice_queue.front();
            alice_queue.pop();

            // Аліса може телепортуватися на +2 або +3
            for (int move : {2, 3}) {
                int new_pos = alice_pos + move;
                if (new_pos <= N && bob_visited.count(new_pos)) {
                    return seconds;
                }
                if (new_pos <= N && !alice_visited.count(new_pos)) {
                    alice_visited.insert(new_pos);
                    alice_queue.push(new_pos);
                }
            }
        }

        // Рух Боба
        for (int i = 0; i < bob_size; i++) {
            int bob_pos = bob_queue.front();
            bob_queue.pop();

            // Боб може телепортуватися на -1 або -2
            for (int move : {-1, -2}) {
                int new_pos = bob_pos + move;
                if (new_pos >= 1 && alice_visited.count(new_pos)) {
                    return seconds;
                }
                if (new_pos >= 1 && !bob_visited.count(new_pos)) {
                    bob_visited.insert(new_pos);
                    bob_queue.push(new_pos);
                }
            }
        }
    }

    // Якщо вони не змогли зустрітися
    return -1;
}

int main() {
    int N;
    cin >> N;
    cout << find_meeting_time(N) << endl;
    return 0;
}