from collections import deque

def can_meet(N):
    # Використовуємо BFS для пошуку мінімальної кількості кроків
    # Містимо пари (позиція Аліси, позиція Боба, кількість кроків)
    queue = deque([(1, N, 0)])  # Початкові позиції Аліси та Боба, кроки = 0
    visited = set([(1, N)])  # Відвідані пари позицій (Аліса, Боб)
    
    while queue:
        alice_pos, bob_pos, steps = queue.popleft()
        
        # Якщо Аліса та Боб на одному боксі
        if alice_pos == bob_pos:
            return steps
        
        # Рух Аліси
        next_alice_positions = []
        if alice_pos + 2 <= N:
            next_alice_positions.append(alice_pos + 2)
        if alice_pos + 3 <= N:
            next_alice_positions.append(alice_pos + 3)
        
        # Рух Боба
        next_bob_positions = []
        if bob_pos - 1 >= 1:
            next_bob_positions.append(bob_pos - 1)
        if bob_pos - 2 >= 1:
            next_bob_positions.append(bob_pos - 2)
        
        # Перевіряємо всі можливі нові пари (Аліса, Боб)
        for next_alice in next_alice_positions:
            for next_bob in next_bob_positions:
                if (next_alice, next_bob) not in visited:
                    visited.add((next_alice, next_bob))
                    queue.append((next_alice, next_bob, steps + 1))
    
    # Якщо не вдалося зустрітися
    return -1

# Зчитуємо вхід
N = int(input().strip())

# Виводимо відповідь
print(can_meet(N))
