from collections import deque

def min_time_to_meet(N):
    # Множини можливих позицій для Аліси та Боба
    alice_positions = {1}
    bob_positions = {N}
    
    # Черги для BFS
    alice_queue = deque([1])
    bob_queue = deque([N])
    
    # Лічильники секунд
    time = 0
    
    # Виконуємо пошук з двох напрямків (BFS)
    while alice_queue and bob_queue:
        time += 1
        
        # Розширюємо можливі позиції Аліси
        for _ in range(len(alice_queue)):
            pos = alice_queue.popleft()
            # Аліса може телепортуватися в pos+2 або pos+3
            for new_pos in [pos + 2, pos + 3]:
                if new_pos <= N and new_pos not in alice_positions:
                    alice_positions.add(new_pos)
                    alice_queue.append(new_pos)
                    # Перевіряємо, чи є спільні позиції
                    if new_pos in bob_positions:
                        return time
        
        # Розширюємо можливі позиції Боба
        for _ in range(len(bob_queue)):
            pos = bob_queue.popleft()
            # Боб може телепортуватися в pos-1 або pos-2
            for new_pos in [pos - 1, pos - 2]:
                if new_pos >= 1 and new_pos not in bob_positions:
                    bob_positions.add(new_pos)
                    bob_queue.append(new_pos)
                    # Перевіряємо, чи є спільні позиції
                    if new_pos in alice_positions:
                        return time
    
    return -1

# Вхідні дані
N = int(input())

# Виведення результату
print(min_time_to_meet(N))
