def cross(o, a, b):
    # Векторне добуток (направлений)
    return (a[0] - o[0]) * (b[1] - o[1]) - (a[1] - o[1]) * (b[0] - o[0])

def can_connect(b, r):
    n = len(b)
    # Сортуємо сині і червоні точки за x, а потім за y
    blue_sorted = sorted(b, key=lambda x: (x[0], x[1]))
    red_sorted = sorted(r, key=lambda x: (x[0], x[1]))

    # Перевіряємо перетини
    for i in range(n):
        for j in range(i+1, n):
            b1 = blue_sorted[i]
            b2 = blue_sorted[j]
            r1 = red_sorted[i]
            r2 = red_sorted[j]

            # Перевіряємо чи перетинаються відрізки (b1, r1) і (b2, r2)
            if cross(b1, r1, b2) * cross(b1, r2, b2) < 0 and cross(r1, b1, b2) * cross(r2, b1, b2) < 0:
                return False
    return True


t = int(input())  # кількість тестів
for _ in range(t):
    N = int(input())  # кількість точок одного кольору
    blue = []
    red = []
    
    # Читання координат синіх точок
    for i in range(N):
        x, y = map(int, input().split())
        blue.append((x, y))
    
    # Читання координат червоних точок
    for i in range(N):
        x, y = map(int, input().split())
        red.append((x, y))

    # Перевіряємо, чи можна побудувати розв'язок
    if can_connect(blue, red):
        for i in range(N):
            print(i + 1, i + 1)  # якщо можна, вивести підходящий результат
    else:
        print(0)  # вивести "0" якщо рішення неможливе

