def min_seconds_to_meet(N):
    if N < 2:
        return -1
    
    # Обчислюємо умову збігу позицій Alice і Bob без перебору.
    # alice_position1 = 1 + 2 * t, alice_position2 = 1 + 3 * t
    # bob_position1 = N - t, bob_position2 = N - 2 * t
    
    # Перевіряємо, чи можна знайти таке t, для якого збігаються позиції.
    # Можливі рівняння:
    # 1 + 2 * t = N - t
    # 1 + 2 * t = N - 2 * t
    # 1 + 3 * t = N - t
    # 1 + 3 * t = N - 2 * t
    
    # Обчислимо t для кожного рівняння.
    t1 = (N - 1) // 3  # З рівняння 1 + 2 * t = N - t
    t2 = (N - 1) // 5  # З рівняння 1 + 3 * t = N - 2 * t
    
    # Перевіримо, чи відповідають ці значення умові t >= 1.
    if t1 >= 1 and (1 + 2 * t1 == N - t1 or 1 + 3 * t1 == N - t1):
        return t1
    if t2 >= 1 and (1 + 2 * t2 == N - 2 * t2 or 1 + 3 * t2 == N - 2 * t2):
        return t2
    
    return -1

N = int(input().strip())
print(min_seconds_to_meet(N))
