import math

def find_numbers_for_sum(N, M):
    if N > 1000000000 or M > 1000000000:
        return "Невірні данні"
    
    # Перевірка, чи можливо скласти M з чисел від 1 до N
    if M > N * (N + 1) // 2:
        return 0

    # Обчислюємо k, максимальне число, яке може бути використане
    k = int((-1 + math.sqrt(1 + 8 * M)) // 2)
    
    # Коригуємо k, щоб він не перевищував N
    if k > N:
        k = N

    # Обчислюємо залишок суми, який потрібно додати, щоб отримати M
    remaining_sum = M - (k * (k + 1)) // 2

    result = list(range(1, k + 1))
    
    # Видаляємо число, яке відповідає залишку
    if remaining_sum > 0:
        result.remove(remaining_sum)

    # Повертаємо результат у відсортованому порядку
    return sorted(result)

N = int(input().strip())
M = int(input().strip())
result = find_numbers_for_sum(N, M)

if result == 0:
    print(0)
elif isinstance(result, str):
    print(result)
else:
    print(*result)
