def count_colored_squares(N, grid):
    count = 0

    # Перебираємо всі можливі довжини сторони квадрата (від 1 до N-1)
    for side in range(1, N):
        # Перебираємо всі можливі верхні ліві вершини квадрата
        for i in range(N - side):
            for j in range(N - side):
                # Отримуємо координати вершин квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + side]
                bottom_left = grid[i + side][j]
                bottom_right = grid[i + side][j + side]

                # Перевіряємо, чи всі вершини одного кольору
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count

# Зчитування вхідних даних
try:
    N = int(input("Введіть розмір квадрата N: "))
    if N < 2 or N > 50:
        raise ValueError("N має бути в межах від 2 до 50")

    grid = []
    print("Введіть матрицю кольорів (0 для синього, 1 для червоного):")
    for _ in range(N):
        row = list(map(int, input().split()))
        if len(row) != N:
            raise ValueError("Кожен рядок має містити рівно N чисел.")
        if any(cell not in [0, 1] for cell in row):
            raise ValueError("Матриця має містити лише числа 0 або 1.")
        grid.append(row)

    # Обчислення і виведення результату
    print("Кількість квадратів з однаковими вершинами: ", count_colored_squares(N, grid))

except ValueError as e:
    print("Помилка вводу:", e)
except Exception as e:
    print("Непередбачена помилка:", e)
