#include <iostream>
#include <vector>

using namespace std;

int main() {
    int N;
    cin >> N;

    // Зчитування матриці кольорів
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int count = 0;

    // Перевірка всіх можливих квадратів розміром від 2x2 до NxN
    for (int size = 2; size <= N; ++size) {
        for (int i = 0; i <= N - size; ++i) {
            for (int j = 0; j <= N - size; ++j) {
                // Перевірка кольору вершин квадрата
                int color = grid[i][j];
                bool isUniform = true;

                for (int x = 0; x < size; ++x) {
                    for (int y = 0; y < size; ++y) {
                        if (grid[i + x][j + y] != color) {
                            isUniform = false;
                            break;
                        }
                    }
                    if (!isUniform) {
                        break;
                    }
                }

                if (isUniform) {
                    ++count;
                }
            }
        }
    }

    cout << count << endl;

    return 0;
}



