def orientation(p, q, r):
    val = (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])
    if val == 0:
        return 0
    elif val > 0:
        return 1
    else:
        return 2

def do_intersect(p1, q1, p2, q2):
    o1 = orientation(p1, q1, p2)
    o2 = orientation(p1, q1, q2)
    o3 = orientation(p2, q2, p1)
    o4 = orientation(p2, q2, q1)
    return (o1 != o2 and o3 != o4)

def solve_matching_problem(N, blue_points, red_points):
    pairs = []
    for i in range(N):
        pairs.append((i, i))

    for i in range(N):
        for j in range(i + 1, N):
            if do_intersect(blue_points[i], red_points[i], blue_points[j], red_points[j]):
                return 0

    result = []
    for i in range(N):
        result.append(f"{i + 1} {i + 1}")

    return result

t = int(input())
for _ in range(t):
    N = int(input())
    blue_points = []
    red_points = []
    
    for _ in range(N):
        x, y = map(int, input().split())
        blue_points.append((x, y))
    
    for _ in range(N):
        x, y = map(int, input().split())
        red_points.append((x, y))
    
    result = solve_matching_problem(N, blue_points, red_points)
    
    if result == 0:
        print(0)
    else:
        for pair in result:
            print(pair)

