def orientation(p, q, r):
    val = (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])
    if val == 0:
        return 0
    elif val > 0:
        return 1
    else:
        return 2

def do_intersect(p1, q1, p2, q2):
    # Перевірка на перетин відрізків
    o1 = orientation(p1, q1, p2)
    o2 = orientation(p1, q1, q2)
    o3 = orientation(p2, q2, p1)
    o4 = orientation(p2, q2, q1)
    return (o1 != o2 and o3 != o4)

def solve_matching_problem(N, blue_points, red_points):
    # Сортуємо точки обох кольорів за координатами (x, y)
    blue_points.sort()
    red_points.sort()

    # Список для збереження пар точок
    result = []

    # Спробуємо з'єднати точки по черзі та перевірити, чи перетинаються відрізки
    for i in range(N):
        for j in range(i + 1, N):
            # Перевірка, чи відрізки між точками не перетинаються
            if not do_intersect(blue_points[i], red_points[i], blue_points[j], red_points[j]):
                result.append((blue_points[i][2], red_points[i][2]))  # Додаємо індекси точок
                break  # Перехід до наступної точки
            else:
                return 0  # Якщо є перетин, повертаємо 0 (неможливо з'єднати)

    return result

# Зчитування кількості тестових блоків
t = int(input())
for _ in range(t):
    N = int(input())
    blue_points = []
    red_points = []

    # Зчитування координат синіх точок
    for i in range(N):
        x, y = map(int, input().split())
        blue_points.append((x, y, i + 1))  # Додаємо індекс точки (від 1 до N)

    # Зчитування координат червоних точок
    for i in range(N):
        x, y = map(int, input().split())
        red_points.append((x, y, i + 1))  # Додаємо індекс точки (від 1 до N)

    # Розв'язання задачі
    result = solve_matching_problem(N, blue_points, red_points)

    if result == 0:
        print(0)
    else:
        for pair in result:
            print(pair[0], pair[1])
