def find_robot_president(numbers):
    """
    Функція визначає, який робот стане президентом або чи відбудуться вибори.
    
    :param numbers: список чисел, які згенерували роботи
    :return: індекс робота-президента (1-індексація) або повідомлення, що вибори не відбулися
    """
    from collections import Counter
    
    # Підраховуємо частоту кожного числа
    count = Counter(numbers)
    
    # Знаходимо всі унікальні числа (які зустрілися лише один раз)
    unique_numbers = {num for num, freq in count.items() if freq == 1}
    
    if not unique_numbers:
        print("Вибори не відбулися")
        return
    
    # Знаходимо мінімальне унікальне число
    min_unique_number = min(unique_numbers)
    
    # Знаходимо індекс робота, який його згенерував (1-індексація)
    president_index = numbers.index(min_unique_number) + 1
    print(f"Президентом став робот з номером {president_index}")

# Приклад використання
numbers = [4, 2, 2, 3, 3, 1]  # Список чисел, згенерованих роботами
find_robot_president(numbers)
