def count_same_color_squares(N, grid):
    """ 
    Рахує кількість квадратів, у яких всі чотири вершини пофарбовані в один колір.
    
    Parameters:
    N (int): розмір матриці
    grid (list of list of int): матриця кольорів (0 або 1)
    
    Returns:
    int: кількість таких квадратів
    """
    count = 0
    
    # Проходимо по всіх можливих розмірах квадратів зі стороною від 1 до N-1
    for size in range(1, N):  # Розмір квадрата (сторона квадрата)
        for i in range(N - size):  # Рядки верхньої лівої вершини
            for j in range(N - size):  # Стовпці верхньої лівої вершини
                # Координати чотирьох вершин квадрата
                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]
                
                # Перевіряємо, чи всі вершини одного кольору
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1
    
    return count


# Ввід даних
N = int(input("Введіть розмір N: "))
grid = [list(map(int, input().split())) for _ in range(N)]

# Підрахунок кількості квадратів із однаковим кольором вершин
result = count_same_color_squares(N, grid)
print(f"Кількість квадратів: {result}")
