from collections import deque
import sys

def min_time_to_meet(N):
    # Черга для BFS (пара позицій Аліси і Боба, кількість секунд)
    queue = deque([(1, N, 0)])  
    visited = set()
    visited.add((1, N))  # додавання стартових позицій в відвідані
    
    while queue:
        alice_pos, bob_pos, seconds = queue.popleft()
        
        # Якщо Аліса та Боб в одній клітинці
        if alice_pos == bob_pos:  
            return seconds
        
        # Перерахунок можливих ходів
        alice_moves = [alice_pos + 2, alice_pos + 3]
        bob_moves = [bob_pos - 1, bob_pos - 2]
        
        # Перевірка всіх можливих переміщень
        for a_move in alice_moves:
            for b_move in bob_moves:
                # Якщо нові позиції допустимі
                if 1 <= a_move <= N and 1 <= b_move <= N and (a_move, b_move) not in visited:
                    visited.add((a_move, b_move))  # помітити пару як відвідану
                    queue.append((a_move, b_move, seconds + 1))  # додавати до черги
    
    # Якщо неможливо зустрітись
    return -1

# Зчитуємо вхідні дані
input_data = sys.stdin.read().strip().splitlines()

# Перевірка, чи вхід коректний
t = int(input_data[0])  # кількість тестів
# Для кожного тесту обробляємо значення N
for i in range(1, t + 1):
    if i < len(input_data):
        N = int(input_data[i])  # отримуємо значення N
        print(min_time_to_meet(N))  # викликаємо функцію для кожного тесту
    else:
        print("Невірний формат даних")