from collections import deque

def min_seconds_to_meet(N):
    # Черги для руху Аліси та Боба
    alice_queue = deque([1])  # Аліса починає з 1
    bob_queue = deque([N])    # Боб починає з N
    
    # Множини для відстеження відвіданих боксів Алісою та Бобом
    alice_visited = set([1])
    bob_visited = set([N])
    
    seconds = 0
    
    while alice_queue and bob_queue:
        seconds += 1
        
        # Рух Аліси
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for next_b in [current + 2, current + 3]:
                if next_b <= N and next_b not in alice_visited:
                    alice_visited.add(next_b)
                    alice_queue.append(next_b)
                    
                    # Перевіряємо, чи не зустрілася Аліса з Бобом
                    if next_b in bob_visited:
                        return seconds
        
        # Рух Боба
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for next_b in [current - 1, current - 2]:
                if next_b >= 1 and next_b not in bob_visited:
                    bob_visited.add(next_b)
                    bob_queue.append(next_b)
                    
                    # Перевіряємо, чи не зустрілася Боб з Алісою
                    if next_b in alice_visited:
                        return seconds
    
    return -1

# Вхідні дані
N = int(input())

# Виведення результату
print(min_seconds_to_meet(N))
