def solve(t, test_cases):
    results = []
    
    for case in test_cases:
        N = case[0]
        blue_points = case[1]
        red_points = case[2]
        
        pairs = []
        used_blue = set()
        used_red = set()
        
        for i in range(N):
            min_distance = float('inf')
            min_pair = (-1, -1)
            
            for j in range(N):
                if j not in used_blue:
                    for k in range(N):
                        if k not in used_red:
                            distance = (blue_points[j][0] - red_points[k][0]) ** 2 + (blue_points[j][1] - red_points[k][1]) ** 2
                            if distance < min_distance:
                                min_distance = distance
                                min_pair = (j + 1, k + 1)
            
            pairs.append(min_pair)
            used_blue.add(min_pair[0] - 1)
            used_red.add(min_pair[1] - 1)
        
        results.append(pairs)
    
    return results

# Ввід вручну
t = int(input("Введіть кількість блоків тестових даних: "))
test_cases = []

for _ in range(t):
    N = int(input("\nВведіть кількість точок одного кольору: "))
    blue_points = []
    red_points = []
    
    print("Введіть координати синіх точок:")
    for _ in range(N):
        x, y = map(int, input().split())
        blue_points.append((x, y))
    
    print("Введіть координати червоних точок:")
    for _ in range(N):
        x, y = map(int, input().split())
        red_points.append((x, y))
    
    test_cases.append((N, blue_points, red_points))

# Розв'язання
results = solve(t, test_cases)

# Вивід результатів
for result in results:
    for pair in result:
        print(pair[0], pair[1])
