def solve_eva_problem(test_cases):
    results = []
    for test in test_cases:
        n, blue_points, red_points = test
        
        # Сортуємо точки за x, а в разі рівності - за y
        blue_sorted = sorted(enumerate(blue_points, start=1), key=lambda p: (p[1][0], p[1][1]))
        red_sorted = sorted(enumerate(red_points, start=1), key=lambda p: (p[1][0], p[1][1]))
        
        # Попарно з'єднуємо точки
        pairs = []
        for i in range(n):
            pairs.append((blue_sorted[i][0], red_sorted[i][0]))
        
        # Перевіряємо на перетини
        def segments_intersect(a, b, c, d):
            # Визначення чи перетинаються два відрізки (a->b, c->d)
            def ccw(p1, p2, p3):
                return (p3[1] - p1[1]) * (p2[0] - p1[0]) > (p2[1] - p1[1]) * (p3[0] - p1[0])
            
            return ccw(a, c, d) != ccw(b, c, d) and ccw(a, b, c) != ccw(a, b, d)
        
        intersect = False
        for i in range(n):
            for j in range(i + 1, n):
                b1, r1 = blue_points[pairs[i][0] - 1], red_points[pairs[i][1] - 1]
                b2, r2 = blue_points[pairs[j][0] - 1], red_points[pairs[j][1] - 1]
                if segments_intersect(b1, r1, b2, r2):
                    intersect = True
                    break
            if intersect:
                break
        
        if intersect:
            results.append([0])
        else:
            results.append(pairs)
    
    return results

# Читання вхідних даних
t = int(input())
test_cases = []
for _ in range(t):
    n = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(n)]
    red_points = [tuple(map(int, input().split())) for _ in range(n)]
    test_cases.append((n, blue_points, red_points))

# Розв'язання задачі
answers = solve_eva_problem(test_cases)

# Виведення результату
for answer in answers:
    if answer == [0]:
        print(0)
    else:
        for pair in answer:
            print(pair[0], pair[1])
