#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

bool is_integer(double v) {
    return floor(v) == v;
}

pair<int, int> find_other_points(int x1, int y1, int x2, int y2, int n, const vector<vector<int>>& arr) {
    double mx = (x1 + x2) / 2.0;
    double my = (y1 + y2) / 2.0;
    double dx = (x2 - x1) / 2.0;
    double dy = (y2 - y1) / 2.0;

    double x3 = mx + dy;
    double y3 = my - dx;
    double x4 = mx - dy;
    double y4 = my + dx;

    if (is_integer(x3) && is_integer(x4) && is_integer(y3) && is_integer(y4)) {
        x3 = round(x3);
        y3 = round(y3);
        x4 = round(x4);
        y4 = round(y4);

        if (x3 >= 0 && x3 < n && y3 >= 0 && y3 < n && x4 >= 0 && x4 < n && y4 >= 0 && y4 < n) {
            return {arr[x3][y3], arr[x4][y4]};
        }
    }
    return {-1, -1};
}

int main() {
    int n;
    cin >> n;
    vector<vector<int>> arr(n, vector<int>(n));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> arr[i][j];
        }
    }

    int squares = 0;

    for (int i1 = 0; i1 < n - 1; i1++) {
        for (int j1 = 0; j1 < n - 1; j1++) {
            int color = arr[i1][j1];
            for (int i2 = i1; i2 < n; i2++) {
                for (int j2 = j1 + 1; j2 < n; j2++) {
                    if (arr[i2][j2] == color) {
                        auto [p3, p4] = find_other_points(i1, j1, i2, j2, n, arr);
                        if (p3 == p4 && p3 == color) {
                            squares++;
                        }
                    }
                }
            }
        }
    }

    cout << squares << endl;

    return 0;
}
