def convex_hull(points):
    points = sorted(points)
    
    def cross(o, a, b):
        return (a[0] - o[0]) * (b[1] - o[1]) - (a[1] - o[1]) * (b[0] - o[0])
    
    lower = []
    for p in points:
        while len(lower) >= 2 and cross(lower[-2], lower[-1], p) <= 0:
            lower.pop()
        lower.append(p)
    
    upper = []
    for p in reversed(points):
        while len(upper) >= 2 and cross(upper[-2], upper[-1], p) <= 0:
            upper.pop()
        upper.append(p)
    
    return lower[:-1] + upper[:-1]

t = int(input())
for _ in range(t):
    n = int(input())
    blues = []
    reds = []
    
    for i in range(n):
        x, y = map(int, input().split())
        blues.append((x, y, i + 1))
    
    for i in range(n):
        x, y = map(int, input().split())
        reds.append((x, y, i + 1))
    
    blue_hull = convex_hull(blues)
    red_hull = convex_hull(reds)
    
    result = []
    
    for i in range(len(blue_hull)):
        result.append(f"{blue_hull[i][2]} {red_hull[i][2]}")
    
    print("\n".join(result))
