#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

// Структура для точки
struct Point {
    int x, y, index;
};

// Функція для обробки одного тестового блоку
bool solveBlock(int N, vector<Point>& blue, vector<Point>& red, vector<pair<int, int>>& result) {
    // Сортуємо сині та червоні точки за координатами (x, y)
    sort(blue.begin(), blue.end(), [](Point& a, Point& b) {
        return a.x < b.x || (a.x == b.x && a.y < b.y);
    });

    sort(red.begin(), red.end(), [](Point& a, Point& b) {
        return a.x < b.x || (a.x == b.x && a.y < b.y);
    });

    // Побудова пар (жадібно)
    for (int i = 0; i < N; ++i) {
        result.push_back({blue[i].index, red[i].index});
    }

    return true;
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);
        vector<pair<int, int>> result;

        // Зчитуємо сині точки
        for (int i = 0; i < N; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }

        // Зчитуємо червоні точки
        for (int i = 0; i < N; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        // Обробляємо блок
        if (solveBlock(N, blue, red, result)) {
            for (auto& p : result) {
                cout << p.first << " " << p.second << endl;
            }
        } else {
            cout << 0 << endl;
        }
    }

    return 0;
}
