import java.util.Scanner;

public class OptimizedSquareCount {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();

        int[][] grid = new int[N][N];
        int[][] prefixSumBlue = new int[N][N];
        int[][] prefixSumRed = new int[N][N];

        // Читання кольорів точок та обчислення префіксних сум
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                grid[i][j] = sc.nextInt();
                prefixSumBlue[i][j] = (i > 0 ? prefixSumBlue[i - 1][j] : 0) + (j > 0 ? prefixSumBlue[i][j - 1] : 0) - (i > 0 && j > 0 ? prefixSumBlue[i - 1][j - 1] : 0) + (grid[i][j] == 0 ? 1 : 0);
                prefixSumRed[i][j] = (i > 0 ? prefixSumRed[i - 1][j] : 0) + (j > 0 ? prefixSumRed[i][j - 1] : 0) - (i > 0 && j > 0 ? prefixSumRed[i - 1][j - 1] : 0) + (grid[i][j] == 1 ? 1 : 0);
            }
        }

        int count = 0;
        for (int x1 = 0; x1 < N; x1++) {
            for (int y1 = 0; y1 < N; y1++) {
                for (int x2 = x1; x2 < N; x2++) {
                    for (int y2 = y1; y2 < N; y2++) {
                        int blueCount = prefixSumBlue[x2][y2] - (x1 > 0 ? prefixSumBlue[x1 - 1][y2] : 0) - (y1 > 0 ? prefixSumBlue[x2][y1 - 1] : 0) + (x1 > 0 && y1 > 0 ? prefixSumBlue[x1 - 1][y1 - 1] : 0);
                        int redCount = prefixSumRed[x2][y2] - (x1 > 0 ? prefixSumRed[x1 - 1][y2] : 0) - (y1 > 0 ? prefixSumRed[x2][y1 - 1] : 0) + (x1 > 0 && y1 > 0 ? prefixSumRed[x1 - 1][y1 - 1] : 0);
                        if (blueCount == (x2 - x1 + 1) * (y2 - y1 + 1) || redCount == (x2 - x1 + 1) * (y2 - y1 + 1)) {
                            count++;
                        }
                    }
                }
            }
        }

        System.out.println(count);
    }
}