import java.util.Scanner;

public class Main7 {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        int[][] colors = new int[N][N];

        // Read the grid values
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                colors[i][j] = sc.nextInt();
            }
        }

        int count = 0;

        // Iterate over possible square sizes from 2 to N (inclusive)
        for (int size = 2; size <= N; size++) {
            for (int i = 0; i <= N - size; i++) {
                for (int j = 0; j <= N - size; j++) {
                    // Assume the color of the square is the top-left corner
                    int color = colors[i][j];
                    boolean isSquare = true;

                    // Check all cells in the square of this size
                    for (int x = i; x < i + size; x++) {
                        for (int y = j; y < j + size; y++) {
                            if (colors[x][y] != color) {
                                isSquare = false;
                                break;
                            }
                        }
                        if (!isSquare) break;
                    }

                    // If the square is filled with the same color, count it
                    if (isSquare) {
                        count++;
                    }
                }
            }
        }

        sc.close();

        // Output the result
        System.out.println(count);
    }
}
