import java.util.*;

public class RobotMatch {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // Кількість тестових наборів
        int t = scanner.nextInt();

        // Обробляємо кожен тестовий набір
        for (int test = 0; test < t; test++) {
            int n = scanner.nextInt();

            // Зчитуємо сині точки
            Point[] blue = new Point[n];
            for (int i = 0; i < n; i++) {
                int x = scanner.nextInt();
                int y = scanner.nextInt();
                blue[i] = new Point(x, y, i + 1);  // Зберігаємо координати і індекс
            }

            // Зчитуємо червоні точки
            Point[] red = new Point[n];
            for (int i = 0; i < n; i++) {
                int x = scanner.nextInt();
                int y = scanner.nextInt();
                red[i] = new Point(x, y, i + 1);  // Зберігаємо координати і індекс
            }

            // Сортуємо сині точки за y-координатою, потім за x
            Arrays.sort(blue, Comparator.comparingInt((Point p) -> p.y).thenComparingInt(p -> p.x));

            // Сортуємо червоні точки за y-координатою, потім за x
            Arrays.sort(red, Comparator.comparingInt((Point p) -> p.y).thenComparingInt(p -> p.x));

            // Формуємо результат
            StringBuilder result = new StringBuilder();
            for (int i = 0; i < n; i++) {
                // Для кожної пари синя точка та червона точка виводимо їх індекси
                result.append(blue[i].index).append(" ").append(red[i].index).append("\n");
            }

            // Виводимо результат для поточного тесту
            System.out.print(result);
        }
    }

    // Клас для точки
    static class Point {
        int x, y, index;

        Point(int x, int y, int index) {
            this.x = x;
            this.y = y;
            this.index = index;
        }
    }
}
