import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int t = scanner.nextInt();
        for (int test = 0; test < t; test++) {
            int N = scanner.nextInt();
            Point[] blue = new Point[N];
            Point[] red = new Point[N];
            for (int i = 0; i < N; i++) {
                blue[i] = new Point(scanner.nextInt(), scanner.nextInt(), i + 1);
            }
            for (int i = 0; i < N; i++) {
                red[i] = new Point(scanner.nextInt(), scanner.nextInt(), i + 1);
            }
            
            List<Pair> result = new ArrayList<>();
            boolean possible = true;
            
            // Check if any pair has the same coordinates
            for (int i = 0; i < N; i++) {
                if (blue[i].x == red[i].x && blue[i].y == red[i].y) {
                    possible = false;
                    break;
                }
                result.add(new Pair(blue[i].index, red[i].index));
            }

            if (possible) {
                for (Pair pair : result) {
                    System.out.println(pair.blue + " " + pair.red);
                }
            } else {
                System.out.println(0); // No valid pairings found
            }
        }
        scanner.close();
    }
}

class Point {
    int x, y, index;
    Point(int x, int y, int index) {
        this.x = x;
        this.y = y;
        this.index = index;
    }
}

class Pair {
    int blue, red;
    Pair(int blue, int red) {
        this.blue = blue;
        this.red = red;
    }
}
