#include <iostream>
#include <vector>
#include <climits>
using namespace std;

int main() {
    long long N, M;
    cin >> N >> M;

    if (M > (N * (N + 1)) / 2) {
        cout << 0 << endl;
        return 0;
    }

    vector<long long> dp(M + 1, LLONG_MAX);
    dp[0] = 0;

    for (long long i = 1; i <= N; ++i) {
        for (long long j = M; j >= i; --j) {
            if (dp[j - i] != LLONG_MAX) {
                dp[j] = min(dp[j], dp[j - i] + 1);
            }
        }
    }

    if (dp[M] == LLONG_MAX) {
        cout << 0 << endl;
        return 0;
    }

    long long sum = M;
    vector<long long> result;
    for (long long i = N; i >= 1; --i) {
        if (sum >= i && dp[sum - i] == dp[sum] - 1) {
            result.push_back(i);
            sum -= i;
        }
    }

    if (sum == 0) {
        for (long long i = 0; i < result.size(); ++i) {
            cout << result[i] << " ";
        }
        cout << endl;
    } else {
        cout << 0 << endl;
    }

    return 0;
}
