#include <iostream>
#include <queue>
#include <vector>
#include <unordered_set>
using namespace std;

int main() {
    long long N, M;
    cin >> N >> M;

    if (M > (N * (N + 1)) / 2) {
        cout << 0 << endl;
        return 0;
    }

    vector<bool> visited(M + 1, false);
    vector<int> parent(M + 1, -1);
    vector<int> last_mark(M + 1, -1);

    queue<int> q;
    q.push(0);
    visited[0] = true;

    while (!q.empty()) {
        int current_sum = q.front();
        q.pop();

        for (int i = N; i >= 1; --i) {
            int new_sum = current_sum + i;
            if (new_sum <= M && !visited[new_sum]) {
                visited[new_sum] = true;
                parent[new_sum] = current_sum;
                last_mark[new_sum] = i;
                q.push(new_sum);
                if (new_sum == M) {
                    break;
                }
            }
        }
    }

    if (!visited[M]) {
        cout << 0 << endl;
    } else {
        vector<int> result;
        int sum = M;
        while (sum > 0) {
            result.push_back(last_mark[sum]);
            sum = parent[sum];
        }

        for (int i = result.size() - 1; i >= 0; --i) {
            cout << result[i] << " ";
        }
        cout << endl;
    }

    return 0;
}
