#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Point {
    int x, y, index;
};

bool compareBlue(Point a, Point b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

bool compareRed(Point a, Point b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

int main() {
    int t;
    cin >> t;
    
    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);

        for (int i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }

        for (int i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        sort(blue.begin(), blue.end(), compareBlue);
        sort(red.begin(), red.end(), compareRed);

        bool valid = true;
        for (int i = 0; i < N; i++) {
            if (blue[i].x == red[i].x && blue[i].y == red[i].y) {
                valid = false;
                break;
            }
        }

        if (valid) {
            for (int i = 0; i < N; i++) {
                cout << blue[i].index << " " << red[i].index << endl;
            }
        } else {
            cout << 0 << endl;
        }
    }

    return 0;
}
