#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Point {
    int x, y, index;
};

bool canConnect(Point a, Point b, Point c, Point d) {
    return (a.x < b.x && c.x < d.x && a.y < b.y && c.y < d.y) || 
           (a.x > b.x && c.x > d.x && a.y > b.y && c.y > d.y);
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);
        
        for (int i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }

        for (int i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        vector<vector<int>> dp(N + 1, vector<int>(N + 1, 0));

        for (int i = 1; i <= N; i++) {
            for (int j = 1; j <= N; j++) {
                if (canConnect(blue[i - 1], red[j - 1], blue[i - 1], red[j - 1])) {
                    dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] + 1);
                } else {
                    dp[i][j] = max(dp[i][j], max(dp[i - 1][j], dp[i][j - 1]));
                }
            }
        }

        cout << dp[N][N] << endl;
    }

    return 0;
}
