#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

struct Point {
    int x, y, index;
};

bool canConnect(Point a, Point b, Point c, Point d) {
    return (a.x < b.x && c.x < d.x && a.y < b.y && c.y < d.y) || 
           (a.x > b.x && c.x > d.x && a.y > b.y && c.y > d.y);
}

bool dfs(int v, vector<vector<int>>& graph, vector<int>& match, vector<bool>& visited) {
    for (int u : graph[v]) {
        if (!visited[u]) {
            visited[u] = true;
            if (match[u] == -1 || dfs(match[u], graph, match, visited)) {
                match[u] = v;
                return true;
            }
        }
    }
    return false;
}

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);
        
        for (int i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }

        for (int i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        vector<vector<int>> graph(N);

        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                if (canConnect(blue[i], red[j], blue[i], red[j])) {
                    graph[i].push_back(j);
                }
            }
        }

        vector<int> match(N, -1);
        int result = 0;

        for (int i = 0; i < N; i++) {
            vector<bool> visited(N, false);
            if (dfs(i, graph, match, visited)) {
                result++;
            }
        }

        if (result == N) {
            for (int i = 0; i < N; i++) {
                cout << match[i] + 1 << " " << i + 1 << endl;
            }
        } else {
            cout << 0 << endl;
        }
    }

    return 0;
}
