#include <iostream>
#include <set>
using namespace std;

pair<bool, int> can_meet(int N) {
    set<int> alice_positions = {1};  // Начальная позиция Алии
    set<int> bob_positions = {N};    // Начальная позиция Боба
    int time = 0;
    
    // Продолжаем, пока есть возможные новые позиции
    while (true) {
        // Проверяем пересечение позиций
        for (int alice_pos : alice_positions) {
            if (bob_positions.count(alice_pos)) {
                return {true, time};
            }
        }
        
        // Новые возможные позиции для Алии
        set<int> new_alice;
        for (int pos : alice_positions) {
            if (pos + 2 <= N) new_alice.insert(pos + 2);
            if (pos + 3 <= N) new_alice.insert(pos + 3);
        }
        
        // Новые возможные позиции для Боба
        set<int> new_bob;
        for (int pos : bob_positions) {
            if (pos - 1 >= 1) new_bob.insert(pos - 1);
            if (pos - 2 >= 1) new_bob.insert(pos - 2);
        }
        
        // Если нет новых позиций для обоих роботов
        if (new_alice.empty() && new_bob.empty()) {
            return {false, -1};
        }
        
        alice_positions = new_alice;
        bob_positions = new_bob;
        time++;
    }
}

int main() {
    int N;
    cin >> N;
    
    pair<bool, int> result = can_meet(N);
    if (result.first) {
        cout << result.second << endl;
    } else {
        cout << -1 << endl;
    }
    
    return 0;
}
