#include <iostream>
#include <vector>
using namespace std;

pair<bool, int> can_meet(int N) {
    vector<bool> alice_positions(N + 1, false);
    vector<bool> bob_positions(N + 1, false);
    alice_positions[1] = true;
    bob_positions[N] = true;
    int time = 0;
    
    while (true) {
        for (int i = 1; i <= N; ++i) {
            if (alice_positions[i] && bob_positions[i]) {
                return {true, time};
            }
        }
        
        vector<bool> new_alice_positions(N + 1, false);
        for (int i = 1; i <= N; ++i) {
            if (alice_positions[i]) {
                if (i + 2 <= N) new_alice_positions[i + 2] = true;
                if (i + 3 <= N) new_alice_positions[i + 3] = true;
            }
        }
        
        vector<bool> new_bob_positions(N + 1, false);
        for (int i = 1; i <= N; ++i) {
            if (bob_positions[i]) {
                if (i - 1 >= 1) new_bob_positions[i - 1] = true;
                if (i - 2 >= 1) new_bob_positions[i - 2] = true;
            }
        }
        
        bool alice_empty = true;
        bool bob_empty = true;
        for (int i = 1; i <= N; ++i) {
            if (new_alice_positions[i]) {
                alice_empty = false;
            }
            if (new_bob_positions[i]) {
                bob_empty = false;
            }
        }

        if (alice_empty && bob_empty) {
            return {false, -1};
        }
        
        alice_positions = new_alice_positions;
        bob_positions = new_bob_positions;
        time++;
    }
}

int main() {
    int N;
    cin >> N;
    
    pair<bool, int> result = can_meet(N);
    if (result.first) {
        cout << result.second << endl;
    } else {
        cout << -1 << endl;
    }
    
    return 0;
}
