#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
using namespace std;

int main() {
    long long n, m;
    cin >> n >> m;

    if (m > n * (n + 1) / 2) {
        cout << 0 << endl;
        return 0;
    }

    vector<long long> dp(m + 1, LLONG_MAX);
    vector<int> prev(m + 1, -1);
    dp[0] = 0;

    for (int i = 1; i <= n; i++) {
        for (int j = m; j >= i; j--) {
            if (dp[j - i] != LLONG_MAX && dp[j - i] + 1 < dp[j]) {
                dp[j] = dp[j - i] + 1;
                prev[j] = i;
            }
        }
    }

    if (dp[m] == LLONG_MAX) {
        cout << 0 << endl;
        return 0;
    }

    vector<int> result;
    int current = m;
    while (current > 0) {
        result.push_back(prev[current]);
        current -= prev[current];
    }

    sort(result.begin(), result.end());
    for (int stamp : result) {
        cout << stamp << " ";
    }
    cout << endl;

    return 0;
}
