#include <iostream>
#include <vector>
using namespace std;

// Функція для перевірки кольору всіх вершин квадрата
bool checkSquare(int x1, int y1, int x2, int y2, const vector<vector<int>>& grid) {
    // Рахуємо чотири вершини квадрата
    int x3 = x1 + (y2 - y1);
    int y3 = y1 - (x2 - x1);
    
    int x4 = x2 + (y2 - y1);
    int y4 = y2 - (x2 - x1);
    
    // Перевіряємо чи всі чотири вершини у межах сітки
    if (x3 < 0 || x3 >= grid.size() || y3 < 0 || y3 >= grid.size() ||
        x4 < 0 || x4 >= grid.size() || y4 < 0 || y4 >= grid.size()) {
        return false;
    }

    // Перевіряємо чи всі чотири вершини однакового кольору
    return grid[x1][y1] == grid[x2][y2] && grid[x2][y2] == grid[x3][y3] && grid[x3][y3] == grid[x4][y4];
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    
    // Читання даних
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < N; ++j)
            cin >> grid[i][j];

    int count = 0;

    // Перебір усіх можливих пар точок
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            for (int k = i + 1; k < N; ++k) {
                for (int l = j + 1; l < N; ++l) {
                    if (checkSquare(i, j, k, l, grid)) {
                        count++;
                    }
                }
            }
        }
    }

    cout << count << endl;

    return 0;
}
