#include <iostream>
#include <vector>
using namespace std;

int countSquaresWithSameColor(int N, const vector<vector<int>>& grid) {
    int count = 0;

    // Перевірка для кожного можливого квадрата
    for (int k = 2; k <= N; ++k) {  // Розмір квадрата від 2x2 до NxN
        for (int i = 0; i <= N - k; ++i) {  // Початок квадрата по вертикалі
            for (int j = 0; j <= N - k; ++j) {  // Початок квадрата по горизонталі
                // Вершини квадрата
                int topLeft = grid[i][j];
                int topRight = grid[i][j + k - 1];
                int bottomLeft = grid[i + k - 1][j];
                int bottomRight = grid[i + k - 1][j + k - 1];
                
                // Перевірка, чи всі вершини одного кольору
                if (topLeft == topRight && topLeft == bottomLeft && topLeft == bottomRight) {
                    ++count;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = countSquaresWithSameColor(N, grid);
    cout << result << endl;

    return 0;
}

