#include <iostream>
#include <vector>
using namespace std;

int countSquaresWithSameColor(int N, const vector<vector<int>>& grid) {
    int count = 0;

    // Перебор квадратов с вершинами в целочисленных координатах
    for (int k = 2; k <= N; ++k) {  // Размер квадрата от 2x2 до NxN
        for (int i = 0; i <= N - k; ++i) {  // Начало квадрата по вертикали
            for (int j = 0; j <= N - k; ++j) {  // Начало квадрата по горизонтали
                int color = grid[i][j];  // Цвет верхней левой вершины
                bool isSquare = true;

                // Проверка, что все четыре вершины квадрата одного цвета
                for (int di = 0; di < k; ++di) {
                    for (int dj = 0; dj < k; ++dj) {
                        if (grid[i + di][j + dj] != color) {
                            isSquare = false;
                            break;
                        }
                    }
                    if (!isSquare) break;
                }

                if (isSquare) {
                    ++count;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = countSquaresWithSameColor(N, grid);
    cout << result << endl;

    return 0;
}
