#include <iostream>
#include <vector>
using namespace std;

int countSquaresWithSameColor(int N, const vector<vector<int>>& grid) {
    int count = 0;

    // Динамическое программирование для проверки квадратов одинакового цвета
    vector<vector<int>> dp_red(N, vector<int>(N, 0)); // dp_red[i][j] - размер наибольшего красного квадрата, который заканчивается в (i, j)
    vector<vector<int>> dp_blue(N, vector<int>(N, 0)); // dp_blue[i][j] - аналогично для синего квадрата

    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            if (i > 0 && j > 0) {
                if (grid[i][j] == 1) { // если точка красная
                    dp_red[i][j] = min({dp_red[i - 1][j], dp_red[i][j - 1], dp_red[i - 1][j - 1]}) + 1;
                }
                if (grid[i][j] == 0) { // если точка синяя
                    dp_blue[i][j] = min({dp_blue[i - 1][j], dp_blue[i][j - 1], dp_blue[i - 1][j - 1]}) + 1;
                }
            } else {
                // Квадраты размером 1x1 всегда возможны
                dp_red[i][j] = (grid[i][j] == 1) ? 1 : 0;
                dp_blue[i][j] = (grid[i][j] == 0) ? 1 : 0;
            }
            count += dp_red[i][j] - 1; // добавляем количество квадратов красного цвета
            count += dp_blue[i][j] - 1; // добавляем количество квадратов синего цвета
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = countSquaresWithSameColor(N, grid);
    cout << result << endl;

    return 0;
}
