#include <iostream>
#include <vector>
using namespace std;

int countSquaresWithSameColor(int N, const vector<vector<int>>& grid) {
    int count = 0;
    
    // Создаем массив для хранения информации о квадрате
    vector<vector<int>> dp(N, vector<int>(N, 0));
    
    // Обрабатываем квадраты размером 1x1 (каждая точка сама по себе)
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            dp[i][j] = 1;  // Все точки 1x1 считаются квадратами
            count++;
        }
    }
    
    // Обрабатываем квадраты размером от 2x2 до NxN
    for (int size = 2; size <= N; ++size) {
        for (int i = 0; i <= N - size; ++i) {
            for (int j = 0; j <= N - size; ++j) {
                // Проверяем, можно ли построить квадрат размером size x size
                if (grid[i][j] == grid[i + size - 1][j] && 
                    grid[i][j] == grid[i][j + size - 1] && 
                    grid[i][j] == grid[i + size - 1][j + size - 1] && 
                    dp[i + 1][j + 1] >= size - 1) {
                    dp[i][j] = size;
                    count++;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = countSquaresWithSameColor(N, grid);
    cout << result << endl;

    return 0;
}
