#include <iostream>
#include <vector>
using namespace std;

int countSquaresWithSameColor(int N, const vector<vector<int>>& grid) {
    int count = 0;

    for (int size = 1; size <= N; ++size) {
        for (int i = 0; i <= N - size; ++i) {
            for (int j = 0; j <= N - size; ++j) {
                int color = grid[i][j];
                bool validSquare = true;

                for (int x = i; x < i + size; ++x) {
                    for (int y = j; y < j + size; ++y) {
                        if (grid[x][y] != color) {
                            validSquare = false;
                            break;
                        }
                    }
                    if (!validSquare) break;
                }

                if (validSquare) {
                    count++;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = countSquaresWithSameColor(N, grid);
    cout << result << endl;

    return 0;
}
