#include <iostream>
#include <vector>
using namespace std;

int countSquaresWithSameColor(int N, const vector<vector<int>>& grid) {
    int count = 0;

    // Перебираем все возможные размеры квадратов от 2x2 до NxN
    for (int size = 2; size <= N; ++size) {
        // Перебираем возможные позиции верхнего левого угла квадрата
        for (int i = 0; i <= N - size; ++i) {
            for (int j = 0; j <= N - size; ++j) {
                // Цвет верхнего левого угла
                int color = grid[i][j];

                // Проверяем все 4 вершины квадрата
                if (grid[i][j] == color && 
                    grid[i + size - 1][j] == color &&
                    grid[i][j + size - 1] == color &&
                    grid[i + size - 1][j + size - 1] == color) {
                    ++count;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = countSquaresWithSameColor(N, grid);
    cout << result << endl;

    return 0;
}
