#include <iostream>
#include <vector>
using namespace std;

int countSquaresWithSameColor(int N, const vector<vector<int>>& grid) {
    int count = 0;

    for (int size = 2; size <= N; ++size) {  // Размер квадрата от 2x2 до NxN
        for (int i = 0; i <= N - size; ++i) {  // i - строка, где квадрат начинается
            for (int j = 0; j <= N - size; ++j) {  // j - столбец, где квадрат начинается
                int color = grid[i][j];  // Цвет верхнего левого угла
                bool validSquare = true;
                // Проверяем все вершины квадрата
                for (int dx = 0; dx < size && validSquare; ++dx) {
                    for (int dy = 0; dy < size && validSquare; ++dy) {
                        if (grid[i + dx][j + dy] != color) {
                            validSquare = false;
                        }
                    }
                }
                if (validSquare) {
                    ++count;
                }
            }
        }
    }

    return count;
}

int main() {
    int N;
    cin >> N;

    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            cin >> grid[i][j];
        }
    }

    int result = countSquaresWithSameColor(N, grid);
    cout << result << endl;

    return 0;
}
