#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int OFFSET = 10000;
const int MAX_COORD = 20000;

struct Point {
    int x, y, index;
    
    Point(int x = 0, int y = 0, int index = 0) : x(x), y(y), index(index) {}
};

void countingSort(vector<Point>& points, bool sortByX) {
    vector<int> count(MAX_COORD + 1, 0);
    vector<Point> output(points.size());
    
    for (auto& point : points) {
        int key = sortByX ? point.x + OFFSET : point.y + OFFSET;
        count[key]++;
    }

    for (int i = 1; i <= MAX_COORD; i++) {
        count[i] += count[i - 1];
    }

    for (int i = points.size() - 1; i >= 0; i--) {
        int key = sortByX ? points[i].x + OFFSET : points[i].y + OFFSET;
        output[count[key] - 1] = points[i];
        count[key]--;
    }

    for (int i = 0; i < points.size(); i++) {
        points[i] = output[i];
    }
}

int main() {
    int t;
    cin >> t;
    
    while (t--) {
        int N;
        cin >> N;
        
        vector<Point> blue(N), red(N);
        
        for (int i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }
        
        for (int i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }
        
        countingSort(blue, true);
        countingSort(red, true);
        
        countingSort(blue, false);
        countingSort(red, false);
        
        for (int i = 0; i < N; i++) {
            cout << blue[i].index << " " << red[i].index << endl;
        }
    }

    return 0;
}
