#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y, index;
    
    Point(int x = 0, int y = 0, int index = 0) : x(x), y(y), index(index) {}

    bool operator<(const Point& other) const {
        if (x != other.x) return x < other.x;
        return y < other.y;
    }
};

int main() {
    int t;
    cin >> t;

    while (t--) {
        int N;
        cin >> N;
        
        vector<Point> blue(N), red(N);
        
        // Зчитуємо сині точки
        for (int i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
        }
        
        // Зчитуємо червоні точки
        for (int i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
        }

        // Сортуємо сині та червоні точки
        sort(blue.begin(), blue.end());
        sort(red.begin(), red.end());

        // Виводимо пари точок: кожну синю точку з'єднуємо з червоною
        for (int i = 0; i < N; i++) {
            cout << blue[i].index << " " << red[i].index << endl;
        }
    }

    return 0;
}
