#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Структура для зберігання точки
struct Point {
    int x, y, index;
    bool isRed; // Якщо true, то це червона точка, якщо false - синя
};

// Порівняння точок за x, а потім за y
bool comparePoints(const Point& a, const Point& b) {
    if (a.x == b.x) return a.y < b.y;
    return a.x < b.x;
}

int main() {
    int t;
    cin >> t; // Читаємо кількість тестових випадків

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);

        // Читання синіх точок
        for (int i = 0; i < N; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1;
            blue[i].isRed = false;
        }

        // Читання червоних точок
        for (int i = 0; i < N; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1;
            red[i].isRed = true;
        }

        // Сортуємо сині та червоні точки
        sort(blue.begin(), blue.end(), comparePoints);
        sort(red.begin(), red.end(), comparePoints);

        // Виводимо результати
        for (int i = 0; i < N; i++) {
            cout << blue[i].index << " " << red[i].index << endl;
        }
    }

    return 0;
}
