#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

// Структура для збереження координат та індексу точки
struct Point {
    int x, y, index;
    
    // Оператор порівняння для сортування за x та потім за y
    bool operator<(const Point& other) const {
        if (x == other.x)
            return y < other.y;
        return x < other.x;
    }
};

int main() {
    int t;
    cin >> t; // Читаємо кількість тестових випадків
    
    while (t--) {
        int N;
        cin >> N; // Кількість точок одного кольору
        
        vector<Point> bluePoints(N), redPoints(N);
        
        // Читаємо координати синіх точок
        for (int i = 0; i < N; ++i) {
            cin >> bluePoints[i].x >> bluePoints[i].y;
            bluePoints[i].index = i + 1; // Номер точки
        }
        
        // Читаємо координати червоних точок
        for (int i = 0; i < N; ++i) {
            cin >> redPoints[i].x >> redPoints[i].y;
            redPoints[i].index = i + 1; // Номер точки
        }
        
        // Сортуємо сині та червоні точки за координатами
        sort(bluePoints.begin(), bluePoints.end());
        sort(redPoints.begin(), redPoints.end());
        
        // Виводимо пари точок для з'єднання
        for (int i = 0; i < N; ++i) {
            cout << bluePoints[i].index << " " << redPoints[i].index << endl;
        }
    }

    return 0;
}
