def find_minimal_stamps(N, M):
    # Generate the list of stamp values
    stamps = list(range(1, N + 1))

    # Best combination tracker
    best_combination = None

    # Iterate through all subsets using bitmasking
    for mask in range(1, 1 << N):  # From 1 to 2^N - 1
        subset = []
        total = 0
        for i in range(N):
            if mask & (1 << i):  # Check if i-th stamp is in the subset
                subset.append(stamps[i])
                total += stamps[i]
                if total > M:  # Early exit if total exceeds M
                    break
        # Check if the subset matches the criteria
        if total == M:
            if best_combination is None or len(subset) < len(best_combination):
                best_combination = subset

    # Return the best combination or [0] if no solution
    return best_combination if best_combination else [0]


# Input from the user
N = int(input())
M = int(input())

# Find and print the result
result = find_minimal_stamps(N, M)
print(0 if result == [0] else "\n".join(map(str, result)))
