#include <iostream>
#include <queue>
#include <unordered_set>
using namespace std;

int teleportationMeeting(int N) {
    // BFS для Аліси та Боба
    queue<pair<int, int>> aliceQueue;  // {позиція, час для Аліси}
    queue<pair<int, int>> bobQueue;    // {позиція, час для Боба}
    
    unordered_set<int> visitedAlice;    // Відвідані позиції Аліси
    unordered_set<int> visitedBob;      // Відвідані позиції Боба
    
    aliceQueue.push({1, 0});  // Аліса починає з клітинки 1
    bobQueue.push({N, 0});    // Боб починає з клітинки N
    
    visitedAlice.insert(1);
    visitedBob.insert(N);
    
    while (!aliceQueue.empty() && !bobQueue.empty()) {
        // Рух Аліси
        int posA = aliceQueue.front().first;
        int timeA = aliceQueue.front().second;
        aliceQueue.pop();
        
        // Перевірка, чи є зустріч
        if (visitedBob.count(posA)) {
            return timeA;
        }

        // Рух Аліси: перевіряємо можливі переміщення
        if (posA + 2 <= N && !visitedAlice.count(posA + 2)) {
            aliceQueue.push({posA + 2, timeA + 1});
            visitedAlice.insert(posA + 2);
        }
        if (posA + 3 <= N && !visitedAlice.count(posA + 3)) {
            aliceQueue.push({posA + 3, timeA + 1});
            visitedAlice.insert(posA + 3);
        }

        // Рух Боба
        int posB = bobQueue.front().first;
        int timeB = bobQueue.front().second;
        bobQueue.pop();
        
        // Перевірка, чи є зустріч
        if (visitedAlice.count(posB)) {
            return timeB;
        }

        // Рух Боба: перевіряємо можливі переміщення
        if (posB - 1 > 0 && !visitedBob.count(posB - 1)) {
            bobQueue.push({posB - 1, timeB + 1});
            visitedBob.insert(posB - 1);
        }
        if (posB - 2 > 0 && !visitedBob.count(posB - 2)) {
            bobQueue.push({posB - 2, timeB + 1});
            visitedBob.insert(posB - 2);
        }
    }
    
    return -1;  // Якщо не знайдена зустріч
}

int main() {
    int N;
    cin >> N;
    
    cout << teleportationMeeting(N) << endl;
    
    return 0;
}
