#include <iostream>
#include <queue>
#include <vector>
#include <climits>
#include <algorithm>

using namespace std;

int min_time_to_meet(int N) {
    vector<int> alice_visited(N + 1, -1);
    vector<int> bob_visited(N + 1, -1);
    queue<int> alice_queue, bob_queue;

    alice_queue.push(1);
    alice_visited[1] = 0;

    while (!alice_queue.empty()) {
        int current = alice_queue.front();
        alice_queue.pop();
        int current_time = alice_visited[current];

        for (int next_pos : {current + 2, current + 3}) {
            if (next_pos <= N && alice_visited[next_pos] == -1) {
                alice_visited[next_pos] = current_time + 1;
                alice_queue.push(next_pos);
            }
        }
    }

    bob_queue.push(N);
    bob_visited[N] = 0;

    while (!bob_queue.empty()) {
        int current = bob_queue.front();
        bob_queue.pop();
        int current_time = bob_visited[current];

        for (int next_pos : {current - 1, current - 2}) {
            if (next_pos >= 1 && bob_visited[next_pos] == -1) {
                bob_visited[next_pos] = current_time + 1;
                bob_queue.push(next_pos);
            }
        }
    }

    int min_time = INT_MAX;
    for (int i = 1; i <= N; i++) {
        if (alice_visited[i] != -1 && bob_visited[i] != -1) {
            min_time = min(min_time, max(alice_visited[i], bob_visited[i]));
        }
    }

    return min_time == INT_MAX ? -1 : min_time;
}

int main() {
    int N;
    cin >> N;
    cout << min_time_to_meet(N) << endl;
    return 0;
}