#include <iostream>
#include <queue>
#include <unordered_set>

using namespace std;

int min_time_to_meet(int N) {
    if (N == 2 || N == 3 || N == 4) return 1;  // Особливі випадки для малих N

    unordered_set<int> alice_visited, bob_visited;
    queue<int> alice_queue, bob_queue;
    
    alice_queue.push(1);
    bob_queue.push(N);
    alice_visited.insert(1);
    bob_visited.insert(N);
    
    int time = 0;
    
    while (!alice_queue.empty() && !bob_queue.empty()) {
        time++;
        
        // Рух Аліси
        int alice_size = alice_queue.size();
        for (int i = 0; i < alice_size; ++i) {
            int current = alice_queue.front();
            alice_queue.pop();

            for (int next_pos : {current + 2, current + 3}) {
                if (next_pos <= N && !alice_visited.count(next_pos)) {
                    if (bob_visited.count(next_pos)) return time;
                    alice_visited.insert(next_pos);
                    alice_queue.push(next_pos);
                }
            }
        }

        // Рух Боба
        int bob_size = bob_queue.size();
        for (int i = 0; i < bob_size; ++i) {
            int current = bob_queue.front();
            bob_queue.pop();

            for (int next_pos : {current - 1, current - 2}) {
                if (next_pos >= 1 && !bob_visited.count(next_pos)) {
                    if (alice_visited.count(next_pos)) return time;
                    bob_visited.insert(next_pos);
                    bob_queue.push(next_pos);
                }
            }
        }
    }
    
    return -1;
}

int main() {
    int N;
    cin >> N;
    cout << min_time_to_meet(N) << endl;
    return 0;
}