#include <iostream>
#include <vector>
#include <unordered_set>
#include <string>
using namespace std;

string key(int x, int y) {
    return to_string(x) + "," + to_string(y);
}

int squares(const vector<vector<int>>& grid, int N) {
    unordered_set<string> points; 
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            points.insert(key(i, j));
        }
    }
    int c = 0;
    for (int x1 = 0; x1 < N; x1++) {
        for (int y1 = 0; y1 < N; y1++) {
            for (int x2 = 0; x2 < N; x2++) {
                for (int y2 = 0; y2 < N; y2++) {
                    if (x1 == x2 && y1 == y2) continue;
                    int dx = x2 - x1;
                    int dy = y2 - y1;
                    int x3 = x1 - dy, y3 = y1 + dx; 
                    int x4 = x2 - dy, y4 = y2 + dx; 
                    if (x3 >= 0 && x3 < N && y3 >= 0 && y3 < N &&
                        x4 >= 0 && x4 < N && y4 >= 0 && y4 < N &&
                        points.count(key(x3, y3)) && points.count(key(x4, y4))) {
                        if (grid[x1][y1] == grid[x2][y2] &&
                            grid[x2][y2] == grid[x3][y3] &&
                            grid[x3][y3] == grid[x4][y4]) {
                            c++;
                        }
                    }
                }
            }
        }
    }

    return c / 4; 
}

int main() {
    int N;
    cin >> N;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }
    cout << squares(grid, N);
    return 0;
}
