#include <iostream>
#include <vector>
using namespace std;
vector<vector<int>> prsum(const vector<vector<int>>& grid, int N) {
    vector<vector<int>> prefix(N + 1, vector<int>(N + 1, 0));
    for (int i = 1; i <= N; i++) {
        for (int j = 1; j <= N; j++) {
            prefix[i][j] = grid[i - 1][j - 1] +  prefix[i - 1][j] + prefix[i][j - 1] - prefix[i - 1][j - 1];
        }
    }
    return prefix;
}
int sum(const vector<vector<int>>& prefix, int x1, int y1, int x2, int y2) {
    return prefix[x2 + 1][y2 + 1] - prefix[x1][y2 + 1] - prefix[x2 + 1][y1] + prefix[x1][y1];
}
int squares(const vector<vector<int>>& grid, int N) {
    auto prefix = prsum(grid, N);
    int c = 0;
    for (int x1 = 0; x1 < N; x1++) {
        for (int y1 = 0; y1 < N; y1++) {
            for (int x2 = x1 + 1; x2 < N; x2++) {
                for (int y2 = y1 + 1; y2 < N; y2++) {
                    int colorSum = sum(prefix, x1, y1, x2, y2);
                    int side = x2 - x1 + 1; 
                    if (colorSum == 0 || colorSum == side * side) {
                        c++;
                    }
                }
            }
        }
    }
    return c;
}

int main() {
    int N;
    cin >> N;
    vector<vector<int>> grid(N, vector<int>(N));
    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            cin >> grid[i][j];
        }
    }
    cout << squares(grid, N);
    return 0;
}
