#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, idx;
};

bool compare(const Point& a, const Point& b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

bool intersect(Point a, Point b, Point c, Point d) {
      auto orientation = [](Point p, Point q, Point r) {
        int val = (q.y - p.y) * (r.x - q.x) - (q.x - p.x) * (r.y - q.y);
        if (val == 0) return 0;
        return (val > 0) ? 1 : 2;
        };
    int o1 = orientation(a, b, c);
    int o2 = orientation(a, b, d);
    int o3 = orientation(c, d, a);
    int o4 = orientation(c, d, b);
    if (o1 != o2 && o3 != o4) return true;
    return false;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<Point> blue(n), red(n);
        for (int i = 0; i < n; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].idx = i + 1;
        }
        for (int i = 0; i < n; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].idx = i + 1;
        }
        sort(blue.begin(), blue.end(), compare);
        sort(red.begin(), red.end(), compare);
        vector<pair<int, int>> matching;
        bool ok = true;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < i; ++j) {
                if (intersect(blue[i], red[i], blue[j], red[j])) {
                    ok = false;
                    break;
                }
            }
            if (!ok) break;
            matching.emplace_back(blue[i].idx, red[i].idx);
        }
        if (!ok) cout << 0 << "\n";
        else {
            for (auto [b, r] : matching) {
                cout << b << " " << r << "\n";
            }
        }
    }
    return 0;
}
