import java.util.*;

public class Main {
    public static int findMeetingTime(int N) {
        if (N < 2) {
            return -1;
        }

        Queue<int[]> queue = new LinkedList<>();
        Set<String> visited = new HashSet<>();

        queue.add(new int[]{1, 0, 1});
        queue.add(new int[]{N, 0, -1});
        visited.add(1 + ",1");
        visited.add(N + ",-1");

        while (!queue.isEmpty()) {
            int[] current = queue.poll();
            int position = current[0];
            int time = current[1];
            int who = current[2];

            if (who == 1) {
                int[] nextPositions = {position + 2, position + 3};
                for (int next : nextPositions) {
                    if (next <= N) {
                        String key = next + "," + who;
                        if (!visited.contains(key)) {
                            visited.add(key);
                            queue.add(new int[]{next, time + 1, who});
                        }
                    }
                }
            } else {
                int[] nextPositions = {position - 1, position - 2};
                for (int next : nextPositions) {
                    if (next > 0) {
                        String key = next + "," + who;
                        if (!visited.contains(key)) {
                            visited.add(key);
                            queue.add(new int[]{next, time + 1, who});
                        }
                    }
                }
            }

            for (int[] state : queue) {
                if (state[0] == position && state[1] == time && state[2] != who) {
                    return time + 1;
                }
            }
        }

        return -1;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int N = scanner.nextInt();
        System.out.println(findMeetingTime(N));
    }
}
