import java.util.*;

public class Main {
    static class Point {
        int x, y, index;
        boolean isBlue;

        Point(int x, int y, int index, boolean isBlue) {
            this.x = x;
            this.y = y;
            this.index = index;
            this.isBlue = isBlue;
        }
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        int t = scanner.nextInt();

        for (int testCase = 0; testCase < t; testCase++) {
            int n = scanner.nextInt();
            List<Point> bluePoints = new ArrayList<>();
            List<Point> redPoints = new ArrayList<>();

            for (int i = 0; i < n; i++) {
                int x = scanner.nextInt();
                int y = scanner.nextInt();
                bluePoints.add(new Point(x, y, i + 1, true));
            }
            
            for (int i = 0; i < n; i++) {
                int x = scanner.nextInt();
                int y = scanner.nextInt();
                redPoints.add(new Point(x, y, i + 1, false));
            }

            if (!pairPoints(bluePoints, redPoints)) {
                System.out.println(0);
            }
        }

        scanner.close();
    }

    private static boolean pairPoints(List<Point> bluePoints, List<Point> redPoints) {
        int n = bluePoints.size();
        List<int[]> result = new ArrayList<>();

        bluePoints.sort(Comparator.comparingInt((Point p) -> p.x).thenComparingInt(p -> p.y));
        redPoints.sort(Comparator.comparingInt((Point p) -> p.x).thenComparingInt(p -> p.y));

        for (int i = 0; i < n; i++) {
            result.add(new int[]{bluePoints.get(i).index, redPoints.get(i).index});
        }

        if (validatePairs(bluePoints, redPoints)) {
            for (int[] pair : result) {
                System.out.println(pair[0] + " " + pair[1]);
            }
            return true;
        }
        return false;
    }

    private static boolean validatePairs(List<Point> bluePoints, List<Point> redPoints) {
        int n = bluePoints.size();
        for (int i = 0; i < n; i++) {
            for (int j = i + 1; j < n; j++) {
                if (segmentsIntersect(bluePoints.get(i), redPoints.get(i), bluePoints.get(j), redPoints.get(j))) {
                    return false;
                }
            }
        }
        return true;
    }

    private static boolean segmentsIntersect(Point p1, Point p2, Point p3, Point p4) {
        return orientation(p1, p2, p3) != orientation(p1, p2, p4) &&
                orientation(p3, p4, p1) != orientation(p3, p4, p2);
    }

    private static int orientation(Point p, Point q, Point r) {
        int val = (q.y - p.y) * (r.x - q.x) - (q.x - p.x) * (r.y - q.y);
        if (val == 0) return 0; 
        return (val > 0) ? 1 : 2; 
    }
}
