import java.util.*;

public class Main {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int N = sc.nextInt();
        
        int[] aliceDist = new int[N + 1];
        int[] bobDist = new int[N + 1];
        Arrays.fill(aliceDist, -1);
        Arrays.fill(bobDist, -1);

        Queue<Integer> queue = new LinkedList<>();
        
        // Aліса
        queue.add(1);
        aliceDist[1] = 0;
        while (!queue.isEmpty()) {
            int k = queue.poll();
            for (int move : new int[]{2, 3}) {
                int newPos = k + move;
                if (newPos <= N && aliceDist[newPos] == -1) {
                    aliceDist[newPos] = aliceDist[k] + 1;
                    queue.add(newPos);
                }
            }
        }

        // Боб
        queue.clear();
        queue.add(N);
        bobDist[N] = 0;
        while (!queue.isEmpty()) {
            int k = queue.poll();
            for (int move : new int[]{1, 2}) {
                int newPos = k - move;
                if (newPos >= 1 && bobDist[newPos] == -1) {
                    bobDist[newPos] = bobDist[k] + 1;
                    queue.add(newPos);
                }
            }
        }

        int minTime = Integer.MAX_VALUE;
        for (int i = 1; i <= N; i++) {
            if (aliceDist[i] != -1 && bobDist[i] != -1) {
                minTime = Math.min(minTime, Math.max(aliceDist[i], bobDist[i]));
            }
        }

        System.out.println(minTime == Integer.MAX_VALUE ? -1 : minTime);
    }
}
