from collections import deque

def can_meet(n: int):
    alice_position = 1
    bob_position = n
    visited_alice = set()
    visited_bob = set()
    queue_alice = deque([(alice_position, 0)])
    queue_bob = deque([(bob_position, 0)])
    while queue_alice:
        position, time = queue_alice.popleft()
        if position in visited_bob:
            return True, time
        visited_alice.add(position)

        for move in [2, 3]:
            next_position = position + move
            if next_position <= n and next_position not in visited_alice:
                queue_alice.append((next_position, time + 1))

    while queue_bob:
        position, time = queue_bob.popleft()
        if position in visited_alice:
            return True, time
        visited_bob.add(position)

        for move in [1, 2]:
            next_position = position - move
            if next_position >= 1 and next_position not in visited_bob:
                queue_bob.append((next_position, time + 1))

    return False, -1


if __name__ == "__main__":
    n = int(input("Enter the number of boxes (N): "))
    can_meet_result, min_time = can_meet(n)
    
    if can_meet_result:
        print(f"Alice and Bob can meet in {min_time} seconds.")
    else:
        print("Alice and Bob cannot meet.")