def can_connect(p1, p2, p3, p4):
    def orientation(a, b, c):
        return (b[1] - a[1]) * (c[0] - b[0]) - (b[0] - a[0]) * (c[1] - b[1])

    o1 = orientation(p1, p2, p3)
    o2 = orientation(p1, p2, p4)
    o3 = orientation(p3, p4, p1)
    o4 = orientation(p3, p4, p2)

    return o1 * o2 < 0 and o3 * o4 < 0


def solve(t, test_cases):
    results = []

    for case in test_cases:
        N, blue_points, red_points = case

        blue_points_sorted = sorted(blue_points)
        red_points_sorted = sorted(red_points)

        pairs = []
        possible = True
        for i in range(N):
            pairs.append((blue_points_sorted[i][2], red_points_sorted[i][2]))

        for i in range(N):
            for j in range(i + 1, N):
                if can_connect(blue_points_sorted[i], red_points_sorted[i], blue_points_sorted[j],
                               red_points_sorted[j]):
                    possible = False
                    break
            if not possible:
                break

        if possible:
            results.append(pairs)
        else:
            results.append([0])

    return results


t = int(input())
test_cases = []
for _ in range(t):
    N = int(input())
    blue_points = []
    red_points = []
    for i in range(N):
        x, y = map(int, input().split())
        blue_points.append((x, y, i + 1))
    for i in range(N):
        x, y = map(int, input().split())
        red_points.append((x, y, i + 1))
    test_cases.append((N, blue_points, red_points))

results = solve(t, test_cases)

for result in results:
    if result == [0]:
        print(0)
    else:
        for pair in result:
            print(pair[0], pair[1])
