import random
from collections import deque

def min_time_to_meet(N):
    queue = deque([(1, N, 0)])
    
    visited_alice = set([1])
    visited_bob = set([N])
    
    while queue:
        alice_pos, bob_pos, seconds = queue.popleft()
        
        if alice_pos == bob_pos:
            return seconds
        
        alice_move = alice_pos + random.choice([2, 3])
        if 1 <= alice_move <= N and alice_move not in visited_alice:
            visited_alice.add(alice_move)
            queue.append((alice_move, bob_pos, seconds + 1))
        
        bob_move = bob_pos - random.choice([1, 2])
        if 1 <= bob_move <= N and bob_move not in visited_bob:
            visited_bob.add(bob_move)
            queue.append((alice_pos, bob_move, seconds + 1))
    
    return -1

N = int(input())

print(min_time_to_meet(N))