from collections import deque

def solve(N):
    alice_queue = deque([1])
    bob_queue = deque([N])
    
    alice_visited = [False] * (N + 1)
    bob_visited = [False] * (N + 1)
    
    alice_visited[1] = True
    bob_visited[N] = True
    
    time = 0
    
    while alice_queue and bob_queue:
        time += 1
        
        for _ in range(len(alice_queue)):
            pos = alice_queue.popleft()
            if bob_visited[pos]:
                return time
            
            for move in [2, 3]:
                new_pos = pos + move
                if new_pos <= N and not alice_visited[new_pos]:
                    alice_visited[new_pos] = True
                    alice_queue.append(new_pos)
        
        for _ in range(len(bob_queue)):
            pos = bob_queue.popleft()
            if alice_visited[pos]:
                return time
            
            for move in [-1, -2]:
                new_pos = pos + move
                if new_pos >= 1 and not bob_visited[new_pos]:
                    bob_visited[new_pos] = True
                    bob_queue.append(new_pos)
    
    return -1

N = int(input())
print(solve(N))
