from collections import deque

def min_teleportation_time(N):
    alice_queue = deque([(1, 0)])  
    bob_queue = deque([(N, 0)])    
    
    alice_visited = set([1])
    bob_visited = set([N])
    
    while alice_queue:
        alice_pos, alice_time = alice_queue.popleft()
        
        for move in [2, 3]:
            next_alice_pos = alice_pos + move
            if next_alice_pos <= N and next_alice_pos not in alice_visited:
                alice_visited.add(next_alice_pos)
                alice_queue.append((next_alice_pos, alice_time + 1))
                
                if next_alice_pos in bob_visited:
                    return alice_time + 1
    
    while bob_queue:
        bob_pos, bob_time = bob_queue.popleft()
        
        for move in [1, 2]:
            next_bob_pos = bob_pos - move
            if next_bob_pos >= 1 and next_bob_pos not in bob_visited:
                bob_visited.add(next_bob_pos)
                bob_queue.append((next_bob_pos, bob_time + 1))
                
                if next_bob_pos in alice_visited:
                    return bob_time + 1
    
    return -1  

print(min_teleportation_time(5))  
print(min_teleportation_time(9))  
