from collections import deque

def min_teleportation_time(N):
    if N == 2:
        return 1

    alice_queue = deque([1])
    bob_queue = deque([N])
    alice_visited = {1}
    bob_visited = {N}

    seconds = 0
    while alice_queue and bob_queue:
        seconds += 1
        
        for _ in range(len(alice_queue)):
            alice_pos = alice_queue.popleft()
            for move in [2, 3]:
                next_alice_pos = alice_pos + move
                if next_alice_pos <= N and next_alice_pos not in alice_visited:
                    alice_visited.add(next_alice_pos)
                    alice_queue.append(next_alice_pos)
                    if next_alice_pos in bob_visited:
                        return seconds
        
        for _ in range(len(bob_queue)):
            bob_pos = bob_queue.popleft()
            for move in [1, 2]:
                next_bob_pos = bob_pos - move
                if next_bob_pos >= 1 and next_bob_pos not in bob_visited:
                    bob_visited.add(next_bob_pos)
                    bob_queue.append(next_bob_pos)
                    if next_bob_pos in alice_visited:
                        return seconds
    
    return -1


print(min_teleportation_time(5))
print(min_teleportation_time(9))
print(min_teleportation_time(1000000000))