from collections import deque

def min_seconds(N):
    alice_positions = deque([1])
    bob_positions = deque([N])
    
    alice_visited = set([1])
    bob_visited = set([N])
    
    seconds = 0
    
    while alice_positions and bob_positions:
        seconds += 1
        
        for _ in range(len(alice_positions)):
            current = alice_positions.popleft()
            for next_pos in [current + 2, current + 3]:
                if 1 <= next_pos <= N and next_pos not in alice_visited:
                    alice_visited.add(next_pos)
                    alice_positions.append(next_pos)
        
        for _ in range(len(bob_positions)):
            current = bob_positions.popleft()
            for next_pos in [current - 1, current - 2]:
                if 1 <= next_pos <= N and next_pos not in bob_visited:
                    bob_visited.add(next_pos)
                    bob_positions.append(next_pos)
        
        if alice_visited & bob_visited:
            return seconds
    
    return -1

N = int(input())

print(min_seconds(N))
