from collections import deque

def teleportation(N):
    alice_queue = deque([1])
    alice_time = {1: 0}
    
    while alice_queue:
        pos = alice_queue.popleft()
        time = alice_time[pos]
        
        for next_pos in (pos + 2, pos + 3):
            if next_pos <= N and next_pos not in alice_time:
                alice_time[next_pos] = time + 1
                alice_queue.append(next_pos)
    
    bob_queue = deque([N])
    bob_time = {N: 0}
    
    while bob_queue:
        pos = bob_queue.popleft()
        time = bob_time[pos]
        
        for next_pos in (pos - 1, pos - 2):
            if next_pos >= 1 and next_pos not in bob_time:
                bob_time[next_pos] = time + 1
                bob_queue.append(next_pos)
    
    min_time = float('inf')
    for pos in alice_time:
        if pos in bob_time:
            min_time = min(min_time, max(alice_time[pos], bob_time[pos]))
    
    if min_time == float('inf'):
        return -1
    
    return min_time

N = int(input())
print(teleportation(N))