import random

def solve():
    N = int(input())  # Розмір квадрата
    grid = [list(map(int, input().split())) for _ in range(N)]  # Сітка точок (червоний/синій)

    squares = []  # Список для збереження знайдених квадратів

    # Проходимо по всіх можливих квадратах
    for i1 in range(N):
        for j1 in range(N):
            if grid[i1][j1] == 1:  # шукаємо тільки червоні точки
                for i2 in range(i1 + 1, N):
                    for j2 in range(j1 + 1, N):
                        # Перевіряємо, чи точка (i2, j2) з цієї ж кольору
                        if grid[i2][j2] == 1:
                            if grid[i1][j2] == 1 and grid[i2][j1] == 1:
                                # Якщо всі 4 вершини однакові, зберігаємо квадрат
                                squares.append([(i1, j1), (i2, j2), (i1, j2), (i2, j1)])

    if squares:
        # Якщо є знайдені квадрати, вибираємо випадковий
        square = random.choice(squares)
        # Виводимо індекси точок (вивести як 1-базовані індекси)
        for (i, j) in square:
            print(i + 1, j + 1)
    else:
        # Якщо квадратів немає, виводимо 0
        print(0)

# Запуск програми
solve()
