#include <chrono>
#include <random>
#include <thread>
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define lf long double
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

struct point {
  ll x;
  ll y;
  ll ind;
  bool red;
};

ll dist(const point &first, const point &second) {
  return (first.x - second.x) * (first.x - second.x) +
         (first.y - second.y) * (first.y - second.y);
}

bool intersect(point a, point b, point c, point d) {
  // first line
  // k(a.x-b.x)=a.y-b.y
  // k=(a.y-b.y)/(a.x-b.x)
  // b=a.y-k*a.x
  lf k1 = (a.y - b.y) / (lf)(a.x - b.x);
  lf b1 = a.y - k1 * a.x;
  lf k2 = (c.y - d.y) / (lf)(c.x - d.x);
  lf b2 = c.y - k2 * c.x;
  // k1x+b1=k2x+b2
  // (k1-k2)x=b2-b1
  if (k1 == k2) {
    return b1 == b2;
  }
  lf x = (b2 - b1) / (k1 - k2);
  if (a.x > b.x) {
    swap(a.x, b.x);
  }
  if (c.x > d.x) {
    swap(c.x, d.x);
  }
  return a.x <= x && c.x <= x && x <= b.x && x <= d.x;
}

mt19937 gen(69420);

int main() {
  ios_base::sync_with_stdio();
  cin.tie(0);
  cout.tie(0);
  ll n, t, a, b, c, d, e, f, g;
  bool bl, bl2;
  cin >> t;
  while (t--) {
    cin >> n;
    vector<point> red;
    vector<point> blue;
    vector<pair<ll, ll>> ans;
    for (ll i = 0; i < n; i++) {
      cin >> a >> b;
      blue.push_back({a, b, i + 1});
    }
    for (ll i = 0; i < n; i++) {
      cin >> a >> b;
      red.push_back({a, b, i + 1});
    }
    ll attempts = 10;
    /*sort(all(blue), [](const point &first, const point &second) {
      if (first.x != second.x) {
        return first.x < second.x;
      }
      return first.y < second.y;
    });*/
    shuffle(all(red), gen);
    bl = true;
    for (ll i = 0; i < n; i++) {
      for (ll j = 0; j < i; j++) {
        if (intersect(blue[i], red[i], blue[j], red[j])) {
          bl = false;
          break;
        }
      }
    }
    if (!bl) {
      cout << 0 << nl;
      continue;
    }
    for (ll i = 0; i < n; i++) {
      cout << blue[i].ind << " " << red[i].ind << nl;
    }
  }
}
