from collections import deque

def teleportation(N):
    # BFS для Аліси
    alice_visited = set()
    bob_visited = set()

    # Черга для Аліси та Боба (номер боксів, час)
    alice_queue = deque([(1, 0)])  # Початковий бокс 1, 0 секунд
    bob_queue = deque([(N, 0)])    # Початковий бокс N, 0 секунд

    alice_visited.add(1)
    bob_visited.add(N)

    while alice_queue or bob_queue:
        # Крок для Аліси
        if alice_queue:
            a_b, a_time = alice_queue.popleft()
            # Якщо зустрілися
            if a_b in bob_visited:
                return a_time
            # Можливі переміщення Аліси
            for next_a in [a_b + 2, a_b + 3]:
                if next_a <= N and next_a not in alice_visited:
                    alice_visited.add(next_a)
                    alice_queue.append((next_a, a_time + 1))

        # Крок для Боба
        if bob_queue:
            b_b, b_time = bob_queue.popleft()
            # Якщо зустрілися
            if b_b in alice_visited:
                return b_time
            # Можливі переміщення Боба
            for next_b in [b_b - 1, b_b - 2]:
                if next_b >= 1 and next_b not in bob_visited:
                    bob_visited.add(next_b)
                    bob_queue.append((next_b, b_time + 1))

    return -1

# Зчитуємо вхід
N = int(input())

# Виводимо результат
print(teleportation(N))
