from collections import deque

def min_teleportation_time(N):
    # Якщо є лише два бокси, то зустріч може статися миттєво
    if N == 2:
        return 1
    
    # Черги для пошуку BFS
    alice_positions = deque([1])  # Аліса починає з 1
    bob_positions = deque([N])    # Боб починає з N
    
    # Множини для відслідковування відвіданих боксів
    alice_visited = set([1])
    bob_visited = set([N])
    
    # Час
    time = 0
    
    # Поки є можливість переміщатися
    while alice_positions and bob_positions:
        time += 1
        
        # Розширюємо позиції Аліси
        for _ in range(len(alice_positions)):
            current = alice_positions.popleft()
            for next_position in (current + 2, current + 3):
                if next_position <= N and next_position not in alice_visited:
                    if next_position in bob_visited:
                        return time
                    alice_visited.add(next_position)
                    alice_positions.append(next_position)
        
        # Розширюємо позиції Боба
        for _ in range(len(bob_positions)):
            current = bob_positions.popleft()
            for next_position in (current - 1, current - 2):
                if next_position >= 1 and next_position not in bob_visited:
                    if next_position in alice_visited:
                        return time
                    bob_visited.add(next_position)
                    bob_positions.append(next_position)
    
    # Якщо не знайдено, виводимо -1
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))