from collections import deque

def min_teleportation_time(N):
    # BFS для пошуку мінімальної кількості секунд
    # Початкові позиції: Аліса на 1, Боб на N
    alice = deque([1])
    bob = deque([N])
    
    visited_alice = set([1])
    visited_bob = set([N])
    
    time = 0
    while alice and bob:
        time += 1
        # Рухаємо Алісу
        next_alice = deque()
        for pos in alice:
            for move in [2, 3]:
                new_pos = pos + move
                if new_pos <= N and new_pos not in visited_alice:
                    visited_alice.add(new_pos)
                    next_alice.append(new_pos)
        alice = next_alice

        # Рухаємо Боба
        next_bob = deque()
        for pos in bob:
            for move in [1, 2]:
                new_pos = pos - move
                if new_pos >= 1 and new_pos not in visited_bob:
                    visited_bob.add(new_pos)
                    next_bob.append(new_pos)
        bob = next_bob

        # Перевірка на перетин позицій
        if visited_alice & visited_bob:
            return time
    
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))
