from collections import deque

def min_teleportation_time(N):
    # Стартові позиції Аліси та Боба
    alice_pos = 1
    bob_pos = N

    # Кроки телепортації для кожного робота
    alice_moves = [2, 3]
    bob_moves = [-1, -2]
    
    # Черга для BFS
    alice_queue = deque([(alice_pos, 0)])  # (позиція, час)
    bob_queue = deque([(bob_pos, 0)])  # (позиція, час)
    
    # Відвідані клітинки для обох роботів
    alice_visited = set([alice_pos])
    bob_visited = set([bob_pos])

    # Пошук в ширину для обох роботів одночасно
    while alice_queue and bob_queue:
        # Обробляємо Алісу
        alice_pos, alice_time = alice_queue.popleft()
        
        # Перевірка на перетин з Бобом
        if alice_pos in bob_visited:
            return alice_time
        
        # Додаємо нові можливі позиції Аліси
        for move in alice_moves:
            new_pos = alice_pos + move
            if 1 <= new_pos <= N and new_pos not in alice_visited:
                alice_visited.add(new_pos)
                alice_queue.append((new_pos, alice_time + 1))
        
        # Обробляємо Боба
        bob_pos, bob_time = bob_queue.popleft()
        
        # Перевірка на перетин з Алісою
        if bob_pos in alice_visited:
            return bob_time
        
        # Додаємо нові можливі позиції Боба
        for move in bob_moves:
            new_pos = bob_pos + move
            if 1 <= new_pos <= N and new_pos not in bob_visited:
                bob_visited.add(new_pos)
                bob_queue.append((new_pos, bob_time + 1))

    # Якщо неможливо зустрітися
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))
