from collections import deque

def min_time_to_meet(N):
    # Використовуємо дві черги для симуляції руху обох роботів
    queue_A = deque([1])  # Позиції Аліси
    queue_B = deque([N])  # Позиції Боба
    visited_A = set([1])  # Відвідані позиції Аліси
    visited_B = set([N])  # Відвідані позиції Боба
    
    time = 0
    while queue_A and queue_B:
        time += 1
        
        # Аліса рухається
        for _ in range(len(queue_A)):
            pos_A = queue_A.popleft()
            for next_pos_A in [pos_A + 2, pos_A + 3]:
                if next_pos_A <= N and next_pos_A not in visited_A:
                    visited_A.add(next_pos_A)
                    queue_A.append(next_pos_A)
        
        # Боб рухається
        for _ in range(len(queue_B)):
            pos_B = queue_B.popleft()
            for next_pos_B in [pos_B - 1, pos_B - 2]:
                if next_pos_B >= 1 and next_pos_B not in visited_B:
                    visited_B.add(next_pos_B)
                    queue_B.append(next_pos_B)
        
        # Перевіряємо на перетин
        if visited_A & visited_B:
            return time
    
    return -1  # Якщо вони не зустрілись

# Читання вхідного значення
N = int(input().strip())

# Виведення результату
print(min_time_to_meet(N))
