from collections import deque

def min_time_to_meet(N):
    # Якщо N дуже маленьке, ми можемо вирішити задачу безпосередньо
    if N == 2:
        return 1
    
    # Ініціалізація черги для BFS
    queue = deque([(1, N)])  # (позиція Аліси, позиція Боба)
    
    # Час, який потрібен, щоб Аліса і Боб зустрілися
    visited = set()  # Для того, щоб не відвідати одні й ті ж позиції
    visited.add((1, N))
    
    time = 0
    
    # BFS пошук
    while queue:
        for _ in range(len(queue)):
            alice_pos, bob_pos = queue.popleft()
            
            # Якщо Аліса і Боб опинились в одному боксі
            if alice_pos == bob_pos:
                return time
            
            # Рухи Аліси (k + 2 або k + 3)
            for alice_move in [2, 3]:
                new_alice_pos = alice_pos + alice_move
                if new_alice_pos <= N:
                    # Рухи Боба (k - 1 або k - 2)
                    for bob_move in [1, 2]:
                        new_bob_pos = bob_pos - bob_move
                        if new_bob_pos >= 1:
                            if (new_alice_pos, new_bob_pos) not in visited:
                                visited.add((new_alice_pos, new_bob_pos))
                                queue.append((new_alice_pos, new_bob_pos))
        
        # Збільшуємо час на одну секунду
        time += 1
    
    # Якщо вони не можуть зустрітися
    return -1

# Читання вхідного значення
N = int(input().strip())

# Виведення результату
print(min_time_to_meet(N))
