from collections import deque

def min_time_to_meet(N):
    # Ініціалізація двох наборів для позицій Аліси та Боба
    alice_positions = set([1])  # Початкова позиція Аліси
    bob_positions = set([N])    # Початкова позиція Боба

    # Час початковий
    time = 0

    # Поки є спільні позиції у Аліси та Боба, продовжуємо рух
    while alice_positions and bob_positions:
        time += 1

        # Нові позиції для Аліси і Боба на поточну секунду
        new_alice_positions = set()
        new_bob_positions = set()

        # Рухи Аліси (k + 2 або k + 3)
        for pos in alice_positions:
            if pos + 2 <= N:
                new_alice_positions.add(pos + 2)
            if pos + 3 <= N:
                new_alice_positions.add(pos + 3)

        # Рухи Боба (k - 1 або k - 2)
        for pos in bob_positions:
            if pos - 1 >= 1:
                new_bob_positions.add(pos - 1)
            if pos - 2 >= 1:
                new_bob_positions.add(pos - 2)

        # Перевірка на перетин позицій Аліси та Боба
        if new_alice_positions & new_bob_positions:
            return time

        # Оновлюємо позиції для наступної секунди
        alice_positions = new_alice_positions
        bob_positions = new_bob_positions

    # Якщо перетину не сталося
    return -1

# Читання вхідного значення
N = int(input().strip())

# Виведення результату
print(min_time_to_meet(N))
