from collections import deque

def min_teleportation_time(N):
    if N == 2:
        return 1

    # Initialize queues and visited sets for both Alice and Bob
    alice_positions = deque([1])
    bob_positions = deque([N])
    alice_visited = set([1])
    bob_visited = set([N])

    time = 0

    # Bidirectional BFS - while both positions are not exhausted
    while alice_positions and bob_positions:
        time += 1

        # Expand Alice's positions (increasing direction)
        for _ in range(len(alice_positions)):
            current = alice_positions.popleft()
            for next_position in (current + 2, current + 3):
                if next_position <= N and next_position not in alice_visited:
                    if next_position in bob_visited:
                        return time
                    alice_visited.add(next_position)
                    alice_positions.append(next_position)

        # Expand Bob's positions (decreasing direction)
        for _ in range(len(bob_positions)):
            current = bob_positions.popleft()
            for next_position in (current - 1, current - 2):
                if next_position >= 1 and next_position not in bob_visited:
                    if next_position in alice_visited:
                        return time
                    bob_visited.add(next_position)
                    bob_positions.append(next_position)

    return -1  # If no solution found

# Read input and output the result
N = int(input().strip())
print(min_teleportation_time(N))
