from collections import deque

def min_teleportation_time(N):
    # Handle the trivial case where N=2 directly
    if N == 2:
        return 1

    # Initialize two queues, one for Alice and one for Bob
    alice_queue = deque([1])
    bob_queue = deque([N])
    
    # Sets to track visited positions for both Alice and Bob
    alice_visited = set([1])
    bob_visited = set([N])

    # Time counter
    time = 0

    # Start the bidirectional BFS
    while alice_queue and bob_queue:
        time += 1
        
        # Expand Alice's positions (1 + 2 or 1 + 3)
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for next_pos in (current + 2, current + 3):
                if next_pos <= N and next_pos not in alice_visited:
                    # If Alice meets Bob
                    if next_pos in bob_visited:
                        return time
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)

        # Expand Bob's positions (N - 1 or N - 2)
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for next_pos in (current - 1, current - 2):
                if next_pos >= 1 and next_pos not in bob_visited:
                    # If Bob meets Alice
                    if next_pos in alice_visited:
                        return time
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)

    return -1  # Return -1 if no solution found

# Read input
N = int(input().strip())

# Output the result
print(min_teleportation_time(N))
