from collections import deque

def min_teleportation_time(N):
    # Edge case when N = 2
    if N == 2:
        return 1

    # Initialize the queues for Alice and Bob
    alice_queue = deque([1])
    bob_queue = deque([N])
    
    # Initialize visited sets
    alice_visited = {1}
    bob_visited = {N}

    # Start time
    time = 0

    while alice_queue and bob_queue:
        time += 1
        
        # Expand Alice's positions: Alice can move to k+2 or k+3
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for next_pos in (current + 2, current + 3):
                if next_pos <= N and next_pos not in alice_visited:
                    # Check if Alice meets Bob
                    if next_pos in bob_visited:
                        return time
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)

        # Expand Bob's positions: Bob can move to k-1 or k-2
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for next_pos in (current - 1, current - 2):
                if next_pos >= 1 and next_pos not in bob_visited:
                    # Check if Bob meets Alice
                    if next_pos in alice_visited:
                        return time
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)

    return -1

# Input and output
N = int(input().strip())
print(min_teleportation_time(N))
