from collections import deque

def min_teleportation_time(N):
    # Edge case when N = 2 (Alice and Bob are already adjacent)
    if N == 2:
        return 1

    # Initialize queues for BFS (Bidirectional Search)
    alice_queue = deque([1])
    bob_queue = deque([N])

    # Sets to track visited positions
    alice_visited = {1}
    bob_visited = {N}

    # Time starts at 0
    time = 0

    # Perform Bidirectional BFS
    while alice_queue and bob_queue:
        time += 1
        
        # Expand Alice's possible moves
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for next_pos in (current + 2, current + 3):
                if next_pos <= N and next_pos not in alice_visited:
                    if next_pos in bob_visited:
                        return time
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)

        # Expand Bob's possible moves
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for next_pos in (current - 1, current - 2):
                if next_pos >= 1 and next_pos not in bob_visited:
                    if next_pos in alice_visited:
                        return time
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)

    return -1

# Input and output handling
N = int(input().strip())
print(min_teleportation_time(N))
