from collections import deque

def min_teleportation_time(N):
    if N == 2:
        return 1  # If N is 2, they meet immediately in one second

    # Initialize BFS queues for Alice and Bob
    alice_queue = deque([1])
    bob_queue = deque([N])

    # Sets to track visited positions for Alice and Bob
    alice_visited = {1}
    bob_visited = {N}

    # Time counter
    time = 0

    # Perform bidirectional BFS
    while alice_queue and bob_queue:
        time += 1

        # Expand Alice's positions for the current second
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for next_pos in (current + 2, current + 3):
                if next_pos <= N and next_pos not in alice_visited:
                    # Check if Alice meets Bob
                    if next_pos in bob_visited:
                        return time
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)

        # Expand Bob's positions for the current second
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for next_pos in (current - 1, current - 2):
                if next_pos >= 1 and next_pos not in bob_visited:
                    # Check if Bob meets Alice
                    if next_pos in alice_visited:
                        return time
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)

    # If no common position is found
    return -1

# Input
N = int(input().strip())

# Output result
print(min_teleportation_time(N))
