from collections import deque

def min_teleportation_time(N):
    # Якщо є лише два бокси, то зустріч може статися миттєво
    if N == 2:
        return 1
    
    # Черга для BFS, де кожен елемент містить пару (позиція, хто це: 0 - Аліса, 1 - Боб)
    queue = deque([(1, 0), (N, 1)])  # Початкові позиції Аліси та Боба
    # Відвідані позиції для Аліси та Боба
    visited = set([(1, 0), (N, 1)])
    
    # Час
    time = 0
    
    while queue:
        time += 1
        
        # Кількість елементів у черзі на поточному рівні часу
        for _ in range(len(queue)):
            current_position, who = queue.popleft()

            # Переміщення для Аліси та Боба
            if who == 0:  # Якщо це Аліса
                for next_position in (current_position + 2, current_position + 3):
                    if next_position <= N and (next_position, 0) not in visited:
                        # Якщо Аліса потрапила на позицію, де є Боб
                        if (next_position, 1) in visited:
                            return time
                        visited.add((next_position, 0))
                        queue.append((next_position, 0))
            else:  # Якщо це Боб
                for next_position in (current_position - 1, current_position - 2):
                    if next_position >= 1 and (next_position, 1) not in visited:
                        # Якщо Боб потрапив на позицію, де є Аліса
                        if (next_position, 0) in visited:
                            return time
                        visited.add((next_position, 1))
                        queue.append((next_position, 1))
    
    # Якщо не знайдено, виводимо -1
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))

