from collections import deque

def min_teleportation_time(N):
    # Якщо кількість боксів парна, зустріч неможлива
    if N % 2 == 0:
        return -1

    # Ініціалізація черг для BFS
    alice_queue = deque([1])
    bob_queue = deque([N])

    # Відвідані позиції
    alice_visited = {1}
    bob_visited = {N}

    # Лічильник часу
    time = 0

    # Двосторонній BFS
    while alice_queue and bob_queue:
        time += 1

        # Розширення позицій Аліси
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for next_pos in (current + 2, current + 3):
                if next_pos <= N and next_pos not in alice_visited:
                    # Перевірка зустрічі з Бобом
                    if next_pos in bob_visited:
                        return time
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)

        # Розширення позицій Боба
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for next_pos in (current - 1, current - 2):
                if next_pos >= 1 and next_pos not in bob_visited:
                    # Перевірка зустрічі з Алісою
                    if next_pos in alice_visited:
                        return time
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)

    # Якщо зустріч неможлива
    return -1

# Введення
N = int(input().strip())

# Виведення результату
print(min_teleportation_time(N))