from collections import deque

def min_teleportation_time(N):
    # Якщо кількість боксів парна, зустріч неможлива
    if N % 2 == 0:
        return -1

    # Черги для BFS
    alice_queue = deque([1])  # Аліса починає з 1
    bob_queue = deque([N])    # Боб починає з N

    # Відвідані позиції
    alice_visited = {1}
    bob_visited = {N}

    time = 0

    while alice_queue and bob_queue:
        time += 1

        # Розширюємо позиції Аліси
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for next_pos in (current + 2, current + 3):
                if next_pos > N:
                    continue
                if next_pos in bob_visited:
                    return time
                if next_pos not in alice_visited:
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)

        # Розширюємо позиції Боба
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for next_pos in (current - 1, current - 2):
                if next_pos < 1:
                    continue
                if next_pos in alice_visited:
                    return time
                if next_pos not in bob_visited:
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)

    return -1  # Якщо зустріч неможлива

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))