from collections import deque

def min_teleportation_time(N):
    # Якщо кількість боксів парна, зустріч неможлива
    if N % 2 == 0:
        return -1

    # Черги для BFS
    alice_queue = deque([1])  # Аліса починає з 1
    bob_queue = deque([N])    # Боб починає з N

    # Відвідані позиції
    alice_visited = {1}
    bob_visited = {N}

    time = 0

    while alice_queue and bob_queue:
        time += 1

        # Розширюємо позиції Аліси
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for next_pos in (current + 2, current + 3):
                if next_pos > N:
                    continue
                if next_pos in bob_visited:
                    return time
from collections import deque

def min_teleportation_time(N):
    # Якщо кількість боксів парна, вони не зможуть зустрітися
    if N % 2 == 0:
        return -1

    # Черга для BFS (початкова позиція для Аліси і Боба)
    alice_queue = deque([1])  # Аліса починає з першого бокс
    bob_queue = deque([N])    # Боб починає з останнього бокс

    # Відвідані позиції
    alice_visited = {1}
    bob_visited = {N}

    time = 0  # Час

    while alice_queue and bob_queue:
        time += 1
        
        # Розширюємо позиції Аліси
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for next_pos in (current + 2, current + 3):
                if next_pos <= N and next_pos not in alice_visited:
                    if next_pos in bob_visited:  # Якщо зустрілися з Бобом
                        return time
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)
        
        # Розширюємо позиції Боба
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for next_pos in (current - 1, current - 2):
                if next_pos >= 1 and next_pos not in bob_visited:
                    if next_pos in alice_visited:  # Якщо зустрілися з Алісою
                        return time
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)

    return -1  # Якщо зустріч неможлива

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))