from collections import deque

def min_teleportation_time(N):
    # Якщо Аліса і Боб починають в одному боксі
    if N == 2:
        return 0
    
    # Черги для BFS
    alice_queue = deque([1])  # Черга для Аліси
    bob_queue = deque([N])    # Черга для Боба
    
    # Множини для відслідковування відвіданих боксів
    alice_visited = {1}
    bob_visited = {N}
    
    time = 0
    
    # Поки є можливість рухатися, виконуємо пошук
    while alice_queue and bob_queue:
        time += 1
        
        # Розширюємо позиції Аліси
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for next_pos in (current + 2, current + 3):  # Аліса може переміщуватися на +2 або +3
                if next_pos <= N and next_pos not in alice_visited:
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)
                    
                    # Перевіряємо, чи Аліса потрапила на бокс, який вже відвідав Боб
                    if next_pos in bob_visited:
                        return time
        
        # Розширюємо позиції Боба
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for next_pos in (current - 1, current - 2):  # Боб може переміщуватися на -1 або -2
                if next_pos >= 1 and next_pos not in bob_visited:
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)
                    
                    # Перевіряємо, чи Боб потрапив на бокс, який вже відвідувала Аліса
                    if next_pos in alice_visited:
                        return time
    
    # Якщо вони не зустрілися, повертаємо -1
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))