def count_colored_squares(N, grid):
    count = 0

    # Iterate over all possible top-left corners of squares
    for i in range(N):
        for j in range(N):
            # Check all possible square sizes
            for size in range(1, N - max(i, j)):
                # Get the four corners of the square
                top_left = grid[i][j]
                top_right = grid[i][j + size]
                bottom_left = grid[i + size][j]
                bottom_right = grid[i + size][j + size]

                # Check if all corners are the same color
                if top_left == top_right == bottom_left == bottom_right:
                    count += 1

    return count


# Input reading
N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]

# Calculate and print the result
result = count_colored_squares(N, grid)
print(result)

Explanation:
 1. Nested Loops:
      •   Iterate over all possible top-left corners (i, j) of the squares within the grid.
      •   For each top-left corner, iterate over all possible square sizes size such that the square remains within bounds.
 2. Corner Extraction:
      •   Extract the values of the four corners of the square.
      •   (i, j) for top-left, (i, j+size) for top-right, (i+size, j) for bottom-left, and (i+size, j+size) for bottom-right.
 3. Comparison:
      •   Check if all four corners have the same color (0 or 1). If they do, increment the counter.
 4. Output:
      •   Finally, return the count of squares that meet the criteria.

This implementation works efficiently given the constraints .