from collections import deque

def min_teleportation_time(N):
    # Черга для Аліси і Боба
    alice_queue = deque([1])
    bob_queue = deque([N])
    
    # Відвідані клітинки для Аліси і Боба
    alice_visited = set([1])
    bob_visited = set([N])
    
    # Кроки телепортації для кожного робота
    alice_steps = [2, 3]
    bob_steps = [-1, -2]
    
    # Час
    time = 0
    
    while alice_queue and bob_queue:
        time += 1
        
        # Розширення Аліси
        for _ in range(len(alice_queue)):
            current = alice_queue.popleft()
            for step in alice_steps:
                next_pos = current + step
                if next_pos <= N and next_pos not in alice_visited:
                    if next_pos in bob_visited:
                        return time
                    alice_visited.add(next_pos)
                    alice_queue.append(next_pos)
        
        # Розширення Боба
        for _ in range(len(bob_queue)):
            current = bob_queue.popleft()
            for step in bob_steps:
                next_pos = current + step
                if next_pos >= 1 and next_pos not in bob_visited:
                    if next_pos in alice_visited:
                        return time
                    bob_visited.add(next_pos)
                    bob_queue.append(next_pos)
    
    # Якщо не знайдено, повертаємо -1
    return -1

# Вхідні дані
N = int(input().strip())

# Вивести результат
print(min_teleportation_time(N))
