N = int(input())
def min_meeting_time(N):
    # Initial positions
    A_positions = {1}
    B_positions = {N}
    
    # We'll limit the search; if they don't meet within N steps, consider it impossible.
    # This is a heuristic bound; for large N it should still work efficiently.
    for t in range(1, N+1):
        # Generate next possible positions for Alice
        next_A_positions = set()
        for pos in A_positions:
            if pos + 2 <= N:
                next_A_positions.add(pos + 2)
            if pos + 3 <= N:
                next_A_positions.add(pos + 3)
        
        # Generate next possible positions for Bob
        next_B_positions = set()
        for pos in B_positions:
            if pos - 1 >= 1:
                next_B_positions.add(pos - 1)
            if pos - 2 >= 1:
                next_B_positions.add(pos - 2)
        
        # Check for intersection
        if next_A_positions & next_B_positions:
            return t
        
        # Update positions
        A_positions = next_A_positions
        B_positions = next_B_positions
        
        # If no positions remain for either, no further movement is possible
        if not A_positions or not B_positions:
            break
    
    return -1

result = min_meeting_time(N)
print(result)