import numpy as np

def get_squares(n, grid):
    count = 0

    # Iterate through all possible top-left points of the square
    for x1 in range(n):
        for y1 in range(n):
            for x2 in range(x1 + 1, n):  # Ensure top-right point is to the right of top-left
                for y2 in range(y1, n):  # Ensure points are aligned properly
                    # Calculate bottom-left (x3, y3) and bottom-right (x4, y4)
                    x3 = x2 - (y2 - y1)
                    y3 = y2 + (x2 - x1)

                    x4 = x1 - (y2 - y1)
                    y4 = y1 + (x2 - x1)

                    # Check bounds
                    if 0 <= x3 < n and 0 <= y3 < n and 0 <= x4 < n and 0 <= y4 < n:
                        # Check if all points have the same value
                        if (grid[x1][y1] == grid[x2][y2] ==
                            grid[x3][y3] == grid[x4][y4]):
                            count += 1

    return count


N = int(input())
grid = [list(map(int, input().split())) for _ in range(N)]
print(get_squares(N, grid))