#include <iostream>
#include <queue>
using namespace std;

int main() {
    int N;
    cin >> N;

    queue<pair<int, int>> alice_queue, bob_queue;

    alice_queue.push({1, 0});
    bob_queue.push({N, 0});

    bool visited_by_alice[1000001] = {false};
    bool visited_by_bob[1000001] = {false};

    visited_by_alice[1] = true;
    visited_by_bob[N] = true;

    while (!alice_queue.empty() || !bob_queue.empty()) {
        if (!alice_queue.empty()) {
            auto [alice_pos, alice_time] = alice_queue.front();
            alice_queue.pop();

            if (visited_by_bob[alice_pos]) {
                cout << alice_time << endl;
                return 0;
            }

            if (alice_pos + 2 <= N && !visited_by_alice[alice_pos + 2]) {
                visited_by_alice[alice_pos + 2] = true;
                alice_queue.push({alice_pos + 2, alice_time + 1});
            }
            if (alice_pos + 3 <= N && !visited_by_alice[alice_pos + 3]) {
                visited_by_alice[alice_pos + 3] = true;
                alice_queue.push({alice_pos + 3, alice_time + 1});
            }
        }

        if (!bob_queue.empty()) {
            auto [bob_pos, bob_time] = bob_queue.front();
            bob_queue.pop();

            if (visited_by_alice[bob_pos]) {
                cout << bob_time << endl;
                return 0;
            }

            if (bob_pos - 1 >= 1 && !visited_by_bob[bob_pos - 1]) {
                visited_by_bob[bob_pos - 1] = true;
                bob_queue.push({bob_pos - 1, bob_time + 1});
            }
            if (bob_pos - 2 >= 1 && !visited_by_bob[bob_pos - 2]) {
                visited_by_bob[bob_pos - 2] = true;
                bob_queue.push({bob_pos - 2, bob_time + 1});
            }
        }
    }

    cout << -1 << endl;
    return 0;
}
