import math

def angle_between_points(p1, p2):
    dx, dy = p2[0] - p1[0], p2[1] - p1[1]
    return math.atan2(dy, dx)

def solve_single_test(n, blue_points, red_points):
    blue_points = [(x, y, i + 1) for i, (x, y) in enumerate(blue_points)]
    red_points = [(x, y, i + 1) for i, (x, y) in enumerate(red_points)]

    pairs = []
    used_red = set()

    for b in blue_points:
        candidates = []
        for r in red_points:
            if r[2] not in used_red:
                angle = angle_between_points(b, r)
                candidates.append((angle, r))
        if not candidates:
            return [0]
        candidates.sort()
        _, selected_red = candidates[0]
        pairs.append((b[2], selected_red[2]))
        used_red.add(selected_red[2])
    
    if len(pairs) < n:
        return [0]
    
    return pairs

def main():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    t = int(data[0])
    results = []
    idx = 1

    for _ in range(t):
        n = int(data[idx])
        idx += 1

        blue_points = [tuple(map(int, data[idx + i].split())) for i in range(n)]
        red_points = [tuple(map(int, data[idx + n + i].split())) for i in range(n)]
        idx += 2 * n

        result = solve_single_test(n, blue_points, red_points)
        results.append(result)

    output = []
    for result in results:
        if result == [0]:
            output.append("0")
        else:
            output.extend(f"{b} {r}" for b, r in result)
            output.append("")
    print("\n".join(output))

if __name__ == "__main__":
    main()
