def orientation(p, q, r):
    return (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])

def do_intersect(a, b, c, d):
    o1 = orientation(a, b, c)
    o2 = orientation(a, b, d)
    o3 = orientation(c, d, a)
    o4 = orientation(c, d, b)
    return o1 * o2 < 0 and o3 * o4 < 0

def solve_case(n, blue, red):
    blue = sorted((x, i + 1) for i, x in enumerate(blue))
    red = sorted((x, i + 1) for i, x in enumerate(red))
    pairs = list(zip([b[1] for b in blue], [r[1] for r in red]))

    for i in range(n):
        for j in range(i + 1, n):
            if do_intersect(blue[i][0], red[i][0], blue[j][0], red[j][0]):
                return [0]
    return pairs

def main():
    t = int(input())
    results = []
    for _ in range(t):
        n = int(input())
        blue = [tuple(map(int, input().split())) for _ in range(n)]
        red = [tuple(map(int, input().split())) for _ in range(n)]
        result = solve_case(n, blue, red)
        results.append(result)
    
    for result in results:
        if result == [0]:
            print(0)
        else:
            for b, r in result:
                print(b, r)

main()
