def can_connect(points_blue, points_red):
    connections = []
    for i in range(len(points_blue)):
        connections.append((points_blue[i], points_red[i]))
    return connections

def solve(test_cases):
    results = []
    for case in test_cases:
        N, blue_points, red_points = case
        blue_points.sort(key=lambda p: (p[0], p[1]))
        red_points.sort(key=lambda p: (p[0], p[1]))

        connections = can_connect(blue_points, red_points)
        results.append(connections)
    return results

def main():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    index = 0
    t = int(data[index])
    index += 1
    test_cases = []
    
    for _ in range(t):
        N = int(data[index])
        index += 1
        blue_points = []
        red_points = []
        
        for _ in range(N):
            x, y = map(int, data[index].split())
            blue_points.append((x, y))
            index += 1
        
        for _ in range(N):
            x, y = map(int, data[index].split())
            red_points.append((x, y))
            index += 1
        
        test_cases.append((N, blue_points, red_points))
    
    results = solve(test_cases)
    
    for connections in results:
        if connections:
            for (blue, red) in connections:
                blue_index = blue_points.index(blue) + 1
                red_index = red_points.index(red) + 1
                print(blue_index, red_index)
        else:
            print(0)

if __name__ == "__main__":
    main()