def do_intersect(p1, q1, p2, q2):
    def orientation(p, q, r):
        val = (q[1] - p[1]) * (r[0] - q[0]) - (q[0] - p[0]) * (r[1] - q[1])
        if val == 0:
            return 0
        return 1 if val > 0 else 2

    o1 = orientation(p1, q1, p2)
    o2 = orientation(p1, q1, q2)
    o3 = orientation(p2, q2, p1)
    o4 = orientation(p2, q2, q1)

    if o1 != o2 and o3 != o4:
        return True

    return False

def can_connect(blue_points, red_points):
    N = len(blue_points)
    pairs = []
    used_red = [False] * N
    used_blue = [-1] * N

    def dfs(blue_index):
        if blue_index == N:
            return True
        for red_index in range(N):
            if not used_red[red_index]:
                can_connect = True
                for b in range(blue_index):
                    if used_blue[b] != -1:
                        if do_intersect(blue_points[b], red_points[used_blue[b]], blue_points[blue_index], red_points[red_index]):
                            can_connect = False
                            break
                if can_connect:
                    used_red[red_index] = True
                    used_blue[blue_index] = red_index
                    if dfs(blue_index + 1):
                        return True
                    used_red[red_index] = False
                    used_blue[blue_index] = -1
        return False

    if dfs(0):
        for i in range(N):
            pairs.append((i + 1, used_blue[i] + 1))
        return pairs
    else:
        return 0

def main():
    import sys
    input = sys.stdin.read
    data = input().splitlines()
    
    index = 0
    t = int(data[index])
    index += 1
    results = []
    
    for _ in range(t):
        N = int(data[index])
        index += 1
        blue_points = []
        red_points = []
        
        for _ in range(N):
            x, y = map(int, data[index].split())
            blue_points.append((x, y))
            index += 1
        
        for _ in range(N):
            x, y = map(int, data[index].split())
            red_points.append((x, y))
            index += 1
        
        result = can_connect(blue_points, red_points)
        if result == 0:
            results.append("0")
        else:
            results.append("\n".join(f"{b} {r}" for b, r in result))
    
    print("\n".join(results))

if __name__ == "__main__":
    main()