#include <iostream>
#include <queue>

using namespace std;

int findMeetingTime(int N) {
    int alicePos = 1, bobPos = N, time = 0;

    queue<pair<int, int>> positions;
    positions.push({alicePos, bobPos});

    while (!positions.empty()) {
        int size = positions.size();
        time++;
        for (int i = 0; i < size; i++) {
            auto [alice, bob] = positions.front();
            positions.pop();

            for (int newAlice : {alice + 2, alice + 3}) {
                if (newAlice == bob) return time;
                if (newAlice <= N) positions.push({newAlice, bob});
                
                for (int newBob : {bob - 1, bob - 2}) {
                    if (newAlice == newBob) return time;
                    if (newBob >= 1) positions.push({alice, newBob});
                }
            }
            
        }
    }

    return -1;
}

int main() {
    int N;
    cin >> N;
    cout << findMeetingTime(N) << endl;
    return 0;
}