#include <iostream>
#include <vector>
#include <algorithm>
#include <limits>

std::vector<int> find_stamps(int N, int M) {
    std::vector<int> dp(M + 1, std::numeric_limits<int>::max());
    std::vector<int> parent(M + 1, -1);
    dp[0] = 0;

    for (int stamp = 1; stamp <= N; ++stamp) {
        for (int value = M; value >= stamp; --value) {
            if (dp[value - stamp] != std::numeric_limits<int>::max() && dp[value - stamp] + 1 < dp[value]) {
                dp[value] = dp[value - stamp] + 1;
                parent[value] = stamp;
            }
        }
    }

    if (dp[M] == std::numeric_limits<int>::max()) {
        return {0};
    }

    std::vector<int> result;
    while (M > 0) {
        result.push_back(parent[M]);
        M -= parent[M];
    }

    std::sort(result.begin(), result.end());
    return result;
}

int main() {
    int N, M;
    std::cin >> N >> M;

    std::vector<int> result = find_stamps(N, M);

    if (result.size() == 1 && result[0] == 0) {
        std::cout << 0 << std::endl;
    } else {
        for (int stamp : result) {
            std::cout << stamp << " ";
        }
        std::cout << std::endl;
    }

    return 0;
}
