#include <bits/stdc++.h>
using namespace std;
struct Pt {
    int idx;
    long long x,y;
    bool blue;
};

static long long cross(const Pt &p,const Pt &q,const Pt &r) {
    return (q.x-p.x)*(r.y-p.y)-(q.y-p.y)*(r.x-p.x);
}

void solve(vector<Pt> &points, vector<pair<int,int>> &pairs) {
    int N=(int)points.size()/2;
    if (N==1) {
        int bidx = -1, ridx = -1;
        for (int i=0; i<(int)points.size(); i++) {
            if (points[i].blue) bidx = i; else ridx = i;
        }
        pairs.push_back({points[bidx].idx, points[ridx].idx});
        return;
    }
    int pivotBlue = -1;
    for (int i=0; i<(int)points.size(); i++) {
        if (points[i].blue) {
            if (pivotBlue == -1 || points[i].x < points[pivotBlue].x ||
               (points[i].x == points[pivotBlue].x && points[i].y < points[pivotBlue].y)) {
                pivotBlue = i;
            }
        }
    }
    Pt B = points[pivotBlue];
    for (int i=0; i<(int)points.size(); i++) {
        if (!points[i].blue) {
            Pt R = points[i];
            if (R.x == B.x && R.y == B.y) continue;
            vector<Pt> leftSet, rightSet;
            for (int j=0; j<(int)points.size(); j++) {
                if (j == i || j == pivotBlue) continue;
                long long c =cross(B,R,points[j]);
                if (c > 0)leftSet.push_back(points[j]); else rightSet.push_back(points[j]);
            }
            int leftBlue=0,leftRed=0;
            for (auto &pp: leftSet) {
                if (pp.blue) leftBlue++; else leftRed++;
            }
            int rightBlue=0, rightRed=0;
            for (auto &pp: rightSet) {
                if (pp.blue) rightBlue++; else rightRed++;
            }
            if (leftBlue == leftRed && rightBlue == rightRed) {
                pairs.push_back({B.idx, R.idx});
                if (!leftSet.empty()) solve(leftSet, pairs);
                if (!rightSet.empty()) solve(rightSet, pairs);
                return;
            }
        }
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t; cin >> t;
    while(t--){
        int N; cin >> N;
        vector<Pt> blues(N), reds(N);
        for (int i=0; i<N; i++){
            cin >> blues[i].x >> blues[i].y;
            blues[i].idx = i+1;
            blues[i].blue = true;
        }
        for (int j=0; j<N; j++){
            cin >> reds[j].x >> reds[j].y;
            reds[j].idx = j+1;
            reds[j].blue = false;
        }
        vector<Pt> allPoints;
        allPoints.reserve(2*N);
        for (auto &b: blues) allPoints.push_back(b);
        for (auto &r: reds) allPoints.push_back(r);
        vector<pair<int,int>> pairs;
        solve(allPoints, pairs);
        if ((int)pairs.size() == N) {
            for (auto &pr: pairs) {
                cout << pr.first << " " << pr.second << "\n";
            }
        } else {
            cout << 0 << "\n";
        }
    }
    return 0;
}