#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x,y;
    int color;
    int idx;
};

int N;
vector<Point> points;
vector<pair<int,int>> ans;

long long orient(const Point &p, const Point &q, const Point &r) {
    long long val = (long long)(q.x - p.x)*(r.y - p.y) - (long long)(q.y - p.y)*(r.x - p.x);
    return val;
}

Point pivot;
bool polarCmp(const Point &A, const Point &B) {
    long long o = orient(pivot,A,B);
    if(o == 0) {
        long long dA=(long long)(A.x - pivot.x)*(A.x - pivot.x)+(long long)(A.y - pivot.y)*(A.y - pivot.y);
        long long dB=(long long)(B.x - pivot.x)*(B.x - pivot.x)+(long long)(B.y - pivot.y)*(B.y - pivot.y);
        return dA < dB;
    }
    return (o > 0);
}

bool solveMatching(int l, int r, vector<int> &idxs) {
    if (r - l == 1) {
        if (points[idxs[l]].color != points[idxs[r]].color) {
            Point A = points[idxs[l]];
            Point B = points[idxs[r]];
            if (A.color == 0) ans.push_back({A.idx, B.idx});
            else ans.push_back({B.idx, A.idx});
            return true;
        } else return false;
    }
    int pivotIndex = l;
    Point P = points[idxs[pivotIndex]];
    int n = r - l + 1;
    vector<int> bluePrefix(n+1,0), redPrefix(n+1,0);
    for (int i = l+1; i <= r; ++i) {
        if (points[idxs[i]].color == 0) {
            bluePrefix[i-l] = bluePrefix[i-l-1]+1;
            redPrefix[i-l] = redPrefix[i-l-1];
        } else {
            redPrefix[i-l] = redPrefix[i-l-1]+1;
            bluePrefix[i-l] = bluePrefix[i-l-1];
        }
    }
    for (int q = l+1; q <= r; ++q) {
        if (points[idxs[q]].color == P.color) continue;
        int leftCount = q - (l+1);
        int rightCount = (r-q);
        int blueLeft = (leftCount > 0 ? bluePrefix[leftCount] : 0);
        int redLeft = (leftCount > 0 ? redPrefix[leftCount] : 0);
        int blueRight = bluePrefix[n-1]-blueLeft; 
        int redRight = redPrefix[n-1]-redLeft; 
        if (blueLeft == redLeft && blueRight == redRight) {
            Point A = points[idxs[pivotIndex]];
            Point B = points[idxs[q]];
            if (A.color == 0) ans.push_back({A.idx,B.idx});
            else ans.push_back({B.idx,A.idx});
            vector<int> leftPart, rightPart;
            for (int i = l+1; i < q; ++i) leftPart.push_back(idxs[i]);
            for (int i = q+1; i <= r; ++i) rightPart.push_back(idxs[i]);
            bool okLeft = true, okRight = true;
            if (!leftPart.empty()) okLeft = solveMatching(0, (int)leftPart.size()-1, leftPart);
            if (!rightPart.empty()) okRight = solveMatching(0, (int)rightPart.size()-1, rightPart);
            return okLeft && okRight;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t; cin >> t;
    while (t--) {
        cin >> N;
        points.clear();
        points.resize(2*N);
        for (int i = 0; i < N; i++) {
            cin >> points[i].x >> points[i].y;
            points[i].color = 0;
            points[i].idx = i+1;
        }
        for (int i = 0; i < N; i++) {
            cin >> points[N+i].x >> points[N+i].y;
            points[N+i].color = 1;
            points[N+i].idx = i+1;
        }
        if (N == 1) {
            if (points[0].color != points[1].color) cout << 1 << " " << 1 << "\n";
            else cout << 0 << "\n";
            continue;
        }
        int pivotId = 0;
        for (int i = 1; i < 2*N; i++) {
            if (points[i].x < points[pivotId].x ||
               (points[i].x == points[pivotId].x && points[i].y < points[pivotId].y)) {
                pivotId = i;
            }
        }
        swap(points[0], points[pivotId]);
        pivot = points[0];
        sort(points.begin()+1, points.end(), polarCmp);
        vector<int> idxs(2*N);
        for (int i = 0; i < 2*N; i++) idxs[i] = i;
        ans.clear();
        bool ok = solveMatching(0, 2*N-1, idxs);
        if(!ok) cout << 0 << "\n";
        else {
            for (auto &p : ans) cout << p.first << " " << p.second << "\n";
        }
    }
    return 0;
}