#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, color, idx;
};

bool polarCompare(const Point &a, const Point &b) {
    return atan2(a.y, a.x) < atan2(b.y, b.x);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        vector<Point> blue(n), red(n), allPoints(2 * n);
        for (int i = 0; i < n; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].color = 0; blue[i].idx = i + 1;
            allPoints[i] = blue[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].color = 1; red[i].idx = i + 1;
            allPoints[n + i] = red[i];
        }

        sort(allPoints.begin(), allPoints.end(), [](const Point &a, const Point &b) {
            return a.x < b.x || (a.x == b.x && a.y < b.y);
        });

        Point pivot = allPoints[0];
        sort(allPoints.begin() + 1, allPoints.end(), [&](const Point &a, const Point &b) {
            return polarCompare({a.x - pivot.x, a.y - pivot.y}, {b.x - pivot.x, b.y - pivot.y});
        });

        for (int i = 0; i < n; ++i) 
            cout << blue[i].idx << " " << red[i].idx << "\n";
    }

    return 0;
}