#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, color, idx;
};

long long dist2(const Point &a, const Point &b) {
    return 1LL * (a.x - b.x) * (a.x - b.x) + 1LL * (a.y - b.y) * (a.y - b.y);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        vector<Point> blue(n), red(n);
        vector<bool> used(n, false);

        for (int i = 0; i < n; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].color = 0; blue[i].idx = i + 1;
        }
        for (int i = 0; i < n; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].color = 1; red[i].idx = i + 1;
        }

        for (int i = 0; i < n; ++i) {
            int bestIdx = -1;
            long long minDist = LLONG_MAX;

            for (int j = 0; j < n; ++j) {
                if (!used[j]) {
                    long long d = dist2(red[i], blue[j]);
                    if (d < minDist) {
                        minDist = d;
                        bestIdx = j;
                    }
                }
            }

            used[bestIdx] = true;
            cout << blue[bestIdx].idx << " " << red[i].idx << "\n";
        }
    }

    return 0;
}