#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, idx;
};

bool isIntersect(pair<Point, Point> a, pair<Point, Point> b) {
    auto ccw = [](Point A, Point B, Point C) {
        return 1LL * (B.y - A.y) * (C.x - B.x) > 1LL * (B.x - A.x) * (C.y - B.y);
    };
    return (ccw(a.first, b.first, b.second) != ccw(a.second, b.first, b.second)) &&
           (ccw(a.first, a.second, b.first) != ccw(a.first, a.second, b.second));
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;

        vector<Point> blue(n), red(n);
        for (int i = 0; i < n; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].idx = i + 1;
        }
        for (int i = 0; i < n; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].idx = i + 1;
        }

        vector<pair<Point, Point>> pairs;
        for (int i = 0; i < n; ++i) {
            pairs.push_back({blue[i], red[i]});
        }

        bool ok = true;
        for (int i = 0; i < n && ok; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (isIntersect(pairs[i], pairs[j])) {
                    ok = false;
                    break;
                }
            }
        }

        if (!ok) {
            cout << 0 << "\n";
        } else {
            for (int i = 0; i < n; ++i) {
                cout << pairs[i].first.idx << " " << pairs[i].second.idx << "\n";
            }
        }
    }

    return 0;
}