#include <bits/stdc++.h>
using namespace std;

struct Point {
    int x, y, idx;
    bool isBlue;
};

bool polarCmp(const Point &a, const Point &b, const Point &origin) {
    long long cross = 1LL * (a.x - origin.x) * (b.y - origin.y) - 1LL * (b.x - origin.x) * (a.y - origin.y);
    if (cross == 0) {
        return hypot(a.x - origin.x, a.y - origin.y) < hypot(b.x - origin.x, b.y - origin.y);
    }
    return cross > 0;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vector<Point> blue(n), red(n), all(2 * n);

        for (int i = 0; i < n; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].idx = i + 1;
            blue[i].isBlue = true;
            all[i] = blue[i];
        }
        for (int i = 0; i < n; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].idx = i + 1;
            red[i].isBlue = false;
            all[n + i] = red[i];
        }

        Point origin = *min_element(all.begin(), all.end(), [](const Point &a, const Point &b) {
            return a.y == b.y ? a.x < b.x : a.y < b.y;
        });

        sort(all.begin(), all.end(), [&](const Point &a, const Point &b) {
            return polarCmp(a, b, origin);
        });

        vector<pair<int, int>> result;
        vector<Point> stack;

        for (Point &p : all) {
            if (!stack.empty() && stack.back().isBlue != p.isBlue) {
                result.emplace_back(stack.back().idx, p.idx);
                stack.pop_back();
            } else {
                stack.push_back(p);
            }
        }

        if (result.size() != n) {
            cout << 0 << "\n";
        } else {
            for (auto &[a, b] : result) {
                cout << a << " " << b << "\n";
            }
        }
    }

    return 0;
}