#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

struct Point {
    int x, y, index;
    Point(int x, int y, int index) : x(x), y(y), index(index) {}
};

bool compareX(const Point &a, const Point &b) {
    return a.x < b.x;
}

bool compareY(const Point &a, const Point &b) {
    return a.y < b.y;
}

int main() {
    int t;
    std::cin >> t;

    while (t--) {
        int N;
        std::cin >> N;

        std::vector<Point> bluePoints, redPoints;
        for (int i = 0; i < N; ++i) {
            int x, y;
            std::cin >> x >> y;
            bluePoints.emplace_back(x, y, i + 1);
        }

        for (int i = 0; i < N; ++i) {
            int x, y;
            std::cin >> x >> y;
            redPoints.emplace_back(x, y, i + 1);
        }

        std::sort(bluePoints.begin(), bluePoints.end(), compareX);
        std::sort(redPoints.begin(), redPoints.end(), compareY);

        std::vector<std::pair<int, int>> result;
        for (int i = 0; i < N; ++i) {
            result.emplace_back(bluePoints[i].index, redPoints[i].index);
        }

        for (const auto &pair : result) {
            std::cout << pair.first << " " << pair.second << std::endl;
        }
    }

    return 0;
}
