#include <iostream>
#include <vector>
#include <algorithm>

struct Point {
    int x, y, index;
    Point(int x, int y, int index) : x(x), y(y), index(index) {}
};

bool compareByX(const Point &a, const Point &b) {
    return a.x < b.x;
}

int main() {
    int t;
    std::cin >> t;

    while (t--) {
        int N;
        std::cin >> N;

        std::vector<Point> bluePoints, redPoints;
        for (int i = 0; i < N; ++i) {
            int x, y;
            std::cin >> x >> y;
            bluePoints.emplace_back(x, y, i + 1);
        }

        for (int i = 0; i < N; ++i) {
            int x, y;
            std::cin >> x >> y;
            redPoints.emplace_back(x, y, i + 1);
        }

        std::sort(bluePoints.begin(), bluePoints.end(), compareByX);
        std::sort(redPoints.begin(), redPoints.end(), compareByX);

        bool valid = true;
        std::vector<std::pair<int, int>> result;
        for (int i = 0; i < N; ++i) {
            if (bluePoints[i].x > redPoints[i].x) {
                valid = false;
                break;
            }
            result.emplace_back(bluePoints[i].index, redPoints[i].index);
        }

        if (valid) {
            for (const auto &pair : result) {
                std::cout << pair.first << " " << pair.second << std::endl;
            }
        } else {
            std::cout << 0 << std::endl;
        }
    }

    return 0;
}
