import sys
import math

input = sys.stdin.read
INF = float('inf')

def min_cost_matching(cost):
    n = len(cost)
    u, v = [0] * n, [0] * n
    p, way = [-1] * n, [-1] * n
    for i in range(n):
        links = [-1] * n
        mins = [INF] * n
        used = [False] * n
        marked_i, marked_j, j = i, -1, 0
        while True:
            j = -1
            for j1 in range(n):
                if not used[j1]:
                    cur = cost[marked_i][j1] - u[marked_i] - v[j1]
                    if cur < mins[j1]:
                        mins[j1] = cur
                        links[j1] = marked_j
                    if j == -1 or mins[j1] < mins[j]:
                        j = j1
            delta = mins[j]
            for j1 in range(n):
                if used[j1]:
                    u[p[j1]] += delta
                    v[j1] -= delta
                else:
                    mins[j1] -= delta
            u[i] += delta
            used[j] = True
            marked_j = j
            marked_i = p[j]
            if marked_i == -1:
                break
        while True:
            if links[j] != -1:
                p[j] = p[links[j]]
                j = links[j]
            else:
                break
        p[j] = i

    result = [-1] * n
    for j in range(n):
        if p[j] != -1:
            result[p[j]] = j
    return result

def solve():
    data = input().strip().split()
    idx = 0
    t = int(data[idx])
    idx += 1
    results = []

    for _ in range(t):
        N = int(data[idx])
        idx += 1
        blue_points = []
        red_points = []

        for i in range(N):
            x, y = int(data[idx]), int(data[idx + 1])
            blue_points.append((x, y))
            idx += 2

        for i in range(N):
            x, y = int(data[idx]), int(data[idx + 1])
            red_points.append((x, y))
            idx += 2

        cost = []
        for i in range(N):
            cost.append([0] * N)
            for j in range(N):
                cost[i][j] = math.hypot(blue_points[i][0] - red_points[j][0], blue_points[i][1] - red_points[j][1])

        result = min_cost_matching(cost)
        output = []
        for i in range(N):
            if result[i] != -1:
                output.append((i + 1, result[i] + 1))
        results.append(output)

    for result in results:
        for pair in result:
            print(pair[0], pair[1])

if __name__ == "__main__":
    solve()
