import sys
import math
from scipy.spatial import KDTree

input = sys.stdin.read

def solve():
    data = input().strip().split()
    idx = 0
    t = int(data[idx])
    idx += 1
    results = []

    for _ in range(t):
        N = int(data[idx])
        idx += 1
        blue_points = []
        red_points = []

        for i in range(N):
            x, y = int(data[idx]), int(data[idx + 1])
            blue_points.append((x, y, i + 1))
            idx += 2

        for i in range(N):
            x, y = int(data[idx]), int(data[idx + 1])
            red_points.append((x, y, i + 1))
            idx += 2

        blue_tree = KDTree([p[:2] for p in blue_points])
        matches = [-1] * N

        for i, red in enumerate(red_points):
            distance, blue_index = blue_tree.query(red[:2])
            matches[blue_index] = i

        pairs = [(blue_points[i][2], red_points[matches[i]][2]) for i in range(N)]

        results.append(pairs)

    for result in results:
        for pair in result:
            print(pair[0], pair[1])

if __name__ == "__main__":
    solve()
