import sys
import math

input = sys.stdin.read

def distance(p1, p2):
    return math.hypot(p1[0] - p2[0], p1[1] - p2[1])

def solve():
    data = input().strip().split()
    idx = 0
    t = int(data[idx])
    idx += 1
    results = []

    for _ in range(t):
        N = int(data[idx])
        idx += 1
        blue_points = []
        red_points = []

        for i in range(N):
            x, y = int(data[idx]), int(data[idx + 1])
            blue_points.append((x, y, i + 1))
            idx += 2

        for i in range(N):
            x, y = int(data[idx]), int(data[idx + 1])
            red_points.append((x, y, i + 1))
            idx += 2

        pairs = []
        used_blue = [False] * N
        used_red = [False] * N

        for i in range(N):
            min_dist = float('inf')
            blue_idx = -1
            red_idx = -1
            for j in range(N):
                if not used_blue[j]:
                    for k in range(N):
                        if not used_red[k]:
                            dist = distance(blue_points[j], red_points[k])
                            if dist < min_dist:
                                min_dist = dist
                                blue_idx = j
                                red_idx = k
            if blue_idx != -1 and red_idx != -1:
                pairs.append((blue_points[blue_idx][2], red_points[red_idx][2]))
                used_blue[blue_idx] = True
                used_red[red_idx] = True

        results.append(pairs)

    for result in results:
        if len(result) == 0:
            print(0)
        else:
            for blue_index, red_index in result:
                print(blue_index, red_index)

if __name__ == "__main__":
    solve()
