#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct Point {
    int x, y, id;
};

bool compare(Point a, Point b) {
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vector<Point> blue(n), red(n);

        for (int i = 0; i < n; i++) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].id = i + 1;
        }

        for (int i = 0; i < n; i++) {
            cin >> red[i].x >> red[i].y;
            red[i].id = i + 1;
        }
        sort(blue.begin(), blue.end(), compare);
        sort(red.begin(), red.end(), compare);

        vector<pair<int, int>> pairs;

        for (int i = 0; i < n; i++) {
            pairs.emplace_back(blue[i].id, red[i].id);
        }

        for (auto &p : pairs) {
            cout << p.first << " " << p.second << "\n";
        }
    }

    return 0;
}