#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <climits>
using namespace std;
struct Point {
    int x, y, id;
    };
long long dist2(const Point& a, const Point& b){
    return (long long)(a.x - b.x) * (a.x - b.x) + (long long)(a.y - b.y) * (a.y - b.y);
}
int main() {
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<Point> blue(n), red(n);
        for (int i = 0; i < n; ++i){
            cin >> blue[i].x >> blue[i].y;
            blue[i].id = i + 1;
        }
        for (int i = 0; i < n; ++i){
            cin >> red[i].x >> red[i].y;
            red[i].id = i + 1;
        }
        vector<bool> usedBlue(n, false), usedRed(n, false);
        vector<pair<int, int>> result;
        for (int i = 0; i < n; ++i) {
            int bestBlue = -1, bestRed = -1;
            long long minDist = LLONG_MAX;
            for (int j = 0; j < n; ++j){
                if (usedBlue[j]) continue;
                for (int k = 0; k < n; ++k){
                    if (usedRed[k]) continue;
                    long long d = dist2(blue[j], red[k]);
                    if (d < minDist){
                        minDist = d;
                        bestBlue = j;
                        bestRed = k;
                    }
                }
            }
            if (bestBlue == -1){
                cout << 0 << endl;
                break;
            }
            usedBlue[bestBlue] = usedRed[bestRed] = true;
            result.push_back({blue[bestBlue].id, red[bestRed].id});
        }
        if (result.size() == n) {
            for (auto& p : result)
                cout << p.first << " " << p.second << endl;
        }
    }
    return 0;
}