#include <iostream>
#include <queue>
#include <vector>
#include <unordered_set>
using namespace std;


struct State {
    int pos, seconds;
};

int main() {
    int N;
    cin >> N;

    
    if (N == 2) {
        cout << 1 << endl;
        return 0;
    }

    
    queue<State> aliceQueue, bobQueue;
    
  
    unordered_set<int> aliceVisited, bobVisited;
    
    
    aliceQueue.push({1, 0});
    bobQueue.push({N, 0});
    
    aliceVisited.insert(1);
    bobVisited.insert(N);

    
    vector<int> aliceMoves = {2, 3};
    
    vector<int> bobMoves = {-1, -2};
    
    
    vector<int> aliceSeconds(N + 1, -1), bobSeconds(N + 1, -1);
    aliceSeconds[1] = 0;
    bobSeconds[N] = 0;


    while (!aliceQueue.empty()) {
        State state = aliceQueue.front();
        aliceQueue.pop();
        
        for (int move : aliceMoves) {
            int newPos = state.pos + move;
            if (newPos <= N && aliceSeconds[newPos] == -1) {
                aliceSeconds[newPos] = state.seconds + 1;
                aliceQueue.push({newPos, state.seconds + 1});
            }
        }
    }


    while (!bobQueue.empty()) {
        State state = bobQueue.front();
        bobQueue.pop();
        
        for (int move : bobMoves) {
            int newPos = state.pos + move;
            if (newPos >= 1 && bobSeconds[newPos] == -1) {
                bobSeconds[newPos] = state.seconds + 1;
                bobQueue.push({newPos, state.seconds + 1});
            }
        }
    }

   
    int minSeconds = -1;
    for (int i = 1; i <= N; ++i) {
        if (aliceSeconds[i] != -1 && bobSeconds[i] != -1) {
            if (minSeconds == -1) {
                minSeconds = max(aliceSeconds[i], bobSeconds[i]);
            } else {
                minSeconds = min(minSeconds, max(aliceSeconds[i], bobSeconds[i]));
            }
        }
    }

    cout << minSeconds << endl;
    return 0;
}