#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;


struct Point {
    int x, y, index;
};


double distance(const Point& a, const Point& b) {
    return sqrt((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

int main() {
    int t; 
    cin >> t;

    while (t--) {
        int N;
        cin >> N;

        vector<Point> blue(N), red(N);

        
        for (int i = 0; i < N; ++i) {
            cin >> blue[i].x >> blue[i].y;
            blue[i].index = i + 1; 
        }

        // Зчитуємо червоні точки
        for (int i = 0; i < N; ++i) {
            cin >> red[i].x >> red[i].y;
            red[i].index = i + 1; 
        }

        
        sort(blue.begin(), blue.end(), [](const Point& a, const Point& b) {
            return a.x < b.x || (a.x == b.x && a.y < b.y);
        });
        sort(red.begin(), red.end(), [](const Point& a, const Point& b) {
            return a.x < b.x || (a.x == b.x && a.y < b.y);
        });

    
        vector<pair<int, int>> result;
        for (int i = 0; i < N; ++i) {
            result.push_back({blue[i].index, red[i].index});
        }

        bool valid = true; 

        if (!valid) {
            cout << "0\n";
        } else {
            for (const auto& pair : result) {
                cout << pair.first << " " << pair.second << "\n";
            }
        }
    }

    return 0;
}