def solve_matching(test_cases):
    results = []
    for case in test_cases:
        N, blue_points, red_points = case
        pairs = []

        # Сортуємо точки синього кольору за координатами x (потім y для унікальності)
        blue_points = sorted(enumerate(blue_points, 1), key=lambda p: (p[1][0], p[1][1]))
        # Сортуємо точки червоного кольору за координатами x (потім y для унікальності)
        red_points = sorted(enumerate(red_points, 1), key=lambda p: (p[1][0], p[1][1]))

        used_red = set()
        for blue_idx, blue_point in blue_points:
            min_dist = float('inf')
            selected_red_idx = -1
            for red_idx, red_point in red_points:
                if red_idx not in used_red:
                    # Обчислюємо евклідову відстань
                    dist = (blue_point[0] - red_point[0]) ** 2 + (blue_point[1] - red_point[1]) ** 2
                    if dist < min_dist:
                        min_dist = dist
                        selected_red_idx = red_idx
            if selected_red_idx == -1:
                # Якщо неможливо з'єднати всі точки
                results.append([0])
                break
            pairs.append((blue_idx, selected_red_idx))
            used_red.add(selected_red_idx)
        else:
            results.append(pairs)

    return results


# Ввід
t = int(input())
test_cases = []
for _ in range(t):
    N = int(input())
    blue_points = [tuple(map(int, input().split())) for _ in range(N)]
    red_points = [tuple(map(int, input().split())) for _ in range(N)]
    test_cases.append((N, blue_points, red_points))

# Розв'язання
results = solve_matching(test_cases)

# Вивід
for result in results:
    if result == [0]:
        print(0)
    else:
        for blue_idx, red_idx in result:
            print(blue_idx, red_idx)
